/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
console.debug("Loading: com.ibm.rqm.appscan.web.client.internal.ScanClient");
dojo.provide("com.ibm.rqm.appscan.web.client.internal.ScanClient");
dojo.require("com.ibm.team.repository.web.transport.ServiceRequest");
dojo.require("com.ibm.team.repository.web.transport.TeamServerClient");

(function() { //module container

var ServiceRequest 			= com.ibm.team.repository.web.transport.ServiceRequest;
var TeamServerClient 		= com.ibm.team.repository.web.transport.TeamServerClient;

com.ibm.rqm.appscan.web.client.internal.ScanClient = {

	SERVICE_URI: "com.ibm.rqm.appscan.common.service.rest.IScanRestService",
    
	_invokeService: function(responseHandler, method, appArgs) {
		var serviceRequest= new ServiceRequest(this.SERVICE_URI, method, appArgs);
		TeamServerClient.invokeService(serviceRequest, responseHandler);
	},
			
	getTemplates: function(serviceResponseHandler) {
		this._invokeService(serviceResponseHandler, "getTemplates", { });
	},
	
	getTestPolicies: function(serviceResponseHandler) {
		this._invokeService(serviceResponseHandler, "getTestPolicies", {});
	},
	
	getRunInfo: function(serviceResponseHandler, scanArgs) {
		this._invokeService(serviceResponseHandler, "getRunInfo", scanArgs);
	},
		
	getScanSummary: function(serviceResponseHandler, scanArgs) {
		this._invokeService(serviceResponseHandler, "getScanSummary", scanArgs);
	},
			
	getScanStatus: function(serviceResponseHandler, scanArgs) {
		this._invokeService(serviceResponseHandler, "getScanStatus", scanArgs);
	},
	
	getScanLogCount: function(serviceResponseHandler, scanArgs) {
		this._invokeService(serviceResponseHandler, "getScanLogCount", scanArgs);
	},
	
	createScan: function(serviceResponseHandler, scanArgs) {
		this._invokeService(serviceResponseHandler, "postCreateScan", scanArgs);
	},

	updateScan: function(serviceResponseHandler, scanArgs) {
		this._invokeService(serviceResponseHandler, "postUpdateScan", scanArgs);
	},
		
	deleteScan: function(serviceResponseHandler, scanArgs) {
		this._invokeService(serviceResponseHandler, "postDeleteScan", scanArgs);
	},
	
	cancelScan: function(serviceResponseHandler, scanArgs) {
		this._invokeService(serviceResponseHandler, "getCancelScan", scanArgs);
	},
	
	getUserById: function(serviceResponseHandler, scanArgs) {
		this._invokeService(serviceResponseHandler, "getUserById", scanArgs);
	}
};

})();
