/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.execution.web.client.internal.execution.ToolAdapterRegistrationClient");

dojo.require("com.ibm.team.repository.web.transport.ServiceRequest");
dojo.require("com.ibm.team.repository.web.transport.TeamServerClient");
dojo.require("com.ibm.team.process.web.client.projectarea");

(function() { //module container

var ServiceRequest 			= com.ibm.team.repository.web.transport.ServiceRequest;
var TeamServerClient 		= com.ibm.team.repository.web.transport.TeamServerClient;
var getCurrentPA            = com.ibm.team.process.web.client.projectarea.getCurrentProjectArea;

com.ibm.rqm.execution.web.client.internal.execution.ToolAdapterRegistrationClient= {

	TOOL_ADATPTER_REGISTRY_SERVICE_URI: "com.ibm.rqm.executionframework.common.service.rest.IToolAdapterRegistrationRestService",
	
	_invokeService: function(responseHandler, method, appArgs) {
		var actualArgs = {};
		if (appArgs) {
			var jsonArgs= dojo.toJson(appArgs);
			actualArgs.jsonString= jsonArgs;
		
		if(appArgs.id)	
			actualArgs.id = appArgs.id;
		if(appArgs.type)	
			actualArgs.type = appArgs.type;
		if(appArgs.name)	
			actualArgs.name = appArgs.name;
		if(appArgs.hostname)	
			actualArgs.hostname = appArgs.hostname;
		if(appArgs.capabilities)	
			actualArgs.capabilities = appArgs.capabilities;
		}
		if (appArgs.requestId) {
			actualArgs.requestId = appArgs.requestId;
		}
		if (appArgs.externalId) {
			actualArgs.externalId = appArgs.externalId;
		}
		if(appArgs.instructions) {
			actualArgs.instructionsJson = dojo.toJson(appArgs.instructions);			
		}
		if(!appArgs.projectAreaItemId){
			actualArgs.projectAreaItemId = getCurrentPA().itemId;
		}else{
			actualArgs.projectAreaItemId = appArgs.projectAreaItemId; 
		}
		var serviceRequest= new ServiceRequest(this.TOOL_ADATPTER_REGISTRY_SERVICE_URI, method, actualArgs);
		TeamServerClient.invokeService(serviceRequest, responseHandler);
	},
	
	getAdapters: function(serviceResponseHandler, params){
		this._invokeService(serviceResponseHandler, "getAdapters", params);
	},

	postRegister: function(serviceResponseHandler, params){
		this._invokeService(serviceResponseHandler, "postRegister", params);
	},
	
	postDelete: function(serviceResponseHandler, params){
		this._invokeService(serviceResponseHandler, "postDeleteRegistry", params);
	},
	
	getAdaptersWithMachines: function(serviceResponseHandler, params){
		this._invokeService(serviceResponseHandler, "getAdaptersDTO", params);
	}
};

})();
