/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2009. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.planning.web.client.internal.mapper.CategoryMapper");
dojo.require("com.ibm.asq.common.web.client.internal.mapper.AbstractMapper");

dojo.declare("com.ibm.rqm.planning.web.client.internal.mapper.CategoryMapper",
             com.ibm.asq.common.web.client.internal.mapper.AbstractMapper, {
			 	
	// maps a summary DTO to a full DTO
	// optimus prime time.  transform summary DTO to look like a real DTO. 
	map: function(summaryDTO) {
		// proceed only if there is actual categories
		var categories = [];
		if (summaryDTO.categoryNames && summaryDTO.categoryItemIds && 
                    summaryDTO.categoryNames.length == summaryDTO.categoryItemIds.length){
			for (var i = 0; i < summaryDTO.categoryItemIds.length; i++) {
				categories.push({
					itemId: summaryDTO.categoryItemIds[i],
					name: summaryDTO.categoryNames[i]
				})
			}
		}
		summaryDTO.categories = categories;
		summaryDTO.categoryItemIds = null;
		summaryDTO.categoryNames = null;
		return summaryDTO;
	}
	
});