/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.execution.web.client.internal.mapper.EWIMapper");
dojo.require("com.ibm.rqm.planning.web.client.internal.mapper.SearchResultMapper");

dojo.declare("com.ibm.rqm.execution.web.client.internal.mapper.EWIMapper",
             com.ibm.rqm.planning.web.client.internal.mapper.SearchResultMapper, {			
				
	// transforms a summary DTO to a full DTO
	map: function(summaryDTO) {
		
		// default script
		summaryDTO.defaultScript = {};
		summaryDTO.defaultScript.id = summaryDTO.defaultScriptId;
		summaryDTO.defaultScript.name = summaryDTO.defaultScriptName;
		summaryDTO.defaultScriptId = null;
		summaryDTO.defaultScriptName = null;
		
		// test plan
		summaryDTO.testPlan = {};
		summaryDTO.testPlan.id = summaryDTO.testPlanId;
		summaryDTO.testPlan.versionableItemId = summaryDTO.testPlanVersionableItemId;
		summaryDTO.testPlan.name = summaryDTO.testPlanName;
		summaryDTO.testPlanId = null;
		summaryDTO.testPlanVersionableItemId = null;
		summaryDTO.testPlanName = null;
		
		// phase
		summaryDTO.phase = {};
		summaryDTO.phase.itemId = summaryDTO.phaseItemId;
		summaryDTO.phase.name = summaryDTO.phaseName;
		summaryDTO.phaseItemId = null;
		summaryDTO.phaseName = null;
		
		// test case
		summaryDTO.testCase = {};
		summaryDTO.testCase.id = summaryDTO.testCaseId;
		summaryDTO.testCase.name = summaryDTO.testCaseName;
		summaryDTO.testCaseId = null;
		summaryDTO.testCaseName = null;
		
		// test case scripts
		if (summaryDTO.testCaseScriptIds!=null) {
			summaryDTO.testCase.scripts = [];
			for (var i=0; i<summaryDTO.testCaseScriptIds.length; i++) {
				summaryDTO.testCase.scripts[i] = {};
				summaryDTO.testCase.scripts[i].id = summaryDTO.testCaseScriptIds[i];
				summaryDTO.testCase.scripts[i].name = summaryDTO.testCaseScriptNames[i];
			}
			summaryDTO.testCaseScriptIds = null;
			summaryDTO.testCaseScriptNames = null;
		}
		
		// owner
		summaryDTO.owner = {};
		summaryDTO.owner.userId = summaryDTO.ownerUserId;
		summaryDTO.owner.name = summaryDTO.ownerName;
		summaryDTO.ownerUserId = null;
		summaryDTO.ownerName = null;
		
		// current result
		if (summaryDTO.currentResultStartTime!=null) {
			summaryDTO.currentResult = {};
			summaryDTO.currentResult.startTime = summaryDTO.currentResultStartTime;
			summaryDTO.currentResult.state = {}
			summaryDTO.currentResult.state.name = summaryDTO.currentResultStateName;
			summaryDTO.currentResult.state.id = summaryDTO.currentResultStateId;
			summaryDTO.currentResult.itemId = summaryDTO.currentResultItemId;
			summaryDTO.currentResultStartTime = null;
			summaryDTO.currentResultStateName = null;
			summaryDTO.currentResultItemId = null;
			if(summaryDTO.currentResultScriptId){
				summaryDTO.currentResult.script = {};
				summaryDTO.currentResult.script.id = summaryDTO.currentResultScriptId;
				summaryDTO.currentResultScriptId = null;
			} 
		}
		
		// configuration
		summaryDTO.config = {};
		summaryDTO.config.id = summaryDTO.configId;
		summaryDTO.config.name = summaryDTO.configName;
		summaryDTO.configId = null;
		summaryDTO.configName = null;
		
//		// blocking defects
		if (summaryDTO.defectIds !=null) {
			summaryDTO.defects = [];
			for (var i=0; i<summaryDTO.defectIds.length; i++) {
				var defect = {workItem:{}};
                defect.workItem.attributes=[];
                defect.workItem.attributes.push({key:"id",value:{id:summaryDTO.defectIds[i],label:summaryDTO.defectIds[i]}});
                defect.workItem.attributes.push({key:"summary",value:{content:summaryDTO.defectNames[i]}});
                defect.workItem.attributes.push({key:"internalResolution",value:{label:summaryDTO.defectIResolutions[i]}});
                defect.workItem.attributes.push({key:"internalState",value:{id:summaryDTO.defectIStateIDs[i],label:summaryDTO.defectIStates[i]}});
                summaryDTO.defects.push(defect);
			}
            summaryDTO.defectIds = null;
            summaryDTO.defectNames = null;
            summaryDTO.defectIResolutions = null;
            summaryDTO.defectIStates = null;
		}
		
		return summaryDTO;
	}
	
});