/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.process.web.client.internal.sizing.SizingClient");

dojo.require("com.ibm.team.repository.web.transport.ServiceRequest");
//xojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");
dojo.require("com.ibm.team.repository.web.transport.TeamServerClient");
dojo.require("com.ibm.team.process.web.client.projectarea");

(function(){ //module container

    
    var ServiceRequest = com.ibm.team.repository.web.transport.ServiceRequest;
//    var ServiceResponseHandler = com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
    var TeamServerClient = com.ibm.team.repository.web.transport.TeamServerClient;
	var getCurrentProjectArea	= com.ibm.team.process.web.client.projectarea.getCurrentProjectArea;
    
    com.ibm.rqm.process.web.client.internal.sizing.SizingClient = {
    
        SIZING_SERVICE_URI: "com.ibm.rqm.process.common.service.rest.ISizingRestService",
        
        _invokeGetService: function(responseHandler, method, appArgs){
            var actualArgs = {};
            if (appArgs) {
                if (appArgs.id) {
                    actualArgs.id = appArgs.id;
                }
                if (appArgs.uid) {
                    actualArgs.uid = appArgs.uid;
                }
				if (appArgs.type) {
                    actualArgs.type = appArgs.type;
                }
            }
			actualArgs.processArea = getCurrentProjectArea().itemId;
            var serviceRequest = new ServiceRequest(this.SIZING_SERVICE_URI, method, actualArgs);
            TeamServerClient.invokeService(serviceRequest, responseHandler);
        },
        
        _invokePostService: function(responseHandler, method, appArgs){
            var actualArgs = {};
            if (appArgs) {
                var jsonArgs = dojo.toJson(appArgs);
                actualArgs.jsonString = jsonArgs;
                if (appArgs.originator) {
                    actualArgs.originator = appArgs.originator;
                }
                if (appArgs.unit) {
                    actualArgs.unit = appArgs.unit;
                }
                if (appArgs.owner) {
                    actualArgs.owner = appArgs.owner;
                }
                if (appArgs.artifactItemId) {
                    actualArgs.artifactItemId = appArgs.artifactItemId;
                }
                if (appArgs.state) {
                    actualArgs.state = appArgs.state;
                }
                if (appArgs.estimatedEffort) {
                    actualArgs.estimatedEffort = appArgs.estimatedEffort;
                }
				if (appArgs.effort) {
                    actualArgs.effort = appArgs.effort;
                }
                if (appArgs.type) {
                    actualArgs.type = appArgs.type;
                }
				if (appArgs.description) {
                    actualArgs.description = appArgs.description;
                }
				if (appArgs.externalId) {
                    actualArgs.externalId = appArgs.externalId;
                }
//				if (appArgs.projectAreaName) {
//                    actualArgs.projectAreaName = appArgs.projectAreaName;
//                }
            }
            actualArgs.processArea = getCurrentProjectArea().itemId;
            var serviceRequest = new ServiceRequest(this.SIZING_SERVICE_URI, method, actualArgs);
            TeamServerClient.invokeService(serviceRequest, responseHandler);
        },
        
        saveSizingRecord: function(serviceResponseHandler, params){
            this._invokePostService(serviceResponseHandler, "postSizingRecord", params);
        },
        getArtifactWithSizing: function(serviceResponseHandler, params){
            this._invokeGetService(serviceResponseHandler, "getTestArtifactWithSizingDTO", params);
        }
    };
    
})();
