/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
/*
*
* This class is specific to users.  It extends the lmContainer object.
* 
* There implementation currently makes use of 2 *internal* Jazz services.  
* Beats writing them ourselves.  I am trying to find out if this is OK or not.
*
*/
(function(){
dojo.require("com.ibm.rational.test.lm.web.client.internal.lmContainer");
dojo.provide("com.ibm.rational.test.lm.web.client.internal.user");

dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");
dojo.require("com.ibm.team.process.web.client.projectarea");

var ServiceResponseHandler = com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
dojo.declare("com.ibm.rational.test.lm.web.client.internal._userWorkItem", com.ibm.rational.test.lm.web.client.internal.lmContainer, 
		
		
		{
			constructor: function(){
		        this.setServiceInterface('com.ibm.team.workitem.common.internal.rest.IWorkItemRestService');
			},
			//
	        getUsers: function(responseHandler, nameFilter)
	        {
	        	var args = {};
	        	if (nameFilter)
	        	{
	        		args[ "nameFilter" ] = nameFilter;
	        	}
	        	return this._invokeService(	responseHandler, 
	        								"getContributors", 
	        								args );
        	}
        }	
);

dojo.declare("com.ibm.rational.test.lm.web.client.internal._userAdminInfo", com.ibm.rational.test.lm.web.client.internal.lmContainer, 
    {
        
        constructor: function(){
            this.setServiceInterface('com.ibm.rational.test.lm.common.IAdminRestService');
        },

        // return the common arguments used in all admin service calls; not API 
        _getAdminServiceArgs: function()
        {
            var args = { 'projectAreaItemId' : com.ibm.team.process.web.projectArea.itemId };
            
            return args;
        }

    }   
);

dojo.declare("com.ibm.rational.test.lm.web.client.internal._userContributor", com.ibm.rational.test.lm.web.client.internal.lmContainer, 
	{
		constructor: function(){
        	this.setServiceInterface('com.ibm.team.repository.common.internal.IContributorRestService');
		},
		//
        getCurrentContributor: function(responseHandler)
        {
        	return this._invokeService(	responseHandler, 
        								"getCurrentContributor" ); 
    	},
    	
        getContributors: function(responseHandler, name)
        {
			var args = null;
			if (name != null) 
			{
				args = {"name": name};
			}
			return this._invokeService(responseHandler, "getContributors", args);
    	}
    }	
);

dojo.declare("com.ibm.rational.test.lm.web.client.internal._projectmembers", com.ibm.rational.test.lm.web.client.internal.lmContainer, 
	{
		constructor: function(){
        	this.setServiceInterface('com.ibm.team.process.internal.common.service.IProcessRestService');
		},
    	
        getMembers: function(responseHandler)
        {
			var getCurrentProjectArea = com.ibm.team.process.web.client.projectarea.getCurrentProjectArea;
			var args = null;
			args = {"projectAreaItemId": getCurrentProjectArea().itemId, 
					"notInfProject": false};
			return this._invokeService(responseHandler, "getMembers", args);
    	}
    }	
);

dojo.declare("com.ibm.rational.test.lm.web.client.internal.projectmembers", null, 
	{
		constructor: function(){
			this.members = new com.ibm.rational.test.lm.web.client.internal._projectmembers();
		},
		
		getMembers: function(responseHandler) {
			return this.members.getMembers(responseHandler);
		}
});

dojo.declare("com.ibm.rational.test.lm.web.client.internal.user", null, 
	{
		constructor: function(){
	        this.workItem = new com.ibm.rational.test.lm.web.client.internal._userWorkItem();
	        this.contributor = new com.ibm.rational.test.lm.web.client.internal._userContributor();
	        this.adminInfo = new com.ibm.rational.test.lm.web.client.internal._userAdminInfo();
		},
	
		// returns an array of the users whose name begins with nameFilter.  Note
		// that on jazz.net I was able to use a pattern of *rass to mean
		// any user whose name includes rass (not begins with rass).
		// if nameFilter is not provided, ALL users are returned!
		// Each object returned contains name and itemId properties.
		//MFV - I could find no instance where getUsers was called with a name filter
		//but I kept this method here and renamed it.
        getFilteredUsers: function(responseHandler, nameFilter)
        {
        	return this.workItem.getUsers(responseHandler,nameFilter);
        },
		
		//Returns all users
		getUsers: function(responseHandler)
		{
			return this.contributor.getContributors(responseHandler, null);
		},
        
        // return detailed info about the current user.  Details include
        //		userId
        //		name
        //		details (photo?)
        //		predecessor (? was null, not sure what this is)
        //		modified (a time value)
        //		stateId (users are auditable, so this specifies the version/state)
        //		itemId
        //		mergePredecessor (?  was null, not sure what this is)
        //		emailAddress
        //		modifiedBy	(a nested object, contains a user's "itemId")
        getCurrent: function(callerResponseHandler)
        {
            var applicationUser = dojo.getObject("com.ibm.team.repository.web.client.internal.AUTHENTICATED_CONTRIBUTOR");
        	var userClass = this;
        	// We use myResponseHandler1 to handle the query for the current user
    		var myResponseHandler1 = new ServiceResponseHandler(
				{
					_success: function ( userInfo ) {
                        return callerResponseHandler.doCallback(userInfo);	
					},
				
					_failure: function (errObj) {
						errObj.compositeContext="getCurrentContributor";
						callerResponseHandler.doErrorCallback(errObj);
					}
				},
				"_success",
				"_failure"
			);
			if (applicationUser){
				// if we have the user stored in the application object, just use it!
				return myResponseHandler1.doCallback(applicationUser);   // already have it in the app user!
			}
        	return this.contributor.getCurrentContributor(myResponseHandler1);
        },
        
        // find the user by name and return detailed information about the user
        // Note that calling this with a null will return ALL users (currently
        // over 2700 on jazz.net), so we guard against this and do not allow it!'
        // If you want all users, call getUsers().
        // Note that for now this returns an ARRAY of users; either length 1 or 0.
        // Not sure how this could ever return multiple users unless it is OK to 
        // have more than one user with the same full name???? probably is OK?
        findByName: function(responseHandler, name)
        {	
        	console.debug( "in findByName: "+name);
        	if (!name)
        	{
        		throw new Error("must specify a non-empty name!");
        	}
        	return this.contributor.getContributors(responseHandler, name);
        }
   }	
);
})();
