/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
(function() {
dojo.provide("com.ibm.rational.test.lm.web.ui.internal.RtlmApplication");

dojo.require("com.ibm.team.repository.web.client.init.InitializationData");
dojo.require("com.ibm.team.repository.web.client.internal.RepositoryClient");
dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");

dojo.require("com.ibm.asq.common.web.ui.internal.app.Application");
dojo.require("com.ibm.asq.common.web.ui.internal.util.CSHelp");

dojo.require("com.ibm.rational.test.lm.web.ui.internal.RtlmUiUtil");
dojo.require("com.ibm.rational.test.lm.web.client.internal.RtlmInitializer");

var RtlmUiUtil 				= com.ibm.rational.test.lm.web.ui.internal.RtlmUiUtil;
var PlatformUI				= net.jazz.ajax.ui.PlatformUI;
var RtlmInitializer         = com.ibm.rational.test.lm.web.client.internal.RtlmInitializer;
var ServiceResponseHandler  = com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
var InitializationData      = com.ibm.team.repository.web.client.init.InitializationData;
var RepositoryClient        = com.ibm.team.repository.web.client.internal.RepositoryClient;

function workbenchRootNode(){
	// summary:
	//		helper to get workbench root node
	return net.jazz.ajax.ui.PlatformUI.getWorkbench().rootNode();
}

dojo.declare("com.ibm.rational.test.lm.web.ui.internal.RtlmApplication", 
             com.ibm.asq.common.web.ui.internal.app.Application, 
{
	// summary:
	//		The Rational Test Lab Manager application object. It's subclassed from
	//	    the jazz.ui._Application widget to implements a Jazz web UI workbench application.
	title: RtlmUiUtil.getMessage("appTitle"),
    titleImagePath: dojo.moduleUrl("com.ibm.rational.test.lm.web", "ui/internal/images/prodtitle_t.gif"),
	
    CSHelpBaseURL: "/help/context?id=com.ibm.rational.test.lm.web.",
    InfoCenterHelpLabel: RtlmUiUtil.getMessage("appInfocenterHelp"),
    InfoCenterLinkLabel: "Link to Info Center",
    InfoCenterURL: "/help/index.jsp",

    initApp: function() {        
        // daisy-chain to initialize logged in user
        var responseHandler = new ServiceResponseHandler(this, "_initCatalogSuccess", "_initFailure");
        RtlmInitializer.initializeData(responseHandler);
    },
    
    _initCatalogSuccess: function(response) {
        console.debug("initialized catalog successfully!");

        // set InitializationData that this app initialized the catalog
        var catalogInitData = {
            "com.ibm.rational.test.lm.web.catalogInitialized": this
        };
        InitializationData._load(catalogInitData);

        this.initUI();  // response handler was used more than once!!!!!
    },

    _initFailure: function(errorObject)
    {
        console.debug("initialization failed!");
        // put up the error message on init failure
        var errorPrompt = document.createElement('div');
        var errorMessage = document.createElement('div');
        errorPrompt.innerHTML = "<p><p><h2>Failed to initialize the Lab Management</h2><p>";
        errorMessage.innerHTML = errorObject['errorMessage'];
        workbenchRootNode().appendChild(errorPrompt);
        workbenchRootNode().appendChild(errorMessage);
    },
    
    _initUIcompleted: false,  // safe guard to init the UI only once
    
	initUI: function() {
	    if (!this._initUIcompleted) {
            _RtlmApplication.superclass.initUI.apply(this, arguments);
            _RtlmApplication.superclass.start.call(this);
            this._initUIcompleted = true;
        }
    }
	
});

var _RtlmApplication = com.ibm.rational.test.lm.web.ui.internal.RtlmApplication;
var MALFORMED_PAGEORDER_MSG	= "Malformed property value for 'com.ibm.team.repository.web.pageorder': ";


function getCurrentWorkbenchID() {
	return net.jazz.ajax.ui.PlatformUI._getApplicationId();
}

})();
