/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.adapter.testrt.web.ui.internal.TestRTUtil");

(function() {

dojo.require("com.ibm.asq.common.web.ui.internal.util.MessageUtil");

// define a message bundle id for TestRT
var MessageBundleTestRT = "TestRT";

dojo.declare("com.ibm.rqm.adapter.testrt.web.ui.internal._MessageLoader", null,
{
    constructor: function(){
        // initializes the rqm message bundle
       MessageUtil.registerRequireBundle(MessageBundleTestRT, "com.ibm.rqm.adapter.testrt.web.ui.internal", "messages");
	   console.debug("Registered TestRT bundle: \"" + MessageUtil.getMessage(MessageBundleTestRT, "bundle_description") + "\"" );
    }
});

// create an instance to ensure the message bundle is loader
com.ibm.rqm.adapter.testrt.web.ui.internal.MessageLoader = new com.ibm.rqm.adapter.testrt.web.ui.internal._MessageLoader();

com.ibm.rqm.adapter.testrt.web.ui.internal.TestRTUtil = {

    /**
     * Return the message from the message bundle with the specified keyword.
     * Optional token arguments are for replacing place holders in the message
     * definition.  The place holders have the syntax "%number" with the number
     * starting from 1.  For example, if the message "myStr" is defined as
     * "This is %1 of %2 message".  getMessage("myStr", "one", "my many") will return
     * "This is one of my many message".
     */
    getMessage: function(keyword, tokens) {
        var args = [MessageBundleTestRT];
        for( var i = 0; i < arguments.length; i++){ 
            args.push(arguments[i]);
        }
        return MessageUtil.getMessage.apply(MessageUtil, args);
    }
};
})();
