/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.adapter.rtc.web.ui.internal.config.TeamConcertWizard");

dojo.require("com.ibm.rqm.defects.web.ui.internal.wizard.Wizard");

dojo.require("com.ibm.rqm.adapter.rtc.web.ui.internal.config.PageWelcome");
dojo.require("com.ibm.rqm.adapter.rtc.web.ui.internal.config.PageRepository");
dojo.require("com.ibm.rqm.adapter.rtc.web.ui.internal.config.PageProjectArea");

dojo.require("com.ibm.rqm.adapter.rtc.web.client.internal.TeamConcertConnectionClient");
dojo.require("com.ibm.team.repository.web.transport.ServiceResponseHandler");
dojo.require("com.ibm.team.repository.web.foundation.Status");

dojo.require("com.ibm.rqm.adapter.rtc.web.ui.internal.RTCAdapterUIUtil");

(function(){

var TeamConcertConnectionClient			= com.ibm.rqm.adapter.rtc.web.client.internal.TeamConcertConnectionClient;
var ServiceResponseHandler				= com.ibm.team.repository.web.transport.ServiceResponseHandler;
var Status 								= com.ibm.team.repository.web.foundation.Status;
var RTCAdapterUIUtil 					= com.ibm.rqm.adapter.rtc.web.ui.internal.RTCAdapterUIUtil;

dojo.declare("com.ibm.rqm.adapter.rtc.web.ui.internal.config.TeamConcertWizard", 
			 [com.ibm.rqm.defects.web.ui.internal.wizard.Wizard], {

	_context: null,
	_type: null,
	_teamConcertDefectProvider: null,
	
	constructor: function(teamConcertDefectProvider, type) {
		this._context= {
			url: teamConcertDefectProvider.getRepositoryUrl() || "",
			name: teamConcertDefectProvider.getConnectionName() || "",
			description: teamConcertDefectProvider.getRepositoryDescription() || "",
			projectArea: teamConcertDefectProvider.getProjectAreaName() || ""
		};
		this._type= type;
		this._title= "Rational Team Concert";
		this._pages.push(com.ibm.rqm.adapter.rtc.web.ui.internal.config.PageWelcome.create(this._context));
		this._pages.push(com.ibm.rqm.adapter.rtc.web.ui.internal.config.PageRepository.create(this._context));
		this._pages.push(com.ibm.rqm.adapter.rtc.web.ui.internal.config.PageProjectArea.create(this._context));
		
		this._teamConcertDefectProvider= teamConcertDefectProvider;
	},

	getInitialPage: function() {
		return this._context.url.length > 0 ? this._pages[1] : this._pages[0];
	},

	performFinish: function(runWhenFinished, monitor) {
		monitor.beginTask(RTCAdapterUIUtil.getMessage("labelSaveConfiguration"));

		var connectionParams= {
			name: this._context.name, 
			description: this._context.description, 
			repositoryUrl: this._context.url, 
			projectAreaName: this._context.projectArea 
		};
		TeamConcertConnectionClient.postDefaultTeamConcertConnection(this._type, connectionParams, dojo.hitch(this, function(status, response) {
			if (status.isOK()) {
				this._teamConcertDefectProvider.setup(function(status) {
					runWhenFinished(status)
				}, monitor);
			} else {
				runWhenFinished(status);
			}
		}));
	},

	// ---- implementation -------------------------------------------------------------------------------------------------

	__sentinel: null // terminates this class definition
});

})();
