/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.planning.web.ui.internal.page.ArtifactEditorPageController");
dojo.require("net.jazz.ajax.ui.PlatformUI");

(function(){
    dojo.declare("com.ibm.rqm.planning.web.ui.internal.page.ArtifactEditorPageController", null, {
        /*
         */
        tabName: null,
        tabIcon: null,

        constructor: function(model, view){
            this._model = model;
            this._view = view;
            
            // connect model to view
            dojo.connect(this._model, "setArtifact", this, "updateTab");
            dojo.connect(this._model, "setTabClass", this, "updateTab");
        },
        
        updateTab: function(){
            if (this._model == null || this._view == null) {
                console.error("Error: cannot update tab name due to null reference");
                return;
            }
            
            var artifact = this._model.getArtifact();
            var name = artifact != null ? artifact.name : null;
			if (artifact && artifact.snapshotInfo) {
				name += " (" + artifact.snapshotInfo.name + ")";
			}
            if (name != null) {
            					
				// update browser title
					this._view.browserTitle = this._model.getArtifactType() + Constants.getMessage("labelColen") + " " + name;
					net.jazz.ajax.ui.PlatformUI.getWorkbench().setTitle(this._view.browserTitle);
					net.jazz.ajax.ui.PlatformUI.getWorkbench().browserTitle = this._view.browserTitle;
					
                if (name.length > 20) {
                    name = name.substring(0, 20);
                    name += "...";
                }
				//update tab name in case the tab name is modified by the GlobalEvents.UpdateCurrentTabLabel event
				this.tabName = this._view.controlButton.label;
                if (!this.tabName || this.tabName != name) {
                    // set the tab name only if it is not set or different
                    this.tabName = name;
                    this._view.controlButton.setLabel(name);
                }
            } else {
					// update browser title
					this._view.browserTitle = this._model.getArtifactType() + ": " + Constants.getMessage("labelCapitalNew");
					net.jazz.ajax.ui.PlatformUI.getWorkbench().setTitle(this._view.browserTitle);
					net.jazz.ajax.ui.PlatformUI.getWorkbench().browserTitle = this._view.browserTitle;
			}
            
            var tabClass = this._model.getTabClass();
            if ((tabClass != null) && (!this.tabIcon || this.tabIcon != tabClass)) {
                // set the tab icon class only if it is not set or different
                this.tabIcon = tabClass;
                this._view.controlButton.containerNode.className = tabClass;
            }
        }
    
    });
})();
