/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
(function() {
dojo.provide("com.ibm.rqm.planning.web.ui.internal.page.Header");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.require("net.jazz.ajax.toolbox.lang.internal.Lang");
dojo.require("net.jazz.ajax.ui.PageList");

dojo.require("com.ibm.team.repository.web.client.session.Session");
dojo.require("com.ibm.team.repository.web.ui.internal.Login");
dojo.require("com.ibm.team.repository.web.ui.internal.Logout");
dojo.require("com.ibm.team.repository.web.client.init.InitializationData");
//xojo.require("com.ibm.team.repository.provision.client.internal.ProvisionResponseHandler");
//xojo.require("com.ibm.team.repository.provision.client.internal.ProvisioningClient");
//xojo.require("com.ibm.team.repository.web.ui.internal.admin.ModeDetector");

dojo.require("com.ibm.rqm.planning.web.ui.internal.page.PageList");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
/**
 * Provides the web UI's header area.
 */

var checkNotNull 	         = net.jazz.ajax.toolbox.lang.checkNotNull;
var isGuest 					= com.ibm.team.repository.web.client.session.isGuest;
var InitializationData		= com.ibm.team.repository.web.client.init.InitializationData;
//var REPO_DB_CONNECTED      = com.ibm.team.repository.web.ui.internal.admin.ModeDetector.REPO_DB_CONNECTED;
var ModeDetector 				= com.ibm.team.repository.web.ui.internal.admin.ModeDetector;

var BANNER_ICON_IMG_SRC         = dojo.moduleUrl("com.ibm.rqm.planning.web", "ui/internal/page/templates/images/banner/REQM_id.gif");
var BANNER_LEFT_IMG_SRC         = dojo.moduleUrl("com.ibm.rqm.planning.web", "ui/internal/page/templates/images/banner/REQM_ban.gif");
var RQM_IMG_SRC                 = dojo.moduleUrl("com.ibm.rqm.planning.web", "ui/internal/page/templates/images/banner/REQM_prodtitle.png");

var X_AUTH_MSG					= "X-com-ibm-team-repository-web-auth-msg";

function getHomeUri() {
	if( com.ibm.team.repository.web.homeuri ) {
		return com.ibm.team.repository.web.homeuri;
	}
	
	return null;
}

function getHomeLinkElement() {
	checkNotNull(getHomeUri(), "getHomeUri()");
	
	var homeLinkElement = document.createElement("a");
	
	homeLinkElement.href = getHomeUri();
	homeLinkElement.innerHTML = com.ibm.rqm.planning.web.client.internal.Constants.getMessage("LabelHome");
	homeLinkElement.className = "home";
	
	return homeLinkElement;
}

function userIsAdmin() {
	var permissionInitializer = InitializationData.get("com.ibm.team.repository.service.canGrantPermissionInitializer");
	if (permissionInitializer != null && permissionInitializer.canGrantPermission) {
		return true;
	}
	else {
		return false;
	}
}

function getAdminLinkElement() {
	var adminLinkElement = document.createElement("a");
	
	adminLinkElement.href = dojo.baseUrl + "../../admin";
	adminLinkElement.innerHTML = com.ibm.rqm.planning.web.client.internal.Constants.getMessage("LabelAdmin");
	adminLinkElement.className = "admin";
	
	return adminLinkElement;
}

dojo.declare("com.ibm.rqm.planning.web.ui.internal.page.Header", [dijit._Widget, dijit._Templated], {
	
	//
	// Module-private properties and methods
	//

	templatePath: dojo.moduleUrl("com.ibm.rqm.planning.web", "ui/internal/page/templates/Header.html"),
	
	showLoginPanel: false,
	
	checkRepoAvailability: false,
	
	forceHideAdminLink: false,
	
	/**
	 * Fill in the dynamic elements of the header nav.
	 */
	postCreate: function() {
		
		this._createPageList();

		if(this.showLoginPanel){
			if (this.checkRepoAvailability) {
				dojo.subscribe("com.ibm.team.repository.web.ui.internal.admin.init", this, "_handleInitAvailable");
				this._handleInitAvailable(false);
//				dojo.subscribe(com.ibm.team.repository.provision.isRepositoryAvailable, this, "_handleRepositoryUpdate");
//				this._fetchRepositoryAvailability();
			}
			else {
				this._showPanel();
			}
		}
		
		
		if(getHomeUri()) {
			this._addHomeLinks();
		}
		/*
		if(!this.forceHideAdminLink && userIsAdmin()) {
			this._addAdminLink();
		}
		*/
		
		this._labelContainer.appendChild(document.createTextNode(this.label));

		/*
		if (dojo.isIE && dojo.isIE<7) { // IE6
			this.rqmLogoImg.src = RQM_IE6_IMG_SRC;
		}
		else {
			this.rqmLogoImg.src = RQM_MOZ_IMG_SRC;
		}
		
		this.bannerLeftImg.src = BANNER_LEFT_IMG_SRC;
		*/	
		//apply images
		//this.rqmLogoImg.src = RQM_IMG_SRC;
		this.bannerIconImg.src = BANNER_ICON_IMG_SRC;
		this.bannerLeftImg.src = BANNER_LEFT_IMG_SRC;
	},
	
	_createPageList: function() {
		var args = this.suppressedPages ? {suppressedPages: this.suppressedPages} : {};
		var pageList = new com.ibm.rqm.planning.web.ui.internal.page.PageList(); //net.jazz.ajax.ui.PageList();
		this.pageListContainer.appendChild(pageList.domNode);
	},
	
	_showPanel: function() {
		if (isGuest()) {
			this._showLoginPanel();
		} else {
			this._showLogoutPanel();
		}
	},
	
	_showPanelNoRepo: function () {
		var bindArgs= {
	        url: "/jazz/auth/whoami",
	        content: { },
			handleAs: "json",
			headers: { },
			handle: dojo.hitch(this, function(response, ioArgs){
				if (response instanceof Error) {
					var errorObj= {
						status: ioArgs.xhr.status
					};
					// format detailed message (unescape URI-encoding formatting, remove leading dashes, and trim whitespace)
					errorObj.message= dojo.trim(unescape(ioArgs.xhr.statusText).replace(/\+/g, " ").replace(/^(-*)/g, ""));
					serviceResponseHandler.doErrorCallback(errorObj);
				}
				else if (ioArgs.xhr.getResponseHeader(X_AUTH_MSG) == null) {
					this._showLoginPanel();
				}
				else {
					this._showLogoutPanel(ioArgs.xhr.getResponseHeader(X_AUTH_MSG));
				}
	        })
	    };
	    dojo.xhrGet(bindArgs);
	},

	_showLoginPanel: function() {
		this.loginPanelContainer.appendChild(new com.ibm.team.repository.web.ui.internal.Login().domNode );
	},
	
	_showLogoutPanel: function(loggedInUser) {
		this.loginPanelContainer.appendChild(new com.ibm.team.repository.web.ui.internal.Logout({ "loggedInUser": loggedInUser}).domNode );
	},
	
	//handles notification 
	_handleInitAvailable: function(availability){
		var initAvailable = this._isInitDataLoaded();
				
		if (this.repoMode == null || this.repoMode != initAvailable) {
			this.repoMode = initAvailable;
			for (var x = 0; x < this.loginPanelContainer.childNodes.length; x++) {
				this.loginPanelContainer.removeChild(this.loginPanelContainer.childNodes[x]);
			}
			if (initAvailable) {
				this._showPanel();
			} else {
				this._showPanelNoRepo();
			}
		}
	},
	
	_isInitDataLoaded: function() {
		if (InitializationData.get("com.ibm.team.repository.service.currentContributorInitializer")) {
			return true;
		}
		return false;
	},
	

/*	_handleRepositoryUpdate: function(repositoryAvailable) {
		if (this.repoAvailable == null || this.repoAvailable != repositoryAvailable) {
			this.repoAvailable = repositoryAvailable;
			for (var x = 0; x < this.loginPanelContainer.childNodes.length; x++) {
				this.loginPanelContainer.removeChild(this.loginPanelContainer.childNodes[x]);
			}
			if (repositoryAvailable) {
				this._showPanel();
			} else {
				this._showPanelNoRepo();
			}
		}
	},
	
	_handleRepositoryUpdateCmd: function(commandResponse) {
		this._handleRepositoryUpdate(commandResponse.repositoryAvailable);
	},
	
	_fetchRepositoryAvailability: function() {
		var prh = new com.ibm.team.repository.provision.client.internal.ProvisionResponseHandler(this, "_handleRepositoryUpdateCmd", "_availabilityRequestFailed");
		com.ibm.team.repository.provision.client.internal.ProvisioningClient.isRepositoryAvailable(prh);
	},
	
	_availabilityRequestFailed: function(errorObject) {
		throw new Error("Header#_availabilityRequestFailed: " + errorObject.statusText);		
	},
*/	
	_addHomeLinks: function() {
		checkNotNull(getHomeUri(), "getHomeUri()");
		
		this.homeLinkContainer.appendChild(getHomeLinkElement());
		this.homeLinkContainer.appendChild(document.createTextNode(" | "));
		this.rqmLogoLink.href = getHomeUri();
		this.rqmLogoLink.title = com.ibm.rqm.planning.web.client.internal.Constants.getMessage("LabelHome");
	},
	
	_addAdminLink: function() {
		this.pageListContainer.appendChild(document.createTextNode(" | "));
		this.pageListContainer.appendChild(getAdminLinkElement());
	}
});

})();
