/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
(function()
{
dojo.provide("com.ibm.rqm.planning.web.ui.internal.page.QMPage");
    
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dojox.data.dom");

dojo.require("com.ibm.team.repository.web.client.init.InitializationData");
dojo.require("com.ibm.team.repository.web.client.session.Session");
dojo.require("com.ibm.team.repository.web.client.internal.licensing");
dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");

dojo.require("com.ibm.team.process.web.client.projectarea");
dojo.require("com.ibm.team.process.web.client.internal.ProcessClient");

dojo.require("com.ibm.asq.common.web.ui.internal.util.CSHelp");
dojo.require("com.ibm.asq.common.web.ui.internal.util.SelectUtility");
dojo.require("com.ibm.asq.common.web.ui.internal.util.GlobalEvents");

dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
//xojo.require("com.ibm.rqm.planning.web.ui.internal.page.PageList");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.common.GlobalTaskBar");
dojo.require("com.ibm.rqm.planning.web.ui.internal.util.EditorUtil");

dojo.require("net.jazz.ajax.toolbox.lang.internal.Lang");

var InitializationData          = com.ibm.team.repository.web.client.init.InitializationData;
var X_AUTH_MSG                  = "X-com-ibm-team-repository-web-auth-msg";
var DEFAULT_LOGOUT_URI          = dojo.moduleUrl("com.ibm.team.repository.web", "loggedout.html");
var isGuest                     = com.ibm.team.repository.web.client.session.isGuest;var getAuthenticatedContributor = com.ibm.team.repository.web.client.session.getAuthenticatedContributor;

var getExpirationInfo           = com.ibm.team.repository.web.client.internal.licensing.getExpirationInfo;
var getLicenseInfo              = com.ibm.team.repository.web.client.internal.licensing.getLicenseInfo;
var ServiceResponseHandler      = com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
var SelectUtil                  = com.ibm.asq.common.web.ui.internal.util.SelectUtility;
var ProcessClient               = com.ibm.team.process.web.client.internal.ProcessClient;
var getCurrentProjectArea       = com.ibm.team.process.web.client.projectarea.getCurrentProjectArea;
var Constants                   = com.ibm.rqm.planning.web.client.internal.Constants;
var GlobalEvents 				= com.ibm.asq.common.web.ui.internal.util.GlobalEvents;

var ACTION_ROOT = "com.ibm.rqm.planning.home.";
var DISPATCHER  = "actionDispatcher";
var HOME_ACTION = "viewUserHome";

function getFormLogoutLinkUri() {
    var uri = com.ibm.team.repository.web.logouturi;
    if (uri == null) {
        uri = DEFAULT_LOGOUT_URI;
    }
    uri += "?path=" + escape(this.location.pathname + this.location.search + this.location.hash);
    return uri;
}

function userIsAdmin()
{
    var permissionInitializer = InitializationData.get("com.ibm.team.repository.service.canGrantPermissionInitializer");
    if (permissionInitializer != null && permissionInitializer.canGrantPermission) 
    {
        return true;
    }
    else
    {
        return false;
    }
}

dojo.declare("com.ibm.rqm.planning.web.ui.internal.page.QMPage", [dijit._Widget, dijit._Templated],
{
    templatePath: dojo.moduleUrl("com.ibm.rqm.planning.web", "ui/internal/page/templates/QMPage.html"),

    labelLoading: Constants.getMessage("labelLoading"),
	
	isFromNonRQMPage: false,
    
    postCreate: function()
    {
//      var anchor = document.createElement("a");
//      anchor.href = /*"https://" + document.location.hostname + ":9443"*/ "/help/index.jsp";
//      anchor.appendChild( document.createTextNode("Help"));
//      anchor.target = "_blank";
//      dojo.addClass(anchor, "help-link");
//      this._help.appendChild(anchor);
        
//      var pageList = new com.ibm.rqm.planning.web.ui.internal.page.PageList({isAdmin: userIsAdmin()});
//      this._tabs.appendChild(pageList.domNode);
		//adding "Skip to main content" for Web Accessibility
		this._mainContentHref.href = "javascript:{}";
		this._mainContentHref.onclick = dojo.hitch(this, "_skipToMain");
		
        this._contributor = getAuthenticatedContributor();
        this._user.appendChild(document.createTextNode(this._contributor.name));

        if (isGuest())
        {
            var loginLink = document.createElement("a");
            loginLink.href = "https://" + window.location.hostname + ":" + com.ibm.team.repository.server.repourl.port.https + window.location.pathname + window.location.search + window.location.hash;
            loginLink.appendChild(document.createTextNode(Constants.getMessage("labelLogIn")));
            this._logout.appendChild(loginLink);
        }
        else
        {
            var logoutLink = document.createElement("a");
            var logoutURI = getFormLogoutLinkUri();
            logoutLink.href = "javascript:{}";
            logoutLink.onclick = function() {
                
                // The onBeforeUnload event handler has confirmation to allow cancel navigating away.
                // The logout handler redirect the page afterwards to the RQM Home page and there
                // will be a chance that the logout is completed but the user chooses to
                // cancel from navigating away.  We will need to do the confirmation ourself
                // and skip the confirmation from the onBeforeUnload event handler.
                if (confirm(Constants.getMessage("promptLogout"))) {
                    // set to be in progress of a logout to eliminate the onBeforeUnload confirmation
                    dojo.setObject("com-ibm-rqm-planning-web-logout-in-progress", true);
            
                    var bindArgs = {
                        url: net.jazz.ajax._contextRoot + "/auth/logout",
                        handleAs: "json",
                        headers: { accept: "text/json" },
                        preventCache: dojo.isIE,
                        handle: function(response, ioArgs){
                            
                            /*window.location.href = document.location.protocol + "//" +
                                                   document.location.host +
                                                   document.location.pathname +
                                                   document.location.search;*/												  
							var pathname = document.location.pathname;
							pathname=pathname.substring(0, pathname.lastIndexOf("/"))+"/QM";
							window.location.href = document.location.protocol + "//" +
                                                   document.location.host +
                                                   pathname +
                                                   document.location.search;
                        }
                    };
                    dojo.xhrPost(bindArgs);
                } else if (dojo.isIE) {
                    // IE trigger the onBeforeUnload event from clicking the link even on cancel of
                    // the confirmation!?  Set to be in progress a logout to suppress the noise form
                    // the conformation but need to reset it right after. 
                    dojo.setObject("com-ibm-rqm-planning-web-logout-in-progress", true);
                    setTimeout(function() {
                        dojo.setObject("com-ibm-rqm-planning-web-logout-in-progress", false);
                    });
                }
            }
            
            logoutLink.appendChild(document.createTextNode(Constants.getMessage("labelLogOut")));
            this._logout.appendChild(logoutLink);
        }
        
        //show license information
        dojo.subscribe(com.ibm.team.repository.web.internal.events.licenseChange, this, "_showLicenseInfo");
        var self = this;
        setTimeout(function() {
            getLicenseInfo(new ServiceResponseHandler(self, "_showLicenseInfo", "_showLicenseInfoErr"));
        });
        
        //show project areas
        this._showProjectAreas();
        
//      var logoutLink = document.createElement("a");
//      logoutLink.href = com.ibm.team.repository.web.logouturi;
//      logoutLink.appendChild(document.createTextNode("Sign out"));
//      this._logout.appendChild(logoutLink);
                    
        this._globalTaskBar = new com.ibm.rqm.planning.web.ui.internal.view.common.GlobalTaskBar();
        this._globalTaskBar.initialize();
        this._globalTaskBarArea.appendChild(this._globalTaskBar.domNode);

        this._globalTaskBar.addHomeLink(this._homeContainer);
        var pageArea = new net.jazz.ajax.ui.PageContainer();
        this._contentArea.appendChild(pageArea.domNode);

		//set rtl attribute:
		if(com.ibm.rqm.planning.web.ui.internal.util.EditorUtil.isDirectionRtl()) {
			this._contentArea.setAttribute("dir", "rtl");
		}
			
        var progressIndicator = new net.jazz.ajax.ui.ProgressIndicator();
        pageArea.domNode.appendChild(progressIndicator.domNode);
        progressIndicator.domNode.className = "com-ibm-team-repository-web-ProgressIndicator";

//      dojo.addClass(dojo.body(), "outer-container");
            
        var footer = document.createElement("div");
        footer.id = "footer";
        var ibm = document.createElement("div");
        ibm.id = "ibm";
        var jazz = document.createElement("div");
        jazz.id = "jazz";
        var copy = document.createElement("div");
        copy.id = "copy";
        var today = new Date();
        copy.innerHTML = Constants.getMessage("labelCopyright", today.getFullYear());
        footer.appendChild(ibm);
        ibm.appendChild(jazz);
        jazz.appendChild(copy);
        dojo.body().appendChild(footer);

        // subscribe to viewPage event from the workbench to check if the user
        // navigated to a Jazz page away from the RQM page
        dojo.subscribe(net.jazz.ajax.internal.events.viewPage, this, "_viewPage");
    },
    
    _viewPage: function(page) {
        var homelink = dojo.getObject("com-ibm-rqm-planning-web-home-link");
        var homeButton = dojo.getObject("com-ibm-rqm-planning-web-home-widget");
        if (page && page.id && page.id == "com.ibm.rqm.planning.web.HomePageView") {
            // showing a RQM page, the id is defined in plugin.xml
            if (homelink) {
                homelink.style.visibility = "hidden";
            }
            if (homeButton) {
                // update home button style to reflect if the "Home" tab is selected
                var homeSelected = window.location.hash.indexOf("&subAction=viewUserHome") > 0;
                homeButton.setDisabled(homeSelected);
            }
			if (net.jazz.ajax.ui.PlatformUI.getWorkbench().browserTitle && net.jazz.ajax.ui.PlatformUI.getWorkbench().browserTitle != Constants.getMessage("labelLoading")) {
				net.jazz.ajax.ui.PlatformUI.getWorkbench().setTitle(net.jazz.ajax.ui.PlatformUI.getWorkbench().browserTitle);
			}
			
			if(this.isFromNonRQMPage){
				dojo.publish("RQM-Event-Back-From-Print-Preview",[]);
				this.isFromNonRQMPage = false;
			}
			
			if(window.location.hash.indexOf(HOME_ACTION) > 0) {
				//refresh "My Tasks" viewlet when change to Home tab
				dojo.publish(GlobalEvents.RefreshMyTasks,[]);
			}
			
			// save the uri of the latest non-rqm page
        	this.lastPageURI = window.location.hash;
        } else {
            // showing a non-RQM page, ensure the back to RQM home link is visible
            if (homelink && !this.isFromNonRQMPage) {

				// we only have a single widget, homePageView, in the Jazz page
				// of which always has a single unique content area
				var homePageViewContentArea = dijit.byId("one-and-only-one-com-ibm-rqm-web-home-page-content-area");
			
				// get the selected tab of the content area for its title
				var selectedTab = homePageViewContentArea ? homePageViewContentArea.getLastSelectedTab() : null;

				// get the label of the selected tab
				var selectedTabTitle = selectedTab ? selectedTab.controlButton.label : null;
				
				// the selected RQM tab will not be defined if a non-RQM page is refreshed
				homelink.innerHTML = selectedTabTitle ? Constants.getMessage("labelBackRQMPage", selectedTabTitle) : Constants.getMessage("labelBackRQMHome");

                homelink.style.visibility = "visible";
                // Use previous RQM page URI for the link.  The link handler will use the Home page URI
				// if this.lastPageURI is not defined.
                homelink.backURI = this.lastPageURI;

				this.isFromNonRQMPage = true;
            }
            if (homeButton) {
                homeButton.setDisabled(false);
                homeButton._focused = false;
            }
        }
    },
    
    //show licensing / expiration information
    _showLicenseInfo: function(licenseInfo) {
        var disabledReason = dojo.getObject("serverLicense.disabledReason", false, licenseInfo || "");
        var expirationTime = dojo.getObject("serverLicense.expirationTime", false, licenseInfo || "");
        
        // if there's no expiration time, don't show anything
        if (!expirationTime && !disabledReason) {
            this._expiration.innerHTML = "";
//            this._expirationSep.style.display = "none";
        } else if(disabledReason) {
            this._expiration.className = "expirationWarning";
            //this._expiration.innerHTML = "<a href='" + licenseInfo.serverLicense.buyURL + "' target='_blank'>" + disabledReason + "</a> ";
            this._expiration.innerHTML = "<b>" + disabledReason + "</b> ";
        } else {
            var expirationInfo = getExpirationInfo(expirationTime);
            //this._expiration.innerHTML = "Your <a href='" + licenseInfo.serverLicense.buyURL + "' target='_blank'>Trial License</a> ";

            if(expirationInfo.isExpired || expirationInfo.daysRemaining <= 14) {
                this._expiration.className = "expirationWarning";
            } else {
                this._expiration.className = "expirationInfo";
            }
            if(expirationInfo.isExpired) {
                this._expiration.innerHTML = Constants.getMessage("labelHasExired");
            } else if (expirationInfo.daysRemaining === 0) {
                this._expiration.innerHTML = Constants.getMessage("labelExpiresToday");
            } else {
                var daysLeft = expirationInfo.daysRemaining;
                if (daysLeft === 1) {
                    this._expiration.innerHTML = Constants.getMessage("labelExpire1day");
                } else {
                    this._expiration.innerHTML = Constants.getMessage("labelExpireNday", daysLeft);
                }
            }
//            this._expirationSep.style.display = "inline";
        }
    },
    
    _showLicenseInfoErr: function(errorObj) {
        console.warn("Unable to fetch license information for header (message: " + errorObj.message + ")");
    },  
    
    _showProjectAreas: function() { 
        /*
		var self = this;            
        var serviceObj = {
            success: function(projectAreas) {
                self._loadProjectAreaList(projectAreas);
            },
            failure: function(e) {
                dojox.data.dom.removeChildren(self._projectList);
                self._projectList.appendChild(new Option(Constants.getMessage("labelErrorLoading"), Constants.getMessage("labelErrorLoading")));
            }
        }
        var responseHandler = new ServiceResponseHandler(serviceObj, "success", "failure");
        ProcessClient.getAllProjectAreas(responseHandler);  
        */
		
		//var projectAreas = InitializationData.get("com.ibm.team.process.service.projectAreaWebUIInitializionData").projectAreas;
		var projectAreas = dojo.getObject("com.ibm.rqm.web.userProjectAreas");
        var currentPA = getCurrentProjectArea();
        dojox.data.dom.removeChildren(this._projectList);
        for (var i = 0; i < (projectAreas ? projectAreas.length : 0); i++) {
            var opt = new Option(projectAreas[i].name, projectAreas[i].itemId);
            if (projectAreas[i].itemId == currentPA.itemId ) {
                opt.selected = true;
            }
            SelectUtil.add(this._projectList, opt);
        }       
    },
    
    _onProjectChange: function() {
		var currentPA = getCurrentProjectArea();
		var selectedItemId = this._projectList.value;
		if (selectedItemId != currentPA.itemId) {
			//switch project areas
			var curUrl = new dojo._Url(location.href);
			var query = curUrl.query ? ("?" + curUrl.query) : "";
			var projectName = this._projectList.options[this._projectList.selectedIndex].text;
			var href = net.jazz.ajax._contextRoot + "/web/console/" + encodeURI(projectName) + query;
			location.href = href;
		} 		
    },
	
	_findUserProject: function() {
		var projectAreas = dojo.getObject("com.ibm.rqm.web.userProjectAreas");
	},
	
	_skipToMain: function(){
		//Summary: skip to main content: Content Area. This is a hack: 
        //1. direct the page to contentArea
        //2. change url back to homepage 
		window.location.href = "#center-area";
		window.location.href = "#action=" + ACTION_ROOT + DISPATCHER + "&subAction=" + HOME_ACTION;
	}
});

})();
