/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/

dojo.provide("com.ibm.rational.test.lm.web.ui.internal.pages.UserHome");

dojo.require("com.ibm.asq.common.web.ui.internal.view.layout.PageLayout");
dojo.require("com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout");
dojo.require("com.ibm.asq.common.web.ui.internal.view.layout.PrimaryActionButton");
dojo.require("com.ibm.asq.common.web.ui.internal.view.layout.SecondaryActionsDropdownButton");
dojo.require("com.ibm.asq.common.web.ui.internal.view.layout.ViewNavigatorCollapsibleArea");

(function() {

function getWorkbench() {
    return net.jazz.ajax.ui.PlatformUI.getWorkbench();
}

var ViewHeaderLayout = com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout;

dojo.declare("com.ibm.rational.test.lm.web.ui.internal.pages.UserHome",
    [com.ibm.asq.common.web.ui.internal.view.layout.PageLayout],
    {
        
        postCreate: function() {
            this.defaultView = new ViewHeaderLayout("This is home");
            this.defaultView.setSubTitle("temporary home");
            this.defaultView.setCSHelpId("rtlm_navigation");
            com.ibm.rational.test.lm.web.ui.internal.pages.UserHome.superclass.postCreate.apply(this, arguments);

            var arg = {
                onClick: function() { alert('Hi!'); },
                actionLabel: "Hello",
                itemLabel: "World"
            };
            var button = new com.ibm.asq.common.web.ui.internal.view.layout.PrimaryActionButton(arg);
            this.setPrimaryAction(button.domNode);
            
            var secondaryActions = new com.ibm.asq.common.web.ui.internal.view.layout.SecondaryActionsDropdownButton();
            secondaryActions.setLabel("More Actions");
            secondaryActions.addAction(dojo.hitch(this, "okStatus"), "Test Success");
            secondaryActions.addAction(dojo.hitch(this, "errorStatus"), "Test Error");
            secondaryActions.addAction(dojo.hitch(this, "infoStatus"), "Test Info");
            secondaryActions.addAction(dojo.hitch(this, "clearStatus"), "Test Clear");
            secondaryActions.addAction(dojo.hitch(this, "startProgress"), "Start Progress");
            secondaryActions.addAction(dojo.hitch(this, "endProgress"), "End Progress");
            this.setSecondaryActions(secondaryActions.domNode);
            
            var viewNav = new com.ibm.asq.common.web.ui.internal.view.layout.ViewNavigatorCollapsibleArea();
            viewNav.setTitle("Test Views");
            viewNav.addLink(function(){alert('Link 1');}, "Link One");
            viewNav.addLink(function(){alert('Link 2');}, "Link Two");
            this._leftNavigator.getViewsSection().appendChild(viewNav.domNode);
            
            // late bind to ActionRegistry to ensure that workbench is instantiated
            ActionRegistry = getWorkbench().getActionRegistry();
    
            ActionRegistry.registerAction("com.ibm.rational.test.lm.web.ui.internal.pages.UserHome.init", this, "init");
            
        },
        
        okStatus: function() {
            this.defaultView.setStatus("This is ok", ViewHeaderLayout.SUCCESS);
        },
        
        errorStatus: function() {
            this.defaultView.setStatus("This is bad", ViewHeaderLayout.ERROR);
        },
        
        infoStatus: function() {
            this.defaultView.setStatus("This is plain info");
        },
        
        clearStatus: function() {
            this.defaultView.clearStatus();
        },
        
        startProgress: function() {
            this.defaultView.setProgressStart("Starting...");
        },
        
        endProgress: function() {
            this.defaultView.setProgressEnd("Finished");
        },
        
        init: function() {
        }
    }
);

})();
