/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
console.debug("Loading com.ibm.rqm.planning.web.ui.internal.view.actionbarentries.ReportsActionBarEntry");
dojo.provide("com.ibm.rqm.planning.web.ui.internal.view.actionbarentries.ReportsActionBarEntry");

dojo.require("net.jazz.ajax.ui.internal.PageRegistry");

dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");

dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.common.ActionBarEntry");

(function() 
{
	var PageRegistry = net.jazz.ajax.ui.internal.PageRegistry;
    var Constants = com.ibm.rqm.planning.web.client.internal.Constants;
    //var MAX_RECENT_REPORTS = 5;
	var MAX_TAB_LABEL_LENGTH = 20;

	dojo.declare(
		"com.ibm.rqm.planning.web.ui.internal.view.actionbarentries.ReportsActionBarEntry",
		[com.ibm.rqm.planning.web.ui.internal.view.common.ActionBarEntry],
		{
			constructor: function() 
			{
				//this._recent = [];
			},
	
			postCreate: function(args)
			{
			},
			
			initialize: function(args)
			{
				com.ibm.rqm.planning.web.ui.internal.view.actionbarentries.ReportsActionBarEntry.superclass.initialize.call(this, args);
				         												
                //create menu items				
				this._addMenuEntry(Constants.getMessage("labelViewReports"), dojo.hitch(this, "viewReports"), false, {'subAction':"viewReports"});
                
				this._addMenuSeparator();
				this._addMenuEntry(Constants.getMessage("labelCopyReport"), dojo.hitch(this, "copyReport"), false, {'subAction':"copyReport"});
				
                var isAdmin = userIsAdmin();                
				if (isAdmin) {
					this._addMenuSeparator();
					this._addMenuEntry(Constants.getMessage("labelAdminDW"), dojo.hitch(this, "adminReports"), false, {'subAction':"adminReports"});
				}
								
                //register actions 
                if(this.actionDispatcher) {
                    this.actionDispatcher.registerDispatchAction("viewReports", dojo.hitch(this, "viewReports"));
					this.actionDispatcher.registerDispatchAction("viewReport", dojo.hitch(this, "viewReport"));
					this.actionDispatcher.registerDispatchAction("copyReport", dojo.hitch(this, "copyReport"));
					if (isAdmin) {
						this.actionDispatcher.registerDispatchAction("adminReports", dojo.hitch(this, "adminReports"));
					}
                }
			},
			
        /*
         * QM Reports Actions
         */
        _onCancel: function(){
        },
		
        _showMsgCloseReport: function(args){
            var self = this;
            var dialogArgs = {
                message: Constants.getMessage("msgCloseReport", this._reportViewerPage.reportName),
                okCallback: function(args){
                    var doViewReport = dojo.hitch(this, function(){
                        var reportViewer = new com.ibm.rqm.reports.web.ui.internal.view.ReportViewer(args);
                        var name = self._abbreviate(args.name ? args.name : Constants.getMessage("labelViewReport"));
                        //refresh the existing page/tab with the content of the new report viewer
                        var newURI = window.location.hash;
                        self._contentArea.updatePageUri(self._reportViewerPage.uri, newURI);
                        self._contentArea.showPageByUri(newURI);
                        self._contentArea.updatePageContent(newURI, reportViewer)
                        self._contentArea.updatePageLabel(newURI, name)
                        self._reportViewerPage = self._contentArea.getPageByUri(newURI);
                        self._reportViewerPage.reportName = name;
                        var tabs = self._contentArea._tabs.getChildren();
                        reportViewer.initialize();
                        reportViewer.setView(self._reportViewerPage);
                    });
                    self._loadClassAsync("com.ibm.rqm.reports.web.ui.internal.view.ReportViewer", doViewReport);
                },
                okCallbackData: args,
                cancelCallback: dojo.hitch(this, "_onCancel")
            };
            
            this.floatingPane = new com.ibm.asq.common.web.ui.internal.widgets.ConfirmationDialog(dialogArgs);
            this.floatingPane.setSecondaryTitle(Constants.getMessage("labelConfirmation"));
			this.floatingPane.open();
        },
        
        viewReports: function(args){
            var doViewReports = function(){
                var reportsView = new com.ibm.rqm.reports.web.ui.internal.view.ReportsView();
				var browserTitle = Constants.getMessage("labelReport") + Constants.getMessage("labelColen") + " " + Constants.getMessage("labelAllView");
                var page = this._addPage({
                    name: Constants.getMessage("labelReports"),
                    content: reportsView.domNode,
                    closable: true,
					browserTitle: browserTitle
                });
                reportsView.setView(page);
            }
            this._loadClassAsync("com.ibm.rqm.reports.web.ui.internal.view.ReportsView", doViewReports);
        },
        
        viewReport: function(args){
            console.debug(this.declaredClass + ": viewReport --> entry.");
            
            if (this._reportViewerPage != null) {
                this._showMsgCloseReport(args);
                return;
            }
            var doViewReport = dojo.hitch(this, function(){
                var reportViewer = new com.ibm.rqm.reports.web.ui.internal.view.ReportViewer(args);
                var name = this._abbreviate(args.name ? args.name : Constants.getMessage("labelViewReport"));
                this._reportViewerPage = this._addPage({
                    name: name,
                    content: reportViewer,
                    closable: true,
					browserTitle: Constants.getMessage("labelReport") + Constants.getMessage("labelColen") + " " + name
                });
                this._reportViewerPage.reportName = args.name;
                //when the page is closed, clear the local reference
                dojo.connect(this._reportViewerPage, "destroy", this, dojo.hitch(this, function(){
                    this._reportViewerPage = null;
                }));
                reportViewer.initialize();
                reportViewer.setView(this._reportViewerPage);
            });
            this._loadClassAsync("com.ibm.rqm.reports.web.ui.internal.view.ReportViewer", doViewReport);
            
            //add this report to the recently run menu
            //this._addRecent(page.name, dojo.hitch(this, "viewReport", args), {'subAction':"viewReport"});
        },
			
			/*
			confirmReplaceReport: function() {
                var args = {
                    title: "",
                    message: "Current open report '' will be replaced.  Contin",
                    okCallback: function(){
                        self.inherited("onCloseButtonClick", arg);
                    },
                    cancelCallback: null
                }
                var dialog = new com.ibm.asq.common.web.ui.internal.widgets.ConfirmationDialog(args);
                dialog.setSecondaryTitle(args.title);
                dialog.open();				
			},
			*/
			
            copyReport: function() {   
                //console.debug(this.declaredClass + ": adminReport --> entry.");            
                var doCopyReport = function() {
                    var copyReport = new com.ibm.rqm.reports.web.ui.internal.view.NewReport();
					var browserTitle = Constants.getMessage("labelReport") + Constants.getMessage("labelColen") + " " + Constants.getMessage("labelCopy");
                    var page = this._addPage({
                        name: Constants.getMessage("labelCopyReport"),
                        content: copyReport.domNode,
                        closable: true,
						browserTitle: browserTitle
                    });
					copyReport.setView(page);         
                }
                this._loadClassAsync("com.ibm.rqm.reports.web.ui.internal.view.NewReport", doCopyReport);
            },			
			
            adminReports: function(args) {   
                //console.debug(this.declaredClass + ": adminReport --> entry.");            
                var doAdminDW = function() {
                    var adminViewer = new com.ibm.rqm.reports.web.ui.internal.view.admin.ReportsAdmin();
					var browserTitle = Constants.getMessage("labelAdminDW");
                    var view = this._addPage({
                        name: Constants.getMessage("labelAdminDW"),
                        content: adminViewer.domNode,
                        closable: true,
						browserTitle: browserTitle
                    });        
                }
                this._loadClassAsync("com.ibm.rqm.reports.web.ui.internal.view.admin.ReportsAdmin", doAdminDW);
            },
			
			/*
			 * Internal
			 */
			
	        //TODO move this into a utility
	        _abbreviate: function(label) {
	            if (dojo.isString(label) && label.length > MAX_TAB_LABEL_LENGTH) {
	                label = label.substring(0, MAX_TAB_LABEL_LENGTH);
	                label += "...";
	            }       
				return label;    
	        }
			
            /* TODO implement this - requires changes to ActionBarEntry, MenuPopup
            _addRecent: function(name, callback, options) {
                //add recent to list, 
                var link = {
                    name: name,
                    callback: callback,
                    options: options
                }
                if (this._recent.length > 0) {
                    this._recent.push(link);
                    if (this._recent.length > MAX_RECENT_REPORTS) {
                        this._recent.splice(0, (this._recent.length - MAX_RECENT_REPORTS));
                    }
                }
                //show recent
                if (this._recentDiv) {
                    dojox.data.dom.removeChildren(this._recentDiv);
                } else {
                    this._addMenuSeparator();
                }
                //show links
                for (var i = 0; i < this._recent.length; i++) {
                    var link = this._recent[i];
                    this._recentDiv = this._addMenuEntry(link.name, link.callback, false, link.options);
                }
                                
            },
            */						
		}
	);
}
)();
