/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
console.debug("Loading com.ibm.rqm.planning.web.ui.internal.view.actionbarentries.RequirementsActionBarEntry");
dojo.provide("com.ibm.rqm.planning.web.ui.internal.view.actionbarentries.RequirementsActionBarEntry");

dojo.require("com.ibm.team.repository.web.client.session.Session");
dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");

dojo.require("com.ibm.asq.common.web.client.internal.PermissionsClient");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");

dojo.require("com.ibm.rqm.planning.web.ui.internal.view.common.ActionBarEntry");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.table.TestCaseTableView");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.table.TestPlanTableView");

(function() 
{
    var Constants = com.ibm.rqm.planning.web.client.internal.Constants;
	var PermissionsClient           = com.ibm.asq.common.web.client.internal.PermissionsClient;
	var getAuthenticatedContributor	= com.ibm.team.repository.web.client.session.getAuthenticatedContributor;
	var TestCaseTableView           = com.ibm.rqm.planning.web.ui.internal.view.table.TestCaseTableView;
	var ServiceResponseHandler		= com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
	var TestPlanTableView           = com.ibm.rqm.planning.web.ui.internal.view.table.TestPlanTableView;

	dojo.declare(
		"com.ibm.rqm.planning.web.ui.internal.view.actionbarentries.RequirementsActionBarEntry",
		[com.ibm.rqm.planning.web.ui.internal.view.common.ActionBarEntry],
		{
			constructor: function()
			{
			},
	
			postCreate: function(args)
			{
			},
			
			initialize: function(args)
			{
				com.ibm.rqm.planning.web.ui.internal.view.actionbarentries.RequirementsActionBarEntry.superclass.initialize.call(this, args);
				var reqPermission = PermissionsClient.getStoredPermission(PermissionsClient.OP_REQ_WORKITEM);
                if (!reqPermission || reqPermission.create) {
					this._addNonDispatchableMenuEntry(Constants.getMessage("labelCreateRequirement"), dojo.hitch(this, "_onClickCreateRequirement"), false, null);
					this._addMenuSeparator();
                    this._addMenuEntry(Constants.getMessage("labelLaunchReqmtTool"), dojo.hitch(this, "_onClickLaunchRequirementTool"), false, {
                        'subAction': "importRequirements"
                    });
					this._addMenuSeparator();
				}
				this._addMenuEntry(Constants.getMessage("labelAllReqmt"), dojo.hitch(this, "_onClickAllRequirements"), false, {'subAction':"allRequirements"});
				if(this.actionDispatcher) {
                    this.actionDispatcher.registerDispatchAction("viewAssociatedTestCases", dojo.hitch(this, "viewAssociatedTestCases"));
					this.actionDispatcher.registerDispatchAction("viewAssociatedTestPlans", dojo.hitch(this, "viewAssociatedTestPlans"));
                }
			},
			
			_onClickCreateRequirement: function()
			{
				window.location.hash = "action=com.ibm.team.workitem.newWorkItem&type=requirement";
			},
			
			_onClickAllRequirements: function()
            {
				net.jazz.ajax.core.internal.loader.load_async("com.ibm.rqm.requirement.web.client.internal.requirement.RequirementWorkItemClient", function(){});
                net.jazz.ajax.core.internal.loader.load_async("com.ibm.rqm.requirement.web.ui.internal.view.table.RequirementTableView", dojo.hitch(this, "_loadRequirements", Constants.getMessage("labelAllReqmt")));
            },            

            _loadRequirements: function(name, queryArgs)
            {
                queryArgs = queryArgs ? queryArgs : {};
				var actions = [];
        		actions.push({
            		label: Constants.getMessage("labelRefresh"),
            		actionHandler: dojo.hitch(this, "_refreshRequirementList"),
            		iconClass: "refresh-icon-image",
            		disabledOnReadOnly: true
        		});
				actions.push({
	                label: Constants.getMessage("labelAssociatedTestPlans"),
	                actionHandler: dojo.hitch(this, "_handleFindAssociatedTestPlan"),
	                iconClass: "tplans-w-requirmt-icon-image",
	                disabledOnReadOnly: true
            	});
				actions.push({
	                label: Constants.getMessage("labelAssociatedTestCases"),
	                actionHandler: dojo.hitch(this, "_handleFindAssociatedTestCase"),
	                iconClass: "tcases-w-requirmt-icon-image",
	                disabledOnReadOnly: true
            	});
                var tableViewArgs = {
					queryName: name,
                    requirements: [],
                    showInitLoadProgress: true,
					actions: actions
                }
	            var list = new com.ibm.rqm.requirement.web.ui.internal.view.table.ExtRequirementTableView(tableViewArgs);
				list.setInProgress(Constants.getMessage("msgQueryTableList", name));
				var browserTitle = Constants.getMessage("labelRequirements") + Constants.getMessage("labelColen") + " " + Constants.getMessage("labelAllView");
				this._addPage( {name: name, content: list.domNode, closable: true, browserTitle:browserTitle});
				
                var self = this;
                var handler = {
                    success: function(requirements) {
						list.refresh(requirements ? requirements : []);
						list.stopInProgress();
                    },
                    error: function(e) {
                        self._error(e);
                    }
                }
                
                var responseHandler = new ServiceResponseHandler(handler, "success", "error");          
                com.ibm.rqm.requirement.web.client.internal.requirement.RequirementWorkItemClient.getRequirementWorkItemDTOs(responseHandler, queryArgs);             
            }, 
			
			_refreshRequirementList: function(tableView){
            	var self = this;
            	var handler = {
                	success: function(requirements){
                    	if (tableView && requirements) {
                        	tableView.refresh(requirements);
                    	}
                	},
                	error: function(e){
                    	self._error(e);
                	}
           		}
            
           		var responseHandler = new ServiceResponseHandler(handler, "success", "error");
            	com.ibm.rqm.requirement.web.client.internal.requirement.RequirementWorkItemClient.getRequirementWorkItemDTOs(responseHandler, {});
        	},
			
			_handleFindAssociatedTestPlan: function(tableView) {
				var selectedReqs = tableView.getSelectedRows();
				if(!selectedReqs || selectedReqs.length != 1) {
					return;
				}
				var selectedReq = selectedReqs[0];
				var args = {};
				args.subAction = "viewAssociatedTestPlans";
				args.itemId = selectedReq.itemId;
				args.id = selectedReq.id;
				this._routeAction(args);
            }, 
			
			viewAssociatedTestPlans: function(args) {
				var queryArgs = {reqWorkItemUUID : args.itemId};
				var name = Constants.getMessage("labelAssociatedTestPlansTitle") + args.id;
				var tableViewArgs = {
                    plans: [], 
                    queryName: name
                }
                
	            var list = new TestPlanTableView(tableViewArgs);
				list.setInProgress(Constants.getMessage("msgQueryTableList", name));
                var pageName = name; 
				this._addPage( {name: pageName, content: list, closable: true});
				
                var self = this;
                var handler = {
                    success: function(plans) {
                        list.refresh(plans ? plans : []);
						list.stopInProgress();
                    },
                    error: function(e) {
                        self._error(e);
                    }
                }
                
                var responseHandler = new ServiceResponseHandler(handler, "success", "error");          
                com.ibm.rqm.requirement.web.client.internal.requirement.RequirementWorkItemClient.getTestPlansByRequirement(responseHandler, queryArgs);             
			},
            
			_handleFindAssociatedTestCase: function(tableView) {
				var selectedReqs = tableView.getSelectedRows();
				if(!selectedReqs || selectedReqs.length != 1) {
					return;
				}
				var selectedReq = selectedReqs[0];
				var args = {};
				args.subAction = "viewAssociatedTestCases";
				args.itemId = selectedReq.itemId;
				args.id = selectedReq.id;
				this._routeAction(args);
            }, 
			
			viewAssociatedTestCases: function(args) {
				var queryArgs = {reqWorkItemUUID : args.itemId};
				if (args.testPlanItemId) {
					queryArgs.testPlanItemId = args.testPlanItemId;
				}
				var name = Constants.getMessage("labelAssociatedTestCasesTitle") + args.id;
				var tableViewArgs = {
                    testCases: [], 
                    queryName: name
                }
                
	            var list = new TestCaseTableView(tableViewArgs);
				list.setInProgress(Constants.getMessage("msgQueryTableList", name));
                var pageName = name; 
				this._addPage( {name: pageName, content: list, closable: true});
				
                var self = this;
                var handler = {
                    success: function(cases) {
						list.refresh(cases ? cases : []);
						list.stopInProgress();
                    },
                    error: function(e) {
                        self._error(e);
                    }
                }
                
                var responseHandler = new ServiceResponseHandler(handler, "success", "error");          
                com.ibm.rqm.requirement.web.client.internal.requirement.RequirementWorkItemClient.getTestCasesByRequirement(responseHandler, queryArgs);             
			},
            
			_showTestCaseList: function(cases, name)
			{
                
			},
			
			_onClickLaunchRequirementTool: function()
			{
                net.jazz.ajax.core.internal.loader.load_async("com.ibm.rqm.requirement.web.ui.internal.view.requirement.RequirementsUploader", dojo.hitch(this, "_showRequirementsUpload", false, null));
			},
			
			_showRequirementsUpload: function()
			{
                var importer = new com.ibm.rqm.requirement.web.ui.internal.view.requirement.RequirementsUploader({
					title: Constants.getMessage("labelUploadRequirements"),
					artifactType: "requirement",
                    contextHelpId: "rqm_import_requirements.html",
                    cshelpLabel: Constants.getMessage("labelImportReqHelp")
				});
				var browserTitle = Constants.getMessage("labelRequirements") + Constants.getMessage("labelColen") + " " + Constants.getMessage("labelImport");
				this._addPage( {name: Constants.getMessage("labelUploadRequirements"), content: importer, closable: true, browserTitle:browserTitle});
			}
			
		}
	);
}
)();
