/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2009. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.planning.web.ui.internal.view.administration.QueryListsContentArea");

dojo.require("dijit.form.CheckBox");

dojo.require("com.ibm.asq.common.web.ui.internal.util.CSHelp");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.administration.AbstractPreferenceContentArea");

(function(){
var Constants = com.ibm.rqm.planning.web.client.internal.Constants;
    
dojo.declare("com.ibm.rqm.planning.web.ui.internal.view.administration.QueryListsContentArea", 
             com.ibm.rqm.planning.web.ui.internal.view.administration.AbstractPreferenceContentArea, 
{
    templateString: '<div>' +
                    '<table>' +
                    '<tr><td class="content-name"><span dojoAttachPoint="_name"></span><span dojoAttachPoint="_cshelp" style="display:none"></span></td></tr>' +
                    '<tr><td><div dojoAttachPoint="_content">' +
                    '<table>' +
                    '   <tr><td>' +
                    '       <label><input type="checkbox" dojoAttachPoint="autoRunCheckbox" dojoType="dijit.form.CheckBox" style="margin-right:4px"/>${labelAutoRun}</label>' +
                    '   </td></tr>' +
                    '   <tr><td>' +
                    '       <label><input type="checkbox" dojoAttachPoint="filterOpenCheckbox" dojoType="dijit.form.CheckBox" style="margin-right:4px"/>${labelFilterOpen}</label>' +
                    '   </td></tr>' +
                    '   <tr><td>' +
                    '       <label class="note-text">${labelNote}</label><label class="note-text">${labelArtifactListsNote}</label>' +
                    '   </td></tr>' +
                    '</table>' +
                    '</div></td></tr>' +
                    '</table>' +
                    '</div>',
    
    autoRunKey: Constants.USER_UI_CUSTOMISE_QUERYLISTS_AUTORUN_MYQUERY_CATEGORY.key,
    filterOpenKey: Constants.USER_UI_CUSTOMISE_QUERYLISTS_FILTER_INITOPEN_CATEGORY.key,
    widgetsInTemplate: true,
    
	pageTitle: Constants.getMessage("labelArtifactListQuerySettings"),
    labelAutoRun: Constants.getMessage("labelAutoRunMyQuery"),
    labelFilterOpen: Constants.getMessage("labelOpenQueryFilterSection"),
    labelAutoRunDescription: Constants.getMessage("labelAutoRunMyQueryDescription"),
    labelFilterOpenDescription: Constants.getMessage("labelOpenQueryFilterDescription"),
    labelArtifactListsNote: Constants.getMessage("labelArtifactListsNote"),
    labelNote: Constants.getMessage("labelNote"),
    
    postCreate: function(){
		// NOTE: not used. We didn't make the CS help content
		// cut off date. We need to add it later. The _cshelp content
		// node's display is turned off at this point.
		//
        this.csHelpId = "rqm_pref_artifact_lists.html";
        this.csHelpLabel = Constants.getMessage("labelActionBarHelp");
        
        this.inherited("postCreate", arguments);
        this.connect(this.autoRunCheckbox, "onChange", "onChange");
        this.connect(this.filterOpenCheckbox, "onChange", "onChange");
    },
    
    // @override for AbstractContentArea
    setName: function(){
        dojox.data.dom.removeChildren(this._name);
        this._name.appendChild(document.createTextNode(this.pageTitle));
    },
    
    // @override for AbstractPreferenceContentArea
    getValues: function(){
        return [{
            key: this.autoRunKey,
            value: this.autoRunCheckbox.checked
        },{
            key: this.filterOpenKey,
            value: this.filterOpenCheckbox.checked
        }];
    },

    // @override set the corresponding user preference for this content area
    setUserPreference: function(userPreference) {
		// flush our old preferences first, before loading
		// the new values.
		this.userPreference = [];
		
        for(var i = 0; i < userPreference.length; i++){
            if(userPreference[i].key == Constants[this.autoRunKey].key ||
               userPreference[i].key == Constants[this.filterOpenKey].key){
                this.setOldValues(userPreference[i]);
            }
        }
        this.displayUserPreference(this.getOldValues());
    },
    
    // @override
    displayUserPreference: function(userPreference){
        for(var i = 0; i < userPreference.length; i++){
            if(userPreference[i].key == this.autoRunKey) {
                this.autoRunCheckbox.setChecked(userPreference[i].value);
            }
	        if(userPreference[i].key == this.filterOpenKey) {
	            this.filterOpenCheckbox.setChecked(userPreference[i].value);
	        }
        }
    },

    setOldValues: function(userPreference) {
        this.userPreference.push(userPreference);
    },
    
    getOldValues: function(){
        return this.userPreference;
    },
    
    getDefaultValues: function(){
        var defPref = [];
        defPref.push(Constants[this.autoRunKey]);
        defPref.push(Constants[this.filterOpenKey]);
        return defPref;
    },

    // @override for AbstractPreferenceContentArea
    isHotSwitchable: function(){
        return false;
    }
});
    
})();
