/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
(function()
{	
	var ImageCache = dojo.provide("com.ibm.rqm.execution.web.ui.internal.view.common.ImageCache");

	ImageCache._BASE= "ui/internal/view/templates/common/images/";

	ImageCache._getImageUri = function(imgName)
	{
		return dojo.moduleUrl("com.ibm.rqm.execution.web", ImageCache._BASE + imgName);
	};
	
	ImageCache.getTypeIconURL = function(/* SimpleExtensionType */ type) {
		var icon = type.icon;	
		var iconImage = icon != null ? icon.substring(icon.lastIndexOf("/") + 1) : "";
		return dojo.moduleUrl("com.ibm.rqm.execution.web", ImageCache._BASE + iconImage);
	};
	
	ImageCache.CLEAR_FILTER_ENABLED     			= ImageCache._getImageUri("clear_enabld_co.gif");
	ImageCache.CLEAR_FILTER_DISABLED    			= ImageCache._getImageUri("clear_disabld_co.gif");
	ImageCache.SORT_ASC                 			= ImageCache._getImageUri("arrow-asc.gif");
	ImageCache.SORT_DSC                				= ImageCache._getImageUri("arrow-dsc.gif");
	ImageCache.REMOVE_ENABLED           			= ImageCache._getImageUri("remove-enabled.gif");
	ImageCache.REMOVE_DISABLED          			= ImageCache._getImageUri("remove-disabled.gif");
	ImageCache.EDIT          						= ImageCache._getImageUri("EditIcon.jpg");
	ImageCache.SAVE          						= ImageCache._getImageUri("save.gif");
	ImageCache.WORK_ITEM							= ImageCache._getImageUri("defect.gif");  //TODO change to the correct image, which is currently used by TEST_PLAN
	ImageCache.TEST_PLAN                			= ImageCache._getImageUri("testplan_obj.gif");
	ImageCache.TEST_GROUP               			= ImageCache._getImageUri("testcasegroup_obj.gif");
	ImageCache.TEST_CASE                			= ImageCache._getImageUri("testcase_obj.gif");
	ImageCache.TEST_SCRIPT              			= ImageCache._getImageUri("testscript_obj.gif");
	ImageCache.EWI                      			= ImageCache._getImageUri("executionwork_obj.gif");
	ImageCache.EWI_LOG                  			= ImageCache._getImageUri("ewi-log.gif");
	ImageCache.EXECUTION_ARROW          			= ImageCache._getImageUri("execution_arrow.gif");
	ImageCache.HELP                     			= ImageCache._getImageUri("help.gif");
	ImageCache.TWISTIE_OPEN             			= ImageCache._getImageUri("section-twistie-open.gif");
	ImageCache.TWISTIE_CLOSED           			= ImageCache._getImageUri("section-twistie-closed.gif");
	ImageCache.FLAG_STATUS_INCOMPLETE   			= ImageCache._getImageUri("incomplete_stat_obj.gif");
	ImageCache.FLAG_STATUS_REQ_NOT_COMP 			= ImageCache._getImageUri("reqnotcomplt_stat_obj.gif");
	ImageCache.FLAG_STATUS_DRAFT_COMP   			= ImageCache._getImageUri("compltdDraft_stat_obj.gif");
	ImageCache.FLAG_STATUS_COMPLETED    			= ImageCache._getImageUri("completed_stat_obj.gif");
	ImageCache.POP_OUT_EXECUTION_WINDOW 			= ImageCache._getImageUri("pop_out.gif");
	ImageCache.DEFECT_VIEW	 						= ImageCache._getImageUri("adddefect.gif");
	ImageCache.ATTACHMENT_VIEW						= ImageCache._getImageUri("addattachment.gif");
	ImageCache.COMMENT_VIEW 						= ImageCache._getImageUri("addcomment.gif");
	
	ImageCache.POP_OUT_EXECUTION_WINDOW_DISABLED 	= ImageCache._getImageUri("pop_out-disabled.gif");
	ImageCache.DEFECT_VIEW_DISABLED 				= ImageCache._getImageUri("adddefect-disabled.gif");
	ImageCache.ATTACHMENT_VIEW_DISABLED 			= ImageCache._getImageUri("addattachment-disabled.gif");
	ImageCache.COMMENT_VIEW_DISABLED 				= ImageCache._getImageUri("addcomment-disabled.gif");
	
	//Execution States Icons
	ImageCache.PASS_ICON							= ImageCache._getImageUri("pass_obj.gif");
	ImageCache.BLOCKED_ICON							= ImageCache._getImageUri("blocked_obj.gif");
	ImageCache.PART_BLOCKED_ICON					= ImageCache._getImageUri("partblocked.gif");
	ImageCache.INCON_ICON							= ImageCache._getImageUri("inconclusive_obj.gif");
	ImageCache.INCOMPLETE_ICON						= ImageCache._getImageUri("incomplete_obj.gif");
	ImageCache.FAIL_ICON							= ImageCache._getImageUri("fail_obj.gif");
	ImageCache.PERMFAIL_ICON                        = ImageCache._getImageUri("permfailed.gif");
	ImageCache.ERROR_ICON							= ImageCache._getImageUri("errorexecution_obj.gif");
	ImageCache.DEFFERED_ICON						= ImageCache._getImageUri("deferred.gif");
	ImageCache.ATTEMPTED_ICON						= ImageCache._getImageUri("attempted.gif");
	ImageCache.PAUSE_ICON							= ImageCache._getImageUri("pause.gif");
	ImageCache.IN_PROGRESS_ICON                     = ImageCache._getImageUri("state_inprogress.gif");
	ImageCache.RESUME_ICON							= ImageCache._getImageUri("resumescript.gif");
	
	ImageCache.ATTACHMENT							= ImageCache._getImageUri("attachment.gif");
	ImageCache.ATTACHMENT_DISABLED					= ImageCache._getImageUri("attachment-disabled.gif");
	ImageCache.DEFECT								= ImageCache._getImageUri("defect.gif");
	ImageCache.COMMENT		 						= ImageCache._getImageUri("comment.gif");
	ImageCache.COMPARE		 						= ImageCache._getImageUri("pastecompare.gif");
	ImageCache.PROGRESS_START						= ImageCache._getImageUri("progress-initial.gif");
	ImageCache.PROGRESS								= ImageCache._getImageUri("progress.gif");
	ImageCache.CONFIGURATION_ICON					= ImageCache._getImageUri("configurationIcon.gif");
	ImageCache.SEPERATOR							= ImageCache._getImageUri("seperator.gif");
	ImageCache.STEP_COMPLETED						= ImageCache._getImageUri("step_complete.gif");
	ImageCache.HEADER_ICON_EWI_RESULT				= ImageCache._getImageUri("qm_ewiresult.gif");
	ImageCache.HEADER_ICON_EWI						= ImageCache._getImageUri("qm_execworkitem.gif");
	ImageCache.DROPDOWN_ARROW						= ImageCache._getImageUri("dropdownarrow.gif");	
	ImageCache.FILE									= ImageCache._getImageUri("file.gif");
	ImageCache.FOLDER								= ImageCache._getImageUri("folder.gif");
	ImageCache.APPLY								= ImageCache._getImageUri("applyverdict-enabled.gif");
	ImageCache.APPLY_ALL							= ImageCache._getImageUri("applyallverdict-enabled.gif");
	ImageCache.APPLY_DISABLED						= ImageCache._getImageUri("applyverdict_disabled.gif");
	ImageCache.APPLY_ALL_DISABLED					= ImageCache._getImageUri("applyallverdict_disabled.gif");
	ImageCache.NOIMAGE								= ImageCache._getImageUri("spacer.gif");
	
	ImageCache.EDIT_ICON       						= ImageCache._getImageUri("edit.gif");
	
	//Request States
	ImageCache.REQ_QUEUED							= ImageCache._getImageUri("queued_obj.gif");
	ImageCache.REQ_RUNNING							= ImageCache._getImageUri("inprogress_obj.gif");
	ImageCache.REQ_CANCELLED						= ImageCache._getImageUri("cancelled_obj.gif");
	ImageCache.REQ_COMPLETED						= ImageCache._getImageUri("complete_obj.gif");
}
)();
