/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
(function()
{	
	var ImageCache = dojo.provide("com.ibm.asq.common.web.ui.internal.view.common.ImageCache");

	ImageCache._BASE = "ui/internal/view/templates/common/images/";
	ImageCache._BASE_ICON = "ui/internal/images/icons/";

    ImageCache._getIconUri = function(imgName)
    {
        return dojo.moduleUrl("com.ibm.asq.common.web", ImageCache._BASE_ICON + imgName);
    };
	
	ImageCache._getImageUri = function(imgName)
	{
		return dojo.moduleUrl("com.ibm.asq.common.web", ImageCache._BASE + imgName);
	};
	
	ImageCache.getTypeIconURL = function(/* SimpleExtensionType */ type)
	{
		var icon = type.icon;	
		var iconImage = icon != null ? icon.substring(icon.lastIndexOf("/") + 1) : "";
		return dojo.moduleUrl("com.ibm.asq.common.web", ImageCache._BASE + iconImage);
	};
	
	ImageCache.CLEAR_FILTER_ENABLED     = ImageCache._getImageUri("clear_enabld_co.gif");
	ImageCache.CLEAR_FILTER_DISABLED    = ImageCache._getImageUri("clear_disabld_co.gif");
    ImageCache.SORT                     = ImageCache._getImageUri("sort.gif");
	ImageCache.SORT_ASC                 = ImageCache._getImageUri("arrow-asc.gif");
	ImageCache.SORT_DSC                 = ImageCache._getImageUri("arrow-dsc.gif");
	ImageCache.REMOVE_ENABLED           = ImageCache._getImageUri("remove-enabled.gif");
	ImageCache.REMOVE_DISABLED          = ImageCache._getImageUri("remove-disabled.gif");
	ImageCache.EDIT          			= ImageCache._getImageUri("EditIcon.jpg");
	ImageCache.SAVE          			= ImageCache._getImageUri("save.gif");
	ImageCache.WORK_ITEM				= ImageCache._getImageUri("defect.gif");
	ImageCache.TEST_PLAN                = ImageCache._getIconUri("obj16/qm_testplan16.gif");
	ImageCache.TEST_GROUP               = ImageCache._getImageUri("testcasegroup_obj.gif");
	ImageCache.TEST_CASE                = ImageCache._getIconUri("obj16/qm_testcase16.gif");
	ImageCache.TEST_SUITE                = ImageCache._getIconUri("obj16/qm_testsuite16.gif");
	ImageCache.TEST_SCRIPT              = ImageCache._getIconUri("obj16/qm_testscript16.gif");
	ImageCache.TEMPLATE_ICON            = ImageCache._getIconUri("obj16/qm_template16.gif");
	ImageCache.EWI                      = ImageCache._getIconUri("obj16/qm_execworkitem16.gif");
	ImageCache.EWI_LOG                  = ImageCache._getImageUri("ewi-log.gif");
	ImageCache.EXECUTION_ARROW          = ImageCache._getImageUri("execution_arrow.gif");
	ImageCache.HELP                     = ImageCache._getImageUri("help.gif");
	ImageCache.TWISTIE_OPEN             = ImageCache._getImageUri("section-twistie-open.gif");
	ImageCache.TWISTIE_CLOSED           = ImageCache._getImageUri("section-twistie-closed.gif");
    ImageCache.SOLID_ARROW_OPEN         = ImageCache._getImageUri("arrow-open.gif");
    ImageCache.SOLID_ARROW_CLOSED       = ImageCache._getImageUri("arrow-closed.gif");
	ImageCache.FLAG_STATUS_INCOMPLETE   = ImageCache._getImageUri("incomplete_stat_obj.gif");
	ImageCache.FLAG_STATUS_REQ_NOT_COMP = ImageCache._getImageUri("reqnotcomplt_stat_obj.gif");
	ImageCache.FLAG_STATUS_DRAFT_COMP   = ImageCache._getImageUri("compltdDraft_stat_obj.gif");
	ImageCache.FLAG_STATUS_COMPLETED    = ImageCache._getImageUri("completed_stat_obj.gif");
	ImageCache.POP_OUT_EXECUTION_WINDOW = ImageCache._getImageUri("pop_out.gif");
	ImageCache.FILE_DEFECT 				= ImageCache._getImageUri("defect.gif");
	ImageCache.EXECUTION_WINDOW_IMG2 	= ImageCache._getImageUri("img2.gif");//VS: Still have to understand what these images will do: Place holder
	ImageCache.EXECUTION_WINDOW_IMG3 	= ImageCache._getImageUri("img3.gif");//VS: Still have to understand what these images will do: Place holder
	ImageCache.PASS_ICON				= ImageCache._getImageUri("pass.gif");
	ImageCache.FAIL_ICON				= ImageCache._getImageUri("fail.gif");
	ImageCache.INCON_ICON				= ImageCache._getImageUri("incon.gif");
	ImageCache.BLOCKED_ICON				= ImageCache._getImageUri("blocked.gif");
	ImageCache.ERROR_ICON				= ImageCache._getImageUri("error.gif");
	ImageCache.EXPAND_PLUS              = ImageCache._getImageUri("expand-plus.gif");
	ImageCache.EXPAND_MINUS             = ImageCache._getImageUri("expand-minus.gif");
    ImageCache.ATTACHMENT               = ImageCache._getImageUri("attachment.gif");
	ImageCache.ATTACH_IMAGE             = ImageCache._getImageUri("attachImage.gif");
    ImageCache.COPY_ICON                = ImageCache._getImageUri("copy.gif");
    ImageCache.PROGRESS                 = ImageCache._getImageUri("progress.gif");	
	ImageCache.VIEW_PROGRESS            = ImageCache._getImageUri("view_progress.gif");	
    ImageCache.PRIORITYLOW_ICON         = ImageCache._getImageUri("priority_low_obj.gif");
    ImageCache.PRIORITYMED_ICON         = ImageCache._getImageUri("priority_med_obj.gif");
    ImageCache.PRIORITYHIGH_ICON        = ImageCache._getImageUri("priority_high_obj.gif");	
	ImageCache.CONFIGURATION_ICON		= ImageCache._getImageUri("configurationIcon.gif");//TODO: Change to the image provided by UX once received.
	ImageCache.COLLAPSE_HOV_ICON        = ImageCache._getIconUri("elcl16/collapse_hov.gif");
	ImageCache.COLLAPSE_ICON            = ImageCache._getIconUri("elcl16/collapse.gif");
	ImageCache.EXPAND_HOV_ICON          = ImageCache._getIconUri("elcl16/expand_hov.gif");
	ImageCache.EXPAND_ICON              = ImageCache._getIconUri("elcl16/expand.gif");
	ImageCache.DELETE					= ImageCache._getIconUri("elcl16/delete.gif");
	ImageCache.DDELETE					= ImageCache._getIconUri("dlcl16/remove-disabled.gif");
	ImageCache.REFRESH_RED				= ImageCache._getIconUri("elcl16/rfs_red.gif");
	ImageCache.REFRESH_GREEN			= ImageCache._getIconUri("elcl16/rfs_green.gif");
	ImageCache.REFRESH_YELLOW			= ImageCache._getIconUri("elcl16/rfs_yellow.gif");
    ImageCache.EDIT_FIELD_ICON          = ImageCache._getIconUri("elcl16/edit_field.gif");
	ImageCache.BULK_CHANGE              = ImageCache._getIconUri("elcl16/bulkchange.gif");
	ImageCache.ADD_ICON_ENABLED         = ImageCache._getIconUri("elcl16/add.gif");
	ImageCache.ADD_ICON_DISABLED        = ImageCache._getIconUri("dlcl16/add.gif");
    ImageCache.RESTORE_ICON_ENABLED     = ImageCache._getIconUri("elcl16/restore.gif");
    ImageCache.RESTORE_ICON_DISABLED    = ImageCache._getIconUri("dlcl16/restore.gif");
	ImageCache.WARNING_ICON             = ImageCache._getIconUri("elcl16/warning.gif");
	ImageCache.CONNECTION_ICON          = ImageCache._getIconUri("elcl16/connection.gif");
	ImageCache.PAUSE_ICON				= ImageCache._getIconUri("elcl16/pause.gif");
	ImageCache.RESUME_ICON				= ImageCache._getIconUri("elcl16/resume.gif");
	ImageCache.REQ_NORMAL				= ImageCache._getIconUri("obj16/req_normal.gif");
	ImageCache.REQ_UPDATED				= ImageCache._getIconUri("obj16/req_updated.gif");
	ImageCache.REQ_REMOVED				= ImageCache._getIconUri("obj16/req_removed.gif");
	ImageCache.TESE_SUSPECT 			= ImageCache._getIconUri("obj16/case_suspect.gif");
	ImageCache.TESE_NONE_SUSPECT		= ImageCache._getIconUri("obj16/case_nonsuspect.gif");	
	ImageCache.MOVE_UP_ICON_ENABLED     = ImageCache._getIconUri("etool16/arrow-up.gif");
	ImageCache.MOVE_DOWN_ICON_ENABLED   = ImageCache._getIconUri("etool16/arrow-down.gif");
    ImageCache.DEFAULT_TEMPLATE_ICON    = ImageCache._getIconUri("etool16/defaulttemplate.gif");
	ImageCache.REQUEST                  = ImageCache._getIconUri("obj16/rtlm_request16.gif");
	ImageCache.RESERVATION              = ImageCache._getIconUri("obj16/rtlm_reserve16.gif");
	ImageCache.MACHINE                  = ImageCache._getIconUri("obj16/rtlm_machine16.gif");
	ImageCache.VIRTUALIMAGE             = ImageCache._getIconUri("obj16/rtlm_virtualimg16.gif");
	ImageCache.MACHINEGROUP             = ImageCache._getIconUri("obj16/rtlm_machinegrp16.gif");
	ImageCache.SEVERITY_BLOCKER         = ImageCache._getIconUri("obj16/sev_blocker.gif");
	ImageCache.SEVERITY_CRITICAL        = ImageCache._getIconUri("obj16/sev_critical.gif");
	ImageCache.SEVERITY_MAJOR           = ImageCache._getIconUri("obj16/sev_major.gif");
	ImageCache.SEVERITY_NORMAL          = ImageCache._getIconUri("obj16/sev_normal.gif");
	ImageCache.SEVERITY_MINOR           = ImageCache._getIconUri("obj16/sev_minor.gif");
	ImageCache.SEVERITY_UNCLASSIFIED    = ImageCache._getIconUri("obj16/sev_unclassified.gif");
	ImageCache.ARCHIVE_ICON_DISABLED	= ImageCache._getIconUri("elcl16/archive.gif");
	ImageCache.ARCHIVE_ICON_ENABLED		= ImageCache._getIconUri("elcl16/archive_hov.gif");
	ImageCache.REQT_ASSIGNED            = ImageCache._getIconUri("obj16/reqt_assigned.gif");
	ImageCache.REQT_COMPLETE            = ImageCache._getIconUri("obj16/reqt_complete.gif");
	ImageCache.REQT_DRAFT               = ImageCache._getIconUri("obj16/reqt_draft.gif");
	ImageCache.REQT_RETURNED            = ImageCache._getIconUri("obj16/reqt_returned.gif");
	ImageCache.REQT_SUBMITTED           = ImageCache._getIconUri("obj16/reqt_submitted.gif");
	ImageCache.REQT_CLOSED              = ImageCache._getIconUri("obj16/reqt_closed_obj.gif");
	ImageCache.ENGINE_AVAILABLE			= ImageCache._getImageUri("health_good.gif");
	ImageCache.ENGINE_NOTAVAILABLE		= ImageCache._getImageUri("health_bad.gif");
	ImageCache.ENGINE_NOTRESPONDED		= ImageCache._getImageUri("health_conditional.gif");
	ImageCache.NOIMAGE					= ImageCache._getImageUri("spacer.gif");
	ImageCache.BLOCKING_DEFECT			= ImageCache._getImageUri("blocking_defect.gif");
	ImageCache.NON_BLOCKING_DEFECT		= ImageCache._getImageUri("nonblocking_defect.gif");
}
)();
