/****************************ImportScriptWizardPage************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
console.debug("Loading: com.ibm.rqm.execution.web.ui.internal.view.common.ImportScriptWizardPage");
dojo.provide("com.ibm.rqm.execution.web.ui.internal.view.common.ImportScriptWizardPage");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.require("com.ibm.team.repository.web.client.session.Session");
dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");

dojo.require("com.ibm.rqm.planning.web.ui.internal.view.table.TestScriptImportTableView");
dojo.require("com.ibm.rqm.planning.web.ui.internal.util.Utility");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.rqm.planning.web.client.internal.RegistryClient");
dojo.require("com.ibm.rqm.execution.web.client.internal.execution.RemoteExecutionScriptClient");
dojo.require("com.ibm.asq.common.web.ui.internal.view.layout.ImportPageLayout");
dojo.require("com.ibm.rqm.execution.web.ui.internal.view.common.RemoteExecutionScriptEditorSection");
dojo.require("com.ibm.asq.common.web.ui.internal.util.GlobalEvents");
dojo.require("com.ibm.asq.common.web.ui.internal.util.SelectUtility");

(function() {

var ServiceResponseHandler			= com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
var getAuthenticatedContributor		= com.ibm.team.repository.web.client.session.getAuthenticatedContributor;
var Utility				   			= com.ibm.rqm.planning.web.ui.internal.util.Utility;
var RegistryClient     				= com.ibm.rqm.planning.web.client.internal.RegistryClient;
var IMPORT							= 1;
var ScriptClient 					= com.ibm.rqm.execution.web.client.internal.execution.RemoteExecutionScriptClient;
var TestScriptImportTableView    	= com.ibm.rqm.planning.web.ui.internal.view.table.TestScriptImportTableView;
var Constants                       = com.ibm.rqm.planning.web.client.internal.Constants;
var RemoteExecutionScriptSection	= com.ibm.rqm.execution.web.ui.internal.view.common.RemoteExecutionScriptEditorSection;
var GlobalEvents 					= com.ibm.asq.common.web.ui.internal.util.GlobalEvents;
var SelectUtility 					= dojo.getObject( "com.ibm.asq.common.web.ui.internal.util.SelectUtility" );

dojo.declare(
	"com.ibm.rqm.execution.web.ui.internal.view.common.ImportScriptWizardPage",
	[dijit._Widget, dijit._Templated, RemoteExecutionScriptSection],
	{
		templatePath: dojo.moduleUrl("com.ibm.rqm.execution.web", "ui/internal/view/templates/common/ImportScriptWizardPage.html"),
		labelScriptType: Constants.getMessage("labelScriptType"),
		labelImport: Constants.getMessage("labelImport"),
		
		
		constructor: function() {
		},
		
		postCreate: function() {
			this.__timer = null
			this.files=[];
			
			SelectUtility.add( this._scriptTypeSelect, new Option(Constants.getMessage("labelLoading"), "") );
			var handler= new ServiceResponseHandler(this, "_showScriptTypes", "_error");
			RegistryClient.getAllExecutionScriptTypes(handler);	
			
			//Create Header
			var header = this._createHeader();
			this.headerNode.appendChild(header.domNode);
			// context sensitive help
			this.insideScriptEditor = false;
			this._createScriptTable();
		},	
		
		setSelectedFiles: function(resource, initialPath, testPlanId, milestoneItemId){
			var fileList = resource.fileList;
			this.initialPath = initialPath;
			this.fileList = fileList;
			this._populateFileTable(fileList);
	   },
   
	   setAdapterInfo: function(arg){
			this.infoFromAdapter = arg;
			this._populateFileTable(arg.scripts);
	   },
		
		_showScriptTypes: function(types, typeName) {
			this.createBrowseSection(this._selectionArea, this._browseContainer, this._adapterContainer);
			if (types != null && types.length > 0){
				this._scriptTypes = types;
				dojox.data.dom.removeChildren(this._scriptTypeSelect);
				for (var i = 0; i < types.length; i++){
					if ( types[i].capabilities && types[i].capabilities.length > 0){
						var capabilities = types[i].capabilities
						for(var j=0;j<capabilities.length;j++){
							if(capabilities[j] == "IMPORT"){ //$non-nls
								var opt = new Option(Constants.getExtensionDisplayMessage(types[i].name), types[i].id);
								SelectUtility.add( this._scriptTypeSelect, opt );
								break;
							}
						}
						
					}
				}
			}
			dojo.connect(this._scriptTypeSelect, "onchange", this, this._updateAdpterInfo);
			this._updateAdpterInfo();
		},
		
		_updateAdpterInfo: function(){
			var types = this._scriptTypes;
			for (var i = 0; i < types.length; i++){
					if ( types[i].id == this._scriptTypeSelect.value){
						this.setScriptType(types[i]);
						this._scriptType = types[i];
						break;
					}
				}
		},
		
		getSelectorHeading: function(){
			return Constants.getMessage("labelImportScriptSelector");
		},
		
		_createScriptTable: function() {
			dojox.data.dom.removeChildren(this._filesContainer);
			this._scriptTable = new TestScriptImportTableView({showFilterBox: false, scripts: [], queryName: Constants.getMessage("labelTestScriptToImport")});
			this._filesContainer.appendChild( this._scriptTable.domNode );
			
			var params = {
				title: "",
				summary: this._selectorContainer
			}
			var container = this._createCollapsibleSection(params)
			this._section.appendChild(container.domNode);
		},
		
		_populateFileTable: function(scripts) {
			this._scripts = scripts ? scripts : [];
			this._scriptTable.endLoadingProgress();
			if(this._scripts.length > 0){
				this._importFilesButton.disabled = false;
			}
			var tableObjects = [];
			var scriptTypeId = this._scriptTypeSelect.value;
			var type = this._getScriptTypeById(scriptTypeId);
			var typeName = type != null ? type.name : "";
			for (var i = 0; i < this._scripts.length; i++){
				tableObjects.push({
               		type: scriptTypeId,
					scriptTypeName: typeName,
					id: i,
               		name: this._scripts[i].name ? this._scripts[i].name : this._scripts[i].resourceName,
					initialPath: this._scripts[i].dataStoreLocation ? null : this.initialPath,
					dataStoreLocation: this._scripts[i].dataStoreLocation ? this._scripts[i].dataStoreLocation :( this._scripts[i].resourceURN.substring(this.initialPath.length, this._scripts[i].resourceURN.length) )
				});
			}
			this._scriptTable.refresh(tableObjects);
		},
		
		_getScriptTypeById: function(scriptTypeId){
			var types = this._scriptTypes
			for (var i = 0; i < types.length; i++){
					if ( types[i].capabilities && types[i].capabilities.length > 0){
						var capabilities = types[i].capabilities
						for(var j=0;j<capabilities.length;j++){
							if(capabilities[j] == "IMPORT" && types[i].id == scriptTypeId){ //$non-nls
								return types[i];
							}
						}
						
					}
				}
			return null;	
		},
		
		_handleImportFiles: function(e){
			this.importFileList = this._scriptTable.getScripts();
			if(!this.importFileList.length > 0){
				alert(Constants.getMessage("msgSelectScriptToImport"));
				return;
			}
			this.files = [];
			this._importFilesButton.disabled = true;
			this.importedFilesCount = 0;
			this.failedImportFilesCount = 0;
			
			this.fileCounter = 0;
			
			for(var i=0;i< this.importFileList.length;i++){				
				var scriptObj = {
					description: "",
					newScript: true,
					supportUniqueName: true,
					ownerId: getAuthenticatedContributor().itemId
				};
				var responseHandler = new ServiceResponseHandler(this, "_checkCompletion", "_creationError");
				this.onSave(responseHandler, scriptObj);
				this.fileCounter++;
			}
		},
		
		_checkCompletion: function(testScript){
			this.importedFilesCount++;
			this.files.push(testScript)
		
			var fileCount = this.importedFilesCount + this.failedImportFilesCount;
			if(fileCount === this.importFileList.length){
				if(this.failedImportFilesCount > 0)
					alert(Constants.getMessage("msgExistScriptsExecution", this.failedImportFilesCount))
				if(this.files.length >0)
					dojo.publish(GlobalEvents.ArtifactsAdded, [Constants.TYPE_SCRIPT, this.files]);	
				parent.location= Utility.getTestScriptsURI(Constants.getMessage("labelMyTestScript"), 2);	
			}
		},
		
		_creationError: function(errorObj){
			this.failedImportFilesCount++;
			var fileCount = this.importedFilesCount + this.failedImportFilesCount;
			if(fileCount === this.importFileList.length){
				if(this.failedImportFilesCount > 0)
					alert(this.failedImportFilesCount + " scripts were not imported as they already exist")
				if(this.files.length >0)
					dojo.publish(GlobalEvents.ArtifactsAdded, [Constants.TYPE_SCRIPT, this.files]);	
				parent.location= Utility.getTestScriptsURI(Constants.getMessage("labelMyTestScript"), 2);	
			}
		},
		
		_createHeader: function() {
            var title = Constants.getMessage("labelImportTestScript");
			var args = {
                title: title,
				contextHelpId:"rqm_import_test_scripts.html"
            }
            this._header = new com.ibm.asq.common.web.ui.internal.view.layout.ImportPageLayout(args);            
			this._header.setCSHelpButtonLabel(Constants.getMessage("labelImportTestScriptCSHelp"));
            this._header.showContentArea(false);
			
			this._importFilesButton = this._header.getImportButton();
            this._header.onImport = dojo.hitch(this, "_handleImportFiles");
            return this._header;          
        }, 
		
		validate: function(){
			return true;
			
		},
	
		getProperties: function(){
			return [];
		},
		
		getAttributes: function(){
			var args = {};
			if(this.browserUsage  == true){
				args.managedByAdapter = false;
				var initialPath = this.importFileList[this.fileCounter].initialPath;
				args.sharePrefix = initialPath;
				var relPath = this.importFileList[this.fileCounter].dataStoreLocation;
				args.relativePath = relPath;
				this.absolutePath = this.initialPath +this.importFileList[this.fileCounter].dataStoreLocation
			}else if(this.adapterUsage == true){
				args.managedByAdapter = true;
				args.adapterId = this.infoFromAdapter.selectedAdapter.id;
				//if(this.getAppendFile()){
				//	args.fullPath = this.importFileList[this.fileCounter].dataStoreLocation+this.getFileSeperater()+ this.importFileList[this.fileCounter].name;
				//}else{
				//	args.fullPath = this.importFileList[this.fileCounter].dataStoreLocation;
				//}
				args.fullPath = this.importFileList[this.fileCounter].dataStoreLocation+this.getFileSeperater()+ this.importFileList[this.fileCounter].name;
			}
			//Pass in name of the script and type as attributes	
			args.name = this.importFileList[this.fileCounter].name;
			args.type = this._scriptType.name ;	
			args.state = Constants.STATETRANSITION_STATE_DRAFT;
			return args;
		},
		
		_createCollapsibleSection: function(args){
			var section = new com.ibm.asq.common.web.ui.internal.view.layout.SimpleSection({contentPaddingBottom:"20px"});
	        section.domNode.name = "first-section";
            section.titleContainerNode.style.display = "none";
			if (args.summary)
				section.containerNode.appendChild(args.summary);

		   	return section;
		},
		
		_error: function(errorObj) {
			console.error("Error: (message: '" + errorObj.message + "') in ImportScriptWizardPage#_error");
		}
	}
);
})();
