/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.planning.web.ui.internal.view.common.NavSectionGroup");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.require("com.ibm.rqm.planning.web.ui.internal.view.common.Section");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.common.ImageCache");

dojo.declare("com.ibm.rqm.planning.web.ui.internal.view.common.NavSectionGroup",
			 [dijit._Widget, dijit._Templated], 
{
	templatePath: dojo.moduleUrl("com.ibm.rqm.planning.web", "ui/internal/view/templates/common/NavSectionGroup.html"),
	
	ImageCache: com.ibm.rqm.planning.web.ui.internal.view.common.ImageCache,
	
	///////////////////////////////////////////////////////////////////////////////////
	// Initialization parameters
	
	label: null,
	sectionWidgets: null,
	open: false,
	flagStatus: 0,
	
	///////////////////////////////////////////////////////////////////////////////////
	// Attach points
	twistieImg: null,
	flagImg: null,
	labelSpan: null,
	sectionsDiv: null,
	
	///////////////////////////////////////////////////////////////////////////////////
	// Private fields
	
	///////////////////////////////////////////////////////////////////////////////////
	// Called on creation
	
	postCreate: function()
	{
		this._setDisplay(this.open);
		
		this.labelSpan.innerHTML= this.label;		
		for (var i= 0; i < this.sectionWidgets.length; i++) {
			this.sectionsDiv.appendChild(this.sectionWidgets[i].domNode);
		}
	},
	
	///////////////////////////////////////////////////////////////////////////////////
	// API
	
	collapse: function() {
		this._setDisplay(false);
	},
	
	expand: function() {
		this._setDisplay(true);
	},
	
	setExpression: function(/* ExpressionDTO[] */ expressions) {
		var hasExpression= false;
		for (var i= 0; i < this.sectionWidgets.length; i++) {
			hasExpression|= this.sectionWidgets[i].setExpression(expressions);
		}
		this._setDisplay(hasExpression);
	},
	
	///////////////////////////////////////////////////////////////////////////////////
	// Helpers
	
	_updateTwistie: function() {
		this.twistieImg.src= this._isVisible() ? this.ImageCache.TWISTIE_OPEN : this.ImageCache.TWISTIE_CLOSED;
	},
	
	_isVisible: function() {
		return this.sectionsDiv.style.display != "none"; //dojo.html.isDisplayed(this.sectionsDiv);
	},
	
	_setDisplay: function(show) {
		this.sectionsDiv.style.display = show ? "inline" : "none";
//		dojo.setDisplay(this.sectionsDiv, show);
		this._updateTwistie();
	},
		
	///////////////////////////////////////////////////////////////////////////////////
	// Event handlers
	
	onToggle: function(e) {
		e.preventDefault();
		this.sectionsDiv.style.display = (this.sectionsDiv.style.display == "none") ? "inline" : "none"; 
		this._updateTwistie();
	}
	
});
	
