/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.asq.common.web.ui.internal.view.common.SimpleClearCollapsibleArea");

dojo.require("dijit.TitlePane");
dojo.require("com.ibm.asq.common.web.ui.internal.view.common.ImageCache");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.InlineEditor");
dojo.require("com.ibm.asq.common.web.ui.internal.util.MessageUtil");

(function() {

var ImageCache = com.ibm.asq.common.web.ui.internal.view.common.ImageCache;

dojo.declare("com.ibm.asq.common.web.ui.internal.view.common.SimpleClearCollapsibleArea",
             dijit.TitlePane,
{
    templateString: '<div id="${id}" dojoAttachPoint="domNode" tabindex="-1" class="com-ibm-asq-common-web-ui-simple-clear-collapsible-area">' +
                    '  <div dojoAttachEvent="onclick:toggle,onkeypress:_onTitleKey" tabindex="0" waiRole="button"' +
                    '       dojoAttachPoint="focusNode" class="simple-clear-header">' +
                    '    <span class="toggle-image"' +
                    '      <img tabindex="0" dojoAttachPoint="toggleImage"/>' +
                    '    </span>' +
                    '    <span dojoAttachPoint="titleNode, headerNode" class="title"></span>' +
                    '  </div>' +
                    '  <div dojoAttachPoint="hideNode">' +
                    '    <div dojoAttachPoint="wipeNode">' +
                    '      <div class="content-area" dojoAttachPoint="containerNode" waiRole="region" tabindex="-1"></div>' +
                    '    </div>' +
                    '  </div>' +
                    '</div>',

    open: false,
    
    postCreate: function() {
        this.arrowNodeInner = document.createElement("div");
        this.inherited("postCreate", arguments);
        
        this._updateToggleImage();
        this.toggleImage.style.visibility = "hidden";

        this.focusNode.onmouseover = dojo.hitch(this, "_mouseOver");
        this.focusNode.onmouseout = dojo.hitch(this, "_mouseOut");
        this.focusNode.onfocus = dojo.hitch(this, "_mouseOver");
        this.focusNode.onblur = dojo.hitch(this, "_mouseOut");
    },
    
    _mouseOver: function() {
        dojo.removeClass(this.focusNode, "simple-clear-header");
        dojo.addClass(this.focusNode, "simple-highlighted-header");
        this.toggleImage.style.visibility = "visible";
    },
    
    _mouseOut: function() {
        dojo.removeClass(this.focusNode, "simple-highlighted-header");
        dojo.addClass(this.focusNode, "simple-clear-header");
        this.toggleImage.style.visibility = "hidden";
    },
    
    _updateToggleImage: function() {
        if (this.open) {
            this.toggleImage.src = ImageCache.COLLAPSE_HOV_ICON;
            this.toggleImage.title = MessageUtil.getMessage(MessageBundle.COMMON, "actionLabel_Collapse");
        }
        else {
            this.toggleImage.src = ImageCache.EXPAND_HOV_ICON;
            this.toggleImage.title = MessageUtil.getMessage(MessageBundle.COMMON, "actionLabel_Expand");
        }
    },
    
    toggle: function() {
        this.inherited("toggle", arguments);
        this._updateToggleImage();
    }
});

})();
