/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.asq.common.web.ui.internal.view.common.SimpleCollapsibleArea");

dojo.require("dijit.TitlePane");

(function() 
{
dojo.declare("com.ibm.asq.common.web.ui.internal.view.common.SimpleCollapsibleArea",
dijit.TitlePane,
{
    templateString: '<div id="${id}" dojoAttachPoint="domNode" class="com-ibm-asq-common-web-ui-simple-collapsible-area">' +
                    '  <div dojoAttachEvent="onclick:toggle,onkeypress:_onTitleKey" tabindex="0" waiRole="button" class="header" dojoAttachPoint="focusNode">' +
                    '    <div class="header-left">' +
                    '      <div class="header-right">' +
                    '        <div class="header-mid">' +
                    '          <div class="title-container">' +
                    '            <span dojoAttachPoint="titleNode" class="title" style="white-space:nowrap"></span>' +
                    '          </div>' +
                    '        </div>' +
                    '      </div>' +
                    '    </div>' +
                    '  </div>' +
                    '  <div class="content-outer-container" dojoAttachPoint="hideNode">' +
                    '    <div class="content-inner-container" dojoAttachPoint="wipeNode">' +
                    '      <div class="content-area" dojoAttachPoint="containerNode,contentNode" waiRole="region" tabindex="-1"></div>' +
                    '      <div class="content-bottom-container">' +
                    '        <div class="content-bottom-left">' +
                    '          <div class="content-bottom-right">' +
                    '            <div class="content-bottom-mid">' +
                    '            </div>' +
                    '          </div>' +
                    '        </div>' +
                    '      </div>' +
                    '    </div>' +
                    '  </div>' +
                    '</div>',

    collapsible: true, // yes, we allow setting it not collapsible
    
    postCreate: function() {
        this.arrowNodeInner = document.createElement("div");
        this.inherited('postCreate', arguments);
    },
    
    _onTitleClick: function() {
        this.toggle();
    },

    toggle: function(){
        /* override the method to allow non-collapsible pane */
        if (this.collapsible) {
            this.inherited('toggle', arguments);
        }
    }

});

dojo.declare("com.ibm.asq.common.web.ui.internal.view.common.ActionLinkCollapsibleArea",
com.ibm.asq.common.web.ui.internal.view.common.SimpleCollapsibleArea,
{
    _actionListNode: null,

	
	_varWidth: "", 
	
	_times: 0,
	
    postCreate: function() {
        this.inherited('postCreate', arguments);
        this._actionListNode = document.createElement("ul");
        dojo.addClass(this._actionListNode, "com-ibm-asq-common-web-ui-view-action-link-button");
        this.containerNode.appendChild(this._actionListNode);
		
		_scrollHandle = dojo.connect(this.domNode, "onscroll", dojo.hitch(this, "_onscroll"));
    },
    
	_onscroll: function(){
		if (this._times == 0 ){
			_varWidth = this.domNode.scrollWidth + "px";
			this._times=1;
		}
	
		var i=0;
		for ( i=0; i<this.domNode.childNodes.length; i++)
		{
			var ele = this.domNode.childNodes[i];
		    if(ele.tagName == "DIV"){
				ele.style.width = _varWidth;
			}
		} 
	},
	
    addActionLink: function(handler, label, callbackData, /* optional */ iconClass) {
        var arg = {
            label: label,
            onClick: function() {
                this.clientCallback(this.callbackData);
            },
            'class': "com-ibm-asq-common-web-ui-action-link-button"
        };
        
        if (iconClass) {
            arg['iconClass'] = iconClass;
        }
        var button = new dijit.form.Button(arg);
        
        // store the client callback and data into the button
        button.clientCallback = handler;
        button.callbackData = callbackData;
        
        var item = document.createElement("li");
        item.appendChild(button.domNode);

        this._actionListNode.appendChild(button.domNode);
        return button;
    },
	
	getActionsNode: function() {
		return this._actionListNode;
	}
});
})();
