/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
console.debug("Loading: com.ibm.rqm.configuration.web.ui.internal.view.configuration.GenerateCFGConfigurationPanel");
dojo.provide("com.ibm.rqm.configuration.web.ui.internal.view.configuration.GenerateCFGConfigurationPanel");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.require("com.ibm.rqm.configuration.web.ui.internal.view.configuration.ConfigurationPanel");
dojo.require("com.ibm.rqm.configuration.web.ui.internal.view.configuration.GenerateCFGOverviewSection");
dojo.require("com.ibm.rqm.configuration.web.ui.internal.view.configuration.GenerateCFGEnvironmentSection");
dojo.require("com.ibm.rqm.configuration.web.ui.internal.view.configuration.PropertiesSection");

dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");

dojo.require("com.ibm.rqm.configuration.web.util.TestConfigurationUtil");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");

(function(){
    var TestConfigurationUtil 			= com.ibm.rqm.configuration.web.util.TestConfigurationUtil;
    var GenerateCFGOverviewSection 		= com.ibm.rqm.configuration.web.ui.internal.view.configuration.GenerateCFGOverviewSection;
    var GenerateCFGEnvironmentSection 	= com.ibm.rqm.configuration.web.ui.internal.view.configuration.GenerateCFGEnvironmentSection;
	var PropertiesSection 				= com.ibm.rqm.configuration.web.ui.internal.view.configuration.PropertiesSection;
	var Constants 						= com.ibm.rqm.planning.web.client.internal.Constants;
	var AlertDialog 					= com.ibm.asq.common.web.ui.internal.widgets.AlertDialog;
	
    dojo.declare("com.ibm.rqm.configuration.web.ui.internal.view.configuration.GenerateCFGConfigurationPanel", [dijit._Widget, dijit._Templated, com.ibm.rqm.configuration.web.ui.internal.view.configuration.ConfigurationPanel], {
        
        constructor: function(args, frag){
            this.testPlan = args.testPlan;
        },
        
		
		//Overriden from ConfigurationPanel
		uninitialize: function(){
			this._environmentWidget.uninitialize();
		},
		
		//Overriden from ConfigurationPanel
        _initTitle: function(){
            this._title.appendChild(document.createTextNode(Constants.getMessage("labelGenerateConfigurations") + ":"));
            this._titleName.appendChild(document.createTextNode(this.testPlan.name));
			this._stepLabel3.style.display = "none";
        },
        
		//Overriden from ConfigurationPanel
        _initOverview: function(){
            dojox.data.dom.removeChildren(this._ewiOverview);
            this._overviewWidget = new GenerateCFGOverviewSection({
                controller: this.controller,
                testPlan: this.testPlan ? this.testPlan : null
            });
            this._ewiOverview.appendChild(this._overviewWidget.domNode);
        },
		
		//Overriden from ConfigurationPanel
		_initTCG: function(){
            dojox.data.dom.removeChildren(this._tCG);
            this._tcgWidget = new PropertiesSection({
                controller: this.controller,
				showWorkItemDistribution: false
            });
            this._tCG.appendChild(this._tcgWidget.domNode);
        },
        
        //Overriden from ConfigurationPanel
        _initEnvironment: function(){
            var self = this;
            var disableCoverageOptions = function(){
                self._tcgWidget.disableSelectOptions("coverage", [1]);
            };
            var enableCoverageOptions = function(number){
                self._tcgWidget.enableSelectOptions("coverage", number);
            };
            dojox.data.dom.removeChildren(this._environment);
            this._environmentWidget = new GenerateCFGEnvironmentSection({
                controller: this.controller,
                disableCoverageOptions: disableCoverageOptions,
                enableCoverageOptions: enableCoverageOptions,
				enableNextButton: dojo.hitch(this, "enableNextButton"),
				testPlan: this.testPlan ? this.testPlan : null
            });
            this._environment.appendChild(this._environmentWidget.domNode);
			this._environmentWidget.initialize();
        },
        
        //Overriden from ConfigurationPanel
        onNext: function(){
//            if (this._environmentWidget.getResourceInfo().length == 0) {
//                alert("Please select one or more environment attributes!");
//                return;
//            }
//                else 
                    if (this._environmentWidget.advancePropertiesPopupWindow && this._environmentWidget.checkEnviromentAndProperties()) {
                        var alertDialog = new AlertDialog({
			                'message': Constants.getMessage("msgConfilictConfiguration")
			            });
			            alertDialog.setSecondaryTitle("");
			            alertDialog.open();
                        return;
                    }
                    else {
                        var params = {
                            interactionLevel: this._tcgWidget.getCoverage(),
                            coverageTarget: "100",
                            executionEnvTypes: this._environmentWidget.getExecutionEnvTypes(),
                            resourceInfomation: this._environmentWidget.getResourceInfomation(),
                            weightsJsonString: this._environmentWidget.getWeightings(),
                            excludes: this._environmentWidget.getExclusions(),
                            includes: this._environmentWidget.getInclusions(),
							testPlan: this.testPlan
                        };
                        
                        this.controller.doNext(params);
                    }
        }
    });
    
})();
