/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
console.debug("Loading: com.ibm.rqm.configuration.web.ui.internal.view.configuration.GenerateEWIEnvironmentSection");
dojo.provide("com.ibm.rqm.configuration.web.ui.internal.view.configuration.GenerateEWIEnvironmentSection");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dojox.data.dom");

dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");

dojo.require("com.ibm.rqm.configuration.web.ui.internal.view.configuration.EnvironmentSection");
dojo.require("com.ibm.rqm.configuration.web.ui.internal.view.table.ConfigurationTableView");
dojo.require("com.ibm.rqm.configuration.web.client.internal.configuration.WHITCHClient");
dojo.require("com.ibm.rational.test.lm.web.client.internal.config");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.common.ContentArea");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.common.MultiTabContainer");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.rqm.planning.web.client.internal.planning.PlanningPageClient");
dojo.require("com.ibm.rqm.configuration.web.util.TestConfigurationUtil");
dojo.require("com.ibm.asq.common.web.ui.internal.util.SelectUtility");

(function(){
    
	var ServiceResponseHandler = com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
	var MultiTabContainer = com.ibm.rqm.planning.web.ui.internal.view.common.MultiTabContainer;
	var ContentAreas = com.ibm.rqm.planning.web.ui.internal.view.common.ContentArea;
	var ConfigurationTableView = com.ibm.rqm.configuration.web.ui.internal.view.table.ConfigurationTableView;
	var WHITCHClient = com.ibm.rqm.configuration.web.client.internal.configuration.WHITCHClient;
	var Constants = com.ibm.rqm.planning.web.client.internal.Constants;
	var TestConfigurationUtil = com.ibm.rqm.configuration.web.util.TestConfigurationUtil;
	var SelectUtility = com.ibm.asq.common.web.ui.internal.util.SelectUtility;
	var PlanningPageClient = com.ibm.rqm.planning.web.client.internal.planning.PlanningPageClient;
	
    dojo.declare("com.ibm.rqm.configuration.web.ui.internal.view.configuration.GenerateEWIEnvironmentSection", [dijit._Widget, dijit._Templated, com.ibm.rqm.configuration.web.ui.internal.view.configuration.EnvironmentSection], {
        templateString: '<div class="com-ibm-rqm-configuration-web-conf">' +
						'<div class="head-title"><span dojoAttachPoint="_environmentLabel">${labelEnvironment}</span><span dojoAttachPoint="_cshelp"></span></div>' +
						'<div dojoAttachPoint="_tabContainer">' +
						'</div>' +
						'<div dojoAttachPoint="_environmentlist">' + 
						'   <div><span style="color:gray" dojoAttachPoint="_inlineHelp">${labelEnvironmentInlineHelp}</span></div>' +
						'   <div dojoAttachPoint="_tables"></div>' +
						'   <div>' +
						'   <span dojoAttachPoint="_advancedP" class="apEnable">' +
						'   </span>' +
						'   </div>' +
						'   <br>'+
						'   <br>'+
						'</div>' +
						'<div dojoAttachPoint="_configurationListContainer">' + 
						'   <div><span style="color:gray" dojoAttachPoint="_inlineHelp">${labelConfigurationListInlineHelp}</span></div>' +
						'   <table class="table" style = "width:300px">' +
						'   <tr>' +
						'   	<td width="40%" >' +
						'   		<label for="_scheduleTestPlan">${labelTestPlan}</label>'+
						'   	</td>' +
						'   	<td width="60%">' +
						'   		<select id="_scheduleTestPlan" dojoAttachPoint="_scheduleTestPlan"></select> 	' +
						'   	</td>' +
						'   </tr>' +
						'   </table>' +		
						'   <div><span dojoAttachPoint="_loadingLabel"></span></div>' +
						'   <div dojoAttachPoint="_configurationList"/>' +
						'</div>' +
						'</div>',
		
		labelEnvironment: Constants.getMessage("labelEnvironment"),
		labelEnvironmentInlineHelp: Constants.getMessage("labelEnvironmentInlineHelp", Constants.getMessage("labelTestExecutionRecords")),
		labelConfigurationListInlineHelp: Constants.getMessage("labelConfigurationListInlineHelp"),
		labelTestPlan: Constants.getMessage("labelTestPlan"),
				
        constructor: function(args){
            if (args.controller == null) {
                throw new Error("Create GenerateEWIEnvironmentSection#constructor: Missing required parameter 'args.controller'");
            }
			this.testCases = args.testCases;
			this.parentTestPlan = args.parentTestPlan;
			
			//existing configuration list
			this._existingConfigurations = [];
        },
        
        initialize: function(){
			this._initTabContainer();
			this._initConfigurationListContainer();
			this._initEnvironmentSection();
			this._initAdvancedProperties();
            if(this.parentTestPlan == null){
				this._loadCatalogEnvironment();
				this._activateTab(1);
			}
			else{
				this._loadTestPlanEnvironment(this.parentTestPlan.id);
				this._getExistingConfigurations(this.parentTestPlan.versionableItemId);
			}			
			this._reloadEnvironmentTopic = dojo.subscribe("TESTPLAN_CHANGED", this, "_reloadEnvironment");
			this._doInitScheduleTestPlan();
			//this._reloadConfigurationsTopic = dojo.subscribe("TESTPLAN_CHANGED", this, "_reloadExistingConfigurations");
        },
		
		uninitialize: function(){
			dojo.unsubscribe(this._reloadEnvironmentTopic);
			//dojo.unsubscribe(this._reloadConfigurationsTopic);
			if(this.advancePropertiesDialog && dojo.isFF){
				this.advancePropertiesDialog.close();
			}
		},
		
		//API
		getExistingConfigurations: function(){
			return this.configurationTableWidget.getSelectedConfigs();
		},
		
		_initTabContainer: function(){
			this._contentArea = new ContentAreas();
			this._contentArea.initialize({tabContainerStyle: "min-height: 100px"});
			
		    this._tabContainer.appendChild(this._contentArea.domNode);
			
			var args = {
				name: Constants.getMessage("labelReuseConfigurations"),
				noSelect: true,
				content: this._configurationListContainer
			};
			this._contentArea.addPage(args);
			
			var args = {
				name: Constants.getMessage("labelGenerateConfigurations"),
				noSelect: true,
				content: this._environmentlist
			};
			this._contentArea.addPage(args);
		},
		
		_initConfigurationListContainer: function(){
			var self = this;
			var oncheckListener = {
				context: this,
				method: function(tableViewer, rowObject, state){
					if(self.enableNextButton != null && (state == true || self.configurationTableWidget.getSelectedConfigs().length > 0)){
						self.enableNextButton(false, null);
					}else{
						self.enableNextButton(true, null);
					}
				}
			};
			this.configurationTableWidget = new ConfigurationTableView({oncheckListener: oncheckListener});
			this._configurationList.appendChild(this.configurationTableWidget.domNode);
		},
		
		_reloadExistingConfigurations: function(testPlanId, testPlanUUID){
			this._existingConfigurations = [];
			if(testPlanUUID == -1){
				this.configurationTableWidget.refresh([]);
				//this._activateTab(1);
			}else{
				this._getExistingConfigurations(testPlanUUID);
			}
		},
		
		_getExistingConfigurations: function(parentTestPlanUUID){
			var self = this;
            var handler = {
                success: function(configs){
					if(configs){
						self._loadingLabel.appendChild(document.createTextNode(Constants.getMessage("labelLoading")));
						self._retrieveConfigurationDetails(configs);
						self._activateTab(0);
					}else{
						self._activateTab(1);
					}
                },
                error: function(e){
					console.debug(e);
                }
            }
            var responseHandler = new ServiceResponseHandler(handler, "success", "error");
            var params = {
                testsPlanUUID: parentTestPlanUUID
            };
            WHITCHClient.getConfigurationsByTestPlan(responseHandler, params);
		},
		
		_displayExistingConfiguration: function(configs){
            this.configurationTableWidget.refresh(configs);
		},
		
		_demarshalConfigurationAndDisplay: function(config){
			this._demarshalConfiguration(config);
			this._displayExistingConfiguration(this._existingConfigurations);
			dojox.data.dom.removeChildren(this._loadingLabel);
		},
		
		_retrieveConfigurationDetails: function(configs){
			this.config = new com.ibm.rational.test.lm.web.client.internal.config();
			for (var i = 0; i < configs.length; i++){
				if(i < configs.length - 1){
					var responseHandler = new ServiceResponseHandler(this, "_demarshalConfiguration", "_error");
				}else{
					var responseHandler = new ServiceResponseHandler(this, "_demarshalConfigurationAndDisplay", "_error");
				}
				this.config.retrieveConfigurationWithDetails(responseHandler, configs[i]);
			}
		},
		
		_demarshalConfiguration: function(configuration){
            var catalog = new com.ibm.asq.common.web.client.internal.Catalog();
            var configur = new com.ibm.asq.common.web.client.internal._catalog.Configuration(configuration.configuration);
            var attributeIds = catalog.getDisplayTypes();
            var config = [];
            for (var i = 0; i < attributeIds.length; i++) {
				var value = configur.getValue(attributeIds[i]);
                if (value) {
					config.push({
						key: attributeIds[i],
						value: value
					});
					
				}
            }
			config.config = configuration;
			config.isExist = true;
            this._existingConfigurations.push(config);
        },
		
		_activateTab: function(tabIndex){
			if(!this._contentArea){
				console.error("this._contentArea has not been initialized.");
				return;
			}
			var tabs = this._contentArea._tabs.getChildren();
			if(tabIndex >= tabs.length){
				throw new Error("The specified tabIndex " + tabIndex + " is out of range.");
			}else{
				this._contentArea._tabs.selectChild(tabs[tabIndex]);
			}
		},
		
		_doInitScheduleTestPlan: function(){
			var self = this;
	        dojo.connect(this._scheduleTestPlan, "onchange", function(e){
	            self._reloadExistingConfigurations(e.currentTarget.options[e.currentTarget.selectedIndex].id, 
					e.currentTarget.options[e.currentTarget.selectedIndex].value);
	        });
	        var handler = {
	            success: function(testPlans){
	                dojox.data.dom.removeChildren(self._scheduleTestPlan);
	                self._scheduleTestPlan.disabled = false;
	                var option = new Option(Constants.getMessage("labelUnassigned"), TestConfigurationUtil.NO_ASSOCIATED_TEST_PLAN);
	                option.id = TestConfigurationUtil.NO_ASSOCIATED_TEST_PLAN;
					SelectUtility.add( self._scheduleTestPlan, option );
	                if (dojo.isArray(testPlans) && testPlans.length > 0) {
	                    for (var i = 0; i < testPlans.length; i++) {
	                        var option = new Option(testPlans[i].name, testPlans[i].versionableItemId);
	                        option.id = testPlans[i].id;
							//when there is a specified parent test plan, disable this selection
	                        if (self.parentTestPlan!=null && self.parentTestPlan.versionableItemId == option.value) {
	                            option.selected = true;
	                            self._scheduleTestPlan.disabled = true;
	                        }
							SelectUtility.add( self._scheduleTestPlan, option );
	                    }
	                }
	            },
	            error: function(e){
	                console.debug(e);
	            }
	        };
	        var responseHandler = new ServiceResponseHandler(handler, "success", "error");
	        com.ibm.rqm.planning.web.client.internal.planning.PlanningPageClient.getRelatedTestPlanByCase(responseHandler, this.testCases[0].versionableItemId);

    	},
		
		_reloadEnvironment: function(id){
			this.inherited("_reloadEnvironment", arguments);
			this._activateTab(1);
			
		}
		
		
    });
    
})();
