/***************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
console.debug("Loading com.ibm.rqm.planning.web.ui.internal.view.construction.ExecutionPopUp");
dojo.provide("com.ibm.rqm.planning.web.ui.internal.view.construction.ExecutionPopUp");

dojo.require("dojox.data.dom");
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dijit.Tooltip");
dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");
dojo.require("com.ibm.rqm.planning.web.client.internal.planning.PlanningPageClient");
dojo.require("com.ibm.rqm.planning.web.client.internal.construction.TestCaseClient");
dojo.require("com.ibm.rqm.planning.web.client.internal.construction.TestScriptClient");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.team.repository.web.client.session.Session");
dojo.require("com.ibm.rqm.planning.web.ui.internal.util.Utility");
dojo.require("com.ibm.asq.common.web.ui.internal.util.SelectUtility");
dojo.require("com.ibm.asq.common.web.ui.internal.view.common.ImageCache");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.Button");
(function(){
   
	var ServiceResponseHandler					= com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
    var PlanningClient 							= com.ibm.rqm.planning.web.client.internal.planning.PlanningPageClient;
	var Constants 								= com.ibm.rqm.planning.web.client.internal.Constants;
	var TestCaseClient         					= com.ibm.rqm.planning.web.client.internal.construction.TestCaseClient;
	var getAuthenticatedContributor				= com.ibm.team.repository.web.client.session.getAuthenticatedContributor;
	var Utility									= com.ibm.rqm.planning.web.ui.internal.util.Utility;
	var SelectUtility 							= dojo.getObject( "com.ibm.asq.common.web.ui.internal.util.SelectUtility" );
	var TestScriptClient						= com.ibm.rqm.planning.web.client.internal.construction.TestScriptClient;
	var CommonImageCache						= com.ibm.asq.common.web.ui.internal.view.common.ImageCache;
	var Button									= com.ibm.asq.common.web.ui.internal.widgets.Button;
	
	dojo.declare("com.ibm.rqm.planning.web.ui.internal.view.construction.ExecutionPopUp", [dijit._Widget, dijit._Templated], {
       templateString: "<div class=\"com-ibm-rqm-construction-newitem-popup\">" +
                        	"<div dojoAttachPoint=\"_topMessageNode\" width=\"100%\"></div>" +
							"<table dojoAttachPoint=\"_formNode\" width=\"100%\">" +
                        		"<tr>" +
	                        		"<td width=\"80%\" dojoAttachPoint=\"_leftColumn\">" +
	                        			"<table width=\"100%\">" +
	                        				"<tr dojoAttachPoint=\"_EWINode\">" +
	                        					"<td width=\"150px\"><span>${labelWorkitem}<span></td>"+ 
	                        					"<td><select dojoAttachPoint=\"_EWIValue\" class=\"newitem-popup-select\" dojoAttachEvent=\"onchange: _handleEWIChange\"></select></td>" +
												"<td></td>" +
	                        				"</tr>" + 
	                        				"<tr dojoAttachPoint=\"_ConfigNode\">" +
	                        					"<td width=\"150px\"><span>${labelConfig}<span></td>" + 
	                        					"<td><select dojoAttachPoint=\"_ConfigValue\" class=\"newitem-popup-select\"></select></td>" +
												"<td></td>" +
	                        				"</tr>" +
											"<tr dojoAttachPoint=\"_TestScriptNode\">" +
	                        					"<td width=\"150px\"><span>${labelTestScript}<span></td>" +    
	                        					"<td><select dojoAttachPoint=\"_TSValue\" class=\"newitem-popup-select\" dojoAttachEvent=\"onchange: _handleScriptChange\"></selcet></td>" +
												"<td></td>" +
	                        				"</tr>" + 
	                        				"<tr dojoAttachPoint=\"_Machine\">" +
	                        					"<td width=\"150px\"><span>${labelMachine}<span></td>" +
												"<td class=\"bordercell\"><span dojoAttachPoint=\"_machineName\"></span></td>" +
												"<td><img dojoAttachPoint=\"_adapterStatusImg\"></img></td>" +
												"<td dojoAttachPoint=\"_changeSpan\"><span dojoAttachPoint=\"_machineChangeButton\"</span></td>" + 
	                        				"</tr>" + 
											"<tr><td colspan =3><br></td></tr><tr>"+
											"<td colspan=3><input type=\"checkbox\" dojoAttachPoint=\"_checkValue\" dojoAttachEvent=\"onclick: _checkValueChange\"></input>"+
												"<span style='padding-left:5px;'>${labelAssociatePlan}</span>"+
											"</td></tr>"+
											"<tr dojoAttachPoint=\"_TPNode\">" +
	                        					"<td width=\"150px\"><span>${labelTestPlan}<span></td>" + 
	                        					"<td><select dojoAttachPoint=\"_TPValue\" class=\"newitem-popup-select\" dojoAttachEvent=\"onchange: _handlePlanChange\"></select></td>" +
												"<td></td>" +
	                        				"</tr>" +   
	                        				"<tr dojoAttachPoint=\"_IterationNode\">" +
	                        					"<td width=\"150px\"><span>${labelIteration}<span></td>"+ 
	                        					"<td><select dojoAttachPoint=\"_IterationValue\" class=\"newitem-popup-select\" dojoAttachEvent=\"onchange: _handleIterationChange\"></select></td>" +
												"<td></td>" +
	                        				"</tr>" + 												
	                        			"</table>" +
	                        		"</td>" +
                        		"</tr>" +
                        	"</table><br/>" +
							"<table width=\"100%\"><tr width=\"100%\">" +
								"<td width=\"60%\" style=\"font-size: 8pt;\"><label style=\"font-weight: bold\">${labelAdapterInfo}</label><div dojoAttachPoint=\"_bottomMessageNode\"></div> </td>"+
							"</tr></table>" +                                            
                        "</div>",

		labelTestPlan: Constants.getMessage("labelTestPlan"),
		labelTestScript: Constants.getMessage("labelTestScript"),
		labelWorkitem: Constants.getMessage("labelEWIs"),
		labelConfig: Constants.getMessage("labelConfig"),
		labelMachine: Constants.getMessage("labelMachine"),
		labelOk: Constants.getMessage("labelOk"),
		labelCancel: Constants.getMessage("labelCancel"),
        labelAdapterInfo: Constants.getMessage("labelAdapterInfo"),		
		labelIteration: Constants.getMessage("labelIteration"),
		labelAssociatePlan: Constants.getMessage("labelAssociateResultsToPlan"),
		labelChange: Constants.getMessage("labelChange"),
		
		EXECUTE: 0,
		loaded: false,
		width: "500px",
		allConfigs: [],
		allEWIs: [],
		allPlans: [],
        constructor: function(){
        },
		
		postCreate: function() {
			net.jazz.ajax.core.internal.loader.load_async("com.ibm.rqm.execution.web.client.internal.execution.ExecutionClient", dojo.hitch(this, "_executionClientLoaded"));
			net.jazz.ajax.core.internal.loader.load_async("com.ibm.rqm.execution.web.ui.internal.view.table.MachineAdapterTableView", dojo.hitch(this, "_MachineTableLoaded"));
			net.jazz.ajax.core.internal.loader.load_async("com.ibm.rqm.process.web.client.internal.timebox.TimeboxClient",function(){});
		},
        
		_executionClientLoaded: function(){
			
		},
		_MachineTableLoaded: function(){
			
		},
		
		initialize: function(args){
			if(!args.testCase){
				console.error("missing required test case attribute");
				return;
			}
			this.defaultScript = args.defaultScript;
			var responseHandler = new ServiceResponseHandler(this, "_fillDetails", "_error");          
            TestCaseClient.getTestCases(responseHandler, {id: args.testCase.id});
			var parent = this;
				var arg = {
		            label: Constants.getMessage("labelChange"),
		            onClick: function(e){parent._handleMachineChange();},
					iconClass: "edit-icon-image",
					showLabel: false 
		        };
				var changeButton = new Button(arg);
				changeButton.setDisabled(true);//Disabled at start
				//Hide and show the change text on hovering/exiting over the row
				this._changeSpan.onmouseover = dojo.hitch(this, function() {changeButton.setDisabled(false)});
            	this._changeSpan.onmouseout = dojo.hitch(this, function() {changeButton.setDisabled(true)});
				this._machineChangeButton.appendChild(changeButton.domNode); 
		},
		
		_fillDetails: function(testCases){
			this.testCase = testCases[0];
			this._getAllInfo(this.testCase);
            /*
    		 * Custom z-index is needed as hover popup wont show up
    		 * For FF3 pass zIndex
    		 */
			var dialogArgs = {
				primaryTitle: Constants.getMessage("labelExeTest"),
                okCallback: dojo.hitch(this, "_onOK"),
                cancelCallback: dojo.hitch(this, "_onCancel"),
				style: "z-index: 9991;",
				zIndex: 9990
            };
            this.floatingPane = new com.ibm.asq.common.web.ui.internal.widgets.SelectionDialog(dialogArgs);
			this.floatingPane._yesAction = function(){
				var selection = null;
        		if (dojo.isFunction(this.selectionHandler)) {
					selection = this.selectionHandler();
				}            
        		if (dojo.isFunction(this.yesCallback)) {
					//allow callback to cancel close (for example, if some validation fails)
					var callbackResponse = this.yesCallback(this.yesCallbackData, selection);
					if (callbackResponse != null && callbackResponse == false) {
						//do not close
						return;
					}
				} 
			};
            this.floatingPane.setWidth(this.width);
            this.floatingPane.contentContainer.appendChild(this.domNode);
            this.floatingPane.getOkButton().disabled = true;    
			this.floatingPane.open();      
		},
		
		_getAllInfo: function(testCase){
			if (testCase) {
                var responseHandler = new ServiceResponseHandler(this, "_setAllPlans", "_error");
				PlanningClient.getRelatedTestPlanByCase(responseHandler, testCase.versionableItemId);
            }
			try{
				var responseHandler = new ServiceResponseHandler(this, "_setServerTime", "_error");
				com.ibm.rqm.execution.web.client.internal.execution.ExecutionClient.getServerTime(responseHandler, {});
			}catch(e){
				console.error("Could not load filesToolAdapterRegistrationClient");
			}		
			try{
				var responseHandler= new ServiceResponseHandler(this, "_setAllConfigs", "_error");
				var cfg = new com.ibm.rational.test.lm.web.client.internal.config();
				cfg.getAll(responseHandler);
			}catch(e){
				console.error("Could not load files lm.config");	
			}
		},
		
		_setServerTime: function(serverTime){
			this.serverTime = serverTime;
		},
		
		_setAllConfigs: function(response){
			this.allConfigs = (response) ? response : [];
			try{
				var responseHandler= new ServiceResponseHandler(this, "_setAllEWIs", "_error");
				com.ibm.rqm.execution.web.client.internal.execution.ExecutionWorkItemClient.getExecutionWorkItemDTOs(responseHandler, {testCaseItemId: this.testCase.versionableItemId});
			}catch(e){
				console.error("Could not load files ExecutionWorkitemClient");
			}
		},
		
		_setAllEWIs: function(ewis){
			this.allEWIs = ewis ? ewis : [];
			this._setEWIs(this.allEWIs);
			this._handleEWIChange();
		},
		
		_setAllPlans: function(plans){
			this.allPlans = plans?plans:[];
			this._TPValue.disabled = true;
			this._IterationValue.disabled = true;
			var execPopupSelf = this;			
			for (var i = 0; i < this.allPlans.length; i++) {
				var responseHandler = new ServiceResponseHandler(this, "_appendIterations", "_error");
				com.ibm.rqm.process.web.client.internal.timebox.TimeboxClient.getTestPhasesDTO(responseHandler, {
					testPlanId: this.allPlans[i].versionableItemId
				});
				var callbackObj = {
					index:i,
					success: function(results){
						execPopupSelf.allPlans[this.index].configurations = results;
					},
					failure: function(e){
						execPopupSelf._error(e);
					}
				}
				var responseHandler2 = new ServiceResponseHandler(callbackObj, "success", "failure");
				PlanningClient.getConfigurations(responseHandler2, this.allPlans[i].versionableItemId);
			}
		},
		_appendIterations: function(iterations){
			if(iterations && iterations.length > 0){
				for(var i=0;i<this.allPlans.length;i++){
					if(this.allPlans[i].versionableItemId === iterations[0].targetTestPlanUUID){
						this.allPlans[i].iterations = iterations;
						break;
					}	
				}
			}
		},
		_setPlans: function(plans, selectId){
			dojox.data.dom.removeChildren(this._TPValue);
			if(!selectId){
				var option = new Option(Constants.getMessage("labelUnassigned"), "global");
				SelectUtility.add( this._TPValue, option );
			}
			if(plans && plans.length>0){
				for(var i=0;i<plans.length;i++){
					var plan = plans[i];
					var option = new Option(plan.name, plan.id);
					option.planObj = plan;
					if(selectId && selectId == plan.id){
						option.selected = true;
					}
					SelectUtility.add( this._TPValue, option );
				}	
			}
		},
		_setIterations:function(selectedPlan,selectPhase){
			dojox.data.dom.removeChildren(this._IterationValue);
			if (selectedPlan && selectedPlan.iterations) {
				for (var i = 0; i < selectedPlan.iterations.length; i++) {
					var option = new Option(selectedPlan.iterations[i].name,selectedPlan.iterations[i].itemId);
					SelectUtility.add(this._IterationValue, option);
				}
			}
			if(selectPhase)
				SelectUtility.select(this._IterationValue,selectPhase.itemId);
		},
		_setScripts: function(scripts){
			dojox.data.dom.removeChildren(this._TSValue);
			if(scripts && scripts.length>0){
				for(var i=0;i<scripts.length;i++){
					if(scripts[i].archived)
						continue;
					var script = scripts[i];
					var option = new Option(script.name, script.id);
					option.scriptObj = script;
					SelectUtility.add( this._TSValue, option );
				}	
			}
			var option = new Option(Constants.getMessage("labelNone"), "-1");
			SelectUtility.add(this._TSValue, option);
		},
		_setEWIs: function(ewis){
			dojox.data.dom.removeChildren(this._EWIValue);
			if(!ewis || ewis.length == 0){
				var option = new Option(Constants.getMessage("labelUnassigned"), "global");
				SelectUtility.add( this._EWIValue, option );
			}
			if(ewis && ewis.length > 0){
				var selectId = "new";
				var lastExecutedEWI = null;
				for(var i=0;i<ewis.length;i++){
					var ewi = ewis[i];
					if(ewi.currentResult){
						if(lastExecutedEWI){
							if(ewi.currentResult.endTime ==0 ||  ewi.currentResult.endTime > lastExecutedEWI.currentResult.endTime){
								lastExecutedEWI = ewi;
							}
						}else
							lastExecutedEWI = ewi;
					}
					var option = new Option(ewi.name, ewi.id);
					option.ewiObj = ewi;
					SelectUtility.add( this._EWIValue, option );
					if(lastExecutedEWI){
						selectId = lastExecutedEWI.id;
						var found = false;
						if(lastExecutedEWI.testCase.scripts && lastExecutedEWI.currentResult.script){
							for(var k=0;k<lastExecutedEWI.testCase.scripts.length;k++){
								if(lastExecutedEWI.currentResult.script.id ==lastExecutedEWI.testCase.scripts[k].id ){
									found  = true;
									break;
								}
							}
						}
						if(found){
							this.lastExecutedScriptId = lastExecutedEWI.currentResult.script.id;
							if((lastExecutedEWI.currentResult.script.scriptType.id != "com.ibm.rqm.planning.common.scripttype.manual") &&
								(lastExecutedEWI.currentResult.properties)){
								for(var j=0;j<lastExecutedEWI.currentResult.properties.length;j++){
									if(lastExecutedEWI.currentResult.properties[j].propertyName == "adapterId"){
										this.lastSelectedAdapterExternalId = lastExecutedEWI.currentResult.properties[j].propertyValue;
										break;
									}
								}
							}
						}else{
							this.lastExecutedScriptId = "-1";//last execution was no-script execution
						}
					}
				}	
				var option = new Option(Constants.getMessage("labelNew"), "new");
				SelectUtility.add(this._EWIValue, option );
				SelectUtility.select(this._EWIValue,selectId);
			}
		},
		
		_setConfigs: function(configs, selectId){
			dojox.data.dom.removeChildren(this._ConfigValue);
			if(!selectId){
				var option = new Option(Constants.getMessage("labelUnassigned"), "global");
				SelectUtility.add( this._ConfigValue, option );	
			}
			if(configs && configs.length>0){
				for(var i=0;i<configs.length;i++){
					var config = configs[i];
					var option = new Option(config.name, config.id);
					if(selectId && selectId == config.id){
						option.selected = true;
					}
					SelectUtility.add( this._ConfigValue, option );					
				}	
			}
		},

		_setMachine: function(machine){
			var selectedScript = this._TSValue.value != "" ? this._TSValue.options[this._TSValue.selectedIndex].scriptObj : null;
			if(!selectedScript){// || selectedScript.archived){//-noscript-
				this.selectedMachine = null;
				this.selectedAdapter = null;
				this.selectedMachineName = Constants.getMessage("labelNA");
				this.lastSelectedAdapterExternalId = null;
				this.engineToolTip = Constants.getMessage("labelNA");
				this._changeSpan.style.display = "none";
				this.engineStatusIcon = CommonImageCache.ENGINE_AVAILABLE;
				this._machineName.parentNode.onclick = null;
			}
			else if( selectedScript.scriptType.id == "com.ibm.rqm.planning.common.scripttype.manual"){
				this.engineToolTip = Constants.getMessage("msgEngAvailable");
				this.engineStatusIcon = CommonImageCache.ENGINE_AVAILABLE;
				this._changeSpan.style.display = "none";
				this._machineName.parentNode.onclick = null;
				this.selectedMachine = null;
				this.selectedAdapter = null;
				this.selectedMachineName = Constants.getMessage("labelLocalComputer");
				this.lastSelectedAdapterExternalId = null;
			}else if(machine){
				this.selectedMachine = machine;
				this.selectedAdapter = machine.adapterInfo;
				this.selectedMachineName = machine.machineName;
				this.lastSelectedAdapterExternalId = machine.adapterInfo.externalId;
				this._changeSpan.style.display = "inline";
				var rowData = this.selectedAdapter;
				if( (rowData.serverTime - rowData.lastHeartBeat) > 10*(rowData.pollingInterval)){
					this.engineStatusIcon = CommonImageCache.ENGINE_NOTAVAILABLE;
					this.engineToolTip = this.getAdapterToolTip(this.selectedMachine, Constants.getMessage("msgEngUnresponsive"));
				}else if( (rowData.serverTime - rowData.lastHeartBeat) > 2*(rowData.pollingInterval)){
					this.engineStatusIcon = CommonImageCache.ENGINE_NOTRESPONDED;
					this.engineToolTip =  this.getAdapterToolTip(this.selectedMachine, Constants.getMessage("msgEngRespondLate"));
				}else{
					this.engineStatusIcon = CommonImageCache.ENGINE_AVAILABLE;
					this.engineToolTip = this.getAdapterToolTip(this.selectedMachine, Constants.getMessage("msgEngAvailable"));
				}
				this._machineName.parentNode.onclick = dojo.hitch(this, "_handleMachineChange");
			}else{
				this.engineToolTip = Constants.getMessage("msgNoEngines");
				this.engineStatusIcon = CommonImageCache.ENGINE_NOTAVAILABLE;
				this._machineName.parentNode.onclick = null;
				this.lastSelectedAdapterExternalId = null;
			}
			this._adapterStatusImg.src = this.engineStatusIcon;
			if(this._adapterStatusImg.toolTipNode){
				this._adapterStatusImg.toolTipNode.label = this.engineToolTip;
			}else{
				this._adapterStatusImg.toolTipNode = new dijit.Tooltip({label: "", connectId: [this._adapterStatusImg]});
				this._adapterStatusImg.toolTipNode.label = this.engineToolTip;
			}
			this._bottomMessageNode.innerHTML = this.engineToolTip;
			this._machineName.innerHTML = this.selectedMachineName;
			this.floatingPane.getOkButton().disabled = false; 
		},

		_handleMachineChange: function(){
			var selectedScript = this._TSValue.value != "" ? this._TSValue.options[this._TSValue.selectedIndex].scriptObj : null;
			var selectedConfigId = this._ConfigValue.value != "global" ? this._ConfigValue.value : null;
			var machineAdapterTable = null;
			if (selectedScript){
				this.machineAdapterTable = new com.ibm.rqm.execution.web.ui.internal.view.table.MachineAdapterTableView({
						scriptType: selectedScript.scriptType.id,
						serverTime: this.serverTime, configID:selectedConfigId,
						lastSelectedAdapterExternalId: this.lastSelectedAdapterExternalId
					});
				//create dialog
				var dialogArgs = {
					okCallback: dojo.hitch(this, "_okButtonClicked"),
					cancelCallback: dojo.hitch(this, "_cancelButtonClicked"),
					style: "z-index: 9995;",
					zIndex: 9994
				};
				var adapterDialog = new com.ibm.asq.common.web.ui.internal.widgets.SelectionDialog(dialogArgs);
				adapterDialog.setWidth("80%");
				adapterDialog.setHeight("80%");
				adapterDialog.contentContainer.appendChild(this.machineAdapterTable.domNode);
				adapterDialog.setSecondaryTitle(Constants.getMessage("labelChooseMachineForRun"));
				adapterDialog.getOkButton().disabled = false;
				adapterDialog.open(false);
			}else
				alert (Constants.getMessage("labelSelectTestScript"));
		},
		
		_okButtonClicked :function(machines){
			var selectedData = this.machineAdapterTable.getSelectedInfo();
			if (selectedData && selectedData.machine != null)
				this._setMachine(selectedData.machine);
			else
				this._setMachine(null);
		},
		
		_cancelButtonClicked: function(){
			//Nothing to do here
		},
		
		getAdapterToolTip: function(machine, availability){
			var reservedTill = machine.reservedTill ? Utility.dateFromISOString(machine.reservedTill) : Constants.getMessage("labelNotReserved");
			var str = "<table><tr><td> </td><td> </td></tr>";
			str +="<tr><td align=left  style=\"font-size: 8pt;\">"+Constants.getMessage("labelHostname")+"</td><td style=\"font-size: 8pt;\">"+machine.adapterInfo.hostName+"</td><tr>";
			str +="<tr><td> </td><td> </td></tr>";
			str +="<tr><td align=left style=\"font-size: 8pt;\">"+Constants.getMessage("labelState")+"</td><td style=\"font-size: 8pt;\">"+ availability +"</td><tr>";				
			str +="<tr><td> </td><td> </td></tr>";
			str +="<tr><td align=left style=\"font-size: 8pt;\">"+Constants.getMessage("labelReserved")+"</td><td style=\"font-size: 8pt;\">"+reservedTill+"</td><tr>";				
			str += "</table>";
			return str;
		},
		_handleEWIChange: function(){
			//filter Configuration, changePlan
			var selectedEWI = ((this._EWIValue.value == "global") || (this._EWIValue.value == "new"))? null:(this._EWIValue.selectedIndex != -1 ? this._EWIValue.options[this._EWIValue.selectedIndex].ewiObj : null);
			if(selectedEWI == null){
				this._ConfigValue.disabled = false;
				this._setConfigs(this.allConfigs);
				this._setPlans(this.allPlans);
				this._setIterations();
				this._setScripts(this.testCase.scripts);
				if(this.defaultScript && this.defaultScript.id)
					SelectUtility.select(this._TSValue, this.defaultScript.id);
			}else{
				var planId = selectedEWI.testPlan ? selectedEWI.testPlan.id : null;
				var configId =  selectedEWI.configuration;
				this._setPlans([]);
				this._setIterations();
				for(var i=0;i<this.allPlans.length;i++){
					if(this.allPlans[i].id == planId){
						this._setPlans([this.allPlans[i]], planId);
						this._setIterations(this.allPlans[i],selectedEWI.phase);
						break;
					}
				}
				this._setConfigs([]);
				for(var i=0;i<this.allConfigs.length;i++){
					if(this.allConfigs[i].id == configId){
						this._setConfigs([this.allConfigs[i]], configId);
						break;
					}
				}
				this._setScripts(selectedEWI.testCase.scripts);
				if(this.lastExecutedScriptId)
					SelectUtility.select(this._TSValue, this.lastExecutedScriptId);
				else if (selectedEWI.defaultScript)
					SelectUtility.select(this._TSValue, selectedEWI.defaultScript.id);
				this._ConfigValue.disabled = true;	
			}
			this._handleScriptChange();
		},
		_getSelectedPlan:function(){
			var selectedPlanId = this._TPValue.value;
			var selectedPlan = null;
			if (selectedPlanId != "global" && this.allPlans) {
				for(var j=0;j<this.allPlans.length;j++){
					if(this.allPlans[j].id == selectedPlanId){
						selectedPlan = this.allPlans[j];
						break;
					}
				}
			}
			return selectedPlan;
		},
		_handlePlanChange:function(){
			var selectedPlan = this._getSelectedPlan();
			if(selectedPlan)
				this._setIterations(selectedPlan);
			else
				this._setIterations();
			this._searchMatchingEWI(selectedPlan);
		},
		_handleIterationChange:function(){
			var selectedPlan = this._getSelectedPlan();
			this._searchMatchingEWI(selectedPlan);
		},
		_searchMatchingEWI:function(selectedPlan){
			var selectedPlanId = this._TPValue.value;
			var selectedPhase = this._IterationValue.value;
			var found = false;
			if(selectedPlanId != "global" && selectedPhase!="" && this.allEWIs){
				for(var i=0;i<this.allEWIs.length;i++){
					if(this.allEWIs[i].testPlan && this.allEWIs[i].testPlan.id == selectedPlanId && 
							this.allEWIs[i].testPlan && this.allEWIs[i].phase.itemId == selectedPhase){
						
						SelectUtility.select(this._EWIValue,this.allEWIs[i].id);
						found = true;
						this._setConfigs(this.allConfigs, this.allEWIs[i].configuration);
						this._ConfigValue.disabled = true;
						break;
					}
				}
			}
			if(!found){
				this._ConfigValue.disabled = false;
				SelectUtility.select(this._EWIValue,"new");
				if(selectedPlan && selectedPlan.configurations && selectedPlan.configurations.length>0){
					var configs = [];
					for(var k=0;k<selectedPlan.configurations.length;k++){
						for(var j=0;j<this.allConfigs.length;j++){
							if(this.allConfigs[j].id == selectedPlan.configurations[k]){
								configs.push(this.allConfigs[j]);
							}
						}
					}
					this._setConfigs(configs);
				}else{
					this._setConfigs([]);
				}
			}
		},
		_checkValueChange:function(){
			if(this._checkValue.checked){
				this._TPValue.disabled = false;
				this._IterationValue.disabled = false;
			}else{
				this._TPValue.disabled = true;
				this._IterationValue.disabled = true;
				SelectUtility.select(this._EWIValue,"global");
				this._handleEWIChange();
			}
		},
		_handleScriptChange: function(){
			this._machineName.innerHTML = Constants.getMessage("labelLoading");
			if(this.floatingPane)
				this.floatingPane.getOkButton().disabled = true;
			var selectedScript = this._TSValue.value != "" ? this._TSValue.options[this._TSValue.selectedIndex].scriptObj : null;
			if(selectedScript && selectedScript.scriptType.id != "com.ibm.rqm.planning.common.scripttype.manual"){
				if(!this.machineAdapterTable){
					this.machineAdapterTable = new com.ibm.rqm.execution.web.ui.internal.view.table.MachineAdapterTableView({
						scriptType: selectedScript.scriptType.id, 
						serverTime: this.serverTime, 
						loadingCompleteCallback: dojo.hitch(this,this._getMachinesFromTable),
						lastSelectedAdapterExternalId:this.lastSelectedAdapterExternalId
					});
				}else{
					this.machineAdapterTable.reInitialize(selectedScript.scriptType.id, null, dojo.hitch(this, this._getMachinesFromTable));
				}
			}else{
				this._setMachine(null);
			}		
			
		},
		_getMachinesFromTable: function(machines){
			this._setMachine(machines[0]);
		},
		_onOK: function(){
			//Get data from all the attibutes and createWorkitem if unassigned chosen. 
			//Else create a request(is automated script chosen)/ manual test to start the run.
			if(this.floatingPane){
				this.floatingPane.getCancelButton().disabled = true;
				this.floatingPane.getOkButton().disabled = true;
			}
			var ewiId = this._EWIValue.value;
			if(ewiId != "global" && ewiId != "new")
				this._setEWI(this._EWIValue.options[this._EWIValue.selectedIndex].ewiObj);
			else{
				var testConfig = this._ConfigValue.value;
				var testCase = this.testCase.versionableItemId;
				var owner = getAuthenticatedContributor().userId;
				var name = this.testCase.name + (this._ConfigValue.value != "global" ? "_" + this._ConfigValue.options[this._ConfigValue.selectedIndex].text : "");
				var testPlanItemId = this._getSelectedPlanItemId();
				var testPhaseId = this._IterationValue.value;
				var params = null;
				params ={
						newExecutionWorkItem: true,
						owner: owner,
						name: name,
						testCase: testCase
					};
				if (this._TSValue.value != "" && this._TSValue.value != "-1") 
					params.defaultScript = this._TSValue.value;
				if(testConfig != "global")
					params.testConfig= testConfig;
				if(testPlanItemId != "global"){
					params.testPlanItemId = testPlanItemId;
				}
				if(testPhaseId && testPhaseId !=""){
					params.testPhase = testPhaseId;
				}
				try{
					var responseHandler = new ServiceResponseHandler(this, "_setEWI", "_error");
					com.ibm.rqm.execution.web.client.internal.execution.ExecutionWorkItemClient.postExecutionWorkItemDTO(responseHandler, params);
				}catch(e){
					console.error("failed to call postEWI");
					this.closeDialog();
				}	
			}	
		},
		_setEWI: function(ewi){
			this.ewi = ewi;
			if(this._TSValue.value == "-1"){
				parent.location = Utility.getResultURI({ewiId: this.ewi.id, resultItemId: null, editable:true});	
				this.closeDialog();
				return;
			}
			var scriptId = this._TSValue.options[this._TSValue.selectedIndex].scriptObj.id;
			var responseHandler = new ServiceResponseHandler(this, "_startExecution", "_error");			
			TestScriptClient.getTestScript(responseHandler, scriptId);
		},
		_startExecution: function(testScript){
			if(this.ewi){
				var script;
				if(testScript){
					if(testScript.length > 0)
						script = testScript[0];
					else
						script = testScript;
				}else{
					alert(Constants.getMessage("errRetrieveTestScript"));
            		return;
				}	
				var scriptType = script.scriptType.id;
				var scriptId = script.id;
				if(scriptType == "com.ibm.rqm.planning.common.scripttype.manual"){
					parent.location = Utility.startExecution(this.ewi.itemId, scriptId);
					this.closeDialog();
					return;
				}

				if(scriptType != "com.ibm.rqm.planning.common.scripttype.manual" && (this.selectedAdapter == null)){
					alert(Constants.getMessage("msgNoAdapterFound"));
					this.closeDialog();
					return;
				}
				var configId = this._ConfigValue.value != "global" ? this._ConfigValue.value : "";
				var configName = this._ConfigValue.value != "global" ? this._ConfigValue.options[this._ConfigValue.selectedIndex].text : "";
				var testPlanId = this._TPValue.value;
				var testPlanName = this._TPValue.value != "global" ? this._TPValue.options[this._TPValue.selectedIndex].text : "";
				var testPlanObj = this._TPValue.value != "global" ? this._TPValue.options[this._TPValue.selectedIndex].planObj : null;
				var hostName = this.selectedAdapter != null ? this.selectedAdapter.hostName : "";
				var machineId = this.selectedMachine != null ? this.selectedMachine.machineID : null;
				this.scriptId = scriptId;
				var scriptName = script.name;
				var scriptObject = script;
				var scriptTypeName = scriptObject ? scriptObject.scriptType.name : "";
				var scriptItemId = scriptObject ? scriptObject.itemId : "";
				var ewiItemId = this.ewi.itemId;
				var owner = getAuthenticatedContributor().userId;
				//Create a remote execution request here.
				var properties = [];
				var props = scriptObject ? scriptObject.properties : [];
				for(var i=0;i<props.length;i++)
					properties.push(props[i]);

				properties.push({propertyName: "scriptId", propertyValue: this.scriptId+"", propertyType: "String"});
				properties.push({propertyName: "scriptTypeName", propertyValue: scriptTypeName, propertyType: "String"});
				if(configName && configName !="")
					properties.push({propertyName: "configuration", propertyValue: configName, propertyType: "String"});
				if(testPlanId != "global" && testPlanObj != null){
					var shareLocation = this.getLocation(testPlanObj.sections, scriptTypeName);
					properties.push({propertyName: "sharePrefix", propertyValue: shareLocation, propertyType: ""});
				}
				if(testPlanId != "global")
					properties.push({propertyName: "testPlan", propertyValue: testPlanName, propertyType: "String"});
				if(configId && configId != "")
					properties.push({propertyName: "configId", propertyValue: configId, propertyType: "String"});
				properties.push({propertyName: "ewiId", propertyValue: this.ewi.id, propertyType: "link"});
				properties.push({propertyName: "scriptType", propertyValue: scriptType, propertyType: "String"});
				properties.push({propertyName: "scriptItemId", propertyValue: scriptItemId, propertyType: "link"});
				if(hostName)
					properties.push({propertyName: "machine", propertyValue: hostName, propertyType: "String"});
				properties.push({propertyName: "owner", propertyValue: owner, propertyType: "String"});
				properties.push({propertyName: "ewiItemId", propertyValue: ewiItemId, propertyType: "String"});
				properties.push({propertyName: "testCaseName", propertyValue: this.ewi.testCase.name, propertyType: "String"});
				properties.push({propertyName: "scriptName", propertyValue: scriptName, propertyType: "String"});
				
				var requestObj = {
					selectedAdapterId: this.selectedAdapter.id,
					requestType: this.EXECUTE,
					properties: properties,
					isNew: true
				};
				this.requestObj = requestObj;
				if(machineId && machineId != null){
					//Create a machine reservation here.
					try{
						var responseHandler = new ServiceResponseHandler(this, "postRequest", "_machineReservationFailed");
						if(this.machineAdapterTable)
							this.machineAdapterTable.reserveMachine(machineId, responseHandler);
						else
							this.postRequest(null);
					}catch(execp){
						console.error("exception in ExecutionPopup _startExecution: "+execp.message)
						this.closeDialog();
					}				
				}
			}
		},
		postRequest: function(reservations){
			//If reservations were made in order to perform this execution then save them with the ExecutionRequest object.
			//These reservations will be released once the execution finishes.
			if (reservations && reservations.ids && reservations.ids.length > 0){
				var idArray = reservations.ids;
				var resIDs = "";
				for (var i = 0; i < idArray.length; i++)
				{
					if (i > 0)
						resIDs += ",";
					resIDs += idArray[i];
				}
				var properties = this.requestObj.properties;
				if (properties)
					properties.push({propertyName: "reservationUUIDs", propertyValue: resIDs, propertyType: "String"});
			}
			try{
					var responseHandler = new ServiceResponseHandler(this, "setRequestId", "_error");
					com.ibm.rqm.execution.web.client.internal.execution.ExecutionClient.postCreateRequest(responseHandler, this.requestObj);
				}catch(e){
					console.error("Failed to call postCreateRequest");
					this.closeDialog();
				}
		},
		_machineReservationFailed: function(error){
			//this._displayAlertDialog(Constants.getMessage("msgMachineReservationFailed",error.message));
			console.debug(Constants.getMessage("msgMachineReservationFailed",error.message));
			this.postRequest();
		},
		
		setRequestId: function(request){
			parent.location = Utility.startExecution(this.ewi.itemId, this.scriptId, null, request.id);
			this.closeDialog();
		},
		_getSelectedPlanItemId: function(){
			var selectedId = this._TPValue.value;
			if(selectedId == "global")
				return selectedId;
			var itemId = "";
			for (var i = 0; i < this.allPlans.length; i++){
				var plan = this.allPlans[i];
				if(plan.id == selectedId){
					itemId = plan.versionableItemId;
					break;
				}
			}
			return itemId;
		},
		getLocation: function(sections, type){
			var sectionId = "com.ibm.rqm.planning.editor.section.planResources";
			var location = "";
			var items = [];
			for(var i=0;i<sections.length;i++){
				if(sections[i].id == sectionId){
					items = sections[i].content ? dojo.fromJson(sections[i].content) : [];
					break;
				}
			}
			for(var j=0;j<items.length;j++){
				if(items[j].type == type)
					location =items[j].resolvedPath; 
			}
			return location;
		},
		closeDialog: function() {
			this.floatingPane.close();
		},
		_onCancel: function(){
			if(this.floatingPane){
				this.floatingPane.getCancelButton().disabled = true;
				this.floatingPane.getOkButton().disabled = true;
			}
		},
        _error: function(errorObj){
			console.error("Error occured in Execution popup "+ errorObj.message);
			this.closeDialog();
        },
		_displayAlertDialog: function(message){
          alert(message);
        }        
    
    });    
})();
