/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
console.debug("Loading com.ibm.rqm.planning.web.ui.internal.view.construction.extension.TestCaseSummarySection");
dojo.provide("com.ibm.rqm.planning.web.ui.internal.view.construction.extension.TestCaseSummarySection");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dojox.data.dom");

//xojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");
dojo.require("com.ibm.team.repository.web.client.session.Session");
dojo.require("com.ibm.team.workitem.web.client.internal.ImageClient");

dojo.require("com.ibm.rqm.planning.web.ui.internal.util.EditorUtil");
dojo.require("com.ibm.rqm.planning.web.ui.internal.util.Utility");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");

dojo.require("com.ibm.rqm.planning.web.ui.internal.view.construction.CategorySelection");

dojo.require("com.ibm.rqm.planning.web.ui.internal.view.extension.AbstractArtifactEditorSection");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.layout.FormTextField");
dojo.require("com.ibm.asq.common.web.ui.internal.util.AutoWordWrapping");

(function(){
    var EditorUtil = com.ibm.rqm.planning.web.ui.internal.util.EditorUtil;
    var Utility = com.ibm.rqm.planning.web.ui.internal.util.Utility;
    var Constants = com.ibm.rqm.planning.web.client.internal.Constants;
    var ImageClient = com.ibm.team.workitem.web.client.internal.ImageClient;
    var AbstractArtifactEditorSection = com.ibm.rqm.planning.web.ui.internal.view.extension.AbstractArtifactEditorSection;
//	var ServiceResponseHandler = com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
	var FormNumericField = com.ibm.asq.common.web.ui.internal.widgets.layout.FormNumericField;
	var wrapText  = com.ibm.asq.common.web.ui.internal.util.wordWrapping.wrapText;
	
    /**
     * Widget to display list of link elements in the LeftNavigation.
     */
    dojo.declare("com.ibm.rqm.planning.web.ui.internal.view.construction.extension.TestCaseSummarySection", [dijit._Widget, dijit._Templated, AbstractArtifactEditorSection], {
        templatePath: dojo.moduleUrl("com.ibm.rqm.planning.web", "ui/internal/view/templates/construction/extension/TestCaseSummarySection.html"),
        
		labelWeight: Constants.getMessage("labelWeight"),
		labelPoints: Constants.getMessage("labelPoints"),
		
        constructor: function(){
        },
        
        postCreate: function(args){
            this.inherited('postCreate', arguments);
			this.addWorkItemSupport(EditorUtil.getCurrentContributor().itemId);
			this._descLabel.innerHTML = wrapText(
                        Constants.getMessage("labelDescription"), 
                        "", 
                        85, // hard code the max width since the dom node has not been added to the tree. 
                        true,
                        "<BR/>") + ":";           
        },
		
        //@Overriden from AbstractArtifactEditorSection
        initialize: function(isEditable){
            var testCase = this.getArtifact();
			
			if(isEditable) {
				if(testCase) {
					this._descriptionArea.value = testCase.description;
				}
				this._descriptionArea.parent = this;
				this._descriptionArea.initialValue = testCase ? testCase.description : "";
				this._descriptionArea.onkeyup = function(){
					var newValue = this.value;
					if(newValue != this.initialValue)
						this.parent.setDirty();
                }
			}
			else {
				dojox.data.dom.removeChildren(this._descriptioNode);
				var node = document.createTextNode(testCase ? testCase.description: "");
				this._descriptioNode.appendChild(node);
			}
			
			dojox.data.dom.removeChildren(this._weight);
			this.weightWidget = new FormNumericField({
				fieldLabel: this.labelWeight + ": *", 
				required: true,
				disabled: !this.isEditable()
			});
			this.weightWidget.setValue(testCase != null ? testCase.weight : Constants.TEST_CASE_DEFAULT_WEIGHT);
			this.weightWidget.onValueChanged = dojo.hitch(this, "_onChange");
			this.weightWidget.setEdited(this.isEditable());
			this.weightWidget.setErrorMessage(Constants.getMessage("msgNumericWeightRequired"));
			this.weightWidget.setPromptMessage(Constants.getMessage("msgWeightRequired"));
			this._weight.appendChild(this.weightWidget.domNode);
			
            //category labels
            this._categoriesTitle.innerHTML = Constants.getMessage("labelCategories");          
            var args = {
                label: Constants.getMessage("labelManageCategories", Constants.TYPE_CASE),
                onClick: dojo.hitch(this, "_handleCategoriesClick"),
                iconClass: "categories-icon-image",
                showLabel: false
            };
            this._manageCategoriesActionButton = new com.ibm.asq.common.web.ui.internal.widgets.Button(args);           
            this._manageCategoriesActionNode.appendChild(this._manageCategoriesActionButton.domNode);
            this._manageCategoriesActionButton.setDisabled(!this.isEditable()); 			
			
			//setup category selection
			dojox.data.dom.removeChildren(this._categoriesNode);
			this._categorySelect = new com.ibm.rqm.planning.web.ui.internal.view.construction.CategorySelection({
				parent: this,
				artifactType: Constants.MODEL_TYPE_CASE,
				artifact: testCase				
			});
			this._categoriesNode.appendChild(this._categorySelect.domNode);
			this._categorySelect.setDisabled(!this.isEditable());
        },
        
        //@Overriden from AbstractArtifactEditorSection
        getActions: function(){
            return null;
        },
        
        //@Overridden from AbstractArtifactEditorSection --> disable 'remove' capability for Summary section          
        getHeaderContent: /* String || DOM Node */ function(isEditable) {
            return null;
        },        
		
		validate: function() {
            //weight
            if (dojo.trim(this.weightWidget.getValue()).length == 0) {
				this.getParentEditor().setHeaderStatus(Constants.VALIDATION_ERROR, Constants.HEADER_STATUS_ERROR, 
					Constants.getMessage("msgRequiredField", Constants.getMessage("labelWeight"), Constants.getMessage("labelTitleSection", this.getDisplayTitle())));
                return false;
            } else {
                var weight = Number(dojo.trim(this.weightWidget.getValue()));
                if (weight != NaN && weight >= 0) {
//                    return true;
                } else {
					this.getParentEditor().setHeaderStatus(Constants.VALIDATION_ERROR, Constants.HEADER_STATUS_ERROR, 
						Constants.getMessage("msgInvalidField", "Weight", "non-negative number", this.getTitle() + " Section"));
	                return false;
                }                
            }	
			//categories
			if (this._categorySelect && !this._categorySelect.validate()) {
				return false;
			}
			
			return true;
		},
		
        //@Overriden from AbstractArtifactEditorSection
        getAttributes: function(){
            var attributes = {};
            //weight
			var weight = Number(dojo.trim(this.weightWidget.getValue()));
			if (weight != NaN && weight >= 0) {
			    attributes.weight = this.weightWidget.getValue();	
			} else {
				attributes.weight = Constants.TEST_CASE_DEFAULT_WEIGHT;
			}                

			if(this._descriptionArea) {
				attributes.description = this._descriptionArea.value;
			}
			if (this._categorySelect) {
                //TODO send up an array instead of this comma delimited string
				attributes.categories = this._categorySelect.getSelectedItemIds().join();
			}
            return attributes;
        },
   
        //@Overridden from AbstractArtifactEditorSection
        saveFinished: function(savedItem){
            this.inherited('saveFinished', arguments);
    //        this.initialize();
			this.initialized = false;
            this.addWorkItemSupport();            
        },
		
		        
        _handleCategoriesClick: function() {
            this._categoriesEditor = new com.ibm.rqm.planning.web.ui.internal.view.administration.CategoriesEditor({
                artifactType: Constants.MODEL_TYPE_CASE,
                onClose: dojo.hitch(this, "_updateCategories")
            });
        },      
        
        _updateCategories: function() {
            //refresh the category selection widget; refreshes the list
            if (this._categorySelect) {
                this._categorySelect.refresh();
            }
        },
				
		_onChange: function(){
			this.setDirty();
		},
        
        _error: function(e){
            throw new Error("An error occurred: [" + e.message + "] @ TestCaseSummarySection#_error");
        }
    });
})();


