/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.rqm.adapter.testrt.web.ui.internal.view.extension.TestRTScriptEditorSection");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.require("dojox.data.dom");
dojo.require("dijit.TitlePane");	
dojo.require("dijit.InlineEditBox");
dojo.require("dijit.form.CheckBox");
dojo.require("dojo.data.ItemFileWriteStore");
dojo.require("dijit.form.ComboBox");

dojo.require("com.ibm.asq.common.web.ui.internal.widgets.InlineEditor");
dojo.require("com.ibm.team.repository.web.transport.TeamServerClient")

dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.rqm.planning.web.ui.internal.util.Utility");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.extension.AbstractArtifactEditorSection");
dojo.require("com.ibm.rqm.execution.web.client.internal.execution.RemoteExecutionScriptClient");
dojo.require("com.ibm.rqm.execution.web.ui.internal.view.common.RemoteExecutionScriptEditorSection");
dojo.require("com.ibm.rqm.adapter.testrt.web.ui.internal.TestRTUtil");

(function() { // module container

var   Constants                        = com.ibm.rqm.planning.web.client.internal.Constants;
var   Utility                          = com.ibm.rqm.planning.web.ui.internal.util.Utility;
var   AbstractArtifactEditorSection    = com.ibm.rqm.planning.web.ui.internal.view.extension.AbstractArtifactEditorSection;
var	  EditorUtil					   = com.ibm.rqm.planning.web.ui.internal.util.EditorUtil;
var   ScriptClient 					   = com.ibm.rqm.execution.web.client.internal.execution.RemoteExecutionScriptClient;
var   REScriptEditorSection			   = com.ibm.rqm.execution.web.ui.internal.view.common.RemoteExecutionScriptEditorSection;
var   TestRTUtil					   = com.ibm.rqm.adapter.testrt.web.ui.internal.TestRTUtil;

dojo.declare(
   "com.ibm.rqm.adapter.testrt.web.ui.internal.view.extension.TestRTScriptEditorSection", 
   [dijit._Widget, dijit._Templated, AbstractArtifactEditorSection, REScriptEditorSection], 
   {
   templatePath: dojo.moduleUrl("com.ibm.rqm.adapter.testrt.web", "ui/internal/view/templates/extension/TestRTScriptEditorSection.html"),
	
   constructor: function(args) {
      this._script = args.script;
   },
   
   postCreate: function() {},   

	initialize: function() {
		this.createBrowseSection(this._selectionArea, this._browseContainer, this._adapterContainer);
	  	if(!this._testrtScriptPathHandle)
	  		this._testrtScriptPathHandle = dojo.connect(this._testrtScriptPath, "onkeypress", this, this.setDirty);            
	  	if(!this._testNodeNameHandle)
	  		this._testNodeNameHandle = dojo.connect(this._testNodeName, "onkeypress", this, this.setDirty);            
		this._sharePrefixBox.disabled = true;
		this._shareprefixlabel.innerHTML = TestRTUtil.getMessage("labelSharedLocation");
		this._typeOfScriptLabel.innerHTML = TestRTUtil.getMessage("labelScriptPath");
		this._testNodeNameLabel.innerHTML = TestRTUtil.getMessage("labelTestNodeName");
		if(this._script) {
			if(this._script.properties) {
				if(this.getScriptProperty(this._script.properties, "testNodeName")) {
					this._testNodeName.value = this.getScriptProperty(this._script.properties, "testNodeName");
				}
			}
		}
		var helpText = document.createElement('label');
		// helpText.setAttribute("for", "browseRadio");
		helpText.innerHTML = TestRTUtil.getMessage("labelTestNodeNameIndication");
		dojo.style(helpText, "fontFamily", "Arial");
		dojo.style(helpText, "fontSize", "8pt");
		dojo.style(helpText, "color", "#736D75");
		this._scriptInfo.appendChild(helpText);
	},
  
   updateAdapterRadioClicked: function() {
			
		dojo.style(this._shareprefixlabel, "display", "none");
		dojo.style(this._sharePrefixBox, "display", "none");	
		dojo.style(this._typeOfScriptLabel, "display", "none");
		dojo.style(this._testrtScriptPath, "display", "none");
		dojo.style(this.adapterSelector._labelScriptPath, "display", "inline");
	 	dojo.style(this.adapterSelector._scriptPath, "display", "inline");		
		if (this._script) 
		{
			this.adapterSelector._scriptPath.value = this._script.fullPath;
		}
	},
	
	updateBrowseRadioListener: function() {
		dojo.style(this.adapterSelector._labelScriptPath, "display", "none");
	 	dojo.style(this.adapterSelector._scriptPath, "display", "none");
		dojo.style(this._shareprefixlabel, "display", "inline");
		dojo.style(this._sharePrefixBox, "display", "inline");	
		dojo.style(this._typeOfScriptLabel, "display", "inline");
		dojo.style(this._testrtScriptPath, "display", "inline");
		if (this._script) {
			var relPath = this.stripLeadingSlash(this._script.relativePath);
			this._testrtScriptPath.value = relPath;
			
			if (this._script.sharePrefix) {
				this._sharePrefixBox.value = this._script.sharePrefix;
			} else {
				this._sharePrefixBox.value = "";
			}
		}
	},
	
	stripLeadingSlash: function(path) {
		var relPath = path;
		if (relPath.charAt(0) == "\\") {
			relPath = relPath.substring(1, relPath.length);
		}
		return relPath;
	},
	
//		if (this._script != null) {
//			if(this._script.managedByAdapter) {
//				this._testrtScriptPath.value = this._script.fullPath;
//			} else {
//				//this._testrtScriptPath.value = this.getScriptProperty(this._script.properties, "absolutePath");
//				this._testrtScriptPath.value = this.getScriptProperty(this._script.properties, "testrtScriptPath");
//			}
//			if(this._script.properties) {
//				if(this.getScriptProperty(this._script.properties, "testNodeName")) {
//					this._testNodeName.value = this.getScriptProperty(this._script.properties, "testNodeName");
//				}
//			}
//	  }
//	  this.createBrowseSection(this._selectionArea, this._browseContainer, this._adapterContainer);     
//	  //dojo.style(this.adapterSelector._labelScriptPath, "display", "none");
//	  //dojo.style(this.adapterSelector._scriptPath, "display", "none");
// 	  if(!this._testNodeNameHandle)
//	  	this._testNodeNameHandle = dojo.connect(this._testNodeName, "onkeypress", this, this.setDirty);
//  },
   	setSelectedFiles: function(resource){
		console.debug("setSelectedFiles");
		var fileList = resource.fileList;
		if(fileList && fileList.length >0){
			this._sharePrefixBox.value = this.initialPath;
			var relPath = this.fileList[0].resourceURN.substring(this.initialPath.length, this.fileList[0].resourceURN.length);		
			relPath = this.stripLeadingSlash(relPath);
			this._testrtScriptPath.value = relPath;
		}
   },
   
//   setSelectedFiles: function(resource){
//		var fileList = resource.fileList;
//		if(fileList && fileList.length >0){
//			this._testrtScriptPath.value = fileList[0].resourceURN;
//		}
//   },
   
   setAdapterInfo: function(param){
   	   if(this.info.selectedAdapter)
   	    	this.adapterSelector._scriptPath.value = this.info.scriptPath+"\\"+this.info.selectedScript.name;
		else
		  this.adapterSelector._scriptPath.value = "";
   },

//   setAdapterInfo: function(param){
//		this._testrtScriptPath.value = (param.scriptPath ? param.scriptPath:"") +"\\"+ (param.selectedScript ? param.selectedScript.name: "");
//   },
   
      //@Overriden from RemoteExecutionScriptEditorSection
   getHelpContextID: function(){
      return null;
   },
   
   //@Overriden from RemoteExecutionScriptEditorSection
   getActions: function(){
      return [];
   },    

   getAttributes: function(){
		var args = {};
		console.debug("TestRTScriptEditorSection->getAttributes");
		if(this.browserUsage  == true){
			args.managedByAdapter = false;
			args.sharePrefix = this._sharePrefixBox.value
			var relPath = this._testrtScriptPath.value;
			args.relativePath = "\\"+relPath;
			this.absolutePath = this.fileList[0].resourceURN;
		}else if(this.adapterUsage == true){
			args.managedByAdapter = true;
			args.adapterId = this.info.selectedAdapter.id;
			args.fullPath = this.adapterSelector._scriptPath.value;
		}
		return args;
	},

   validate: function(){
   		
	   	if (this.browserUsage  == true){
			if (!this._sharePrefixBox.value || dojo.trim(this._sharePrefixBox.value).length == 0) {
				this.setValidationError(TestRTUtil.getMessage("msgRequiredFieldSharedpath"));
				return false;
			} 
			if (!this._testrtScriptPath.value || dojo.trim(this._testrtScriptPath.value).length == 0) {
				this.setValidationError(TestRTUtil.getMessage("msgRequiredFieldScriptName"));
				return false;
			} 
			
		} 
		if (this.adapterUsage == true) {
			
			if(!this.info || !this.info.selectedAdapter)
			{
				this.setValidationError(TestRTUtil.getMessage("msgRequiredFieldAdapter"));
				return false;
			}
			
			if ( dojo.trim(this.adapterSelector._scriptPath.value).length == 0) {
				this.setValidationError(TestRTUtil.getMessage("msgRequiredFieldScriptPath"));
				return false;
			}
			
			return true;
		}
		return true;
   },
      
//   validate: function(){
//  	if (dojo.trim(this._testrtScriptPath.value).length == 0) {
//		 this.setValidationError(TestRTUtil.getMessage("noScriptPath"));
//		 this._testrtScriptPath.focus();
//         return false;
//      }
//	  return true;
//   },
     
   //@Overridden from RemoteExecutionScriptEditorSection
   saveFinished: function(testScript){
      this._script = testScript;
	 //this.initialize();
	 this.setSectionDirty(false);
   },
//   saveFinished: function(testScript){
//      this._script = testScript;
//	  this.initialize();
//	  this.setSectionDirty(false);
//   }   

   getProperties: function(){
   	var props=[];
		var testNodeName = {
			propertyType: "string",
			propertyName: "testNodeName",
			propertyValue: this._testNodeName.value
		}
		props.push(testNodeName)
	return props;
   }

//   getProperties: function(){
//		var props = [];
//		var testRTPathProperty = {
//			propertyType: "string",
//			propertyName: "testrtScriptPath",
//			propertyValue: this._testrtScriptPath.value
//		}
//		props.push(testRTPathProperty)
//		var testNodeName = {
//			propertyType: "string",
//			propertyName: "testNodeName",
//			propertyValue: this._testNodeName.value
//		}
//		props.push(testNodeName)
//		return props;
//   },

});

})();