/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.planning.web.ui.internal.view.planning.environment.EnvironmentListTableView");
 
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.require("com.ibm.asq.common.web.ui.internal.view.common.ImageCache");
dojo.require("com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout");

//xojo.require("com.ibm.rqm.execution.web.ui.internal.util.Utility");

dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentProvider");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableCellModifier");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.ListRowRenderer");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.planning.environment.MultiSelectCellRenderer");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.planning.environment.EnvironmentChooserDialog");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");

(function() {

var TableConstants = com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants;
var ImageCache     = com.ibm.asq.common.web.ui.internal.view.common.ImageCache;
//var Utility        = com.ibm.rqm.execution.web.ui.internal.util.Utility;
var EnvDialog		= com.ibm.rqm.planning.web.ui.internal.view.planning.environment.EnvironmentChooserDialog;
var Constants = com.ibm.rqm.planning.web.client.internal.Constants;
 
dojo.declare("EnvironmentListTableView.TableListener", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableListener,
{
	parentView: null,
    
    constructor: function(testView)
    {
        this.parentView = testView;
    },
    
	
	setTableActionListener: function(listener) {
		this.tableActionListener = listener
	},
	
    // Summary:
    //   If the table's rows are checkable, when a row is checked, or unchecked, this method is
    //   called.
    //
    rowCheckStateChanged: function(tableViewer, rowObject, state)
    {
    },
	
	tableContentActionInvoked: function(tableViewer, actionId, callbackData)
	{
		if(actionId == "environment.addNew")
		{
			if(this.parentView)
				this.parentView._addType();//Open the dialog
		}	
	}
});

dojo.declare("EnvironmentListTableView.CellModifier", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableCellModifier,
{
    // Summary:
    //    Method to be called when a cell renderer changes the cell value. This notifies
    //    the cell's value change event. 
    //    
    //
	setComboListener: function(listener) {
		this.comboListener = listener;
	},
	    
    cellValueChanged: function(oldValue, newValue, rowObject, columnIndex)
    {
		//alert("Old "+oldValue+" New "+newValue+" Row Data "+rowObject+" Col Index "+columnIndex);
		var listener = this.comboListener;
      	if (listener && listener.context && listener.method) {
        	listener.method.apply(listener.context, [oldValue, newValue, rowObject]);
		}	
    },
    
    cellActionInvoked: function(rowObject, columnIndex)
    {
    }
});

dojo.declare("EnvironmentListTableView.ListRowRenderer",
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.ListRowRenderer,
{    
    // Summary:
    //   Override the base list row renderer's create list content method
    //   to supply more custom contents.
    //
    _createListContents: function(viewer, rowObject, listWidget)
    {
        this.inherited("_createListContents", arguments);   
        
        var moreContents = document.createElement("div");
        var toggle = document.createElement("button");
        toggle.innerHTML = Constants.getMessage("labelAddedCustomControl");
        moreContents.appendChild(toggle);
        listWidget.contentNode.appendChild(moreContents);
    }
});

dojo.declare("EnvironmentListTableView.TableProvider", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentProvider,
{
    // Summary:
    //
    getNumColumns: function(content)
    {
        return 2;
    },
    
    // Summary:
    //
    getColumnHeading: function(content, index)
    {
        var headings = [
            Constants.getMessage("labelTypeEnvironment"),
            Constants.getMessage("labelAttributesEnvironment")
        ];
        return headings[index];
    },

    // Summary:
    //    Optionally, returns an image src URL to be placed in the column header. If both heading
    //    and image are specified, both are shown.
    //    
    getColumnHeadingImage: function(content, atColumnIndex)
    {
        return null;
    },
	 
    // Summary:
    //    Returns the column header horizontal alignment. By default, the columns are
    //    aligned to the left.
    //
    //    Client optionally can indicate the alignment for the column header.
    //
    getColumnHeadingAlignment: function(atColumnIndex)
    {
        return this.getCellAlignment(null, atColumnIndex);
    },	 
    
    getIsColumnGroupable: function(content, atColumnIndex)
    {
        return false;     
    },

    getIsColumnSortable: function(content, atColumnIndex)
    {
        return false;   
    },
    
    getIsCellEditable: function(rowData, atColumnIndex)
    {
		if(atColumnIndex != 1)
        	return true;
		else
			return false;	
    },
	
    getColumnWidth: function(content, atColumnIndex)
    {
        switch(atColumnIndex) {
            case 0: 
                return 20;
            case 1: 
                return 80;
        }
        return 0;
    },
    
    // Summary:
    //    The only assumptions the table have on the data that it displays
    //    is that it's an array contents. These are the data content/object that
    //    will be displayed in the table rows.
    //
    getContentObjects: function(content)
    {
        // our content is already an array of objects
        return content;
    },
    
    getRowDataId: function(rowData)
    {
        return "_table_row_for_env_list_" + rowData.name;
    },
    
    // Summary:
    //    Returns the type of the cell to be displayed. By default, the TableViewer
    //    will support a set of cell types. The type of the cell will map to a specific
    //    cell renderer (to be discussed).
    getCellDisplayType: function(rowData, atColumnIndex)
    {
        var type = TableConstants.RENDER_TYPE_TEXT;

        switch(atColumnIndex) {
            case 1: 
                type = "RenderType.MultiSelect";
                break;	
        }
        return type;
    },

    getCellAlignment: function(rowData, atColumnIndex)
    {
        return TableConstants.ALIGN_LEFT;
    },
    
    // Summary:
    //    Returns the display data of the cell. For cell renderer type of TEXT, this will
    //    be the string. Others cell render type would be Date, or integer value, etc. If the 
    //    cell renderer type is image, the client can also supply cell data that can be sortable/groupable. 
    //    The TableViewer's default sorter, filter operates on this returned data. For "complex" 
    //    cell types such as image where it could have multiple values for different states, the 
    //    client also needs to implement the next method.
    //    
    //    Client must implement this method to provide the cell data.
    //    
    getCellDisplayData: function(rowData, atColumnIndex)
    {
        var val = "";
		  var currentValue = rowData;
        switch(atColumnIndex) {
            case 0: 
                val = rowData.catalogType; //Type
                break;
            case 1: 
				val =  "";
				break;          
        }
        return val;
    },

    
    // Summary:
    //    If applicable, returns the extended display information of the cell. The return extended
    //    info must be an object with the following attributes:
    //    
    //    {
    //      /* attribute common for all cell renderer types */
    //      "tooltip": <string>,
    //
    //      /* attributes for IMAGE and ACTION cell renderer types */
    //      "isHidden": <true, false> the image is hidden if the row is not on the mouse over
    //      "image": base image URL,  
    //      "mouseOverImage": image URL, (optional)
    //      "mouseOutImage": image URL,  (optional) (overrides "image")
    //
    //      /* attributes for SELECT cell renderer type */
    //      "select" : 'value', the selection in the combo
    //      "choices" : [{'text':'display text', 'value':'value'}, ] array of objects with 'text' and 'value' attributes
    //
    //      /* attributes for CHECKBOX cell renderer type */
    //      "state" : <true, false> initial state of the check box
    //
    //      /* attributes for LINK cell renderer type */
    //      "href" : <string> the href string for the link
    //    }
    //
    //    Client can implement this method to provide extended display infor for the cell.
    //    Certain cell renderer type will require the client to implement this method to
    //    provide needed display information, such as an image ACTION.
    //
    getCellDisplayExtendedInfo: function(rowData, atColumnIndex)
    {  
        var val = null;
        if(atColumnIndex == 1) {
            val = {};
            val.select = rowData.catalogEntries[0]; 
				val.choices = [];
				var test = rowData.catalogEntries;
				if (test && test.length > 0) {
					for (var i = 0; i < test.length; i++) {
						if(rowData.selectedValues[i])
							val.choices.push({text: test[i], value: test[i], selected: true})
						else
							val.choices.push({text: test[i], value: test[i]})	
					}
				} else {
					val.choices.push({text: Constants.getMessage("labelNotAvailableEnvironment"), value: "-1"})
				}
        }
        return val;
    }
    
    
});

dojo.declare("com.ibm.rqm.planning.web.ui.internal.view.planning.environment.EnvironmentListTableView", 
    [dijit._Widget, dijit._Templated],
{    
    templateString: '<div dojoAttachPoint="_tableViewerNode" class="com-ibm-rqm-test-artifact-table-view" tabindex="-1">' +
						  '<!--div dojoAttachPoint="_actions">   <table><tr>' + 
						  '      <td><a><label dojoAttachPoint="_add" dojoAttachEvent="onclick: _addType" class="query-title">Edit</label></a> </td>&nbsp;<td> </td>' +
						  '   </tr></table> </div-->' +
						  '</div>',

    editable: true,
	printable: false,
    widgetsInTemplate: false,

    constructor: function() {
	 	this.results = null;
		this.queryName = null;
		this.executable = false;
	 },

    postCreate: function() 
    {
        this.inherited("postCreate", arguments);
        //var tableViewer = new com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer();      
        var tableViewer = new com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer({
            //turn off all controls if in print mode             
            showPagingControl: !this.printable,
            showPagingRangeControl: !this.printable,
            showGroupFilterControls: !this.printable,
            showPagingActionsControls: !this.printable          
        });		  
		
        this._tableViewerNode.appendChild(tableViewer.domNode);
		
		this.parts = [];

        var content = this.parts ? this.parts : [];
		  
        //tableViewer.setContentPageSize(10);
        tableViewer.setContent(content);
        tableViewer.setContentProvider(new EnvironmentListTableView.TableProvider());
		  
		var tableListener = new EnvironmentListTableView.TableListener(this);        
		tableViewer.setTableListener(tableListener);
		var cellModifier = new EnvironmentListTableView.CellModifier();
	    tableViewer.setCellModifier(cellModifier);
		if (this.comboListener) {
        	cellModifier.setComboListener(this.comboListener);
		}
		tableViewer.registerCellRenderer("RenderType.MultiSelect", 
			new com.ibm.rqm.planning.web.ui.internal.view.planning.environment.MultiSelectCellRenderer());
		
        tableViewer.show();
	    this.tableViewer = tableViewer;
		this.tableViewer.setEditable(this.editable);
		
		this.tableViewer.addAction("environment.addNew", Constants.getMessage("labelEditTestEnvironment"), null, "test-image-1");
    },
	
	updateMode: function(mode){
        this.editable = mode;
		this.tableViewer.setEditable(this.editable);
	},
	
	updateParts: function(part)
	{
		var found = false;
		for(var i=0; i< this.parts.length ;i++)
		{
			if(this.parts[i])
			{
				if(this.parts[i].catalogType === part.catalogType)
				{
					this.parts[i].catalogEntries.push(part.catalogEntries[0]);
					found = true;
				}
			}		
		}
		if(!found)
		{
			this.parts.push(part);	
		}
		
		this.tableViewer.setContent(this.parts);
		this.tableViewer.show();
        this.tableViewer.setEditable(this.editable);
	},
	
	appendConfig: function(args)
	{
		var newConfigValues = [];var count = 0;
		for(var i=0;i<args.length;i++)
		{
			if(args[i].selectedValues.length >0)
			{
				var stale = true;
				for(var j=0;j<args[i].selectedValues.length;j++)
				{
					if(args[i].selectedValues[j] == true)
					stale = false;
				}
				if(!stale)
				{
					newConfigValues[count] = args[i];
					count++;
				}	
			}
		}
		
		this.parts = args;
		this.tableViewer.setContent(newConfigValues);
		this.tableViewer.show();	
        this.tableViewer.setEditable(this.editable);
	},
	
	updateEnvContainer: function(args)
	{
		var listener = this.changeListener;
		if (listener && listener.context && listener.method) {
        	listener.method.apply(listener.context, [args]);
		}
	},
	
	_addType: function()
	{
		this.envDialog = new EnvDialog({parentWidget: this})
		this.envDialog.setAllOptions(this.parts);
	}
});

})();
