/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
console.debug("Loading com.ibm.rqm.planning.web.ui.internal.view.planning.environment.EnvironmentSection");
dojo.provide("com.ibm.rqm.planning.web.ui.internal.view.planning.environment.EnvironmentSection");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.extension.AbstractArtifactEditorSection");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.planning.environment.EnvironmentListTableView");
dojo.require("com.ibm.rqm.planning.web.client.internal.planning.PlanningPageClient");

dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");
dojo.require("com.ibm.asq.common.web.client.internal._catalog.Configuration");
dojo.require("com.ibm.asq.common.web.client.internal.Catalog");
dojo.require("com.ibm.asq.common.web.client.internal.PermissionsClient");
dojo.require("com.ibm.asq.common.web.ui.internal.view.common.ImageCache");
dojo.require("com.ibm.rqm.planning.web.ui.internal.util.Utility");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.common.ContentArea");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");
dojo.require("com.ibm.rational.test.lm.web.client.internal.config");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.widgets.FilteredSelectionDialog");

(function() 
{	
	var ContentAreas 						= com.ibm.rqm.planning.web.ui.internal.view.common.ContentArea;
	var ImageCache							= com.ibm.asq.common.web.ui.internal.view.common.ImageCache;
	var EnvironmentListTableView			= com.ibm.rqm.planning.web.ui.internal.view.planning.environment.EnvironmentListTableView;
	var ServiceResponseHandler   			= com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
	var Utility								= com.ibm.rqm.planning.web.ui.internal.util.Utility;
	var AbstractArtifactEditorSection 		= com.ibm.rqm.planning.web.ui.internal.view.extension.AbstractArtifactEditorSection;
	var Constants							= com.ibm.rqm.planning.web.client.internal.Constants;
	var AlertDialog 						= com.ibm.asq.common.web.ui.internal.widgets.AlertDialog;
	
dojo.declare("com.ibm.rqm.planning.web.ui.internal.view.planning.environment.EnvironmentSection",
			 [dijit._Widget, dijit._Templated, AbstractArtifactEditorSection],
	{
		templateString: '<div class="com-ibm-rqm-test-planning-environment-environmentsection">' +
						'    <div class="" dojoattachpoint="_envSection"></div>' +
						'    <div class="" dojoattachpoint="_tabContainer"></div>' + 
						'    <div class="" dojoattachpoint="_environmentsContainer"></div>' +
						'    <div class="" dojoattachpoint="_configurationsContainer"></div>' +
						'</div>',

		configValues: [],
		environmentUpdated: false,
		tabs: [],
		//configuration list
		configurations: [],
		
		constructor: function(args) 
		{
		},

		postCreate: function() {
            this.inherited('postCreate', arguments);
            this.addWorkItemSupport();			
		},
		
		//@Overriden from AbstractArtifactEditorSection - invoked on first expand
		initialize: function(isEditable)
		{
			this.inherited('initialize', arguments);
			this._plan = this.getArtifact();
			//PermissionsClient.checkPermissions(handler, {
			//	operationId: PermissionsClient.OP_CONFIG_EWI,
			//	action: PermissionsClient.ACTION_CREATE
			//});
			setTimeout(dojo.hitch(this, "_postInit"), 250);
		},

        _postInit: function() {
            this._initTabContainer();
            this._createCatalog();          
		},
		
		//@Overridden from AbstractArtifactEditorSection
		saveFinished: function(savedItem){
            this.inherited('saveFinished', arguments);
            this.addWorkItemSupport();
			this.environmentUpdated = false;			
        },
		
        //@Overriden from AbstractArtifactEditorSection
        getAttributes: function(){
            var returnArray = [];
			if (this.configValues && this.configValues.length > 0) {
				for (var i = 0; i < this.configValues.length; i++) {
					if (this.configValues[i].catalogEntries.length > 0) {
						var arr = [];
						var object = {
							catalogType: this.configValues[i].catalogType
						}
						for (var j = 0; j < this.configValues[i].catalogEntries.length; j++) 
							arr.push({
								name: this.configValues[i].catalogEntries[j]
							});
						object.catalogEntries = arr;
						returnArray.push(object)
					}
				}
			}
            return {
                catalogTypesJsonString: this.initialized && this.initialized == true ? dojo.toJson(returnArray) : null
            }
        },
		
		//@Overriden from AbstractArtifactEditorSection
        getActions: function(){
/*            var actions = [];
            actions.push({
                label: "Change Mode",
                actionHandler: dojo.hitch(this, "toggleMode"),
                iconClass: "add-icon-image",
                disabledOnReadOnly: true                
            });
            return actions;
*/
			return null;
        },
        
 		toggleMode: function()
		{			
			this.updateMode(this.isEditable()); 
		},
 
		_createCatalog: function()
		{	
		   this.theCatalog = this.theCatalog ? this.theCatalog : new com.ibm.asq.common.web.client.internal.Catalog();
         //initialize the catalog if necessary
			var catalog = com.ibm.asq.common.web.client.internal.Catalog;
			if (!catalog.theCatalog) {			
				var self = this;
				var callbackObj = {
					success: function(){
						self._setConfig();
					},
					failure: function(e){
						self._error(e);
					}
				}
				var responseHandler = new ServiceResponseHandler(callbackObj, "success", "failure");
				this.theCatalog.initializeTemplates(responseHandler);
			} else {
				this._setConfig();
			}
		},
		
		_setConfig: function(newConfigList)
		{
			var configs =[];
			if(newConfigList)
				configs = newConfigList;
			else
				configs = this._plan ? this._plan : null;
			this._envItems = [];
			this.configValues = [];
			var types = this.theCatalog.getDisplayTypes();
			for(var i=0;i<types.length;i++)
			{
				var ele = {
					catalogType: types[i],
					catalogEntries: []
				}
				this.configValues.push(ele);
			}
			var attributeIds = types;
			var attributeVals = [];
			for (var i = 0; i < attributeIds.length; i++) {
            var displayValues = this.theCatalog.getValuesForDisplayType(attributeIds[i]);
			var selectedValues = [];
			if(configs && configs.catalogTypes && configs.catalogTypes.length >0){
			for(var k=0;k<configs.catalogTypes.length;k++)
			{
				if(configs.catalogTypes[k].name == attributeIds[i])
				{
					var values = [];
					for(var p=0;p<configs.catalogTypes[k].values.length;p++)
					{
						for(var j=0;j<displayValues.length;j++)
						{
							if(configs.catalogTypes[k].values[p].name == displayValues[j])
							{
								values.push(configs.catalogTypes[k].values[p].name);
								selectedValues[j] = true;
								break;
							}
						}
					}
					if(values.length > 0)
						this.updateData(null, values, {catalogType: configs.catalogTypes[k].name}, true);
				}
			}
		}	
			var configObj = {
				catalogType: attributeIds[i],
				catalogEntries: displayValues,
				selectedValues: selectedValues 
				}
			this._envItems.push(configObj);	
         }
			this._updateTabs(this._envItems); 
		},
		
		_updateTabs: function(items)
		{
			for(var i=0;i<this.tabs.length ; i++)
				this.tabs[i].appendConfig(items);
		},
		
		updateMode: function(mode)
		{
			for(var i=0;i<this.tabs.length ; i++)
			{
				this.tabs[i].updateMode(this.editable);
			}	
		},
		
		appendConfigAndUpdateTabs: function(config)
		{
			//this.config = config;
			this._setConfig();
		},
		
		_initTabContainer: function() {
			//set up the tab container (if not in print mode)
			if (!this.isPrintView()) {
				this._contentArea = new ContentAreas();
				this._contentArea.initialize({
					tabContainerStyle: "min-height: 100px"
				});
				
				this._tabContainer.appendChild(this._contentArea.domNode);
				
				var args = {
					name: Constants.getMessage("labelPlatformCoverage"),
					noSelect: true,
					content: this._environmentsContainer
				};
				this._contentArea.addPage(args);
				
				var args = {
					name: Constants.getMessage("labelTestEnvironment"),
					noSelect: true,
					content: this._configurationsContainer
				};
				this._contentArea.addPage(args);
			} else {
				//otherwise, for print view, add titles
				var coverageTitle = document.createElement("span");
				coverageTitle.innerHTML = Constants.getMessage("labelPlatformCoverage");
				dojo.addClass(coverageTitle, "printable-section-title");
				this._environmentsContainer.appendChild(coverageTitle);
				
                var envTitle = document.createElement("span");
                envTitle.innerHTML = Constants.getMessage("labelTestEnvironment");
                dojo.addClass(envTitle, "printable-section-title");
                this._configurationsContainer.appendChild(envTitle);				
			}
			
			//create EnvironmentList table ('Platform Coverage' tab in UI)
			var self = this;
			var tabArgs = {
				editable: this.isEditable(),
				printable: this.isPrintView(),
                changeListener: {
					context: self,
					method: self._updateEnvironment
				}                
			}
			this.envListTable = new EnvironmentListTableView(tabArgs);
			this._getTabbedViewer(this._environmentsContainer, this.envListTable);
			
			//create ConfigurationTableView table ('Test Environments' tab in UI)
			var className = "com.ibm.rqm.configuration.web.ui.internal.view.table.ConfigurationTableView";
			var handler = {
				loaded: function(className){
					var constructor = dojo.getObject(className);
					var args = {
						editable: self.isEditable(),
						printable: self.isPrintView(), 
						actions: self._getConfigurationTableActions(),
                        allowSettings: true,
                        tableId: "RQM-ENV-CONFIG-TABLEVIEWER"				
					};
					self.configurationTableWidget = new constructor(args);
//					self._getTabbedViewer(self._configurationsContainer, self.configurationTableWidget);
					self._configurationsContainer.appendChild(self.configurationTableWidget.domNode);
					self._loadConfigurations();
				}
			}
			net.jazz.ajax.core.internal.loader.load_async("com.ibm.rqm.configuration.web.client.internal.configuration.WHITCHClient", function(){});
            net.jazz.ajax.core.internal.loader.load_async(className, dojo.hitch(handler, "loaded", className));
		},
		
		_updateConfigurations: function(/*boolean*/ newConfigsAdded) {
			if (newConfigsAdded) {
				this.setDirty();
			}
			this._loadConfigurations();
		},
		
		_loadConfigurations: function(){
			if (dojo.isFunction(this.getArtifact) && this.getArtifact() && this.getArtifact().id){
				this.configurations = [];
				var self = this;
	            var handler = {
	                success: function(configs){
						if(configs){
							self._retrieveConfigurationDetails(configs);
						}
	                },
	                error: function(e){
						console.debug(e);
	                }
	            }
	            var responseHandler = new ServiceResponseHandler(handler, "success", "error");
	            com.ibm.rqm.configuration.web.client.internal.configuration.WHITCHClient.getConfigurationsByTestPlan(responseHandler, {testsPlanUUID: this.getArtifact().versionableItemId});
			}
		},
		
		_retrieveConfigurationDetails: function(configs){
			this.catalogClient = new com.ibm.rational.test.lm.web.client.internal.config();
			for (var i = 0; i < configs.length; i++){
				if(i < configs.length - 1){
					var responseHandler = new ServiceResponseHandler(this, "_demarshalConfiguration", "_error");
				}else{
					var responseHandler = new ServiceResponseHandler(this, "_demarshalConfigurationAndDisplay", "_error");
				}
				this.catalogClient.retrieveConfigurationWithDetails(responseHandler, configs[i]);
			}
		},
		
		_demarshalConfiguration: function(configuration){
            var catalog = new com.ibm.asq.common.web.client.internal.Catalog();
            var configur = new com.ibm.asq.common.web.client.internal._catalog.Configuration(configuration.configuration);
            var attributeIds = catalog.getDisplayTypes();
            var config = [];
            for (var i = 0; i < attributeIds.length; i++) {
				var value = configur.getValue(attributeIds[i]);
                if (value) {
					config.push({
						key: attributeIds[i],
						value: value
					});
					
				}
            }
			config.config = configuration;
            this.configurations.push(config);
        },
		
		_demarshalConfigurationAndDisplay: function(config){
			this._demarshalConfiguration(config);
			this.configurationTableWidget.refresh(this.configurations);
		},
		
		_getConfigurationTableActions: function(){
			var actions = [];

            var ewi_type = com.ibm.asq.common.web.client.internal.PermissionsClient.OP_CONFIG_EWI;
            var ewi_perm = com.ibm.asq.common.web.client.internal.PermissionsClient.getStoredPermission(ewi_type);
            if (!ewi_perm || ewi_perm.create) {
                actions.push({
                    label: Constants.getMessage("labelGenerateNewConfigurations"),
                    actionHandler: dojo.hitch(this, "_handleGenerateConfigurationClicked"),
                    iconClass: "generate-config-icon",
                    disabledOnReadOnly: true
                });
                actions.push({
                    label: Constants.getMessage("labeAddExistingConfigurations"),
                    actionHandler: dojo.hitch(this, "_handleAddConfigurationClicked"),
                    iconClass: "add-icon-image",
                    disabledOnReadOnly: true
                });
            }
			actions.push({
                label: Constants.getMessage("labelDeleteConfigurations"),
                actionHandler: dojo.hitch(this, "_handleDeleteConfigurationClicked"),
                iconClass: "delete-icon-image",
                disabledOnReadOnly: true
            });
			
			return actions;
		},
		
		_handleGenerateConfigurationClicked: function(){
			var wizardClassName = "com.ibm.rqm.configuration.web.ui.internal.view.configuration.GenerateCFGWizard";
            net.jazz.ajax.core.internal.loader.load_async(wizardClassName, dojo.hitch(this, "_showCFGWizard", wizardClassName));
		},
		
		_showCFGWizard: function(wizardClassName) {
			if (dojo.isFunction(this.getArtifact) && this.getArtifact() && this.getArtifact().id && !this.environmentUpdated) {
				var isEmpty = true;
				for(var i = 0; i < this.configValues.length; i++){
					if(this.configValues[i].catalogEntries && this.configValues[i].catalogEntries.length > 0){
						isEmpty = false;
						break;
					}
				}
				if(!isEmpty){
					var self = this;
		            var args = {
		                parentController: self,
		                callback: {context: self, method: self._updateConfigurations},
		                testPlan: this.getArtifact()
		            }
		            var constructor = dojo.getObject(wizardClassName);
		            this._ewiWizard = new constructor(args);
				}else{
					var msg = Constants.getMessage("msgNoTestEnvironments", this.getArtifactType());
					this._displayAlertDialog(msg);
					this._activateTab(0);
				}
			} else {
                var msg = Constants.getMessage("msgSaveToGenerateConfigurations", this.getArtifactType());
				this._displayAlertDialog(msg);
            }
        },
		
		_handleDeleteConfigurationClicked: function(){
			var configurations = this.configurationTableWidget.getSelectedConfigs();
			if (configurations.length == 0) {
				//				alert(Constants.getMessage("msgDeleteConfiguration"));
				this._displayAlertDialog(Constants.getMessage("msgDeleteConfiguration"));
				return;
			}
			else {
				var msg = "";
				if (configurations.length == 1) {
					msg = Constants.getMessage("msgPromptDeleteConfiguration", configurations[0].config.name);
				}
				else 
					if (configurations.length > 1) {
						msg = Constants.getMessage("msgPromptDeleteConfiguration1", configurations.length);
					}
				var self = this;
				var args = {
					title: Constants.getMessage("labelConfirmation"),
					message: msg,
					yesCallback: function(){   
						self._deleteConfiguration(configurations);
						return true;          
					},
					noCallback: function() {
						return false;
					}
				}
				var dialog = new com.ibm.asq.common.web.ui.internal.widgets.YesNoDialog(args);
	        	dialog.setSecondaryTitle(args.title);
	        	dialog.open();
			}
			
		},
		
		_deleteConfiguration: function(configurations){
			var configs = [];
			for( var i = 0; i < configurations.length; i++){
				configs.push(configurations[i].config.id);
			}
			var self = this;
			var handler = {
				success: function(){
					self.configurationTableWidget.removeSelectedConfigs();
					self.setDirty();
				},
				error: function(e){
					console.error(e);
				}
			}
			var responseHandler = new ServiceResponseHandler(handler, "success", "error");
			com.ibm.rqm.configuration.web.client.internal.configuration.WHITCHClient.postConfigurationsToTestPlan(responseHandler, {
						testsPlanUUID: this.getArtifact().versionableItemId,
						addedConfigurations: null,
						deletedConfigurations: configs
				});
		},
		
		_handleAddConfigurationClicked: function()
		{
			//Load all the configs so we can show them in the selection dialog
    	    var configs = new com.ibm.rational.test.lm.web.client.internal.config();
        	var responseHandler= new com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper(this, "_loadAllConfigsSuccessHandler", "_loadAllConfigsErrorHandler");   
        	configs.getAll(responseHandler);
		},
		
    
	    _loadAllConfigsSuccessHandler :function(response)
	    {
			//The list of configs is in the response.
			//Extract them and show them in the dialog.
	        this.selectDlg = new com.ibm.rational.test.lm.web.ui.internal.widgets.FilteredSelectionDialog({title:Constants.getMessage("labelSelectTestEnvironment")});
	        this.selectDlg.setOKaction( dojo.hitch( this, this._handleSelectOK ) );
	        if (response) 
	        {
				 response.sort(dojo.hitch(this, "_compareEnvironmentsByName"));
	            for (var i = 0; i < response.length; i++) 
	            {
	                var name = response[i].name;
	                var description = response[i].description;
	                var id = response[i].id;
	                
	                this.selectDlg.addListItem(id, name);
	            }
	        }
	        this.selectDlg.show();
	    },
    
	    _handleSelectOK :function()
	    {
	        var newItems = this.selectDlg.getSelectedItems();
			var configs = [];
	        
			//Push the IDs of all the selected configs onto the array.
			//The array is used below to add the IDs to the Test Plan
	        for (var i = 0; i < newItems.length; i++)
	            configs.push(newItems[i].id);

			var self = this;
			var handler = {
				success: function(){
					self._updateConfigurations(true);
					self.setDirty();
				},
				error: function(e){
					console.error(e);
				}
			}
			var responseHandler = new ServiceResponseHandler(handler, "success", "error");
			com.ibm.rqm.configuration.web.client.internal.configuration.WHITCHClient.postConfigurationsToTestPlan(responseHandler, {
						testsPlanUUID: this.getArtifact().versionableItemId,
						addedConfigurations: configs,
						deletedConfigurations: null
				});

	    },
    
	    _loadAllConfigsErrorHandler :function(response)
	    {
	        console.error(response);
	    },		
		
		
		_activateTab: function(tabIndex){
			if(!this._contentArea){
				console.error("this._contentArea has not been initialized.");
				return;
			}
			var tabs = this._contentArea._tabs.getChildren();
			if(tabIndex >= tabs.length){
				throw new Error(Constants.getMessage("labelTabIndex", tabIndex));
			}else{
				this._contentArea._tabs.selectChild(tabs[tabIndex]);
			}
		},
		
		_getTabbedViewer: function(node, tabContent)
		{
			this.tabs = [];
			node.appendChild(tabContent.domNode);
			this.tabs.push(tabContent);
		},
		
		updateData: function(oldValues, newValues, rowData, internal)
		{
			var configObjects =[];
			//First prepare config object to save older data
			for(var i=0; i<this.configValues.length; i++)
			{
				if(this.configValues[i].catalogType === rowData.catalogType)
				{
					this.configValues[i].catalogEntries = newValues;
				}
			}
			if(!internal)
			{
				for(var i=0; i<this.configValues.length; i++)
				{
					var obj = {name: this.configValues[i].catalogType, values: []};
					//Store the older values and overwrite if needed
					for(var count=0;count<this.configValues[i].catalogEntries.length;count++)
						obj.values[count] = {name: this.configValues[i].catalogEntries[count]};
					if(this.configValues[i].catalogType === rowData.catalogType)
					{
						obj.values = [];
						for(var j=0;j<newValues.length;j++)
							obj.values[j] = {name: newValues[j]};
						configObjects.push(obj);
					}
					configObjects.push(obj);
				}
				this._setConfig({catalogTypes: configObjects})
			}
			
		},
		
		_updateEnvironment: function(config)
		{
			this.configValues = config;
			this.environmentUpdated = true;
			this.setDirty();
		},
		
		_displayAlertDialog: function(message, handler)
		{
			var args = {
                'message': message
            };
			if(handler){
				args.okCallback = handler;
			}
			var alertDialog = new AlertDialog(args);
			
            alertDialog.setSecondaryTitle("");
            alertDialog.open();
		},
		
		_compareEnvironmentsByName: function(obj1, obj2) {
			var val1 = obj1 && obj1.name ? obj1.name : "";
			var val2 = obj2 && obj2.name ? obj2.name : "";
			if(val1 == val2)
            	return 0;
        	return (val1 > val2) ? 1 : -1;
		},
		
		_error: function()
		{
			alert(Constants.getMessage("labelErrorInfoEnvironment"))
		}
	}
);
}
)();
