/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/

/*
 * Adapter Selector widget - 
 * Author: vasrivas
 */

dojo.provide("com.ibm.rqm.execution.web.ui.internal.view.resourcebrowser.AdapterSelector");

dojo.require("dojox.data.dom");
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");
dojo.require("com.ibm.rqm.execution.web.ui.internal.view.table.MachineAdapterTableView");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.rqm.execution.web.client.internal.execution.ToolAdapterRegistrationClient");
dojo.require("com.ibm.rqm.execution.web.client.internal.execution.ExecutionClient");
dojo.require("com.ibm.rqm.execution.web.client.internal.execution.ExecutionWorkItemClient");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.table.TestScriptImportTableView");

(function(){ 
    
	var ServiceResponseHandler			= com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
	var Constants						= com.ibm.rqm.planning.web.client.internal.Constants;
	var ExecutionClient 				= com.ibm.rqm.execution.web.client.internal.execution.ExecutionClient;
	var ExecutionWorkItemClient			= com.ibm.rqm.execution.web.client.internal.execution.ExecutionWorkItemClient;
	var ToolAdapterRegistrationClient	= com.ibm.rqm.execution.web.client.internal.execution.ToolAdapterRegistrationClient;
	var TestScriptImportTableView    	= com.ibm.rqm.planning.web.ui.internal.view.table.TestScriptImportTableView;
	var MachineAdapterTV           		= com.ibm.rqm.execution.web.ui.internal.view.table.MachineAdapterTableView;
	var IMPORT							= 1;
    dojo.declare("com.ibm.rqm.execution.web.ui.internal.view.resourcebrowser.AdapterSelector", [dijit._Widget, dijit._Templated], {
        templateString: "<div class= \"com-ibm-rqm-execution-resourcebrowser-adapter-selector\" dojoAttachPoint=\"_adapterContainer\">" +
							"<table><tbody><tr>"+
							"<td style=\"display: none;\"><label style=\"font-family:Arial;font-size:9pt;\" dojoAttachPoint=\"_selectedAdapter\"></label></td><td style=\"display: none;\"><input dojoAttachPoint=\"_adapterName\"></input></td><td><button style=\"font-family:Arial;font-size:9pt;\" dojoAttachPoint=\"_onBrowse\" dojoAttachEvent=\"onclick: _onOpenAdapterDialog\"></button></td>"+
							"</tr><tr>"+
							"<td><label style=\"font-family:Arial;font-size:9pt;\" dojoAttachPoint=\"_labelScriptPath\"></label></td><td style=\"padding-right: 2px;\" colspan=\"2\"><input style=\"width:100%;\" dojoAttachPoint=\"_scriptPath\"></input></td>"+
							"</tr></tbody></table>"+
							"<div dojoAttachPoint=\"_adapterDialogNode\"></div>"+
						"</div>",
		
		dialogWidth: "80%",
		adapterId: -1,
        constructor: function(args){
		},
        
        postCreate: function(){
			this._labelScriptPath.innerHTML = Constants.getMessage("labelScriptPath");
			this._onBrowse.innerHTML = Constants.getMessage("labelSelectAdapter");
			this._scriptPath.readOnly = true;
			if(this.insideScriptEditor == false){
				dojo.style(this._labelScriptPath, "display", "none");
				dojo.style(this._scriptPath, "display", "none");
			}
			
			if(this.script){
				this.adapterId = this.script.adapterId ? this.script.adapterId : null;
				this._scriptPath.value = this.script.fullPath ? this.script.fullPath : "";
				this._scriptPath.title = this.script.fullPath ? this.script.fullPath : "";
				var responseHandler = new ServiceResponseHandler(this, "_prefillEngines", "_error");
				ToolAdapterRegistrationClient.getAdapters(responseHandler, {type:this.scriptType.id});
			}
		},

		_prefillEngines: function(engs){
			var engines = engs && engs.length > 0 ? engs : [];
			for(var i=0;i<engines.length;i++){
				if(engines[i].id == this.adapterId){
					this.selectedAdapter = engines[i];
					break;
				}	
			}
		},

		initialize: function(){
		},
		
		setScriptType: function(scriptType){
			this.scriptType = scriptType;
		},
		
		getProjectPath: function(){
			if(this.dataStoreLocation)
			  	return this.dataStoreLocation;
			else
				return this._scriptPath.value;
		},
		
		getSelectedAdapter: function(){
			return this.selectedAdapter;
		},
		
		_onOpenAdapterDialog: function(e){
			if(!this.scriptType.id){
				console.error(Constants.getMessage("errMissScriptTypeId"));
				return;
			}
			
			var adapterArgs = {
					scriptType: this.scriptType.id,
					loadingCompleteCallback: dojo.hitch(this, this._createDialog),
					hideReservationNode: true
					}
				this.adapterTable = new MachineAdapterTV(adapterArgs);
		},
		
		_createDialog: function(engineList){
			dojox.data.dom.removeChildren(this._adapterDialogNode);
			
			this.topSection = document.createElement('div');
			this.middleSection = document.createElement('div');
			this.bottomSection = document.createElement('div');

			this.nextButton = document.createElement('button');
			this.nextButton.innerHTML = Constants.getMessage("labelNext");
			dojo.style(this.nextButton, "fontSize", "1em");
			dojo.connect(this.nextButton, "onclick", this, this._onNextClicked);
			
			this.backButton = document.createElement('button');
			this.backButton.innerHTML = Constants.getMessage("labelPrevious");
			dojo.style(this.backButton, "fontSize", "1em");
			this.backButton.disabled = true;
			dojo.connect(this.backButton, "onclick", this, this._onBackClicked);
			
			this.finishButton = document.createElement('button');
			this.finishButton.innerHTML = Constants.getMessage("labelFinish");
			dojo.style(this.finishButton, "fontSize", "1em");
			dojo.connect(this.finishButton, "onclick", this, this._onFinishClicked);
			this.finishButton.disabled = true;
			
			this.cancelButton = document.createElement('button');
			this.cancelButton.innerHTML = Constants.getMessage("labelCancel");
			dojo.style(this.cancelButton, "fontSize", "1em");
			dojo.connect(this.cancelButton, "onclick", this, this._onCancelClicked);
			
			var buttonDiv = document.createElement('span');
			buttonDiv.appendChild(this.backButton);
			buttonDiv.appendChild(this.nextButton);
			buttonDiv.appendChild(this.finishButton);
			buttonDiv.appendChild(this.cancelButton);
			
			var tableDiv = document.createElement('div');
			this.messageNode = document.createElement('span');
			tableDiv.appendChild(this.messageNode);
			this.messageNode.innerHTML = Constants.getMessage("msgStep1AdapterSearch");
			
			var table = document.createElement('table');
			table.width = "80%";
			var tbody = document.createElement("tbody");
			table.appendChild(tbody);
			var tr1 = this._getEmptyRow();
			tbody.appendChild(tr1);
			
			var td1 = this._getEmptyCell();
			td1.width = "10%";
			var pathLabel = document.createElement("label");
			pathLabel.innerHTML = Constants.getMessage("labelProjectPath");
			td1.appendChild(pathLabel);
			tr1.appendChild(td1);
			
			this.pathValue = document.createElement("input");
			this.pathValue.type = "text";
			this.pathValue.size = "80";
			this.pathValue.value = "";
			var td2 = this._getEmptyCell();
			td2.width = "70%";
			td2.appendChild(this.pathValue);
			tr1.appendChild(td2);
			
			var goButton = document.createElement('button');
			goButton.innerHTML = Constants.getMessage("labelGo");
			dojo.style(goButton, "fontSize", "1em");
			dojo.connect(goButton, "onclick", this, this._onGoClicked);
			var td3 = this._getEmptyCell();
			td3.width = "20%";
			td3.appendChild(goButton);
			tr1.appendChild(td3);
			
			tableDiv.appendChild(document.createElement('br'));
			tableDiv.appendChild(document.createElement('br'));
			tableDiv.appendChild(table);
			this.projectPathNode = table; 
			this.projectPathNode.style.display = "none";
			
			
			//Error Label & Error Value
			var tr2 = this._getEmptyRow();
			tbody.appendChild(tr2);
			var tr3 = this._getEmptyRow();
			tbody.appendChild(tr3);
			
			var tr4 = this._getEmptyRow();
			tbody.appendChild(tr4);
			var td2_1 = this._getEmptyCell();
			td2_1.width = "10%";
			this.errorLabel = document.createElement("label");
			this.errorLabel.innerHTML =  Constants.getMessage("labelError");
			this.errorLabel.style.display = "none";
			td2_1.appendChild(this.errorLabel);
			tr4.appendChild(td2_1);
			
			var td2_2 = this._getEmptyCell();
			td2_2.width = "70%";
			this.errorValue = document.createElement("label");
			this.errorValue.style.display = "none";
			td2_2.appendChild(this.errorValue);
			tr4.appendChild(td2_2);
			
			var td2_3 = this._getEmptyCell();
			td2_3.width = "20%";
			tr4.appendChild(td2_3);
			
			this.topSection.appendChild(tableDiv);
			this.middleSection.appendChild(this.adapterTable.domNode);
			this.bottomSection.appendChild(buttonDiv);
			
            var dialogArgs = {
                primaryTitle: Constants.getMessage("labelAdapterLocalResource"),
                showActions: false,
				isClosable: true,
				style: "z-index:9999;" 
            }
            this._adapterDialog = new com.ibm.asq.common.web.ui.internal.widgets.SelectionDialog(dialogArgs);
            this._adapterDialog.setWidth(this.dialogWidth);
			this._adapterDialog.contentContainer.appendChild(this.topSection);
			this._adapterDialog.contentContainer.appendChild(this.middleSection);
			this._adapterDialog.contentContainer.appendChild(this.bottomSection);				
			
			buttonDiv.style.cssFloat = "right";
			buttonDiv.style.Float = "right";
			this.selectedAdapter = null;
			this.selectedScript = null;
			this._adapterDialog.open(false);
		},
		
		_onCancelClicked: function(){
			this._adapterDialog.close();
		},
		
		_onGoClicked: function(){
			this.errorLabel.style.display = "none";
			this.errorValue.style.display = "none";
			
			if(this._timer)
				clearInterval(this._timer);
				
			if(this.pathValue.value == ""){
				alert(Constants.getMessage("msgEnterProjectPath"));
				return;
			}
			this._scriptTable.refresh();
			this._scriptTable.showLoadingProgress();
			var props = [];
			props.push({propertyName: "scriptType", propertyValue: this.scriptType.id});
			props.push({propertyName: "scriptPath", propertyValue: this.pathValue.value});
			
			var requestObj = {
				selectedAdapterId: this.selectedAdapter.id,
				requestType: IMPORT,
				properties: props,
				isNew: true
			}
			var responseHandler = new ServiceResponseHandler(this, "_startChecking", "_error");
			ExecutionClient.postCreateRequest(responseHandler, requestObj);
		},
		
		_onNextClicked: function(){
			if(this._timer)
				clearInterval(this._timer);
			var adapter = this.adapterTable.getSelectedAdapter();
			if(!adapter){
				alert(Constants.getMessage("msgSelectAdapter"))
				return;
			}
			this.messageNode.innerHTML = Constants.getMessage("msgStep2AdapterSearch");
			this.projectPathNode.style.display = "inline";
			
			this.selectedAdapter = adapter;
			this.nextButton.disabled = true;
			this.backButton.disabled = false;
			this.finishButton.disabled = true;
			dojo.style(this.adapterTable.domNode, "display", "none");

			this._scriptTable = new TestScriptImportTableView({singleSelect: this.insideScriptEditor, 
															   scripts: [], 
															   queryName: Constants.getMessage("labelSelectTestScript"),
															   rowCheckListener:dojo.hitch(this,this._rowCheckListener)});
			this.middleSection.appendChild( this._scriptTable.domNode );
		},
		_rowCheckListener:function(state){
			this.finishButton.disabled = !state;
		},		
		_startChecking: function(request){
			this.requestId = request.id;
			// Clear any timer that might be already existing
			if(this._timer)
				clearInterval(this._timer);
			this._timer = setInterval(dojo.hitch(this, "fetchFiles"), 2000);
		},
		fetchFiles: function(){
			var importSelf = this;
			var callbackObj = {
				success: function(request){
					if(request && request.length > 0 && request[0].id == importSelf.requestId){
						var requestObject = request[0];//Only one object should be returned
						var percent =requestObject.progress;
						var responseObjects = requestObject.response;
						if(percent=="100"){
							clearInterval(importSelf._timer);
							importSelf._timer = null;
							
							var scriptNamesArray = []
							var message = responseObjects ? responseObjects.data : "";
							if(responseObjects){
								var messagesArr = [];
								messagesArr = responseObjects.messages;
								if(messagesArr){
									for(var i=0 ;i<messagesArr.length; i++){
										if(messagesArr[i].statusCode == 404){
											var error  = messagesArr[i].message;
											if(error == "labelInvalidDir")
											{
												importSelf.errorValue.innerHTML = Constants.getMessage("labelInvalidDir");
												importSelf.errorLabel.style.display = "inline";
												importSelf.errorValue.style.display = "inline";
											}
										}
									}
								}
							}
							var arr = [];
							var newMessage = dojo.fromJson(message);
							if(newMessage.fileSeparator){
								if(newMessage.dataStoreLocation != null ){
									importSelf.dataStoreLocation = newMessage.dataStoreLocation;
								}
								arr.push(newMessage.fileSeparator);
								for(var i=0;i<newMessage.resourceList.length;i++){
									arr.push(newMessage.resourceList[i]);
								}
							} else{
								//1.0
								arr = message && message != "" ? message.split(":") : [];
							}
							if(arr[0] != "-1"){//File Seperater passed from the adapter
								if(importSelf.parentEditor){
									importSelf.parentEditor.setFileSeperater(arr[0]);
								}
							}	
							
							for(var j=1;j<arr.length;j++)//Skip the first in array
								scriptNamesArray.push(arr[j])
							importSelf._populateFileTable(scriptNamesArray);
						}
					}
				},
				
				error: function(e){
					importSelf._error(e);
				}				
			}
			
			var param = {
					requestId: importSelf.requestId
				}
			var responseHandler = new ServiceResponseHandler(callbackObj, "success", "error");
			ExecutionWorkItemClient.getRequestDTO(responseHandler, param);
		},
		
		_populateFileTable: function(scripts){
			this._scripts = scripts ? scripts : [];
			this._scriptTable.endLoadingProgress();
			var tableObjects = [];
			var normalizedPath = "";
			if(this.dataStoreLocation != null){
				normalizedPath = this._normalizePath(this.dataStoreLocation);
			}
			else{
				normalizedPath = this._normalizePath(this.pathValue.value);
			}
			for (var i = 0; i < this._scripts.length; i++) {
				tableObjects.push({
               		type: this.scriptType.id,
					scriptTypeName: this.scriptType.name,
					id: i,
               		name: this._scripts[i],
					dataStoreLocation: normalizedPath
				});
			}
			this._scriptTable.refresh(tableObjects);
			if( this._adapterDialog )this._adapterDialog.updatePosition();
		},
		
		_onBackClicked: function(){
			this.errorLabel.style.display = "none";
			this.errorValue.style.display = "none";
			
			// In case going back from the page that's getting a list
			// Clear the timer
			if(this._timer){
				clearInterval(this._timer);
				delete this._timer;
			}
			if(this._scriptTable)
				dojo.style(this._scriptTable.domNode, "display", "none");
			dojo.style(this.adapterTable.domNode, "display", "inline");
			this.messageNode.innerHTML = Constants.getMessage("msgStep1AdapterSearch");
			this.projectPathNode.style.display = "none";
			this.nextButton.disabled = false;
			this.backButton.disabled = true;
			this.finishButton.disabled = true;
		},
		
		_onFinishClicked: function(){
			var scripts = this._scriptTable ? this._scriptTable.getSelectedRows() : [];
			this.selectedScript = (scripts && scripts.length > 0 ?scripts[0]:null);
			this._adapterDialog.close();
			this._adapterDialog = null;
			if(this._timer)
				clearInterval(this._timer);
			var scriptPath = this.pathValue.value;
			if(this.dataStoreLocation){
				scriptPath = this.dataStoreLocation + this.parentEditor.getFileSeperater() + this.selectedScript.name;
			}else if(this.selectedScript && dojo.trim(this.selectedScript.name).length > 0){
				scriptPath = scriptPath + this.parentEditor.getFileSeperater() + this.selectedScript.name;//Add appendFile check here
			} 
				
			this._scriptPath.value = scriptPath;
			this._scriptPath.title = scriptPath;
			if(dojo.isFunction(this.onClose))
				this.onClose()
		},
		
		_getEmptyRow: function() {
			var row = document.createElement("tr");
			return row;
		},
		
		_getEmptyCell: function(span, align){
			var cell = document.createElement("td");
			if ( span != null ) {
				cell.colSpan = span;
			}
			if ( align != null ){
				cell.align = align;
			}
			return cell;
		},
		
		getAttributes: function(){
			var normalizedPath = this._normalizePath(this.pathValue.value);
			if(this.dataStoreLocation){
				//1.0.1
				normalizedPath = this.dataStoreLocation;
			}
			if(this.insideScriptEditor){
				var param = {
					selectedAdapter: this.selectedAdapter,
					scriptPath: normalizedPath,
					selectedScript: this.selectedScript
				}
				return param;
			}else
			{
				var param = {
					selectedAdapter: this.selectedAdapter,
					scripts: this._scriptTable ? this._scriptTable.getSelectedRows() : []
				}
				return param;
			}
		},
		
		_normalizePath: function(path){
			if (path.lastIndexOf("/") == path.length - 1
							|| this.pathValue.value.lastIndexOf("\\") == path.length - 1){
				return path.substring(0, path.length - 1 );
			} else {
				return path;
			}
		},
		
		disconnectEvents: function(){
			this._onBrowse.disabled = true;
			this._scriptPath.readOnly = true;
		},
		
		connectEvents: function(){
			this._onBrowse.disabled = false;
			this._scriptPath.readOnly = false;
		},
		
		_error: function(errorObj){
			if(this._scriptTable){
				this._scriptTable.endLoadingProgress();
			}
			console.error(Constants.getMessage("errInAdapterSelector")+ errorObj.message + " ");
		}        
    });
})();