/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
/*
 * Selection Popup for Script Adapter selection for a Suite
 * Author: vasrivas
 */
dojo.provide("com.ibm.rqm.execution.web.ui.internal.view.suite.SelectionPopUp");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("net.jazz.ajax.ui.internal.HoverPopup");
dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");
dojo.require("com.ibm.rqm.execution.web.ui.internal.view.common.ImageCache");
dojo.require("com.ibm.asq.common.web.ui.internal.view.common.ImageCache");
dojo.require("com.ibm.rqm.execution.web.ui.internal.util.Utility");
dojo.require("com.ibm.rqm.execution.web.client.internal.execution.TestExecutionSuiteClient");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.rqm.execution.web.ui.internal.view.table.MachineAdapterTableView");
dojo.require( "com.ibm.asq.common.web.ui.internal.util.SelectUtility" );
dojo.require("com.ibm.team.repository.web.client.session.Session");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.Button");
dojo.require("com.ibm.rqm.planning.web.client.internal.planning.PlanningPageClient");
dojo.require("com.ibm.rqm.process.web.client.internal.timebox.TimeboxClient");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentProvider");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer");

(function(){ 
	var ServiceResponseHandler			= com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
    var ToolAdapterRegistrationClient	= com.ibm.rqm.execution.web.client.internal.execution.ToolAdapterRegistrationClient;
	var ImageCache     					= com.ibm.rqm.execution.web.ui.internal.view.common.ImageCache;
	var CommonImageCache				= com.ibm.asq.common.web.ui.internal.view.common.ImageCache;
	var ExecutionClient 				= com.ibm.rqm.execution.web.client.internal.execution.ExecutionClient;
	var TestSuiteClient					= com.ibm.rqm.execution.web.client.internal.execution.TestExecutionSuiteClient;
	var Utility							= com.ibm.rqm.execution.web.ui.internal.util.Utility;
	var MachineAdapterTV				= com.ibm.rqm.execution.web.ui.internal.view.table.MachineAdapterTableView;
	var getAuthenticatedContributor		= com.ibm.team.repository.web.client.session.getAuthenticatedContributor;
	var getCurrentProjectArea 			= com.ibm.team.process.web.client.projectarea.getCurrentProjectArea;
	var Button							= com.ibm.asq.common.web.ui.internal.widgets.Button;
	var PlanClient 						= com.ibm.rqm.planning.web.client.internal.planning.PlanningPageClient;
	var TimeBoxClient					= com.ibm.rqm.process.web.client.internal.timebox.TimeboxClient;
	var TC_ID							= "_tc_";
	var SCRIPT_ID 						= "_scirpt_";
	var ADAPTER_ID 						= "_adp_";
	var ADAPTER_IMG_ID 					= "_adpImg_";
	var CHG_ID							= "_chg_";
	var Constants 						= com.ibm.rqm.planning.web.client.internal.Constants;
	var SelectUtility 					= dojo.getObject( "com.ibm.asq.common.web.ui.internal.util.SelectUtility" );
	var TableConstants 					= com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants;
	
	dojo.declare("SelectionPopUp.TableListener", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableListener,
	{        
		constructor: function(parentView) {
	        this.parentView = parentView;
	    },
	
	    rowCheckStateChanged: function(tableViewer, rowObject, state){
			var selectedRows = tableViewer.getCheckedRows();
			var selectionCount = selectedRows.length;
			if(selectionCount == 1){
				if(selectedRows[0].selectedScriptTypeId == "com.ibm.rqm.planning.common.scripttype.manual")
					this.parentView.changeAction.setDisabled(true);
				else
					this.parentView.changeAction.setDisabled(false);
			}else if(selectionCount >1){
				var selectedType = selectedRows[0].selectedScriptTypeId;
				var notSameType = false;
				if(selectedType == "com.ibm.rqm.planning.common.scripttype.manual"){
					notSameType = true;
				}else{
					for(var i=0;i<selectionCount;i++){
						if(selectedRows[i].selectedScriptTypeId != selectedType){
							notSameType = true;
							break;
						}
					}
				}
				if(notSameType)
					this.parentView.changeAction.setDisabled(true);
				else
					this.parentView.changeAction.setDisabled(false);
			}else{
				this.parentView.changeAction.setDisabled(true);
			}
	    },
	 
	    tableContentActionInvoked: function(tableViewer, actionId, callbackData, callback){                
	        if (callback === null && callbackData !== null && dojo.isFunction(callbackData)) {
	            callbackData();
	        }
			if (callback !== null && dojo.isFunction(callback)) {
	            if (callbackData !== null) {
	                callback(callbackData);
	            } else {
	                callback();
	            }
	        } 
	    }
	});
	dojo.declare("SelectionPopUp.CellModifier", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableCellModifier,
	{
		setChangeListener: function(listener){
			this.changeListener = listener;
		},
		cellValueChanged: function(oldValue, newValue, rowObject, columnIndex){
			if(columnIndex == 3) {
				if(this.changeListener && this.changeListener._scriptChanged){
					this.changeListener._scriptChanged.apply(this.changeListener.context, [rowObject,newValue]);
				}
	        }    
		},
	    cellActionInvoked: function(rowObject, columnIndex){
			if(columnIndex ==6){
				if(rowObject.selectedScriptTypeId != "com.ibm.rqm.planning.common.scripttype.manual"){
					if(this.changeListener && this.changeListener._scriptChanged){
						this.changeListener._adapterChange.apply(this.changeListener.context, [rowObject.index]);
					}
				}
			}
		}
	});

	dojo.declare("SelectionPopUp.TableProvider", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentProvider,
	{
		labelUnassigned: Constants.getMessage("labelUnassigned"),
		labelLoading: Constants.getMessage("labelLoading"),
	    getNumColumns: function(content){
	        return 7;
	    },
	    getColumnHeading: function(content, index){
	        var headings = [
					Constants.getMessage("labelTestCase"),
					Constants.getMessage("labelTestPlan"),
					Constants.getMessage("labelIteration"),
					Constants.getMessage("labelTestScript"),
					Constants.getMessage("labelMachine"),
					Constants.getMessage("labelHealth")
				];
	        return headings[index];
	    },
	    getColumnHeadingAlignment: function(atColumnIndex){
	        return this.getCellAlignment(null, atColumnIndex);
	    },	 
	    getIsColumnGroupable: function(content, atColumnIndex){
	        return false;
	    },
	    getIsColumnSortable: function(content, atColumnIndex){
	        return false;   
	    },
	    getColumnWidth: function(content, atColumnIndex){
	        switch(atColumnIndex) {
	            case 0: 
	                return 20;
	            case 1: 
					return 15;
	            case 2: 
	                return 15;
	            case 3: 
					return 25;
	            case 4: 
	                return 15;
				case 5: 
	                return 5;
				case 6: 
	                return 5;				 
	        }
	        return 0;
	    },
		
	    getContentObjects: function(content){
	        return content;
	    },
	    
		getRowDataId: function(rowData){
	        return rowData.index+"";
	    },
		
	    getCellDisplayType: function(rowData, atColumnIndex){
	        var type = TableConstants.RENDER_TYPE_TEXT;
	        switch(atColumnIndex) {
				case 3:
					type = TableConstants.RENDER_TYPE_ENUM;
					break;
	            case 5: 
	                type = TableConstants.RENDER_TYPE_IMAGE;
	                break;
				case 6:
					type = TableConstants.RENDER_TYPE_ACTION;
					break;
	        }
	        return type;
	    },
	
	    getCellAlignment: function(rowData, atColumnIndex){
	        return  atColumnIndex==5? TableConstants.ALIGN_CENTER:TableConstants.ALIGN_LEFT;
	    },
	 
	    getCellDisplayData: function(rowData, atColumnIndex){
	        var val = "";
	        switch(atColumnIndex) {
	            case 0: 
	                val = rowData.workitem.testCase.name;//TestCase
	                break;
	            case 1://TestPlan
	                val = rowData.workitem.testPlan ? rowData.workitem.testPlan.name : this.labelUnassigned;
	                break;
				case 2://Test Iteration
					val = rowData.workitem.testPhase ? rowData.workitem.testPhase.name : this.labelUnassigned;
					break;
				case 4:
					val = rowData.machine?rowData.machine.machineName:this.labelLoading;
					break;
	        }
	        return val;
	    },
	
	    getCellDisplayExtendedInfo: function(rowData, atColumnIndex){  
	        var val = null;
	        if (atColumnIndex == 3) {
				val = {};
				val.choices = [];
				var scripts = rowData.workitem.testCase.scripts;
				for (var i = 0; i < scripts.length; i++) {
					if(scripts[i].archived)
						continue;
					val.choices.push({text: scripts[i].name, value: scripts[i].id});
				}
				val.select = rowData.selectedScriptId;
			}else if(atColumnIndex == 5){
				val = {};
				val.image = rowData.adapterImg;
				val.tooltip = rowData.adapterStatus;
			}else if(atColumnIndex == 6){
				val = {};
				if(rowData.selectedScriptTypeId != "com.ibm.rqm.planning.common.scripttype.manual"){
					val.image = ImageCache.EDIT_ICON;
					val.tooltip = Constants.getMessage("labelChange");
				}else{
					val.image = ImageCache.NOIMAGE;
				}
			}
			return val;
	    }
	});
	dojo.declare("com.ibm.rqm.execution.web.ui.internal.view.suite.SelectionPopUp", [dijit._Widget, dijit._Templated], {
        templateString: '<div class= "com-ibm-rqm-execution-web-selection-popup">' +
						'    <div dojoAttachPoint="_messageNode"></div>'+
						'        <div dojoAttachPoint="_surroundingNode">'+
						'            <div dojoAttachPoint="_tableViewerNode" class="com-ibm-rqm-test-artifact-table-view" tabindex="-1">'+
						'            </div>'+
						'            <table width="100%">' +
						'                <tr>'+
						'                 <td colspan="3">' +		
						'                     <input class="check" dojoAttachPoint="parExecCheck" type="checkbox">${labelExecuteSuite}</input>' +
						'                 </td>'+
						'             </tr>'+						
						'             <tr>'+
						'                 <td colspan="3">'+
						'                     <input type="checkbox" dojoAttachPoint="_checkValue" dojoAttachEvent="onclick: _checkValueChange"></input>'+
						'                         <span style="padding-left:5px;">${labelAssociatePlan}</span>'+
						'                 </td>'+
						'             </tr>'+
						'             <tr dojoAttachPoint="_TPNode">' +
	                    '                  <td width="150px"><label for="TestPlan">${labelTestPlan}</label></td>' + 
	                    '                  <td><select id="TestPlan" dojoAttachPoint="_TP" style="width:200px" dojoAttachEvent="onchange: onSelectTP" disable="true"></select></td>' +
						'                  <td></td>' +
	                    '              </tr>' +   
	                    '              <tr dojoAttachPoint="_IterationNode">' +
	                    '                  <td width="150px"><label for="Iteration">${labelIteration}<span></td>'+ 
	                    '                      <td><select id="Iteration" dojoAttachPoint="_Iteration" style="width:200px" disable="true"></select></td>' +
						'                     <td></td>' +
	                    '              </tr>' + 
						'             </table>' +
						'        </div>'+	
					    '    </div>'+
						'</div>',
        
		width: "1000px",
		labelTestPlan:Constants.getMessage("labelTestPlan"),
		labelIteration: Constants.getMessage("labelIteration"),
		labelAssociatePlan: Constants.getMessage("labelAssociateResultsToPlan"),
        labelTitle: Constants.getMessage("labelExeTestSuite"),
		labelRun: Constants.getMessage("labelRun"),
		labelCancel: Constants.getMessage("labelCancel"),		
		labelExecuteSuite: Constants.getMessage("labelExecuteSuite"),
		
        constructor: function(args){
		},
        
        postCreate: function(){
			this.TC_ID = this.id+TC_ID;
			this.SC_ID = this.id+SCRIPT_ID;
			this.ADP_ID = this.id+ADAPTER_ID;
			this.ADP_IMG_ID = this.id+ADAPTER_IMG_ID;
			this.CHG_ID = this.id+CHG_ID;
			this.rowsWithArchivedScripts = [];
			this.cantProceed = false;
		},
		
		initialize: function(suite){
			this.suite = suite;
			this.elements = [];
			var currentResultElements = suite.currentResultGroup && suite.currentResultGroup.elements ? suite.currentResultGroup.elements : [];
			if(this.suite.elements && this.suite.elements.length > 0){
				var noScriptMsg = "";
				this.elements = this.suite.elements;
				for(var i=0;i<this.elements.length;i++){
					for(var j=0;j<currentResultElements.length;j++){
						if(currentResultElements[j].ewiId == this.elements[i].workitem.id && 
							currentResultElements[j].index == this.elements[i].index){
								this.elements[i].selectedScriptId = currentResultElements[j].scriptId;
								this.elements[i].selectedScriptTypeId = currentResultElements[j].scriptTypeId;
								this.elements[i].selectedScriptName = currentResultElements[j].scriptName;
								this.elements[i].adapterId = currentResultElements[j].adapterId+"";
								this.elements[i].adapterImg = ImageCache.NOIMAGE;
								this.elements[i].adapterStatus = "";
								break;
						}
					}
					if(!this.elements[i].workitem.testCase.scripts || this.elements[i].workitem.testCase.scripts.length === 0){
						noScriptMsg = Constants.getMessage("msgScriptNotFoundInTestCase", this.elements[i].workitem.testCase.name);
					}else{
						var selectedFound = false;
						var defaultFound = false;
						var elementScriptFound = false;
						//remove any archived scripts and also check if the last selected script is available and if the default script is available
						for(var k=0;k<this.elements[i].workitem.testCase.scripts.length;k++){
							if(this.elements[i].workitem.testCase.scripts[k].archived){
								if(this.elements[i].selectedScriptId == this.elements[i].workitem.testCase.scripts[k].id)
									this.elements[i].selectedScriptId = null;
								if(this.elements[i].workitem.defaultScript &&
										this.elements[i].workitem.defaultScript.id == this.elements[i].workitem.testCase.scripts[k].id)
									this.elements[i].workitem.defaultScript = null;
								this.elements[i].workitem.testCase.scripts.splice(k,1);
								k=k-1;
							}else{
								if(this.elements[i].selectedScriptId == this.elements[i].workitem.testCase.scripts[k].id)
									selectedFound = true;
								if(this.elements[i].script && 
										this.elements[i].script.id == this.elements[i].workitem.testCase.scripts[k].id)
									elementScriptFound = true;	
								else if(this.elements[i].workitem.defaultScript && 
										this.elements[i].workitem.defaultScript.id == this.elements[i].workitem.testCase.scripts[k].id)
									defaultFound = true;
							}
						}
						if(!selectedFound)
							this.elements[i].selectedScriptId = null;
						if(!defaultFound)
							this.elements[i].workitem.defaultScript = null;
						if(!elementScriptFound)
							this.elements[i].script = null;	
						if(this.elements[i].workitem.testCase.scripts.length === 0){
							noScriptMsg = Constants.getMessage("msgScriptNotFoundInTestCase", this.elements[i].workitem.testCase.name);
						}else if(!this.elements[i].selectedScriptId ){//either suite changed or this is the first run 
							var script  = this.elements[i].script ? this.elements[i].script : this.elements[i].workitem.defaultScript;
							if(!script)
								script = this.elements[i].workitem.testCase.scripts[0];
							this.elements[i].selectedScriptId = script.id;
							this.elements[i].selectedScriptTypeId = script.scriptType.id;
							this.elements[i].selectedScriptName = script.name;
							this.elements[i].adapterId = "";
							this.elements[i].adapterImg = ImageCache.NOIMAGE;
							this.elements[i].adapterStatus = "";
							if(script.archived){
								this.rowsWithArchivedScripts.push(this.elements[i]);
								dojo.style(this._messageNode, "display", "inline");
								this._messageNode.innerHTML = "<img src='"+CommonImageCache.ERROR_ICON+"' style='vertical-align:middle;'></img>"+
										Constants.getMessage("msgTestScriptArchived",script.name,this.elements[i].workitem.testCase.name);
								this.cantProceed = true;
							}
						}
					}
				}
				if(noScriptMsg !== ""){
					this._messageNode.innerHTML = "<img src='"+CommonImageCache.ERROR_ICON+"' style='vertical-align:middle;'></img>"+noScriptMsg;
					dojo.style(this._messageNode, "display", "inline");
					dojo.style(this._surroundingNode, "display", "none");
					this._showAsDialog(true);
				}else{
					dojo.style(this._surroundingNode, "display", "inline");
					if(this.cantProceed){
						this._showAsDialog(true);
					}else{
						dojo.style(this._messageNode, "display", "none");
						this._messageNode.innerHTML = "";
						this._showAsDialog(false);
					}
					this.parExecCheck.checked = this.suite.sequentialExecution ? false : true;//Checkbox is for parallel wi6856
					this._showTable();
					this._fillTestPlanTestPhase();
				}	
			} else {
				this._messageNode.innerHTML = "<img src='"+CommonImageCache.ERROR_ICON+"' style='vertical-align:middle;'></img>"+
					Constants.getMessage("msgNoTestCasesFoundForSuite");
				dojo.style(this._messageNode, "display", "inline");	
				dojo.style(this._surroundingNode, "display", "none");
				this._showAsDialog(true);
			}
			
		},
		
		_fillTestPlanTestPhase: function(){
			this.allPlans = [];
			this.testCases= [];
			this.testPlansForTestCaseReceivedCount = 0;
			for(var i=0; i<this.suite.elements.length; i++){
				this.testCases.push(this.suite.elements[i].workitem.testCase);
			}
			if (this.testCases && this.testCases.length > 0) {
				for (var j = 0; j < this.testCases.length; j++) {
					var responseHandler = new ServiceResponseHandler(this, "_fillPlans", "_error");
					PlanClient.getRelatedTestPlanByCase(responseHandler, this.testCases[j].versionableItemId);
				}
			}
		},
		
		_showAsDialog: function(disableRunButton){
            if (!this._dialog) {
        		/*
        		 * Custom z-index is needed as hover popup wont show up
        		 * For FF3 pass zIndex
        		 */
		        var dialogArgs = {
					primaryTitle: this.labelTitle,
					okLabel: this.labelRun,
					cancelLabel: this.labelCancel,
                    okCallback: dojo.hitch(this, "_onRunClick"),
                    cancelCallback: dojo.hitch(this, "_onCancelClick"),
					style: "z-index: 9991;",
					zIndex: 9990
                };
                this._dialog = new com.ibm.asq.common.web.ui.internal.widgets.SelectionDialog(dialogArgs);
                this._dialog.setWidth(this.width);
                this._dialog.contentContainer.appendChild(this.domNode);
                this._dialog.getOkButton().disabled = disableRunButton;                                
            }
            this._dialog.open(false);
        },
		
		_showTable: function(){
			this._setAdapters();
			var tableViewer = new com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer({showFilterControl:false,pageSize:2});        
        	this._tableViewerNode.appendChild(tableViewer.domNode);
			var content = this.elements;
			tableViewer.setContent(content);
			this.tableContentProvider = new SelectionPopUp.TableProvider();
        	tableViewer.setContentProvider(this.tableContentProvider);
			tableViewer.setTableSummary(Constants.getMessage("labelTableSummary", Constants.getMessage("labelTestCaseInTestSuite")));
			tableViewer.setTableRowsCheckable(true, /* isSingleSelect */false);
			tableViewer.setTableListener(new SelectionPopUp.TableListener(this));
			var cellModifier = new SelectionPopUp.CellModifier();
			cellModifier.setChangeListener({
				context: this,
				_scriptChanged:dojo.hitch(this,this._scriptSelectionChanged),
				_adapterChange:dojo.hitch(this, this._onChangeClick)
			});
			tableViewer.setCellModifier(cellModifier);
			this.changeAction = tableViewer.addAction("change", 
					Constants.getMessage("labelChange"), -1, "edit-icon-image", dojo.hitch(this, this._onChangeClick));
			this.changeAction.setDisabled(true);
	        tableViewer.show();
			this.tableViewer = tableViewer;

		},
		_setAdapters:function(){
			for(var i=0;i<this.elements.length;i++){
				if(this.elements[i].selectedScriptTypeId != "com.ibm.rqm.planning.common.scripttype.manual"){
					var selectedConfigId = null;
					if (this.elements[i].workitem.configuration) {
						selectedConfigId = this.elements[i].workitem.configuration != "global" ? this.elements[i].workitem.configuration : null;
					}
					var machineTV = new MachineAdapterTV({
						rowNum: this.elements[i].index, 
						scriptType: this.elements[i].selectedScriptTypeId, 
						loadingCompleteCallback: dojo.hitch(this, this._getMachinesFromTable),
						lastSelectedAdapter:this.elements[i].adapterId,
						configID: selectedConfigId
					});
					this.elements[i].matv = machineTV;
				}else{
					this.elements[i].machine = {
						name: Constants.getMessage("labelLocalComputer"),
						adapterInfo: {
							id: "global",
							name: Constants.getMessage("labelLocalComputer"),
							hostName: Constants.getMessage("labelLocalComputer")
						},
						machineName: Constants.getMessage("labelLocalComputer")
					};
				}
			}
		},
		//Handle the click on the "Change" test.  Display the MATV to let the user choose a different machine
		_onChangeClick: function(num){
			var matv = null;
			var dialogArgs = {
				style: "z-index: 9995;",
				zIndex: 9994
			};
			
			if (num != -1 && this.elements[num].matv){
				matv = this.elements[num].matv;
				dialogArgs.okCallback = dojo.hitch(this, "_okButtonClicked");
				dialogArgs.okCallbackData = {matv: matv};
			}else{
				var scriptTypeId = this.tableViewer.getCheckedRows()[0].selectedScriptTypeId;
				matv = new MachineAdapterTV({
						scriptType: scriptTypeId,
						allowMultiSelect:true
				});
				dialogArgs.okCallback = dojo.hitch(this, "_handleMultiAdapterChange");
				dialogArgs.okCallbackData = {matv: matv};
			}
			var adapterDialog = new com.ibm.asq.common.web.ui.internal.widgets.SelectionDialog(dialogArgs);
			adapterDialog.setWidth("80%");
			adapterDialog.setHeight("80%");
			adapterDialog.contentContainer.appendChild(matv.domNode);
			adapterDialog.setSecondaryTitle(Constants.getMessage("labelChooseMachineForRun"));
			adapterDialog.getOkButton().disabled = false;
			adapterDialog._onClose = function(){
				this.destroy();//dont destroy recursive;
			};
			adapterDialog.open(false);	
		},
		_handleMultiAdapterChange:function(callbackData){
			var selectedRows = this.tableViewer.getCheckedRows();
			var selectedData = callbackData.matv.getSelectedInfo();
			var j=0;
			if(selectedData.length>0){
				for(var i=0;i<selectedRows.length;i++){
					var machine = selectedData[j].machine;
					var num = selectedRows[i].index;
					this.elements[num].machine = machine;
					this.elements[num].adapterId = machine.adapterInfo.id+"";
					this._getAdapterStatus(this.elements[num]);
					j++;
					if(j==selectedData.length)
						j = 0;
				}
				this.tableViewer.setContent(this.elements);
				this.tableViewer.refresh();
			}
		},
		_okButtonClicked: function(callbackData){
			var selectedData = callbackData.matv.getSelectedInfo();
			if (selectedData && selectedData.machine){
				this._getMachinesFromTable([selectedData.machine], callbackData.matv);
			}
		},
		_scriptSelectionChanged: function(rowObject,changedValue){
			var scriptObj = null;
			var scripts = rowObject.workitem.testCase.scripts;
			var scriptId = parseInt(changedValue,10);
			for(var j=0;j<scripts.length;j++){
				if(scripts[j].id == scriptId){
					scriptObj = scripts[j];
					rowObject.selectedScriptName = scripts[j].name;
					rowObject.selectedScriptId = scripts[j].id;
					rowObject.selectedScriptTypeId = scripts[j].scriptType.id;
				}
			}
			for(var i=0;i<this.rowsWithArchivedScripts.length;i++){
				if(this.rowsWithArchivedScripts[i].id == rowObject.id){
					this.rowsWithArchivedScripts.splice(i,1);
					break;
				}
			}
			if(scriptObj && scriptObj.archived){
				this.rowsWithArchivedScripts.push(rowObject);
				dojo.style(this._messageNode, "display", "inline");
				this._messageNode.innerHTML = "<img src='"+CommonImageCache.ERROR_ICON+"' style='vertical-align:middle;'></img>"+
					Constants.getMessage("msgTestScriptArchived",scriptObj.name,rowObject.workitem.testCase.name);
				this._dialog.getOkButton().disabled = true;
				return;
			}else if(this.rowsWithArchivedScripts.length > 0){
				dojo.style(this._messageNode, "display", "inline");
				this._messageNode.innerHTML = "<img src='"+CommonImageCache.ERROR_ICON+"' style='vertical-align:middle;'></img>"+
					Constants.getMessage("msgTestScriptArchived", this.rowsWithArchivedScripts[0].selectedScriptName,this.rowsWithArchivedScripts[0].workitem.testCase.name);
				this._dialog.getOkButton().disabled = true;
				this.cantProceed = true;
				return;
			}
			this.cantProceed = false;
			dojo.style(this._messageNode, "display", "none");
			this._messageNode.innerHTML = "";
			this._dialog.getOkButton().disabled = false;
			var matv = rowObject.matv;
			
			var selectedConfigId = null;
			if (this.elements[rowObject.index].workitem.configuration) {
				selectedConfigId = this.elements[rowObject.index].workitem.configuration != "global" ? this.elements[rowObject.index].workitem.configuration : null;
			}
					
			if(rowObject.selectedScriptTypeId == "com.ibm.rqm.planning.common.scripttype.manual"){
				if(matv){
					matv.scriptType = rowObject.selectedScriptTypeId;
					this._getMachinesFromTable([], matv);
				}
			}else if(matv){//Here we need MATV to be called to get the list of adapters which are available currently.
				matv.reInitialize(rowObject.selectedScriptTypeId, selectedConfigId, dojo.hitch(this, this._getMachinesFromTable));
			}else{
				var machineTV = new MachineAdapterTV({
					rowNum: rowObject.index, 
					scriptType: rowObject.selectedScriptTypeId, 
					loadingCompleteCallback: dojo.hitch(this, this._getMachinesFromTable),
					lastSelectedAdapter:rowObject.adapterId,
					configID: selectedConfigId
				});
				rowObject.matv = machineTV;
			}
		},
	
		_getMachinesFromTable: function(machines, context){
			var num = null;
			var scriptType = null;
			if(context && context.rowNum !== null){
				num = context.rowNum;
				scriptType = context.scriptType;
				//If the script type is manual then just allow running on the local computer
				if (scriptType && scriptType == "com.ibm.rqm.planning.common.scripttype.manual"){
					this.elements[num].machine = {
						name: Constants.getMessage("labelLocalComputer"),
						adapterInfo: {
							id: "global",
							name: Constants.getMessage("labelLocalComputer"),
							hostName: Constants.getMessage("labelLocalComputer")
						},
						machineName: Constants.getMessage("labelLocalComputer")
					};
					this.elements[num].adapterImg = ImageCache.NOIMAGE;
					this.elements[num].adapterStatus = "";
					this.elements[num].adapterId = "";
				}else {
					this.elements[num].machine = machines.length > 0 ? machines[0] : {machineName:Constants.getMessage("labelNotFound")};
					this.elements[num].adapterId = machines.length > 0 ? machines[0].adapterInfo.id+"":"";
					this._getAdapterStatus(this.elements[num]);
					context.lastSelectedAdapter = machines.length > 0 ? machines[0].id:null;
				}
				var content = this.elements?this.elements:[];
				this.tableViewer.setContent(content);
				this.tableViewer.refresh();
			}
		},
		
		_getAdapterStatus: function(element){
			var adapterStatusIcon = CommonImageCache.ENGINE_AVAILABLE;
			var adapterObj = element.machine.adapterInfo;
			if(adapterObj){
				var availablity = Constants.getMessage("msgEngAvailable");
				 
				if( (adapterObj.serverTime - adapterObj.lastHeartBeat) > 10*(adapterObj.pollingInterval)){
					adapterStatusIcon = CommonImageCache.ENGINE_NOTAVAILABLE;
					availablity = Constants.getMessage("msgEngUnresponsive");
				}
				else if( (adapterObj.serverTime - adapterObj.lastHeartBeat) > 2*(adapterObj.pollingInterval)){
					adapterStatusIcon = CommonImageCache.ENGINE_NOTRESPONDED;
					availablity = Constants.getMessage("msgEngRespondLate");
				}
				element.adapterImg = adapterStatusIcon;
				element.adapterStatus = this.getAdapterToolTip(element.machine, availablity);
			}else{
				element.adapterImg = ImageCache.NOIMAGE;
				element.adapterStatus = "";
			}
		},
		
		getAdapterToolTip: function(machine, availability){
			var reservedTill = machine.reservedTill ? Utility.dateFromISOString(machine.reservedTill) : Constants.getMessage("labelNotReserved");
			var str = "<table><tr><td> </td><td> </td></tr>";
			str +="<tr><td align=left  style=\"font-size: 8pt;\">"+Constants.getMessage("labelHostname")+" "+"</td><td style=\"font-size: 8pt;\">"+machine.adapterInfo.hostName+"</td><tr>";
			str +="<tr><td> </td><td> </td></tr>";
			str +="<tr><td align=left style=\"font-size: 8pt;\">"+Constants.getMessage("labelState")+" "+"</td><td style=\"font-size: 8pt;\">"+ availability +"</td><tr>";				
			str +="<tr><td> </td><td> </td></tr>";
			str +="<tr><td align=left style=\"font-size: 8pt;\">"+Constants.getMessage("labelReserved")+" "+"</td><td style=\"font-size: 8pt;\">"+reservedTill+"</td><tr>";				
			str += "</table>";
			return str;
		},
		
		validate: function(){
			if(this.cantProceed)
				return false;
			var items = this.elements ? this.elements :[];
			for(var i=0;i<items.length;i++){
				var scriptTypeId = items[i].selectedScriptTypeId;
				var adapterId = items[i].adapterId;
				if(scriptTypeId != "com.ibm.rqm.planning.common.scripttype.manual" && (adapterId === "" || adapterId == "global")){
					dojo.style(this._messageNode, "display", "inline");
					this._messageNode.innerHTML = "<img src='"+CommonImageCache.ERROR_ICON+"' style='vertical-align:middle;'></img>"+
							Constants.getMessage("msgNoAdapterFoundForTestScript", items[i].selectedScriptName);
					this._dialog.getOkButton().disabled = true;
					return false;
				}
			}
			dojo.style(this._messageNode, "display", "none");
			this._messageNode.innerHTML = "";
			this._dialog.getOkButton().disabled = false;
			return true;
		},
		
		_fillPlans: function(plans){
			if(plans && plans.length > 0){
				for(var i=0;i<plans.length;i++){
					var found = false;
					for(var j=0;j<this.allPlans.length;j++){
						if(this.allPlans[j].plan.id == plans[i].id){
							found = true;
							break;
						}
					}
					if(found){
						this.allPlans[j].count = this.allPlans[j].count + 1; 
					}else{
						this.allPlans[j] = {};
						this.allPlans[j].count = 1;
						this.allPlans[j].plan = plans[i];
					}
				}
			}
			this.testPlansForTestCaseReceivedCount++;
			if(this.testPlansForTestCaseReceivedCount == this.testCases.length){
				this.plansToShow = [];
				for(var i=0;i<this.allPlans.length;i++){
					if(this.allPlans[i].count == this.testCases.length){
						this.plansToShow.push(this.allPlans[i].plan);
					}
				}
				this._fillTPCombo(this.plansToShow);
				this._TP.disabled = true;
                this._Iteration.disabled = true;   
				var responseHandler= new ServiceResponseHandler(this, "_appendIterations", "_error");
				TimeBoxClient.getTestPhasesDTO(responseHandler, {});
			}
		},
		
		_fillTPCombo:function(plans){
			dojox.data.dom.removeChildren(this._TP);
			var option = new Option(Constants.getMessage("labelUnassigned"), "global");
			SelectUtility.add(this._TP, option);
			if (plans && plans.length > 0) {
				for (var i = 0; i < plans.length; i++) {
					var planoption = new Option(plans[i].name, plans[i].id);
					SelectUtility.add(this._TP, planoption);
				}
			}
		},
		_getSelectedPlanItemId: function(){
			var selectedId = this._TP.value;
			if(selectedId == "global")
				return selectedId;
			var itemId = "";
			for (var i = 0; i < this.allPlans.length; i++){
				var plan = this.allPlans[i].plan;
				if(plan.id == selectedId){
					itemId = plan.versionableItemId;
					break;
				}
			}
			return itemId;
		},
		onSelectTP: function(){
			this._updateIterationCombo();
		},
		
		_appendIterations: function(iterations){
			if(iterations && iterations.length > 0){
				for(var j=0;j<iterations.length;j++){
					for(var i=0;i<this.plansToShow.length;i++){
						if(!this.plansToShow[i].iterations)
							this.plansToShow[i].iterations = [];
						if(this.plansToShow[i].versionableItemId === iterations[j].targetTestPlanUUID){
							this.plansToShow[i].iterations.push(iterations[j]);
						}	
					}
				}
			}
		},
		
		_updateIterationCombo: function(){
			var planId = this._TP.value;
			dojox.data.dom.removeChildren(this._Iteration);
			if(planId ==="global"){
				this._Iteration.disabled = true;
				return;
			}
			this._Iteration.disabled = false;
			for(var i=0;i<this.plansToShow.length;i++){
				var id = parseInt(planId, 10);
				if(this.plansToShow[i].id === id){
					var planIterations = this.plansToShow[i].iterations;
					if(planIterations){
						for(var j=0;j<planIterations.length;j++){
							var opt = new Option(planIterations[j].name, planIterations[j].itemId);
							SelectUtility.add( this._Iteration, opt );
						}
						break;	
					}else
						this._Iteration.disabled = true;
				}
			}
		},
 
		_checkValueChange:function(){
			if(this._checkValue.checked){
				this._TP.disabled = false;
				this._Iteration.disabled = false;
			}else{
				this._TP.disabled = true;
				this._Iteration.disabled = true;
			}
		},
		
		_onRunClick: function(){
			this.itemList = [];
			if(!this.validate()){
				return false;
			}
			if(!this.elements || this.elements.length === 0){
				return false;
			}
			if(this._dialog){
				this._dialog.getOkButton().disabled = true;
				this._dialog.getCancelButton().disabled = true;
			}
			var containsArchived =  false;
			for(var i=0;i<this.elements.length;i++){
				if(this.elements[i].workitem.archived === true){
					containsArchived = true;
					break;
				}		
			}
			if(this._checkValue.checked && this._TP.value != "global" && this._TP.value != ""){
				var testPlanItemId = this._getSelectedPlanItemId();
				var testPhaseId = this._Iteration.value;
				this._runWithTestPlanTestPhase(this.elements, testPlanItemId, testPhaseId);
			}else if(containsArchived){
				this._runWithTestPlanTestPhase(this.elements);
			}else{
				this._run(this.elements);
			}
			
		},
		
		_runWithTestPlanTestPhase: function(items, testPlanItemId, testPhaseId){
			this.ewiReceivedCount = 0;
			this.ewis = [];
			for (index in items) {
				var item = items[index];
				var testCase = item.workitem.testCase.versionableItemId;
				var owner = getAuthenticatedContributor().userId;
				var name = item.workitem.testCase.name + (item.ewiConfigurationName ? "_" + item.ewiConfigurationName : "");
				var defaultScript = item.selectedScriptId;
				var params = {
					newExecutionWorkItem: true,
					owner: owner,
					name: name,
					testCase: testCase,
					defaultScript: defaultScript
				};
				if (item.workitem.configuration) {
					params.testConfig = item.workitem.configuration;
				}
				if (testPlanItemId && testPlanItemId != "global" && testPlanItemId != "") {
					params.testPlanItemId = testPlanItemId;
				}
				if (testPhaseId && testPhaseId != "") {
					params.testPhase = testPhaseId;
				}
				if(!testPlanItemId && !testPhaseId && !item.workitem.archived){
					this.ewis.push({
						workitem: {id: item.workitem.id}, 
							 index: index,
							 selectedScriptId: item.selectedScriptId,
							 adapterId: item.adapterId,
							 adapterObj: item.machine
						});
					this.ewiReceivedCount++;
					if(this.ewiReceivedCount == this.suite.elements.length){
						this._run(this.ewis);
						return;
					}else
						continue;						
				}
				var self = this;
				var handler = {
					index: index,
					item: item,
					_setEWI: function(ewi){
						self.ewis.push(
							{workitem: {id: ewi.id}, 
							 index: this.index,
							 selectedScriptId: this.item.selectedScriptId,
							 adapterId: this.item.adapterId,
							 adapterObj: this.item.machine
							 });
						self.ewiReceivedCount++;
						if(self.ewiReceivedCount == self.suite.elements.length){
							self._run(self.ewis);
						}
					},
					
					_error: function(errorObj){
						self._error(errorObj);
					}
				};
				
				try {
					var responseHandler = new ServiceResponseHandler(handler, "_setEWI", "_error");
					com.ibm.rqm.execution.web.client.internal.execution.ExecutionWorkItemClient.postExecutionWorkItemDTO(responseHandler, params);
				} 
				catch (e) {
					console.error("failed to call postEWI");
					this.closeDialog();
				}
			}
		},
		
		_run: function(items){			
			var self = this;
			this.reservationCount = 0;
			this.reservationIds = [];
			for(var i=0;i<items.length;i++){
				var itemId = items[i].workitem.id;
				var index = items[i].index;
				var scriptId = items[i].selectedScriptId;
				var adapterId = items[i].adapterId;
				var adapterObj = items[i].machine;
				var hasMatv = items[i].matv;
				if(adapterId == "" || adapterId == "global"){
					this.itemList.push({index: index, workItemid: itemId, testScriptId: scriptId});
				}else{
					if(adapterObj && adapterObj.adapterInfo && adapterObj.machineName){
						this.itemList.push({index: index, workItemid: itemId, adapterId: adapterId, testScriptId: scriptId, hostName: adapterObj.machineName});
					}else{
						this.itemList.push({index: index, workItemid: itemId, adapterId: adapterId, testScriptId: scriptId});
					}
				}
				
				if(adapterObj && adapterObj.machineID && hasMatv){
					var callback = {
						success: function(response){
							self.reservationCount++;
							if(response.ids && response.ids.length>0){
								self.reservationIds = self.reservationIds.concat(response.ids);
							}
							if(self.reservationCount == self.suite.elements.length){
								self._postExecute();
							}
						},
						failure: function(e){
							self.reservationCount++;
							if(self.reservationCount == self.suite.elements.length){
								self._postExecute();
							}
						}
					};
					var responseHandler = new ServiceResponseHandler(callback, "success", "failure");
					this.reserveMachine(adapterObj.machineID, responseHandler);
				} else {
					this.reservationCount++;
					if(this.reservationCount == this.suite.elements.length){
						this._postExecute();
					}
				}
			}
		},
		
		//Utility method for reserving a selected machine.
	    //It will use the current duration in the class as the reservation duration
	    reserveMachine: function(machineID, responseHandler)
	    {
	        var reservationService = new com.ibm.rational.test.lm.web.client.internal.reservations();
	
	        var fromDate = new Date();
	        var toDate = new Date(fromDate.getTime() + this.duration*60*1000);  //Duration is in minutes, need milliseconds
	        
	        //Fill in any gaps in the reservation
	        reservationService.fillReservationGaps(responseHandler, machineID, fromDate.getTime(), toDate.getTime(), false);       
	    },
	
		_postExecute:function(){
			var startTime = Utility._convertDateToLong(new Date());
			var params = {
				startTime: startTime,
				testSuiteId: this.suite.id,
				stateId: this.suite.stateId,
				suiteElementsJsonString: dojo.toJson(this.itemList),
				isSerialExecution: !this.parExecCheck.checked,
				projectAreaItemId: getCurrentProjectArea().itemId,
				reservationUUIDs:this.reservationIds
			};
			
			var responseHandler = new ServiceResponseHandler(this, "_executionStarted", "_executionError");
			TestSuiteClient.postExecute(responseHandler, params);
		},
		_executionStarted: function(erg){
			//Automatically navigate to the suiteExecution page.
			parent.location = Utility.runSuite({groupId: erg.id});
		},
		_executionError: function(errorObj){
			var arg = errorObj;
			alert(errorObj.message);
		},
		
		closeDialog: function() {
			this._dialog.close();
		},

		_onCancelClick: function(){
			if(this._dialog){
				this._dialog.getOkButton().disabled = true;
				this._dialog.getCancelButton().disabled = true;
			}
		},
		_error: function(errorObj){
			console.error("Error in SelectionPopUp "+ errorObj.message + " ");
		}        
    });
})();
