//ELTV
/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.execution.web.ui.internal.view.table.ExecutionLogTableView");
 
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");
dojo.require("com.ibm.asq.common.web.ui.internal.view.common.ImageCache");
dojo.require("com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout");

dojo.require("com.ibm.asq.common.web.client.internal.PermissionsClient");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentProvider");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableCellModifier");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.ListRowRenderer");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentFilterProvider");
dojo.require("com.ibm.asq.common.web.ui.internal.util.GlobalEvents");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");

dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.rqm.planning.web.client.internal.PreferenceClient");

dojo.require("com.ibm.rqm.execution.web.ui.internal.util.Utility");
dojo.require("com.ibm.rqm.execution.web.client.internal.execution.ExecutionResultClient");
dojo.require("com.ibm.rqm.execution.web.client.internal.execution.ExecutionResultGroupClient");
dojo.require("com.ibm.rqm.execution.web.client.internal.execution.ExecutionResultStateClient");
dojo.require("com.ibm.rqm.execution.web.client.internal.mapper.AllResultsMapper");
dojo.require("com.ibm.rqm.execution.web.ui.internal.view.table.AbstractFilteredExecutionTableView");

(function() {

var ServiceResponseHandler = com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
var TableConstants = com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants;
var ImageCache     = com.ibm.asq.common.web.ui.internal.view.common.ImageCache;
var Utility        = com.ibm.rqm.execution.web.ui.internal.util.Utility;
var Constants      = com.ibm.rqm.planning.web.client.internal.Constants;
var GlobalEvents   = com.ibm.asq.common.web.ui.internal.util.GlobalEvents;
var ViewHeaderLayout = com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout;
var AbstractFilteredExecutionTableView = com.ibm.rqm.execution.web.ui.internal.view.table.AbstractFilteredExecutionTableView;
var TableContentFilterProvider = com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentFilterProvider;
var ExecutionResultClient = com.ibm.rqm.execution.web.client.internal.execution.ExecutionResultClient;
var ExecutionResultGroupClient = com.ibm.rqm.execution.web.client.internal.execution.ExecutionResultGroupClient;
var ExecutionResultStateClient = com.ibm.rqm.execution.web.client.internal.execution.ExecutionResultStateClient;
var PreferenceClient = com.ibm.rqm.planning.web.client.internal.PreferenceClient;
var AllResultsMapper = com.ibm.rqm.execution.web.client.internal.mapper.AllResultsMapper;

dojo.declare("ExecutionLogTableView.TableListener", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableListener,
{
    constructor: function(parentView) {
        this.parentView = parentView;
    },

    rowCheckStateChanged: function(tableViewer, rowObject, state)
    {
        var selectionCount = tableViewer.getCheckedRows().length;
        if (this.parentView.deleteActionNode)
            this.parentView.deleteActionNode.setDisabled(selectionCount == 0);        
    },
	
    groupRowsCheckStateChanged: function(tableViewer, rowObjects, state) 
    {
        this.rowCheckStateChanged(tableViewer, rowObjects, state);
    },
    
    tableContentActionInvoked: function(tableViewer, actionId, callbackData, callback)
    {                
     	if (callback == null && callbackData != null && dojo.isFunction(callbackData)) {
            callbackData();
        }
		
		if (callback != null && dojo.isFunction(callback)) {
            if (callbackData != null) {
                callback(callbackData);
            } else {
                callback();
            }
        } 
    },

    tableContentFilterActionInvoked: function(tableViewer, actionId, filters, callback, callbackData)
    {
        if(callback) {
            callback(actionId, filters);
        }                     
    }	
});

dojo.declare("ExecutionLogTableView.CellModifier", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableCellModifier,
{

    cellValueChanged: function(oldValue, newValue, rowObject, columnIndex)
    {
        // store the new values in our internal data model
        if(columnIndex == 6) {
            if(dojo.isString(newValue)) {
                rowObject.selection = newValue;
            }
        }
    },
    
    cellActionInvoked: function(rowObject, columnIndex){}
});

dojo.declare("ExecutionLogTableView.ListRowRenderer",
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.ListRowRenderer,
{    
    _createListContents: function(viewer, rowObject, listWidget)
    {
        this.inherited("_createListContents", arguments);   
        var moreContents = document.createElement("div");
        var toggle = document.createElement("button");
        toggle.innerHTML = Constants.getMessage("labelAddCustCrtl");
        moreContents.appendChild(toggle);
        listWidget.contentNode.appendChild(moreContents);
    }
});

dojo.declare("ExecutionLogTableView.TableProvider", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentProvider,
{
    getNumColumns: function(content)
    {
        return 7;
    },
 
    getColumnHeading: function(content, index)
    {
        var headings = [
            Constants.getMessage("labelType"),
			Constants.getMessage("labelId"),
			Constants.getMessage("labelName"),
			Constants.getMessage("labelTestCase"),
            Constants.getMessage("labelTestScript"),
            Constants.getMessage("labelCompleted"),
			Constants.getMessage("labelState")
        ];
        return headings[index];
    },
 
    getColumnHeadingImage: function(content, atColumnIndex)
    {
        return null;
    },

    getColumnHeadingAlignment: function(atColumnIndex)
    {
        return this.getCellAlignment(null, atColumnIndex);
    },	 
    
    getIsColumnGroupable: function(content, atColumnIndex)
    {
        return (atColumnIndex >= 0 && atColumnIndex <= 6 && atColumnIndex != 4 && atColumnIndex != 1);     
    },

    getIsColumnSortable: function(content, atColumnIndex)
    {
        return (atColumnIndex >= 0 && atColumnIndex <= 6 && atColumnIndex != 1);   
    },
    
    getColumnWidth: function(content, atColumnIndex)
    {
        switch(atColumnIndex) {
            case 0: 
                return 5;
			case 1: 
                return 5;
            case 2: 
                return 20;
			case 3:
				return 25;
            case 4: 
                return 25;
            case 5: 
                return 10;
			case 6:
				return 10;		 
        }
        return 0;
    },
    
    getContentObjects: function(content)
    {
        return content;
    },
    
    getRowDataId: function(rowData)
    {
        return "_table_row_for_execution_result_" + rowData.itemId;
    },
    
    getCellDisplayType: function(rowData, atColumnIndex)
    {
        var type = TableConstants.RENDER_TYPE_TEXT;

        switch(atColumnIndex) {
            case 0: 
                type = TableConstants.RENDER_TYPE_IMAGE;
                break;
			case 1: 
                type = TableConstants.RENDER_TYPE_TEXT;
                break;
            case 2: 
                type = TableConstants.RENDER_TYPE_LINK;
                break;
			case 3: 
                type = rowData.type == Constants.TYPE_SUITE ? TableConstants.RENDER_TYPE_TEXT: TableConstants.RENDER_TYPE_LINK;
                break;
			case 4: 
                type = rowData.type == Constants.TYPE_SUITE ? TableConstants.RENDER_TYPE_TEXT: TableConstants.RENDER_TYPE_LINK;
                break;
            case 5: 
                type = TableConstants.RENDER_TYPE_DATE;
                break;					 			 
            case 6: 
                type = TableConstants.RENDER_TYPE_LINK;
                break;					 
        }
        return type;
    },

    getCellAlignment: function(rowData, atColumnIndex)
    {
        if(atColumnIndex == 0)
            return TableConstants.ALIGN_CENTER;
        return TableConstants.ALIGN_LEFT;
    },

    getCellDisplayData: function(rowData, atColumnIndex)
    {
        var val = "";
        switch(atColumnIndex) {
            case 0: 
                val = rowData.type == Constants.TYPE_SUITE ? Constants.getMessage("labelSuiteResult") : Constants.getMessage("labelExeResult");
                break;
			case 1:
				val = rowData.id;
				break;
			case 2:
                var name = rowData.name ? rowData.name : "";
				val = Constants.getMessage("labelNamedResult", name);
				break;	
			case 3:
				val = rowData.testCase ? rowData.testCase.name: "";
				break;
            case 4: 
                val = rowData.script && rowData.script.name ? rowData.script.name:""; //Test Script Name
                break;
            case 5:
				val = Constants.getMessage("labelNA"); 
                if (rowData.endTime > 0) {
                   val = new Date(); //Completed
                   val.setTime(rowData.endTime);
                }
                break;   
            case 6: 
                val = Utility.getStatusText(rowData); //State
                break;  
        }
        return val;
    },

    getCellDisplayExtendedInfo: function(rowData, atColumnIndex)
    {  
        var val = {};
		if (atColumnIndex == 0) {
			//result type image
			val.href = this.getHref(rowData);
			if (rowData.type == Constants.TYPE_SUITE) {
				val.image = ImageCache.TEST_SUITE;				
				val.tooltip = Constants.getMessage("labelSuiteResult");
			
			} else if (rowData.type == Constants.TYPE_EWI) {
				val.image = ImageCache.EWI_LOG;
				val.tooltip = Constants.getMessage("labelExeResult");
			}
		}
        // name column: attach to the result page.
		if(atColumnIndex == 2) {
            val.href = this.getHref(rowData);
        }
		if (atColumnIndex == 3 && rowData.testCase && rowData.testCase.id) {
			val.href = Utility.getTestCaseURI(rowData.testCase.id, Utility.CONSTRUCTION_PERSPECTIVE);
		}
        if (atColumnIndex == 4 && rowData.script && rowData.script.id) {
			val.href = Utility.getTestScriptURI(rowData.script.id, Utility.CONSTRUCTION_PERSPECTIVE);
		}
        if (atColumnIndex == 6) {
			val.href = this.getHref(rowData);
		}		  
        return val;
    },
	
	getHref: function(rowData) {
		if (rowData.type == Constants.TYPE_SUITE) {
			return Utility.showSuiteResult({ id: rowData.id });
		} else if (rowData.type == Constants.TYPE_EWI) {
			return Utility.getResultURI({resultItemId: rowData.itemId});
		}
	}
    
    
});

dojo.declare("ExecutionLogTableView.TableFilterProvider", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentFilterProvider,
{
    constructor: function(tableView, openSection) {
        this.tableView = tableView;
        this.initOpenFilter = openSection;
		
        // define the static filters
        this.filters = [
            {
                name: "myItemsOnly",  // must match key in the arg list of the API
                title: Constants.getMessage("labelOnlyMyResults"),
                promptTitle: Constants.getMessage("labelOnlyMyResults"),
                type: TableContentFilterProvider.FIELD_CHECKBOX,
                defaultValue: true,
                params: null
            }, {
                name: "name",  // must match key in the arg list of the API
                title: Constants.getMessage("labelname"),
                promptTitle: Constants.getMessage("labelName"),
                type: TableContentFilterProvider.FIELD_TEXT,
                defaultValue: null,
                params: null
            }
        ];
    },

    getTitle: function() {
        return Constants.getMessage("labelFilterTitle");    
    },
    
    getSummaryText: function() {
        return Constants.getMessage("labelFilterDescriptionAllVisible");
    },
	
    getIsSectionOpenInitially: function() {
       return this.initOpenFilter; 
    },	
    
    getInitialVisibleFilterCount: function() {
        return 4;    
    },
    
    getFilterCount: function() {
        return this.filters.length;
    },
    
    getFilterName: function(index) {
        return this.filters[index].name;
    },
    
    getFilterTitle: function(index) {
        return this.filters[index].title;
    },
    
    getFilterPromptTitle: function(index) {
        return this.filters[index].promptTitle;        
    },
    
    getFilterType: function(index) {
        return this.filters[index].type;
    },
    
    getFilterDefaultValue: function(index) {
        return this.filters[index].defaultValue;
    },
    
    getFilterParams: function(index) {        
        return this.filters[index].params;
    },
    
    getCustomField: function(index) {
        return null;
    },
    
    getActionsInfo: function() {
        var actions = [
            {
                id: "cancel",
                title: Constants.getMessage("labelReset"),
                callback: dojo.hitch(this, "filterResetActionInvoked"),
                callbackData: null,
                isDefault: false
            }, {
                id: "run",
                title: Constants.getMessage("labelRun"),
                callback: dojo.hitch(this, "filterRunActionInvoked"),
                callbackData: null,
                isDefault: true
            }
        ];
        return actions;
    },
    
    filterResetActionInvoked: function(actionName, filters) {
        this.tableView.tableViewer.setContentFilterAttributeProvider(this.tableView.filterProvider);
    },

    filterRunActionInvoked: function(actionName, filters){
        var args = {};
            
        for (var nameKey in filters) {
            if (filters[nameKey] != null) {
                args[nameKey] = filters[nameKey] || "";
                if (args[nameKey] == 'Any@@') {
					args[nameKey] = '';
				}
            }
        }
        this.tableView.runQuery(args);
    }
});

dojo.declare("com.ibm.rqm.execution.web.ui.internal.view.table.ExecutionLogTableView", 
    [dijit._Widget, dijit._Templated, AbstractFilteredExecutionTableView],
{    
    templateString: '<div dojoAttachPoint="_tableViewerNode" class="com-ibm-rqm-test-artifact-table-view" tabindex="-1">' +
                    '  <div dojoType="com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout" "noline"=true dojoAttachPoint="viewHeaderNode">' +
                    '    <div dojoAttachPoint="_tableViewerNode" class="com-ibm-rqm-test-artifact-table-view" tabindex="-1"></div>' +
                    '  </div>' +
                    '</div>',

    widgetsInTemplate: true,

    constructor: function() {
	 	this.results = null;
        this.showInitLoadProgress = false;
        this.showQueryFilters = false;
        this.filterArgs = null;
        this.initOpenFilter = true;
	 },

    postCreate: function() {
        this.inherited("postCreate", arguments);

        // the view is in a query page if there is a query name otherwise it is within
        // some container that don't need the header
        this.isQueryPage = this.queryName;
		
        // we're showing query filters, we'll be managing our own
        // contents. Initialize the query filters first.
        if (this.isQueryPage && this.showQueryFilters) {
	        //setup search details
			this.setSearchFunction(dojo.hitch(ExecutionResultGroupClient, "searchAllResults"));
	        this.setSearchCallback(dojo.hitch(this, "refresh"));
	        this.setResponseHandlerType(AllResultsMapper);
	        this.setTypeLabel(Constants.getMessage("labelAllExeResult"));
		    
			//determine preference for initially expanding the filter section
            var self = this;
			var context = {
                prefCallback: function(userPref) {
                    self.initOpenFilter = (userPref && typeof userPref['value'] != "undefined") ? userPref.value : true;
                    self._initializeFilters();
                }
            }
            PreferenceClient.getCurrentUserPreferences(context, context.prefCallback, Constants.USER_UI_CUSTOMISE_QUERYLISTS_FILTER_INITOPEN_CATEGORY.key);
			
        } else {
            this._initialize();
        }
	},
	
    // Constructs the query filter definitions and the content filter provider for the
    // table. The table will construct the filters section based on the definitions.
    // 
    _initializeFilters: function() {
        // create the filter provider for the table
        this.filterProvider = new ExecutionLogTableView.TableFilterProvider(this, this.initOpenFilter);
		
        //append new filters - owner and then states (via callback)
        var callback = dojo.hitch(this, function(){
	        var statesFilter = {           
	            //filterName, filterLabel, filterPrompt, filterType, callback
	            name: "stateIds",
	            label: Constants.getMessage("labelStateLabel"),
	            prompt: Constants.getMessage("labelState"),
				type:TableContentFilterProvider.FIELD_TOGGLELIST
	        }
	        this.addExecutionStateFilter(statesFilter, this.filterProvider.filters, dojo.hitch(this, "_initialize")); 			
		});
		
		//append owner field
        var ownerFilter = {
            name: "ownerUUIDs",
            label: Constants.getMessage("labelowner"),
            prompt: Constants.getMessage("labelOwner") ,
			type:TableContentFilterProvider.FIELD_TOGGLELIST
        }
        this.addContributorFilter(ownerFilter, this.filterProvider.filters, callback);
    },
	
	_initialize: function() {
        var tableViewer = new com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer({
            allowAdjustSettings: true,
            autoSaveSettings: true,
            tableId: "RQM-TE-LOG-TABLEVIEWER"                                
        });        
		
        if (this.showQueryFilters) {
            tableViewer.setContentFilterAttributeProvider(this.filterProvider);
            
            // we're not showing any content yet, disable the no item message
            tableViewer.noItemMessage = " ";
        }
				
        this._tableViewerNode.appendChild(tableViewer.domNode);
		          
        var content = this.results ? this.results : [];
		this.queryName = this.queryName ? this.queryName : Constants.getMessage("labelExeResults");
        
		 if (this.isQueryPage) {
            // it is a query page so set header title and add table viewer as the header content
            this.viewHeaderNode.setTitle(this.queryName);
            this._tableViewerNode.appendChild(tableViewer.domNode);
        } else {
            // it is not a query page i.e. within a section without header
            this.viewHeaderNode.domNode.style.display = "none";
            this.domNode.appendChild(tableViewer.domNode);
        }
		  
        tableViewer.setContentPageSize(20);
        tableViewer.setContent(content);
        tableViewer.setContentProvider(new ExecutionLogTableView.TableProvider());
        tableViewer.setTableListener(new ExecutionLogTableView.TableListener(this));
        tableViewer.setCellModifier(new ExecutionLogTableView.CellModifier());
		tableViewer.setTableSummary(Constants.getMessage("labelTableSummary", this.queryName));
		
		if (this.refreshCallback && dojo.isFunction(this.refreshCallback)) {
            tableViewer.addAction("Refresh", Constants.getMessage("labelRefresh"), this, "refresh-icon-image", this.refreshCallback);
        }
		
        var type = com.ibm.asq.common.web.client.internal.PermissionsClient.OP_EXECUTION_RESULT;
        var perm = com.ibm.asq.common.web.client.internal.PermissionsClient.getStoredPermission(type);
        
		if (this.isQueryPage && (!perm || perm.archive)) {
            this.deleteActionNode = tableViewer.addAction(
                    "delete",                                  // action id
                    Constants.getMessage("labelDelete"),       // label
                    null,                                      // callback data
                    "delete-icon-image",                       // icon class
                    dojo.hitch(this, "_onDeleteActionClick")); // callback
            this.deleteActionNode.setDisabled(true);
        }
		tableViewer.setTableRowsCheckable(true, false);
        if(this.showInitLoadProgress) {
            tableViewer.showLoadingProgress();
        }
        tableViewer.show();
		  
		this.tableViewer = tableViewer;
		
        // apply the user preference whether to run my query immediately.
        if (this.isQueryPage && this.showQueryFilters) {
            PreferenceClient.getCurrentUserPreferences(this, this.initRunQuery, Constants.USER_UI_CUSTOMISE_QUERYLISTS_AUTORUN_MYQUERY_CATEGORY.key);
        }
    },

	_onDeleteActionClick: function() {
        var args = {
            'message': Constants.getMessage("msgDelExecutionResultConfirm"),
            'yesCallback': 
                function(view) {
                    view._deleteAction();
                },
            'yesCallbackData': this,
            'noCallback': null,
            'noCallbackData': null
        };
        var confirmDialog = new com.ibm.asq.common.web.ui.internal.widgets.YesNoDialog(args);
        confirmDialog.setSecondaryTitle(Constants.getMessage("labelConfirmation"));
        confirmDialog.open();
    },

    _deleteAction: function() {         
        var selectedERs = this.tableViewer.getCheckedRows();
        this.deleteActionNode.setDisabled(true);
        this.selectedERCount = selectedERs.length;
        this.errorERCount = 0;
        this.deletedERCount = 0;

        if (this.selectedERCount > 0) {
            for (var i = 0; i < this.selectedERCount; i++) {
				if (selectedERs[i].type != Constants.TYPE_SUITE) {
					var responseHandler = new ServiceResponseHandler(this, "_deleteSuccess", "_deleteFailure");
					ExecutionResultClient.archiveExecutionResult(responseHandler, {
						uuid_er: selectedERs[i].itemId,
						resultStateId: selectedERs[i].stateId,
						archive: true
					});
				}else{
					var responseHandler = new ServiceResponseHandler(this, "_deleteSuccess", "_deleteFailure");
					ExecutionResultGroupClient.postDeleteResult(responseHandler,{
						uuid_erg:selectedERs[i].itemId,
						stateId:selectedERs[i].stateId,
						archive:true
					});
				}
                if (this.isQueryPage)
                    this.viewHeaderNode.setProgressStart(Constants.getMessage("msgDeletingExecutionResult", selectedERs[i].name));
            }
        }
    },
    
    _deleteSuccess: function(response) {
        if (this.isQueryPage) {
			this.viewHeaderNode.setProgressEnd();
		}
        this.deletedERCount++;
        this._setDeleteStatus();
    },
    
    _deleteFailure: function(err) {
        if (this.isQueryPage) {
			this.viewHeaderNode.setProgressEnd();
		}
        this.errorERCount++;
        this._setDeleteStatus();
    },
    
    _setDeleteStatus: function() {
        if ((this.deletedERCount + this.errorERCount) == this.selectedERCount) {
            if (this.isQueryPage)
                this.viewHeaderNode.setStatus(
                    Constants.getMessage("msgDeletedExecutionResults", this.deletedERCount, this.selectedERCount),
                    this.errorERCount == 0 ? ViewHeaderLayout.SUCCESS : this.selectedERCount == 1 ? ViewHeaderLayout.ERROR : ViewHeaderLayout.INFO
                );
            if (this.deletedERCount > 0) {
                // notify all pages (including itself) execution results are deleted
                dojo.publish(GlobalEvents.ArtifactsDeleted, [Constants.TYPE_EXE_LOG, this.tableViewer.getCheckedRows()]);
            }
        }
    },

	refresh: function(content) {
        if(this.showInitLoadProgress && !this.inProgress) {
            this.tableViewer.endLoadingProgress();
            this.showInitLoadProgress = false;
        }
		
		this.results = content;
        this.tableViewer.setContent(content);
        this.tableViewer.refresh();
    },

    // handler on added exe log
    onArtifactChanged: function(changeType, artifactType, artifactArray) {
        // only care about exe log
        if (artifactType == Constants.TYPE_EXE_LOG) {
            if (changeType == GlobalEvents.ArtifactsAdded) {
                // add exe log to the table
                if (!this.results) {
                    this.results = artifactArray;
                } else {
                    this.results = this.results.concat(artifactArray);
                }
                this.tableViewer.setContent(this.results);
                this.tableViewer.refresh();
            } else {
				var found = false;
                // iterate through the array of artifacts
                for (var i = 0; i < artifactArray.length; i++) {
					found = false;
                    // iterate through the array of results in the table
                    for (var j = 0; j < this.results.length; j++) {
                        // handle the matching result
                        if (artifactArray[i].id == this.results[j].id && artifactArray[i].type == this.results[j].type) {
                            // swap result on update
							if (changeType == GlobalEvents.ArtifactsUpdated){
								this.results.splice(j, 1, artifactArray[i]);
                           	 	this.tableViewer.setContent(this.results);
                            	this.tableViewer.refresh();
							}else if (changeType == GlobalEvents.ArtifactsDeleted){//remove on deletion
								this.results.splice(j, 1);
                            	this.tableViewer.setContent(this.results);
                            	this.tableViewer.refresh();
							}
							found = true;
                            break;
                        }
                    }
					if (!found) {
						this.results = this.results.concat(artifactArray);
					}
                }
            }
        }
    }
});

})();