/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.execution.web.ui.internal.view.table.ExecutionWorkItemTableView");
 
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");
dojo.require("com.ibm.asq.common.web.client.internal.PermissionsClient");
dojo.require("com.ibm.asq.common.web.ui.internal.view.common.ImageCache");
dojo.require("com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout");

dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.rqm.planning.web.client.internal.PreferenceClient");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.table.AbstractFilteredTableView");
dojo.require("com.ibm.rqm.execution.web.ui.internal.util.Utility");

dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentProvider");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableCellModifier");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentFilterProvider");

dojo.require("com.ibm.rqm.execution.web.ui.internal.view.table.AbstractFilteredExecutionTableView");
dojo.require("com.ibm.rqm.execution.web.ui.internal.view.table.cellrenderers.TextComboCellRenderer");
dojo.require("com.ibm.rqm.execution.web.ui.internal.view.table.cellrenderers.ScriptComboCellRenderer");
dojo.require("com.ibm.asq.common.web.client.internal.CommonPreferenceClient");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");
dojo.require("com.ibm.rqm.execution.web.client.internal.execution.ExecutionWorkItemClient");
dojo.require("com.ibm.asq.common.web.ui.internal.util.GlobalEvents");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.views.configurations.ConfigurationsUriUtil");
dojo.require("com.ibm.asq.common.web.client.internal._catalog.Configuration");
dojo.require("com.ibm.rqm.execution.web.client.internal.execution.ExecutionResultStates");
dojo.require("com.ibm.rqm.execution.web.client.internal.execution.ExecutionResultStateClient");
dojo.require("com.ibm.rqm.execution.web.client.internal.mapper.EWIMapper");

(function() {

var ServiceResponseHandler	= com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
var TableConstants 			= com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants;
var ImageCache     			= com.ibm.asq.common.web.ui.internal.view.common.ImageCache;
var Utility        			= com.ibm.rqm.execution.web.ui.internal.util.Utility;
var Constants      			= com.ibm.rqm.planning.web.client.internal.Constants;
var AbstractFilteredExecutionTableView = com.ibm.rqm.execution.web.ui.internal.view.table.AbstractFilteredExecutionTableView;
var GlobalEvents   			= com.ibm.asq.common.web.ui.internal.util.GlobalEvents;
var ExecutionWorkItemClient	= com.ibm.rqm.execution.web.client.internal.execution.ExecutionWorkItemClient;
var YesNoDialog				= com.ibm.asq.common.web.ui.internal.widgets.YesNoDialog;
var ConfigurationUriUtil 	= com.ibm.rational.test.lm.web.ui.internal.views.configurations.ConfigurationsUriUtil;
var ViewHeaderLayout        = com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout;
var PermissionsClient       = com.ibm.asq.common.web.client.internal.PermissionsClient;
var TableContentFilterProvider = com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentFilterProvider;
var ExecutionResultStateClient = com.ibm.rqm.execution.web.client.internal.execution.ExecutionResultStateClient;
var EWIMapper                  = com.ibm.rqm.execution.web.client.internal.mapper.EWIMapper;
var PreferenceClient        = com.ibm.rqm.planning.web.client.internal.PreferenceClient;

dojo.declare("ExecutionWorkItemTableView.TableListener", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableListener,
{        
	constructor: function(parentView) {
        this.parentView = parentView;
    },
	
	setRowCheckListener: function(listener) {
		this.rowCheckListener = listener;
	},
	
    rowCheckStateChanged: function(tableViewer, rowObject, state)
    {
		var selectionCount = tableViewer.getCheckedRows().length;
		if(this.parentView.inEditMode)
			return;
        if (this.parentView.deleteActionNode)
            this.parentView.deleteActionNode.setDisabled(selectionCount == 0 || !tableViewer.isEditable());
		if (selectionCount > 0 && tableViewer.isEditable()){
			this.parentView.enableAction("edit");
			this.parentView.enableAction("unblock");
		}else{
			this.parentView.disableAction("edit");
			this.parentView.disableAction("unblock");
		}
		if (selectionCount == 1 && tableViewer.isEditable()) {
			this.parentView.enableAction("execute");
		}else {
			this.parentView.disableAction("execute");
		}
		if (this.rowCheckListener && dojo.isFunction(this.rowCheckListener)) {
				this.rowCheckListener(rowObject, state);
		}

    },
    
    groupRowsCheckStateChanged: function(tableViewer, rowObjects, state) 
    {
        this.rowCheckStateChanged(tableViewer, rowObjects, state);
    },
	
    tableContentActionInvoked: function(tableViewer, actionId, callbackData, callback)
    {                
        if (callback == null && callbackData != null && dojo.isFunction(callbackData)) {
            callbackData();
        }
		
		if (callback != null && dojo.isFunction(callback)) {
            if (callbackData != null) {
                callback(callbackData);
            } else {
                callback();
            }
        } 
    },

    tableContentFilterActionInvoked: function(tableViewer, actionId, filters, callback, callbackData)
    {
        if(callback) {
            callback(actionId, filters);
        }                     
    }
});

dojo.declare("ExecutionWorkItemTableView.CellModifier", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableCellModifier,
{
    showTestCase: true,
    
    constructor: function(args) {
        dojo.mixin(this, args);
    },
    
	setComboChangeListener: function(listener)
	{
		this.comboChangeListener = listener;
	},
	
    cellValueChanged: function(oldValue, newValue, rowObject, columnIndex)
    {
		if( this.parent.parentSection && this.parent.inEditMode){
			this.parent.parentSection.setDirty();
		}
        // store the new values in our internal data model
        columnIndex += (this.showTestCase || (columnIndex == 0) ? 0 : 1);
        if(columnIndex == 10){
            var listener = this.comboChangeListener;
            if (newValue.search(/^\s*[0-9]*[1-9][0-9]*\s*$/) != -1) {
				rowObject.weight = parseInt(newValue);
			}else{
				rowObject.weight = -1;
			}
            if(listener && listener.method)
                listener.method.apply(listener.context, [rowObject]);
        }
		if(columnIndex == 6) {
			rowObject.selectedScriptId = newValue;
			if(this.parent.inEditMode){	
				rowObject.isChanged = true;	
				var listener = this.comboChangeListener;
				if(rowObject.defaultScript)
					rowObject.defaultScript.id = newValue;
				else 
					rowObject.defaultScript = { id: newValue };
				if(rowObject.defaultScript.id == "-1") 
					rowObject.defaultScript.id = null;
				if(listener && listener.method)
					listener.method.apply(listener.context, [rowObject]);
			}
        }
		if(columnIndex == 5) {
			var listener = this.comboChangeListener;
			if(rowObject.owner)
				rowObject.owner.userId = newValue;
			else 
				rowObject.owner = { userId: newValue };
			if(listener && listener.method)
				listener.method.apply(listener.context, [rowObject]);
        }
		if(columnIndex == 4) {
			var listener = this.comboChangeListener;
			if(rowObject.phase)
				rowObject.phase.itemId = newValue;
			else 
				rowObject.phase = { itemId: newValue };
			if(listener && listener.method)
				listener.method.apply(listener.context, [rowObject]);
        }
    },
    
    cellActionInvoked: function(rowObject, columnIndex){}
});

dojo.declare("ExecutionWorkItemTableView.TableProvider", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentProvider,
{
    showTestCase: true,
    customEditable: false,
    labelUnassigned: Constants.getMessage("labelUnassigned"),
    labelBlocking: Constants.getMessage("msgHasBlockingDefect"),
    labelNonBlocking: Constants.getMessage("msgNoBlockingDefect"),
    labelNoDefect: Constants.getMessage("msgNoDefect"),
    
    constructor: function(args) {
        dojo.mixin(this, args);
    },
     
	getIsCellEditable: function(rowData, atColumnIndex)
	{
		atColumnIndex += (this.showTestCase || (atColumnIndex == 0 ) ? 0 : 1);
		if (atColumnIndex == 10) {
			var editableRows = this.getEditableRows();
			var found = false;
			if (editableRows) {
				for (var j = 0; j < editableRows.length; j++) {
					if (editableRows[j].id == rowData.id) {
						found = true;
						break;
					}
				}
			}
		
			return this.isCustomEditable() && found;
		}
		return atColumnIndex == 6 ? !this.isCustomEditable() : true;
	},
	    
    getNumColumns: function(content)
    {
        return this.showTestCase ? 11 : 10;
    },

    getColumnHeading: function(content, index)
    {
        var headings = [];
		headings.push(Constants.getMessage("labelName"));
//		headings.push(Constants.getMessage("labelstatus")); 
        if (this.showTestCase) {
            headings.push(Constants.getMessage("labelTestCase"));    
        }
        headings.push(
            Constants.getMessage("labelConfig"),
			Constants.getMessage("labelTestPlan"),
			Constants.getMessage("labelIteration"),
			Constants.getMessage("labelOwner"),
			Constants.getMessage("labelScript"),
			Constants.getMessage("labelDefectStatus"),
			Constants.getMessage("labelLastResult"),
			Constants.getMessage("labelLastMod"),
			Constants.getMessage("labelWeight")
        );
        return headings[index];
    },
  
    getColumnHeadingImage: function(content, atColumnIndex)
    {
        atColumnIndex += (this.showTestCase || (atColumnIndex == 0 ) ? 0 : 1);
        return null;
    },

    getColumnHeadingAlignment: function(atColumnIndex)
    {
        atColumnIndex += (this.showTestCase || (atColumnIndex == 0 ) ? 0 : 1);
        return this.getCellAlignment(null, atColumnIndex);
    },	 
    
    getIsColumnGroupable: function(content, atColumnIndex)
    {
        atColumnIndex += (this.showTestCase || (atColumnIndex == 0 ) ? 0 : 1);
        return (atColumnIndex == 1 || atColumnIndex == 2 || atColumnIndex == 3 || atColumnIndex == 4 || atColumnIndex == 5 || atColumnIndex == 8);     
    },

    getIsColumnSortable: function(content, atColumnIndex)
    {
        atColumnIndex += (this.showTestCase || (atColumnIndex == 0 ) ? 0 : 1);
        return true;   
    },
    
    getColumnWidth: function(content, atColumnIndex)
    {
        atColumnIndex += (this.showTestCase || (atColumnIndex == 0 ) ? 0 : 1);
        switch(atColumnIndex) {
			case 0: 
                return 10;
            case 1: 
                return 12;
            case 2: 
                return this.showTestCase ? 5 : 13;
			case 3:
				return this.showTestCase ? 7 : 10;	
            case 4: 
                return 7;
            case 5: 
                return this.showTestCase ? 8 : 10;
            case 6: 
                return 25;
			case 7: 
                return 5;		
            case 8: 
                return 10;
			case 9:
				return 10;
        }
		//Do not return 0 width, it causes and invalid argument in IE
        return 1;
    },
    
    getContentObjects: function(content)
    {
        return content;
    },
    
    getRowDataId: function(rowData)
    {
        return "_table_row_for_ewi_" + rowData.id;
    },
    
    getCellDisplayType: function(rowData, atColumnIndex)
    {
        atColumnIndex += (this.showTestCase || (atColumnIndex == 0 ) ? 0 : 1);
        var type = TableConstants.RENDER_TYPE_TEXT;

        switch(atColumnIndex) {
			case 1:
                type = TableConstants.RENDER_TYPE_LINK;
                break;
			case 2:
				type = rowData.config && rowData.config.name ? TableConstants.RENDER_TYPE_LINK : TableConstants.RENDER_TYPE_TEXT;
				break;
			case 4:
				type = "RenderType.TextCombo";
				break;
			case 5:
				type = "RenderType.TextCombo";
				break;				 			 
            case 6: 
                type = "RenderType.ScriptCombo";
                break;
			case 7: 
                type = TableConstants.RENDER_TYPE_IMAGE;
                break;	
			case 8: 
                type = TableConstants.RENDER_TYPE_IMAGE;
                break;									 
            case 9: 
                type = TableConstants.RENDER_TYPE_DATE;
                break;                                   
			case 10:
				type = TableConstants.RENDER_TYPE_EDITABLE_TEXT;
				break;    
        }
        return type;
    },

    getCellAlignment: function(rowData, atColumnIndex)
    {
		atColumnIndex += (this.showTestCase || (atColumnIndex == 0 ) ? 0 : 1);
		var val = TableConstants.ALIGN_LEFT;
		switch(atColumnIndex){
			case 7:
			case 8:
				val = TableConstants.ALIGN_CENTER;
				break; 
		}
        return val ;
    },
    
    getCellDisplayData: function(rowData, atColumnIndex)
    {
        atColumnIndex += (this.showTestCase || (atColumnIndex == 0 ) ? 0 : 1);
        var val = "";
		var currentResult = rowData.currentResult;
        var compact = (this.viewer) ? this.viewer.isCompactMode : false;
        
        switch(atColumnIndex) {
            case 0: 
                val = rowData.name || "";
                if(!compact && this.shouldWrap && val != "") {
                    val = this._wordWrap(val, 20, "\n", false);
                }
                break;
			case 1: 
                val = (rowData.testCase && rowData.testCase.name)? rowData.testCase.name : ""; //TestCase Name
                if(!compact && this.shouldWrap && val != "") {
                    val = this._wordWrap(val, 20, "\n", false);
                }
                break;
            case 2: 
                val = (rowData.config && rowData.config.name) ? rowData.config.name : this.labelUnassigned; //Configuration
                if(!compact && this.shouldWrap && val != "") {
                    val = this._wordWrap(val, 20, "\n", false);
                }
				break;          
            case 3: 
				val = (rowData.testPlan && rowData.testPlan.name) ? rowData.testPlan.name : ""; //Test Plan
				break;
			case 4:
				val = rowData.phase? rowData.phase.name : "";//Iteration
                break;
			case 5: 
                val = rowData.owner ? rowData.owner.name:"";//Owner
                break; 
			case 6: 
                val = ""; //Script
                break;
			case 7: 
                val = ""; //Blocking
                break;	
			case 8:
			    val = "";//Last Result
			    break;
			case 9: 
                var date = new Date();
                date.setTime(rowData.modified);
                val = date; //Last Modified
                break;	
            case 10:
            	if (rowData.weight) {
					val = rowData.weight;
				} else {
					val = "";
				}
            	break;	
		}
        return val;
    },	
    getCellRawData: function(rowData, atColumnIndex)
    {
        atColumnIndex += (this.showTestCase || (atColumnIndex == 0 ) ? 0 : 1);
        var val = "";
        switch(atColumnIndex) {
            case 0: 
                val = (rowData.name || "");
                break;
            case 1: 
                val = (rowData.testCase && rowData.testCase.name) ? rowData.testCase.name : ""; //TestCase Name
                break;
            case 2: 
                val = (rowData.config && rowData.config.name) ? rowData.config.name : this.labelUnassigned; //Configuration
                break;          
            case 3: 
                val = (rowData.testPlan && rowData.testPlan.name) ? rowData.testPlan.name : ""; //Test Plan
                break;
            case 4:
                val = rowData.phase ? rowData.phase.name : "";//Iteration
                break;
            case 5: 
                val = rowData.owner ? rowData.owner.name: "";//Owner
                break; 
            case 6: 
                if(rowData.currentResult && rowData.currentResult.script) {
                    val = (rowData.currentResult.script.name || "none");
                }
                if(rowData.defaultScript){
                    val = (rowData.defaultScript.name || "none");
                }
                else{
                    val = "none";
                }
                break;
            case 7: 
                if(rowData.defects && rowData.defects.length > 0){
                    val =  this.labelNonBlocking;
                    for(var i=0;i<rowData.defects.length;i++){
                        if(rowData.defects[i].isBlocking){
                            val = this.labelBlocking;
                            return val;
                        }
                    }
                }
                else {
                    val = this.labelNoDefect;
                }
                break;  
            case 8:
                val = rowData.currentResult ? rowData.currentResult.state.id : "none";
                break;
            case 9: 
                val = rowData.modified;
                break;  
        }
        return val;
    },  
	_wordWrap: function(bigString, metric, b, force){ 
		var i, j, s, results = bigString.split("\n"); 
    	if(metric > 0) 
			for(i in results){ 
	        	for(s = results[i], results[i] = "";
					s.length > metric; 
					j = force ? metric : (j = s.substr(0, metric).match(/\S*$/)).input.length - j[0].length || metric,  results[i] += s.substr(0, j) + ((s = s.substr(j)).length ? b : "") 
				); 
	        	results[i] += s; 
    		} 
    	return results.join("\n"); 
	},
    getCellDisplayExtendedInfo: function(rowData, atColumnIndex)
    {  
        atColumnIndex += (this.showTestCase || (atColumnIndex == 0 ) ? 0 : 1);
        var val = null;
		if(atColumnIndex == 7) {
            val = {};
			if(rowData.defects && rowData.defects.length > 0){
				val.image = ImageCache.NON_BLOCKING_DEFECT;
				val.tooltip = this.labelNonBlocking;
				for(var i=0;i<rowData.defects.length;i++){
					if(rowData.defects[i].isBlocking){
						val.image = ImageCache.BLOCKING_DEFECT;
						val.tooltip = this.labelBlocking;
						return val;
					}
				}
			}else{
				val.image = ImageCache.NOIMAGE;
				val.tooltip = this.labelNoDefect;
			}
        }
		if(atColumnIndex == 1) {
            val = {};
            val.href = Utility.getTestCaseURI(rowData.testCase.id);
			val.tooltip = Constants.getMessage("labelClickToOpenTestCase")				
        }
		if(atColumnIndex == 2){
			val = {}
			if(rowData.config && rowData.config.id)
				val['href'] = ConfigurationUriUtil.getEditConfigurationURI(rowData.config.id);
		}
		if(atColumnIndex == 4) {
            val = {};
			val.choices = [];
			if(rowData.testPlan && this.iterations){
				for(var p=0;p<this.iterations.length;p++){
					var iteration = this.iterations[p];
					if(rowData.testPlan.versionableItemId == iteration.targetTestPlanUUID){
						val.choices.push({text: iteration.name, value: iteration.itemId});	
					}
				}
			}	
			val.select = rowData.phase ? rowData.phase.itemId: "";
			val.defaultText = rowData.phase ? rowData.phase.name: "";
		}
		if(atColumnIndex == 5) {
            val = {};
			val.choices = [];
			var contributors = this.contributors ? this.contributors : [];
				for (var i = 0; i < contributors.length; i++) {
					if (contributors[i].name != "ADMIN" && contributors[i].name != "GUEST") 
					{
						//Don't use archived users unless they are the current owner
						if (contributors[i].archived)
							if (!rowData.owner || rowData.owner.name != contributors[i].name)
								continue;
						val.choices.push({text: contributors[i].name, value: contributors[i].userId, disabled:contributors[i].archived});
					}	
				}
			val.select = rowData.owner && rowData.owner.userId ? rowData.owner.userId : rowData.owner.id;//SummaryDTO has id whos value is userId
			val.defaultText = rowData.owner ? rowData.owner.name: "";//Possible the contributors are not received
		} 
		if(atColumnIndex == 6) {
            val = {};
            val.select = null;
			var defaultScriptId = null;
			if(rowData.selectedScriptId)
				val.select = rowData.selectedScriptId;
			else if(rowData.currentResult) {
				if(rowData.currentResult.script){
					val.select = rowData.currentResult.script.id;
				}else{
					val.select = "-1";
				}
			}else if(rowData.defaultScript && rowData.defaultScript.id){
				val.select = rowData.defaultScript.id;
				defaultScriptId = rowData.defaultScript.id;
			}
			val.choices = [];
			var test = rowData.testCase;
			if (test && test.scripts && test.scripts.length > 0) {
				var found = false;
				var defaultScriptFound = false;
				for (var i = 0; i < test.scripts.length; i++) {
					if(!test.scripts[i].archived){
						val.choices.push({text: test.scripts[i].name, value: test.scripts[i].id});
						if(val.select == test.scripts[i].id){
							found = true;
						}
						if(test.scripts[i].id == defaultScriptId){
							defaultScriptFound = true;
						}
					}else{
						if(rowData.selectedScriptId == test.scripts[i].id){
							rowData.selectedScriptId = null;
						}	
						if(val.select == test.scripts[i].id){
							found = false;
						}	
					}
				}
				if(!found && val.select != "-1"){
					val.select = defaultScriptFound ? rowData.defaultScript.id :rowData.currentResult? "-1":null;
				}
				val.choices.push({text: Constants.getMessage("labelNone"), value: "-1"});
				if(!rowData.selectedScriptId)
					rowData.selectedScriptId = val.select ? val.select : (val.choices.length > 1 ? val.choices[0].value : "-1");
			}else{
				val.choices.push({text: Constants.getMessage("labelNone"), value: "-1"});
				val.select = "-1";
				rowData.selectedScriptId = "-1";
			}
        }     
        if(atColumnIndex == 8) {
            val = {};
			var resultState = rowData.currentResult ? rowData.currentResult.state.id : null;
			val.image = Utility.getImageForState(resultState);
            val.href = rowData.currentResult && rowData.currentResult.state ? Utility.getEWIResultsURI(rowData.itemId) : "javascript:{}";
			val.tooltip = rowData.currentResult ? Utility.getResultsTooltip({result: rowData.currentResult, ewiItemId:rowData.itemId}) : Utility.getResultsTooltip();
        }		       
        return val;
    },
	
	setCustomEditable: function(flag,editableRows)
	{
		this.customEditable = flag;
		if(flag && editableRows)
			this.editableRows = editableRows;
	},
    getEditableRows:function()
	{
		return this.editableRows;
	},
	isCustomEditable: function()
	{
		return this.customEditable;
	},
	
	setContributors: function(contributors)
	{
		this.contributors = contributors;
	},
	
	setIterations: function(iterations)
	{
		this.iterations = iterations;
	}
    
});

dojo.declare("ExecutionWorkItemTableView.TableFilterProvider", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentFilterProvider,
{
    constructor: function(tableView, openSection) {
        this.tableView = tableView;
        this.initOpenFilter = openSection;

        // define the static filters
        this.filters = [
            {
                name: "myItemsOnly",  // must match key in the arg list of the API
                title: Constants.getMessage("labelOnlyMyTERs"),
                promptTitle: Constants.getMessage("labelOnlyMyTERs"),
                type: TableContentFilterProvider.FIELD_CHECKBOX,
                defaultValue: true,
                params: null
            }, {
                name: "name",  // must match key in the arg list of the API
                title: Constants.getMessage("labelname"),
                promptTitle: Constants.getMessage("labelName"),
                type: TableContentFilterProvider.FIELD_TEXT,
                defaultValue: null,
                params: null
            }
        ];
    },

    getTitle: function() {
        return Constants.getMessage("labelFilterTitle");    
    },
    
    getSummaryText: function() {
        return Constants.getMessage("labelFilterDescriptionAllVisible");
    },
    
    getIsSectionOpenInitially: function() {
       return this.initOpenFilter; 
    },
    
    getInitialVisibleFilterCount: function() {
        return 4;    
    },
    
    getFilterCount: function() {
        return this.filters.length;
    },
    
    getFilterName: function(index) {
        return this.filters[index].name;
    },
    
    getFilterTitle: function(index) {
        return this.filters[index].title;
    },
    
    getFilterPromptTitle: function(index) {
        return this.filters[index].promptTitle;        
    },
    
    getFilterType: function(index) {
        return this.filters[index].type;
    },
    
    getFilterDefaultValue: function(index) {
        return this.filters[index].defaultValue;
    },
    
    getFilterParams: function(index) {        
        return this.filters[index].params;
    },
    
    getCustomField: function(index) {
        return null;
    },
    
    getActionsInfo: function() {
        var actions = [
            {
                id: "cancel",
                title: Constants.getMessage("labelReset"),
                callback: dojo.hitch(this, "filterResetActionInvoked"),
                callbackData: null,
                isDefault: false
            }, {
                id: "run",
                title: Constants.getMessage("labelRun"),
                callback: dojo.hitch(this, "filterRunActionInvoked"),
                callbackData: null,
                isDefault: true
            }
        ];
        return actions;
    },
    
    filterResetActionInvoked: function(actionName, filters) {
        this.tableView.tableViewer.setContentFilterAttributeProvider(this.tableView.filterProvider);
    },

    filterRunActionInvoked: function(actionName, filters){
        var args = {};
            
        for (var nameKey in filters) {
            if (filters[nameKey] != null) {
                if (nameKey == "weight") {
                    args['weightComparator'] = filters[nameKey].operator;
                    args['weightValue'] = filters[nameKey].value;
                } else {
                    args[nameKey] = filters[nameKey] || "";
                    if (args[nameKey] == 'Any@@') 
                        args[nameKey] = '';
                }
            }
        }
        this.tableView.runQuery(args);
    }
});

dojo.declare("com.ibm.rqm.execution.web.ui.internal.view.table.ExecutionWorkItemTableView", 
    [dijit._Widget, dijit._Templated, AbstractFilteredExecutionTableView],
{    
    templateString: '<div dojoAttachPoint="_tableViewerNode" class="com-ibm-rqm-test-artifact-table-view" tabindex="-1">' +
	                '  <div dojoType="com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout" "noline"=true dojoAttachPoint="viewHeaderNode">' +
                    '    <div dojoAttachPoint="_tableViewerNode" class="com-ibm-rqm-test-artifact-table-view" tabindex="-1"></div>' +
                    '  </div>' +
				    '</div>',

    editable: true,
    printable: false,
    widgetsInTemplate: true,

    constructor: function() {
        this.actions = [];
        this._actionButtons = [];
	 	this.executionWorkItems = [];
		this.queryName = null;
		this.executable = false;
        this.showTestCase = true;
		
		this.contentAfterEdit = [];
        this.showInitLoadProgress = false;
        this.showQueryFilters = false;
        this.filterArgs = null;
		this.initOpenFilter = false;
	 },

    postCreate: function() {
        this.inherited("postCreate", arguments);

        // the view is in a query page if there is a query name otherwise it is within
        // some container that don't need the header
        this.isQueryPage = this.queryName;

        // apply the user preference whether to initially open the 
        // filter area
        if (this.isQueryPage && this.showQueryFilters) {
	        this.setSearchFunction(dojo.hitch(ExecutionWorkItemClient, "searchExecutionWorkItem"));
			this.setSearchCallback(dojo.hitch(this, "show"));
	        this.setResponseHandlerType(EWIMapper);
	        this.setTypeLabel(Constants.getMessage("labelEWIs"));
					
            var context = {
                self: this,
                prefCallback: function(userPref) {
                    this.self.initOpenFilter = (userPref && typeof userPref['value'] != "undefined") ? userPref.value : true;
                    this.self._initializeFilters();
                }
            }
            PreferenceClient.getCurrentUserPreferences(context, context.prefCallback, Constants.USER_UI_CUSTOMISE_QUERYLISTS_FILTER_INITOPEN_CATEGORY.key);         
        }
        else {
            this._initialize();
        }
    },
	
    // Constructs the query filter definitions and the content filter provider for the
    // table. The table will construct the filters section based on the definitions.
    // 
    _initializeFilters: function() {
        // create the filter provider for the table
        this.filterProvider = new ExecutionWorkItemTableView.TableFilterProvider(this, this.initOpenFilter);

        // get the list of contributors for originator and owner filters
        if (this.contributors && this.contributors.length > 0) {
            var contributors = [];
            var owners = [];
            for (var i = 0; i < this.contributors.length; i++) {
                contributors.push({
                    name: (this.contributors[i].name == "Unassigned") ? Constants.getMessage("labelUnassigned") : this.contributors[i].name,
                    value: this.contributors[i].itemId,
                    checked: false
                });
                owners.push({
                    name: (this.contributors[i].name == "Unassigned") ? Constants.getMessage("labelUnassigned") : this.contributors[i].name,
                    value: this.contributors[i].itemId,
                    checked: false
                });
            }
                
            this.filterProvider.filters.push ({
                name: "originatorUUIDs",  // must match key in the arg list of the API
                title: Constants.getMessage("labeloriginatorLabel"),
                promptTitle: Constants.getMessage("labelOriginator"),
                type: TableContentFilterProvider.FIELD_TOGGLELIST,
                defaultValue: [],
                params: {options: contributors}
            });
            
            this.filterProvider.filters.push ({
                name: "ownerUUIDs",  // must match key in the arg list of the API
                title: Constants.getMessage("labelowner"),
                promptTitle: Constants.getMessage("labelOwner"),
                type: TableContentFilterProvider.FIELD_TOGGLELIST,
                defaultValue: [],
                params: {options: owners}
            });
        }

        this.weightFilter = {
            name: "weight",
            title: Constants.getMessage("labelWeight") + Constants.getMessage("labelColen"),
            promptTitle: Constants.getMessage("labelWeight"),
            type: TableContentFilterProvider.FIELD_NUMERIC,
            defaultValue: null,
            params: {'showNumericOperators':true}            
        };

        // initlize the execution state filter
        var self = this;
        var serviceObj = {
            success: function(executionStates) {
                if (dojo.isArray(executionStates) && (executionStates.length > 0)) {
                    // sort the states by name
                    function stateCompare (stateA, stateB) {
                        var a = stateA.name;
                        var b = stateB.name;
                        return a > b ? 1 : a < b ? -1 : 0;
                    }
                    executionStates = executionStates.sort(stateCompare);
                    var stateOptions = [];
                    for (var i = 0; i < executionStates.length; i++) {
                        stateOptions.push({
                            name: executionStates[i].name,
                            value: executionStates[i].id,
                            checked: false
                        });
                    }
                
                    var statesFilter = {
                        name: "stateIds", // must match key in the arg list of the API
                        title: Constants.getMessage("labelStateLabel"),
                        promptTitle: Constants.getMessage("labelState"),
                        type: TableContentFilterProvider.FIELD_TOGGLELIST,
                        defaultValue: [],
                        params: {options: stateOptions}
                    };
                    self.filterProvider.filters.push(statesFilter);
                }
                self.filterProvider.filters.push(self.weightFilter);
                self._initialize();
            },
            
            failure: function(e) {
                self._error(e);
                self.filterProvider.filters.push(self.weightFilter);
                self._initialize();
            }
        }
        var responseHandler = new ServiceResponseHandler(serviceObj, "success", "failure");
        ExecutionResultStateClient.getExecutionResultStates(responseHandler, {includeHidden: false});
    },	
        
    _initialize: function()  {
		
        this.printable = this.parentSection ? this.parentSection.isPrintView() : false;
		// We are trying to get the Last Modified column index 
		var lastModifiedColumn = this.showTestCase ? 9 : 8;

        //create the table viewer
        var tableViewer = new com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer({
            //turn off all controls if in print mode 
            showPagingControl: !this.printable,
			showPagingRangeControl: !this.printable,
            showGroupFilterControls: !this.printable,
            showPagingActionsControls: !this.printable,
			sortByColumn: lastModifiedColumn,
			sortDir: TableConstants.SORT_DIR_DESCEND,
            allowAdjustSettings: true,
            autoSaveSettings: true
        });
			        
        if (this.showQueryFilters) {
            tableViewer.setContentFilterAttributeProvider(this.filterProvider);
            
            // we're not showing any content yet, disable the no item message
            tableViewer.noItemMessage = " ";
        }

        this._tableViewerNode.appendChild(tableViewer.domNode);
        var content = this.executionWorkItems ? this.executionWorkItems : [];

        if (this.isQueryPage) {
            // it is a query page so set header title and add table viewer as the header content
            this.viewHeaderNode.setTitle(this.queryName);
            this.viewHeaderNode.setCSHelpId("rqm_view_ters.html");        
            this._tableViewerNode.appendChild(tableViewer.domNode);
        } else {
            // it is not a query page i.e. within a section without header
            this.viewHeaderNode.domNode.style.display = "none";
            this.domNode.appendChild(tableViewer.domNode);
        }
        
        // setup the table's id for saving table settings
        tableViewer.tableId = (this.isQueryPage) ? "RQM-TER-QUERY-TABLEVIWER" : "RQM-TER-TABLEVIWER";
        
        tableViewer.setContentPageSize(20);
        tableViewer.setContent(dojo.clone(content));
		var shouldWrap = com.ibm.asq.common.web.client.internal.CommonPreferenceClient.getIsWordWrapEnabled();
        var showArgs = {
            showTestCase: this.showTestCase,
			contributors: this.contributors,
			iterations: this.iterations,
			parent: this,
			shouldWrap: shouldWrap,
            viewer: tableViewer
        }
        tableViewer.setContentProvider(new ExecutionWorkItemTableView.TableProvider(showArgs));
		tableViewer.setTableSummary(Constants.getMessage("labelTableSummary", this.queryName ? this.queryName: Constants.getMessage("labelEWIs")));
		tableViewer.getContentProvider().setCustomEditable(false);  
		var tableListener = new ExecutionWorkItemTableView.TableListener(this);
		if (this.executable && this.rowCheckListener)
           tableListener.setRowCheckListener(this.rowCheckListener);
		tableViewer.setTableListener(tableListener);		
		var cellModifier = new ExecutionWorkItemTableView.CellModifier(showArgs)
		var listener = {
			context: this,
			method:dojo.hitch(this, function(rowObject, state) {
                    this.storeChangedEWIs(rowObject);
                })
		}
		cellModifier.setComboChangeListener(listener)
		tableViewer.setCellModifier(cellModifier);
		this.inEditMode = false;
		tableViewer.setTableRowsCheckable(this.editable && this.executable && !this.printable, false);
        tableViewer.registerCellRenderer("RenderType.TextCombo", 
			new com.ibm.rqm.execution.web.ui.internal.view.table.cellrenderers.TextComboCellRenderer());
				
		tableViewer.registerCellRenderer("RenderType.ScriptCombo",
			new com.ibm.rqm.execution.web.ui.internal.view.table.cellrenderers.ScriptComboCellRenderer());
		tableViewer.customEditable = false;
        for (var i = 0; i < (this.actions ? this.actions.length : 0); i++) {
            var action = this.actions[i];
            var actionButton = tableViewer.addAction(action.actionId, action.label, action.actionHandler, action.iconClass);
            if (action.disabled && action.disabled == true)
                actionButton.setDisabled(true);
            if (action.hidden && action.hidden == true)
                dojo.addClass(actionButton.domNode, "dijitDisplayNone");
            this._actionButtons.push(actionButton);
        }

        this.ewi_exe_perm = PermissionsClient.getStoredPermission(PermissionsClient.OP_EXECUTION_EWI_EXE);
        var ewi_perm = PermissionsClient.getStoredPermission(PermissionsClient.OP_EXECUTION_EWI);
        if (!ewi_perm || ewi_perm.archive) {
            this.deleteActionNode = tableViewer.addAction("delete", // action id
                Constants.getMessage("labelDelete"), // label
                null, // callback data
                "delete-icon-image", // icon class
                dojo.hitch(this, "_onDeleteActionClick")); // callback
            this.deleteActionNode.setDisabled(true);
        }
        if(this.showInitLoadProgress) {
            tableViewer.showLoadingProgress();
        }
        tableViewer.show();
		tableViewer.setEditable(this.editable);
		this.tableViewer = tableViewer;		  
              
        // apply the user preference whether to run my query immediately.
        if (this.isQueryPage && this.showQueryFilters) {
            PreferenceClient.getCurrentUserPreferences(this, this.initRunQuery, Constants.USER_UI_CUSTOMISE_QUERYLISTS_AUTORUN_MYQUERY_CATEGORY.key);
        }   
    },
    
	 // API
    getSelectedEWIs: function() {
        return this.tableViewer.getCheckedRows();
    },

    getAction: function(actionId) {
        for (var i = 0; i < (this.actions ? this.actions.length : 0); i++) {
            if (this.actions[i].actionId == actionId) {
                return this.actions[i];
            }
        }        
    },
    
    getActionButton: function(actionId) {
        for (var i = 0; i < (this._actionButtons ? this._actionButtons.length : 0); i++) {
            if (this._actionButtons[i].actionId == actionId) {
                return this._actionButtons[i];
            }
        }        
    },
    
    hideAction: function(actionId) {
        var button = this.getActionButton(actionId);
        if (button && !dojo.hasClass(button.domNode, "dijitDisplayNone")) {
			dojo.addClass(button.domNode,"dijitDisplayNone");
        }
    },
    
    showAction: function(actionId) {
        var button = this.getActionButton(actionId);
        if (button && dojo.hasClass(button.domNode, "dijitDisplayNone")) {
			dojo.removeClass(button.domNode,"dijitDisplayNone");
        } 
    },    

	disableAction: function(actionId) {
        var button = this.getActionButton(actionId);
         if (button ) {
            button.setDisabled(true);
        } 
    },
	
	enableAction: function(actionId) {
        var button = this.getActionButton(actionId);
        if (button ) {
            button.setDisabled(false);
        } 
    }, 
        
    appendEWI: function(ewi) {
    	var content = this.tableViewer.getContent();
        content.push(ewi);
        this.tableViewer.setContent(content);
        this.tableViewer.show();
    },
	
    addConfigurationInfo: function(ewiId, config) {
        var content = this.tableViewer.getContent();
        for (var i = 0; i < content.length; i++) {
        	if (content[i].id == ewiId) {
        		content[i].config = config;
				break;
        	}
        }
        this.tableViewer.setContent(content);
        this.tableViewer.refresh();
    },
	
	updateEWI: function(ewi,refresh) {
        var content = this.tableViewer.getContent();
        for (var i = 0; i < content.length; i++) {
        	if (content[i].id == ewi.id) {
        		content[i].phase = ewi.phase;
				content[i].owner = ewi.owner;
				content[i].modified = ewi.modified;
				content[i].stateId = ewi.stateId;
				content[i].defaultScript = ewi.defaultScript;
				content[i].defects = ewi.defects;
				break;
        	}
        }
        this.tableViewer.setContent(content);
		if(refresh)
        	this.tableViewer.refresh();
    },
	
	updateOwnerInfo: function(ewiId, ownerUserId) {
        var content = this.tableViewer.getContent();
		var found = false;
		var contributors = this.contributors ? this.contributors : []
        for (var i = 0; i < content.length; i++) {
        	if (content[i].id == ewiId) {
				for(var j=0;j<contributors.length;j++){
					if(ownerUserId == contributors[j].userId){
						content[i].owner = contributors[j]
						this.storeChangedEWIs(content[i]);
						found = true;
					}
				}
				if(found)
					break;
        	}
        }
        this.tableViewer.setContent(content);
        this.tableViewer.refresh();
    },
	
	
	refresh: function(content, iterations, contributors, resetProgress) {
		var tableContentProvider = this.tableViewer.getContentProvider()
		this.iterations = iterations ? iterations : this.iterations;
		this.contributors = contributors ? contributors : this.contributors;
        tableContentProvider.setIterations(this.iterations)
		tableContentProvider.setContributors(this.contributors);
		// need this for WI 4015
		var oldContent = this.tableViewer.getContent();
		if(oldContent){
			for(var i=0;i<oldContent.length;i++){
				for(var j=0;j<content.length;j++){
					if(content[j].itemId == oldContent[i].itemId){
						if(oldContent[i].selectedScriptId){
							content[j].selectedScriptId = oldContent[i].selectedScriptId;
							break;
						}
					}
				}
			}
		}
        if(this.showInitLoadProgress && resetProgress) {
            this.tableViewer.endLoadingProgress();
            this.showInitLoadProgress = false;
        }
		this.executionWorkItems = content ? content:[];
		this.tableViewer.setContent(dojo.clone(this.executionWorkItems));
		this.tableViewer.refresh();
		this.enableEditableActions(false);
	 },
	 
	 show: function(ters) {
        if (this.ewiList) {
            this.ewiList._setEWITableContent(ters || []);
        } else {
            this.refresh(ters || []);
            this.stopInProgress();
        }	 	
	 },
	
	isCustomEditable: function()
	{
		return this.tableViewer.getContentProvider().isCustomEditable();;
	},
	
	toggleTableStateForEditing: function(discard)
	{
		if(this.inEditMode && discard)
			this.tableViewer.setContent(dojo.clone(this.executionWorkItems));
		this.inEditMode = !this.inEditMode;
		var selectedEWIs = null;
		if(this.inEditMode){
			selectedEWIs = this.tableViewer.getCheckedRows();
			this.contentAfterEdit = selectedEWIs;
		}
		
		this.tableViewer.getContentProvider().setCustomEditable(this.inEditMode,selectedEWIs)
		this.tableViewer.setTableRowsCheckable(this.executable, false);
		this.enableEditableActions(this.inEditMode);
		this.changedEWIList = []; //initial definition
		this.tableViewer.refresh();
	},
	
	getContentAfterEdit: function(){
		return this.contentAfterEdit;   //Store the checked row's state when click the "Edit" button.
	},
	
    storeChangedEWIs: function(rowData)
    {
        var found = false;
        if (this.changedEWIList) {
            for (var i = 0; i < this.changedEWIList.length; i++) {
                if (this.changedEWIList[i].id == rowData.id) {
                    found = true;
                    this.changedEWIList[i].owner = rowData.owner ? rowData.owner.userId : null;
                    this.changedEWIList[i].testPhase = rowData.phase ? rowData.phase.itemId : null;
                    this.changedEWIList[i].defaultScript = rowData.defaultScript ? rowData.defaultScript.id : null;
                    this.changedEWIList[i].weight = rowData.weight ? rowData.weight: null;
                }
            }
            if (!found) {
                var args = {
                    id: rowData.id,
                    owner: rowData.owner ? rowData.owner.userId : null,
                    testPhase: rowData.phase ? rowData.phase.itemId : null,
                    defaultScript: rowData.defaultScript ? rowData.defaultScript.id : null,
                    newExecutionWorkItem: false,
                    ewiStateId: rowData.stateId,
                    weight: rowData.weight
                }
                this.changedEWIList.push(args);
            }
        }
    },
	
	getChangedEWIs: function()
	{
		var allChanges = [];  // Adding checked rows which values changed before edit and no change before save
		
		var included = this.getContentAfterEdit();
		for( var m = 0; m < included.length; m ++){
			included[m].needToPost = false;  
			if( included[m].isChanged){
				included[m].needToPost = true;
			}
		}

		if(included.length == this.changedEWIList.length){
			return this.changedEWIList;
		}
		var missed = [];
		for(var i = 0; i < included.length; i ++){
			var found = false;
			for(var j = 0; j < this.changedEWIList.length; j ++){
				if(included[i].id == this.changedEWIList[j].id){
					found = true;
					break;
				}
			}
			if((!found) && included[i].needToPost){
				missed.push(i);
			}
		}
		for( var k = 0; k < missed.length; k ++){
			var args = {
					id: included[missed[k]].id,
					owner: included[missed[k]].owner ? included[missed[k]].owner.userId : null,
					testPhase: included[missed[k]].phase ? included[missed[k]].phase.itemId : null,
					defaultScript: included[missed[k]].defaultScript ? included[missed[k]].defaultScript.id : null,
					ewiStateId: included[missed[k]].stateId
				}
				this.changedEWIList.push(args);
		}		
		return this.changedEWIList;
	},
	
	enableEditableActions: function(editable)
	{
		if(editable){
			this.disableAction("edit");
			this.hideAction("edit");
			this.hideAction("execute");
			this.hideAction("resume");
			this.hideAction("unblock");
			this.hideAction("refresh");
			if(this.deleteActionNode)
				dojo.addClass(this.deleteActionNode.domNode, "dijitDisplayNone");
			this.enableAction("discardedit");
			this.enableAction("save");
			this.enableAction("batcheditowner");
			this.hideAction("generate");
		}else{
            if (!this.ewi_exe_perm || this.ewi_exe_perm.execute) {
                this.showAction("execute");
                this.showAction("resume");
                this.disableAction("execute");
                this.disableAction("resume");
            } else {
                this.hideAction("execute");
                this.hideAction("resume");
            }
			this.showAction("unblock");
			this.showAction("refresh");
			this.showAction("edit");
			this.showAction("generate");
			//hidden class doesnt work with IE7
			if(this.deleteActionNode)
				dojo.removeClass(this.deleteActionNode.domNode, "dijitDisplayNone");
			this.disableAction("unblock");
			this.disableAction("edit");
			if(this.deleteActionNode)
				this.deleteActionNode.setDisabled(true);
			//need to disable first otherwise dijit unhides it
			this.disableAction("batcheditowner");
			this.disableAction("save");
			this.disableAction("discardedit");
			this.hideAction("batcheditowner");
			this.hideAction("save");
			this.hideAction("discardedit");
			this.enableAction("refresh");			
		}
		
 
	},    

    _onDeleteActionClick: function() {
        var args = {
            'message': Constants.getMessage("msgDelEWIConfirm"),
            'yesCallback': 
                function(view) {
                    view._deleteAction();
                },
            'yesCallbackData': this,
            'noCallback': null,
            'noCallbackData': null
        };
        var confirmDialog = new YesNoDialog(args);
        confirmDialog.setSecondaryTitle(Constants.getMessage("labelConfirmation"));
        confirmDialog.open();
    },

    _deleteAction: function() {         
        var selectedEWIs = this.tableViewer.getCheckedRows();
        this.deleteActionNode.setDisabled(true);
        this.selectedEWICount = selectedEWIs.length;
        this.errorEWICount = 0;
        this.deletedEWICount = 0;
        if (this.selectedEWICount > 0) {
            for (var i = 0; i < this.selectedEWICount; i++) {
                var responseHandler = new ServiceResponseHandler(this, "_deleteSuccess", "_deleteFailure");
                var args = {
                            uuid_ewi: selectedEWIs[i].itemId,
							ewiStateId:selectedEWIs[i].stateId,
                            archive: true
                        }
				ExecutionWorkItemClient.postArchiveEWI(responseHandler, args);
                if (this.isQueryPage)
                    this.viewHeaderNode.setProgressStart(Constants.getMessage("msgDeletingEWI", selectedEWIs[i].name));
            }
        }
    },
	
    _deleteSuccess: function(response) {
        if (this.isQueryPage)
            this.viewHeaderNode.setProgressEnd();
        this.deletedEWICount++;
        this._setDeleteStatus();

    },
    
    _deleteFailure: function(err) {
        if (this.isQueryPage)
            this.viewHeaderNode.setProgressEnd();
        this.errorEWICount++;
        this._setDeleteStatus();
    },
    
    _setDeleteStatus: function() {
        if ((this.deletedEWICount + this.errorEWICount) == this.selectedEWICount) {
            if (this.isQueryPage)
                this.viewHeaderNode.setStatus(
                    Constants.getMessage("msgDeletedEWI", this.deletedEWICount, this.selectedEWICount),
                    this.errorEWICount == 0 ? ViewHeaderLayout.SUCCESS : this.selectedEWICount == 1 ? ViewHeaderLayout.ERROR : ViewHeaderLayout.INFO
                );
            if (this.deletedEWICount > 0) {
                // notify all pages (including itself) execution workitem are deleted
                dojo.publish(GlobalEvents.ArtifactsDeleted, [Constants.TYPE_EWI, this.tableViewer.getCheckedRows()]);
				if(!this.isQueryPage){//Inside editor Update myself
					this.onArtifactChanged(GlobalEvents.ArtifactsDeleted, Constants.TYPE_EWI, this.tableViewer.getCheckedRows());
				}
            }
        }
    },

    // handler on artifacts changed
    onArtifactChanged: function(changeType, artifactType, artifactArray) {
        // only care about EWI
        if (artifactType == Constants.TYPE_EWI) {
            if (changeType == GlobalEvents.ArtifactsAdded) {
                // add EWI to the table
                if (!this.executionWorkItems)
                    this.executionWorkItems = artifactArray;
                else
                    this.executionWorkItems = this.executionWorkItems.concat(artifactArray);
                this.tableViewer.setContent(dojo.clone(this.executionWorkItems));
                this.tableViewer.refresh();
            } else {
                // iterate through the array of artifacts
                for (var i = 0; i < artifactArray.length; i++) {
                    // iterate through the array of EWI's in the table
                    for (var j = 0; j < this.executionWorkItems.length; j++) {
                        // handle the matching EWI
                        if (artifactArray[i].id == this.executionWorkItems[j].id) {
                            if (changeType == GlobalEvents.ArtifactsUpdated) {
                                // swap EWI on update
                                this.executionWorkItems.splice(j, 1, artifactArray[i]);
                                this.tableViewer.setContent(dojo.clone(this.executionWorkItems));
                                this.tableViewer.refresh();
                            } else if (changeType == GlobalEvents.ArtifactsDeleted) {
                                // remove EWI from table on delete
                                this.executionWorkItems.splice(j, 1);
                                this.tableViewer.setContent(dojo.clone(this.executionWorkItems));
                                this.tableViewer.refresh();
                            }
                            break;
                        }
                    }
                }
            }
        }else if ((artifactType == Constants.TYPE_CASE) && ((changeType == GlobalEvents.ArtifactsUpdated))){
			for (var i = 0; i < artifactArray.length; i++) {
                    // iterate through the array of EWI's in the table
                    for (var j = 0; j < this.executionWorkItems.length; j++) {//Should traverse all EWIs to update test case
                        // handle the matching EWI
                        if (artifactArray[i].id == this.executionWorkItems[j].testCase.id) {
								this.executionWorkItems[j].testCase =artifactArray[i]; 
                        }
                    }
                }
				this.tableViewer.setContent(dojo.clone(this.executionWorkItems));
                this.tableViewer.refresh();
			}
    },
	
	getCurrentEditableRows: function(){
		return this.tableViewer.getContentProvider().getEditableRows();
	},

	getIsInEditMode:function(){
		return this.inEditMode;
	},

    _error: function(e) {
        console.error(this.declaredClass + ": Error: " + e.message);
    }
});
})();
