//MACHINEADAPTERTABLEVIEW
/***************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.execution.web.ui.internal.view.table.MachineAdapterTableView");
 
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.require("com.ibm.rqm.execution.web.ui.internal.view.common.ImageCache");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.asq.common.web.client.internal.PermissionsClient");
dojo.require("com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentProvider");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.ListRowRenderer");
dojo.require("com.ibm.asq.common.web.client.internal.Catalog");
dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");
dojo.require("com.ibm.rational.test.lm.web.client.internal.reservations");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.widgets.ConfigSummary");
dojo.require("com.ibm.rqm.execution.web.client.internal.execution.ToolAdapterRegistrationClient");
dojo.require("com.ibm.rational.test.lm.web.client.internal.config");
dojo.require("com.ibm.asq.common.web.ui.internal.util.SelectUtility");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.RtlmUiUtil");          //Using this for Date formatting.  Probably should use an RQM method
dojo.require("com.ibm.asq.common.web.ui.internal.view.common.ImageCache");
dojo.require("com.ibm.rqm.execution.web.ui.internal.util.Utility");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.pages.AssetUriUtil");

(function() {
	
var TableConstants 					= com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants;
var ImageCache     					= com.ibm.rqm.execution.web.ui.internal.view.common.ImageCache;
var Constants      					= com.ibm.rqm.planning.web.client.internal.Constants;
var ServiceResponseHandler 			= com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
var getAuthenticatedContributor		= com.ibm.team.repository.web.client.session.getAuthenticatedContributor;
var SelectUtility					= com.ibm.asq.common.web.ui.internal.util.SelectUtility;
var RtlmUiUtil 						= com.ibm.rational.test.lm.web.ui.internal.RtlmUiUtil;
var CommonImageCache				= com.ibm.asq.common.web.ui.internal.view.common.ImageCache;
var Utility        					= com.ibm.rqm.execution.web.ui.internal.util.Utility;
var ViewHeaderLayout				= com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout;
var AssetUriUtil					= com.ibm.rational.test.lm.web.ui.internal.pages.AssetUriUtil;
var MACHINE_SEARCH_COLUMNS = "machine.id, machine.name, machine.operatingsystem.hostname";

/*The data structure of the row data is
{
	machineID   
	machineName
	osName
	reservedTill
	adapterInfo    (A structure defining the info for an adapter)
}
*/
dojo.declare("MachineAdapterTableView.Sorter",
			com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableSorter,
{
	_sortComparator: function(obj1, obj2){
		if(this.sortCol == 4){
			if(obj1.statusValue == null || obj2.statusValue == null)
				return 0;
			if(this.sortDir == TableConstants.SORT_DIR_ASCEND){
				return obj1.statusValue - obj2.statusValue;
			}else{
				return obj2.statusValue - obj1.statusValue;
			} 
		}else 
			return this.inherited("_sortComparator",arguments);
	},
	setConsoleNode: function(consoleNode){
		this.consoleNode = consoleNode;
	}
});

dojo.declare("MachineAdapterTableView.TableProvider", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentProvider,
{
    getNumColumns: function(content){
        return this.consoleNode ? 8 : 7;
    },

    getColumnHeading: function(content, index){
        if(this.consoleNode){
			var headings = [
	            Constants.getMessage("labelId"),
				Constants.getMessage("labelMachineName"),
	            Constants.getMessage("labelAdapterType"),
				Constants.getMessage("labelAdapterStatus"),
				Constants.getMessage("labelHealth"),
				Constants.getMessage("labelHostname"),
				Constants.getMessage("labelIPAddress"),
				Constants.getMessage("labelPollingInterval")
	        ];
		}else{
			var headings = [
			 	Constants.getMessage("labelId"),
	            Constants.getMessage("labelMachineName"),
	            Constants.getMessage("labelHostname"),
				Constants.getMessage("labelAdapterName"),
				Constants.getMessage("labelHealth"),
				Constants.getMessage("labelReserved"),
				Constants.getMessage("labelJobsInQueue")
	        ];
		}	
        return headings[index];
    },
   
    getColumnHeadingImage: function(content, atColumnIndex){		  
        return null;
    },
	 
    getColumnHeadingAlignment: function(atColumnIndex){
        return this.getCellAlignment(null, atColumnIndex);
    },	 
    
	//Group by State and Reservation
    getIsColumnGroupable: function(content, atColumnIndex){
		//Group by the State Column or machines and types (on consoleNode)
        return this.consoleNode ? (atColumnIndex != 4 && atColumnIndex != 5 && atColumnIndex != 6 && atColumnIndex != 7) : (atColumnIndex == 4);     
    },

    getIsColumnSortable: function(content, atColumnIndex){
        return true;   
    },
    
    getColumnWidth: function(content, atColumnIndex){
        switch(atColumnIndex) {
            case 0: 
                return 5;
			case 1: 
                return 15;
            case 2: 
                var width = this.consoleNode ? 20 : 30;
				return width;
            case 3: 
                return 10;
            case 4: 
               return 10;
            case 5: 
                return 20;
			case 6: 
                return 10;
			case 7: 
                return 10;				 
        }
        return 0;
    },
	
	setConsoleNode: function(consoleNode){
		this.consoleNode = consoleNode;
	},
	
    setServerTime: function(serverTime){
		this.serverTime = serverTime;
	},

    getContentObjects: function(content){
        return content;
    },
    
	getRowDataId: function(rowData){
        return rowData.adapterInfo.id;
    },
	
    getCellDisplayType: function(rowData, atColumnIndex){
        var type = TableConstants.RENDER_TYPE_TEXT;
        switch(atColumnIndex) {
			case 4: 
                type = TableConstants.RENDER_TYPE_IMAGE;
                break;					 
        }
		if(this.consoleNode && atColumnIndex == 1){
			//Only for AdapterConsole, not from the dialogs.
			type = TableConstants.RENDER_TYPE_LINK;
		}
        return type;
    },

    getCellAlignment: function(rowData, atColumnIndex){
		if(atColumnIndex == 4)
			return TableConstants.ALIGN_CENTER;
		else	
        	return TableConstants.ALIGN_LEFT;
    },
 
    getCellDisplayData: function(rowData, atColumnIndex){
        var val = "";
        switch(atColumnIndex) {
            case 0: 
                val = rowData.adapterInfo.id;
                break;
			case 1: 
                val = rowData.machineName;
                break;
            case 2: 
                val = this.consoleNode ? rowData.adapterInfo.adapterType.adapterName : rowData.adapterInfo.hostName;
                break;
			case 3:
				if(this.consoleNode){
					var engineStatus = Constants.getMessage("labelAvailable");
					rowData.statusValue = 0;
					if( (rowData.adapterInfo.serverTime - rowData.adapterInfo.lastHeartBeat) > 10*(rowData.adapterInfo.pollingInterval)){
						engineStatus = Constants.getMessage("labelUnAvailable");
						rowData.statusValue = 2;
					}else if( (rowData.adapterInfo.serverTime - rowData.adapterInfo.lastHeartBeat) > 2*(rowData.adapterInfo.pollingInterval)){
						engineStatus = Constants.getMessage("labelAvailable");
						rowData.statusValue = 1;
					}
				}
				val = this.consoleNode ?  engineStatus : Constants.getExtensionDisplayMessage(rowData.adapterInfo.name);
				break;
            case 4: 
                this.engineStatus = Constants.getMessage("labelAvailable");
				this.engineStatusIcon = CommonImageCache.ENGINE_AVAILABLE;
				this.engineToolTip = Constants.getMessage("msgEngAvailable");
				rowData.statusValue = 0;
				if( (rowData.adapterInfo.serverTime - rowData.adapterInfo.lastHeartBeat) > 10*(rowData.adapterInfo.pollingInterval)){
					this.engineStatus = Constants.getMessage("labelUnAvailable");
					this.engineStatusIcon = CommonImageCache.ENGINE_NOTAVAILABLE;
					this.engineToolTip = Constants.getMessage("msgEngUnresponsive");
					rowData.statusValue = 2;
				}
				else if( (rowData.adapterInfo.serverTime - rowData.adapterInfo.lastHeartBeat) > 2*(rowData.adapterInfo.pollingInterval)){
					this.engineStatus = Constants.getMessage("labelAvailable");
					this.engineStatusIcon = CommonImageCache.ENGINE_NOTRESPONDED;
					this.engineToolTip = Constants.getMessage("msgEngRespondLate");
					rowData.statusValue = 1;
				}
				val = this.engineStatus;
                break;
			case 5:
				var tillDate = rowData.reservedTill;
				if (tillDate != null && tillDate != ""){
					var resTill = RtlmUiUtil.getDateDisplay(tillDate, false);
					val = Constants.getMessage("labelReservedUntil", resTill);
				}
				if(this.consoleNode){
					val = rowData.adapterInfo.hostName;
				}
				break;
			 case 6: 
                val = this.consoleNode ? rowData.adapterInfo.machine.ipAddress : rowData.adapterInfo.requestsInQueue;
                break;
			case 7: 
                val = this.consoleNode ? Utility.getTimeDifferenceInHrMinSec(rowData.adapterInfo.pollingInterval) : "";
                break;		
        }
        return val;
    },

	getToolTip: function(adapter, avail){
		var reqInQueue = adapter.requestsInQueue ? adapter.requestsInQueue : 0; 
		var str = "<table><tr><td> </td><td> </td></tr>";
		str +="<tr><td align=left>"+Constants.getMessage("labelstatus")+": "+"</td><td>"+avail+"</td></tr>";
		str +="<tr><td> </td><td> </td></tr>";
		str +="<tr><td align=left>"+Constants.getMessage("labelJobsInQueue")+": "+"</td><td>"+ reqInQueue +"</td></tr>";				
		str +="<tr><td> </td><td> </td></tr>";
		if(this.consoleNode && adapter.name){
			str +="<tr><td align=left>"+Constants.getMessage("labelName")+": "+"</td><td>"+ adapter.name +"</td></tr>";				
			str +="<tr><td> </td><td> </td></tr>";
		}
		str += "</table>";
		return str;
	},

    getCellDisplayExtendedInfo: function(rowData, atColumnIndex){  
        var val = null;
        if (atColumnIndex == 4) {
           val = {};
			  val.image = this.engineStatusIcon;
			  val.tooltip = this.getToolTip(rowData.adapterInfo, this.engineToolTip);
		  }else if(this.consoleNode && atColumnIndex == 1){
		  	 val = {};
			 val.href = AssetUriUtil.getViewAssetDetailURI( "Machine", rowData.machineID);;
		  }		  
        return val;
    }
});

dojo.declare("com.ibm.rqm.execution.web.ui.internal.view.table.MachineAdapterTableView", 
    [dijit._Widget, dijit._Templated],
{    
    templateString: '<div dojoAttachPoint="domNode" class="com-ibm-rqm-test-execution-machine-adapter-view">' +
					'    <div dojoAttachPoint="configNode">' +
					'        <table class="ma-config-table" dojoAttachPoint="configTableNode">' +
					'            <tr>' +
					'                <td>' +
					'                  <div class="ma-label" dojoAttachPoint="configSummaryLabelNode">Configuration:</div>' +
					'                </td>' +
					'            </tr>' +
					'            <tr>' +
					'                <td>' +
					'                  <div dojoAttachPoint="configSummaryNode"></div>' +
					'                </td>' +
					'            </tr>' +
					'            <tr>' +
					'                <td>' +
					'                  <input dojoAttachPoint="applyFilterCheckBox" type="checkbox" id="applyFilterCB"/>' +
					'                  <label for="applyFilterCB" dojoAttachPoint="applyFilterLabel">Filter Machines by Configuration</label>' +
					'                </td>' +
					'            </tr>' +
					'        </table>' +
	                '    </div>' + 
					'    <div dojoAttachPoint="durationNode">' +
					'        <label class="ma-label" for="durationSelect" dojoAttachPoint="durationLabel">Duration of execution:</label>' +
					'        <select class="ma-select" dojoAttachPoint="durationSelector" id="durationSelect">' +
					'        </select>' +
					'    </div>' +
	                '  <div dojoType="com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout" "noline"=true dojoAttachPoint="viewHeaderNode">' +
					'  </div>'+
					'    <div dojoAttachPoint="_tableViewerNode" class="com-ibm-rqm-test-artifact-table-view" tabindex="-1"> ' +
					'    </div>' +
					'</div>',

    widgetsInTemplate: true,
	allowMultiSelect: false,
    constructor: function(){
		//Expected to be supplied by the caller:
		//scriptType - String representing the type of script to find adapters for 
		//serverTime - the current time on the server - used to determine the state of the adapter
		//configID - the internal ID of the config we will use to in the search for machines - Can be NULL
		//loadingCompleteCallback - Called when all the data is loaded into the table.
		//							returns the data that would show in the table
		this.hideReservationNode =false;
	},
	 
	postCreate: function(){
		this.inherited("postCreate", arguments);		
		this.results = null;
		this.theConfig = null;
		if(this.allowMultiSelect)
			this.selection = [];
		else
			this.selection={};
		this.theCatalog = new com.ibm.asq.common.web.client.internal.Catalog();
		this.initialLoad = true;  //Used to gate calls to the loadingComplete callback
		
		this.isQueryPage = this.queryName;
        if (this.isQueryPage) {
            this.viewHeaderNode.setTitle(this.queryName);
			this.configNode.style.display = "none";
			this.consoleNode = true;
        } else {
            this.viewHeaderNode.domNode.style.display = "none";
			this.configNode.style.display = "inline";
			this.consoleNode = false;
        }
		//Add the click handler to the show all checkbox
		this.applyFilterCheckBox.onclick = dojo.hitch(this,"_onApplyFilterCheckClick");
		//Todo load this value from the string catalog
		this.applyFilterLabel.innerHTML = Constants.getMessage("lableFilterByConfiguration");
		this.durationLabel.innerHTML = Constants.getMessage("labelExecutionDuration");
		this.configSummaryLabelNode.innerHTML = Constants.getMessage("labelConfiguration"); 
		//Create the table for showing the machines
		var tableViewer = new com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer({
            allowAdjustSettings: true,
            autoSaveSettings: true,
            tableId: "RQM-EXE-MACH-ADAPTER-TABLEVIEWER"                                
        });
        this._tableViewerNode.appendChild(tableViewer.domNode);
        tableViewer.setContentPageSize(20);
		var tableProvider = new MachineAdapterTableView.TableProvider();
		tableProvider.setServerTime(this.serverTime);
		tableProvider.setConsoleNode(this.consoleNode);
        tableViewer.setContentProvider(tableProvider);
        tableViewer.setTableListener(this);
		tableViewer.setTableRowsCheckable(true, /* isSingleSelect */!(this.consoleNode||this.allowMultiSelect));
		tableViewer.setTableSummary(Constants.getMessage("labelTableSummary", Constants.getMessage("labelMachineAdapter")));
		var sorter = new MachineAdapterTableView.Sorter();
		sorter.setConsoleNode(this.consoleNode);
		tableViewer.setSorter(sorter);
		var content = [];
		tableViewer.setContent(content);
        tableViewer.show();
		this.tableViewer = tableViewer;
		if(this.consoleNode){
            this.refreshAction = tableViewer.addAction("Refresh", Constants.getMessage("labelRefresh"), this, "refresh-icon-image", dojo.hitch(this, this.refreshMATV));
            var type = com.ibm.asq.common.web.client.internal.PermissionsClient.OP_ADAPTER;
            var perm = com.ibm.asq.common.web.client.internal.PermissionsClient.getStoredPermission(type);
            
            if (!perm || perm['delete']) {
                this.deleteAction = tableViewer.addAction("Delete", Constants.getMessage("labelDelete"), this, "delete-icon-image", dojo.hitch(this, this.deleteActionM));
                this.deleteAction.setDisabled(true);
            }
		}
		this._loadDurations();
		this.durationSelector.onchange = dojo.hitch(this,"_onDurationChange");
		//Get the default duration of the execution
		this.duration = this.durationSelector.options[ this.durationSelector.selectedIndex ].value;
		if(this.hideReservationNode){
			this.durationNode.style.display = "none";
		}
		this._loadTable();
	},
	
	_loadDurations: function(){
		SelectUtility.add(this.durationSelector, new Option( Constants.getMessage("labelNMinutes", 5), 5 ));
		SelectUtility.add(this.durationSelector, new Option( Constants.getMessage("labelNMinutes", 10), 10 ));
		SelectUtility.add(this.durationSelector, new Option( Constants.getMessage("labelNMinutes", 15), 15 ));
		SelectUtility.add(this.durationSelector, new Option( Constants.getMessage("labelNMinutes", 30), 30 ));
		SelectUtility.add(this.durationSelector, new Option( Constants.getMessage("labelOneHour"), 60 ));
		SelectUtility.add(this.durationSelector, new Option( Constants.getMessage("labelNHours", 2), 120 ));
		SelectUtility.add(this.durationSelector, new Option( Constants.getMessage("labelNHours", 4), 240 ));
		SelectUtility.add(this.durationSelector, new Option( Constants.getMessage("labelNHours", 8), 480 ));
		SelectUtility.add(this.durationSelector, new Option( Constants.getMessage("labelNHours", 16), 960 ));
		SelectUtility.add(this.durationSelector, new Option( Constants.getMessage("labelOneDay"), 1440, true, true ));
		SelectUtility.add(this.durationSelector, new Option( Constants.getMessage("labelNDays", 2), 2880 ));
		SelectUtility.add(this.durationSelector, new Option( Constants.getMessage("labelNDays", 3), 4320 ));
		SelectUtility.add(this.durationSelector, new Option( Constants.getMessage("labelNDays", 4), 5760 ));
		SelectUtility.add(this.durationSelector, new Option( Constants.getMessage("labelNDays", 5), 7200 ));
	},
	
	//Here's how this goes.....
	//Find the Machines based on the supplied configuration id.  If no configuration, start with all machines
	_loadTable: function(){
		//load the config if necessary
		if (this.configID && this.applyFilterCheckBox.checked) 
			this._loadTableByConfig(this.configID);
		else{ //No config so load all the machines and hide the show all checkbox
			//If no config passed in then hide the cofig area
			if (!this.configID)
				this.configNode.style.display="none";
			else
				this._loadAndShowConfig(this.configID);
				
			this._loadMachines(null);
		}
	},
	
	_loadTableByConfig: function(configID){
		if (configID == null)
			this._loadMachines(null);
		//Setup the response handlers and load the config
        var responseHandler = new ServiceResponseHandler(this, "_loadConfigSuccess", "_loadConfigFailure");
        var configService = new com.ibm.rational.test.lm.web.client.internal.config();
		configService.retrieveConfigurationWithDetails(responseHandler, configID);
	},
	
	_loadConfigSuccess: function(response){
        var config = this.theCatalog.createConfigurationFromJson(response.configuration);
		this.theConfig = config;
		this._showConfig(config);
		this._loadMachines(config);	
	},
	
	_loadConfigFailure: function(response){
		//For now just proceed and assume no config.
		//NEED TO DECIDE HOW TO HANDLE THIS BETTER
		this._loadMachines(null);
	},
	
	_showConfig: function(config){
		dojox.data.dom.removeChildren(this.configSummaryNode);
		var configSummary = new com.ibm.rational.test.lm.web.ui.internal.widgets.ConfigSummary({configPart:config.getRootPart(0)});
		if (configSummary)
			this.configSummaryNode.appendChild(configSummary.domNode);
	},
	
	_loadAndShowConfig: function(configID){
		//Setup the response handlers and load the config
        var responseHandler = new ServiceResponseHandler(this, "_loadConfigForShowSuccess", "_loadConfigFailure");
        var configService = new com.ibm.rational.test.lm.web.client.internal.config();
		configService.retrieveConfigurationWithDetails(responseHandler, configID);
	},
	
	_loadConfigForShowSuccess: function(response){
        var config = this.theCatalog.createConfigurationFromJson(response.configuration);
		this.theConfig = config;
		this._showConfig(config);		
	},
	
	_loadMachines: function(config){
	   	var responseHandler = new ServiceResponseHandler(this, "_searchSuccess", "_searchError");
		if (config == null){
    	    config = this.theCatalog.createConfiguration("Machine"); 
		}
		var searchParam = {configuration: config,
						   index:0,  //For now just use the first Part in the config
	                       columns: ( MACHINE_SEARCH_COLUMNS )
	                      };
	                this.theCatalog.search(responseHandler, searchParam);
	},
	
	_searchSuccess: function(response){
		//If no machines match then no sense continuing
		if (response == null || response.Data == null || response.Data.length == 0){
			this.tableViewer.setContent([]);
			this.tableViewer.show();
			//Perform the supplied callback to indicate loading is complete
			if (this.loadingCompleteCallback && this.initialLoad){
				this.initialLoad = false;
				this.loadingCompleteCallback([], this);
			}
		}else{
			var reservationService = new com.ibm.rational.test.lm.web.client.internal.reservations();
			//Save the data from this call.
			//This will be passed to the table in the reservation response handler
			//Build objects out of each row in the response
			this.tableData = [];
			//Get the ids for passing to the reservation checking service
			var ids = [];
			for (var i = 0; i < response.Data.length; i++){
				var machineInfo = {};
				machineInfo.machineID = response.Data[i][0];
				machineInfo.machineName = response.Data[i][1];
				machineInfo.osName = response.Data[i][1];
				this.tableData.push(machineInfo);
				
				//build a list of IDs to pass to the reservation checking service
				ids.push(response.Data[i][0]);
			}
			var responseHandler = new ServiceResponseHandler(this, "_searchResSuccess", "_searchResError");
			reservationService.getReservationsInWindow(responseHandler, ids, this.duration);
		}
		this.stopInProgress();		
	},
	
	_searchError: function(response){
		//Perform the supplied callback to indicate loading is complete
		if (this.loadingCompleteCallback && this.initialLoad){
			this.initialLoad = false;
			this.loadingCompleteCallback([], this);
		}
		this.stopInProgress();
	},
	
	_searchResSuccess: function(response){
		//Save the response data.  it will be used by a callback from the table provider
		//The callback will ask if a particular machine is reserved.  To answer that we need this response data
		this.reservationData = response;
		if (this.reservationData == null)
			this.reservationData = [];  //Don't like nulls
		this.mergedData = this._mergeResDataWithMachines();  //Merges this.reservationData with this.tableData
		var params = {};
		if(this.scriptType){
			params.type = this.scriptType;
		}
		var toolService = com.ibm.rqm.execution.web.client.internal.execution.ToolAdapterRegistrationClient;
		var responseHandler = new ServiceResponseHandler(this, "_searchAdapterSuccess", "_searchAdapterError");
		toolService.getAdaptersWithMachines(responseHandler, params);
	},
	
	_searchResError: function(){
		//Perform the supplied callback to indicate loading is complete
		if (this.loadingCompleteCallback && this.initialLoad){
			this.initialLoad = false;
			this.loadingCompleteCallback([], this);
		}
	},
	
	_searchAdapterSuccess:function(response){
		this.adapterData = response;
		this.mergedData = this._mergeAdapterDataWithMachines();
		if(this.lastSelectedAdapter || this.lastSelectedAdapterExternalId){
			for(var i=0;i<this.mergedData.length;i++){
				if((this.mergedData[i].adapterInfo.id == this.lastSelectedAdapter || 
						this.mergedData[i].adapterInfo.externalId == this.lastSelectedAdapterExternalId ) && i!=0){
					var tempData = this.mergedData[0];//swap the first adapter with the last selected one
					this.mergedData[0] = this.mergedData[i];
					this.mergedData[i] = tempData;
					break;
				}
			}
		}
        this.tableViewer.setContent( this.mergedData );
		if(!this.consoleNode && this.mergedData && this.mergedData.length>0){
			this.isPreChecked = true;
			this.tableViewer.rowCheckedHandler.setRowCheckState(this.mergedData[0],true);
			this.rowCheckStateChanged(this.tableViewer, this.mergedData[0], true);
		}
        this.tableViewer.show();
		this.tableViewer.performSortBy(3, TableConstants.SORT_DIR_ASCEND);
		//Perform the supplied callback to indicate loading is complete
		if (this.loadingCompleteCallback && this.initialLoad){
			this.initialLoad = false;
			this.loadingCompleteCallback(this.mergedData, this);
		}
	},

	_searchAdapterError:function(response){
		//Perform the supplied callback to indicate loading is complete
		if (this.loadingCompleteCallback && this.initialLoad){
			this.initialLoad = false;
			this.loadingCompleteCallback([], this);
		}
	},
	
	//Merge this.tableData with this.reservationData
	//Any machines that are reserved by someone else are removed from this.tableData
	//Any remaining machines will have the reservation time added to it
	_mergeResDataWithMachines: function(){
		//If no reservations or no machines then return
		if (this.tableData.length == 0 || this.reservationData.length == 0)
			return this.tableData;
		var currentUserID = this.getCurrentUserID();	
		var mergedData = [];
		//Loop over all the this.tableData rows
		for (var i = 0; i < this.tableData.length; i++){
			var machineRow = this.tableData[i];
			var machineID = machineRow.machineID;
			var mergedRow = null;
			var badReservation = false;
			//See if the machine is reserved.
			for (var j = 0; j < this.reservationData.length; j++){
				if (this.reservationData[j].resourceId == machineID){
					//The machine is reserved.  Ensure that ALL the reservations are for the current user
					for (var k = 0; k < this.reservationData[j].reservations.length; k++){
						//See if it is reserved for the current user
						if (this.reservationData[j].reservations[k].reservedFor.id != currentUserID){ //It is reserved for the current user
							//This may be better handled by having rows in the table that are not selectable so the user can see that
							//there are matching machines but they are currently reserved by someone else
							badReservation = true;
							break;
						}
					}
					//If no bad reservations then add in some reservation data and push the row onto the merged data array
					if (!badReservation){
						mergedRow = machineRow;
						//Save the reserved time to display in the table
						mergedRow.reservedTill = this.reservationData[j].reservations[0].reserveTo;
					}
					//Only 1 set of reservation data per machine ID so we can break here
					break;
				}
			}
			//If this machine is reserved by someone else then continue on to the next machine without pushing it into the merged data array
			if (badReservation)
				continue;
			if (mergedRow)  //The reservation data is in the merged info so push it onto the array we will return
				mergedData.push(mergedRow);
			else{ //There must be no reservation for this machine so lets add it to the merged data without any reservation info
				mergedData.push(machineRow);
			}
		}
		return mergedData;
	},
	
	_mergeAdapterDataWithMachines :function(){
		//Get the server time that was returned with the adapter data
		//We'll use that to show adapter availability
		if (this.adapterData != null && this.adapterData.length > 0){
			this.serverTime = this.adapterData[0].serverTime;
		}
		//Iterated over all the mergedData
		//The merged data will contain at this point all the reserveable machines
		//Remove any machine from the list that is not in the adapter data
		//because that indicates that the machine is not running the necessary adapter
		//add the adapter info to the merged data for any matchine machine.
		var resultData = [];
		for (var i = 0; i < this.mergedData.length; i++){
			var mergedInstance = this.mergedData[i];
			var machineID = mergedInstance.machineID;
			var adapterArray = this._findAdaptersForMachine(machineID, this.adapterData);
			if (adapterArray == null)  //no match for the machine so don't add it to the resulting merged data
				continue;
			//At least one adapter found for this machine
			//The adapter matches the machine so add the adapter info to this row
			for (var j = 0; j < adapterArray.length; j++){
				var resultInstance = this._cloneData(mergedInstance);
				resultInstance.adapterInfo = adapterArray[j];
				resultData.push(resultInstance);
			}
		}
		return resultData;
	},
	
	_findAdaptersForMachine: function(machineID, adapterData){
		if (machineID == null || adapterData == null)
			return null;
		var adapterArray = [];
		for (var i = 0; i < adapterData.length; i++)
			if (adapterData[i].machine && adapterData[i].machine.itemId == machineID)
				adapterArray.push(adapterData[i]);
		return adapterArray;
	},

	getSelection :function(){
		return this.selection;
	},

	//Helpers
	getCurrentUserName: function(){
		return getAuthenticatedContributor().userId;
	},

	getCurrentUserID: function(){
		return getAuthenticatedContributor().itemId;
	},

	//Event Handlers
	_onApplyFilterCheckClick: function(){
		if (this.applyFilterCheckBox.checked)
			this._loadMachines(this.theConfig);
		else
			this._loadMachines(null);
	},
	
	_onDurationChange: function(){
		//Get the duration of the execution
		this.duration = this.durationSelector.options[ this.durationSelector.selectedIndex ].value;
		if (this.applyFilterCheckBox.checked || this.theConfig == null)
			this._loadMachines(null);
		else
			this._loadMachines(this.theConfig);		
	},
	//Ideally should be in table listener
	rowCheckStateChanged: function(tableViewer, rowObject, state){
		if(this.consoleNode && this.deleteAction){
			if(tableViewer.getCheckedRows().length > 0)
				this.deleteAction.setDisabled(false);
			else
				this.deleteAction.setDisabled(true);
		}
        if (state == true){
			if(this.allowMultiSelect){
				this.selection.push({
					machine:rowObject,machineID:rowObject.machineID,machineName:rowObject.machineName,adapter:rowObject.adapterInfo
				});
			}else{
				this.selection.machine = rowObject;
				this.selection.machineID = rowObject.machineID;
				this.selection.machineName = rowObject.machineName;
				this.selection.adapter = rowObject.adapterInfo;
			}
			if(!this.consoleNode && this.onCheckedStateChange && this.isPreChecked){
				this.onCheckedStateChange(true);	
			}
		}else{
			if(this.allowMultiSelect){
				for(var i=0;i<this.selection.length;i++){
					if(this.selection[i].machineID == rowObject.machineID){
						this.selection.splice(i,1);
						break;
					}
				}
				if(tableViewer.getCheckedRows().length=== 0){
					if(!this.consoleNode && this.onCheckedStateChange && this.isPreChecked){
						this.onCheckedStateChange(false);	
					}
				}
			}else{
				this.selection.machine = null;
				this.selection.machineID = null;
				this.selection.machineName = null;
				this.selection.adapterID = null;
				this.selection.adapter = null;
				if(!this.consoleNode && this.onCheckedStateChange && this.isPreChecked){
					this.onCheckedStateChange(false);	
				}
			}
		}
    },
	//Ideally should be in table listener
	tableContentActionInvoked: function(tableViewer, actionId, callbackData, callback){
        if (callback != null && dojo.isFunction(callback)) {
            if (callbackData != null) {
                callback(callbackData);
            } else {
                callback();
            }
        } 
    },
	
	//Methods for the callers to get selelcted info
	getSelectedAdapter: function(){
		return this.selection.adapter;
	},
	
	getSelectedInfo: function(){
		return this.selection;
	},
	
	//Return all the data that would show in the table
	getAllMachineAdapterInfo: function(){
		return(this.mergedData);
	},
	
	//Utility method for reserving a selected machine.
	//It will use the current duration in the class as the reservation duration
	reserveMachine: function(machineID, responseHandler){
		var reservationService = new com.ibm.rational.test.lm.web.client.internal.reservations();
		var fromDate = new Date();
		var toDate = new Date(fromDate.getTime() + this.duration*60*1000);  //Duration is in minutes, need milliseconds
		//Fill in any gaps in the reservation
		reservationService.fillReservationGaps(responseHandler, machineID, fromDate.getTime(), toDate.getTime(), false);		
	},
	
	reInitialize: function(scriptType, configID, loadingCompleteCallback){
		this.scriptType = scriptType;
		this.configID = configID;
		this.loadingCompleteCallback = loadingCompleteCallback;
		this.initialLoad = true;
		this._loadTable();
	},
	
	refreshMATV: function(){
		this.reInitialize(this.scriptType, this.configID, this.loadingCompleteCallback);
		this.viewHeaderNode.clearStatus();
	},

	deleteActionM: function(){		
		var selectedItems = this.tableViewer.getCheckedRows();
		if (selectedItems && selectedItems.length >0 ){
			var messagespan = document.createElement("label");
            messagespan.innerHTML = Constants.getMessage("msgDeleteAdapter");
            var yesNoDialog = new com.ibm.asq.common.web.ui.internal.widgets.YesNoDialog({
				primaryTitle:Constants.getMessage("labelDelete")+" "+Constants.getMessage("labelAdapter"),
                yesCallback:dojo.hitch(this,"_deleteAdapter"),
                yesCallbackData:selectedItems,
				isClosable: true
            });
            yesNoDialog.contentContainer.appendChild(messagespan);
            yesNoDialog.open();
		}
	},
	_deleteAdapter:function(selectedItems){
		this.adaptersToDeleteCount = selectedItems.length;
		this.adaptersDeletedCount = 0;
		var toolService = com.ibm.rqm.execution.web.client.internal.execution.ToolAdapterRegistrationClient;
		for(var i=0;i<selectedItems.length;i++){
			var params = { id: selectedItems[i].adapterInfo.id};
			var responseHandler = new ServiceResponseHandler(this, "_success", "_failure");
			toolService.postDelete(responseHandler, params);
		}
		
	},
	_success: function(object){
		this.adaptersDeletedCount++;
		if(this.adaptersDeletedCount == this.adaptersToDeleteCount){
			this.refreshMATV();
			this.deleteAction.setDisabled(true);
			this.viewHeaderNode.setStatus(Constants.getMessage("msgAdapterDeleteSuccess"),ViewHeaderLayout.INFO);
		}
	},
	
	_failure: function(object){
		this.adaptersDeletedCount++;
		if(this.adaptersDeletedCount == this.adaptersToDeleteCount){
			this.deleteAction.setDisabled(true);
			this.viewHeaderNode.setStatus(Constants.getMessage("msgAdapterDeleteFailed"),ViewHeaderLayout.ERROR,object.message);
		}
	},
	
	_cloneData:function(sourceObj){
		var destObject = {};
	    for (var i in sourceObj){
        	if (typeof sourceObj[i] == 'object'){
            	destObject[i] = this._cloneData(sourceObj[i]);
        	}else
            	destObject[i] = sourceObj[i];
    	}
		return destObject;
	},

 	setInProgress: function(msg) {
		this.viewHeaderNode.setProgressStart(msg);
	},
	
	stopInProgress: function() {
		this.viewHeaderNode.setProgressEnd();
	}
});

})();