/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.requirement.web.ui.internal.view.table.RequirementTableView");
 
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.require("com.ibm.asq.common.web.client.internal.PermissionsClient");
dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");
dojo.require("com.ibm.asq.common.web.ui.internal.view.common.ImageCache");
dojo.require("com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout");

dojo.require("com.ibm.rqm.planning.web.ui.internal.util.Utility");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.rqm.requirement.web.client.internal.requirement.RequirementWorkItemClient");

dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentProvider");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableCellModifier");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.ListRowRenderer");

(function() {

var ServiceResponseHandler = com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
var TableConstants = com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants;
var ImageCache     = com.ibm.asq.common.web.ui.internal.view.common.ImageCache;
var Utility        = com.ibm.rqm.planning.web.ui.internal.util.Utility;
var Constants = com.ibm.rqm.planning.web.client.internal.Constants;
var getCurrentProjectArea	= com.ibm.team.process.web.client.projectarea.getCurrentProjectArea;
var LOCATION                = "jazz/web/projects/";
var WORKITEM_URL 				= "#action=com.ibm.team.workitem.viewWorkItem&id=";
var RENDER_TYPE_REQLINK = "RenderType.ReqLink";
var RequirementWorkItemClient = com.ibm.rqm.requirement.web.client.internal.requirement.RequirementWorkItemClient;
var ViewHeaderLayout = com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout;

dojo.declare("com.ibm.rqm.requirement.web.ui.internal.view.table.RequirementTableViewTableListener", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableListener,
{
	parentView: null,
    
	constructor: function(testView)
	{
    	this.parentView = testView;
	},
	// Summary:
    //   If the table's rows are checkable, when a row is checked, or unchecked, this method is
    //   called.
    //
    setRowCheckListener: function(listener) {
		this.rowCheckListener = listener;
	},
	
	rowCheckStateChanged: function(tableViewer, rowObject, state)
    {
	    rowObject.selected = state;
		var listener = this.rowCheckListener;
      	if (listener && listener.context && listener.method) {
			listener.method.apply(listener.context, [rowObject, state]);
		}
		var selectionCount = tableViewer.getCheckedRows().length;
        var disabled = (selectionCount == 0 || !tableViewer.isEditable());
		if (this.parentView.clearStatusActionNode) {
			var test = selectionCount == 1 && (tableViewer.getCheckedRows()[0].status =="updated");
			this.parentView.clearStatusActionNode.setDisabled(!test);
		} 
		if (this.parentView.assoicatedTestPlanNode) {
			this.parentView.assoicatedTestPlanNode.setDisabled(disabled); 
		}
		if (this.parentView.assoicatedTestCaseNode) {
			this.parentView.assoicatedTestCaseNode.setDisabled(disabled);
		}	
		if (this.parentView.disaccosicateButton) {
			this.parentView.disaccosicateButton.setDisabled(disabled);
		}		
	},
	
	// Summary:
    //    If the client have registered table actions, this message will be fired when an action (button)
    //    is invoked by the user.
    //
    tableContentActionInvoked: function(tableViewer, actionId, callbackData, callback)
    {
        if (callback != null && dojo.isFunction(callback)) {
            if (callbackData != null) {
                callback(callbackData);
            } else {
                callback();
            }
        }        
    }
});
dojo.declare("com.ibm.rqm.requirement.web.ui.internal.view.table.RequirementTableLinkCellRenderer",
			com.ibm.asq.common.web.ui.internal.widgets.tableViewer.LinkCellRenderer,
{
	renderCell: function(viewer, cellData, extendedDisplayInfo,cellModifier, rowObject, columnIndex, cellWidthHint)
	{
		var node = document.createElement("a");
        var textData = cellData + "";
        var displayNode = document.createElement("span");
        var href = "#";
                
        if(extendedDisplayInfo && (typeof extendedDisplayInfo['href'] != "undefined")) {
            href = extendedDisplayInfo['href'];
        }
        if(viewer.isCompactMode && typeof cellWidthHint != "undefined") {
            textData = this._handleCompactCellText(viewer, textData, extendedDisplayInfo, node, cellWidthHint);
        }
        else {
            // the parent class's attach tooltip will not create a tooltip
            // if the string is null, or undefined. Don't have to check it here.
            this._attachTooltipToCell(node, extendedDisplayInfo['tooltip']);            
        }
        displayNode.innerHTML = textData;
        node.appendChild(displayNode);
        node.href = href;
		node.target ="_blank";
		return node;
	}
	
});

dojo.declare("com.ibm.rqm.requirement.web.ui.internal.view.table.RequirementTableViewCellModifier", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableCellModifier,
{
	parentView: null,
    
   	constructor: function(testView)	{
        	this.parentView = testView;
    },
		
    // Summary:
    //    Method to be called when a cell renderer changes the cell value. This notifies
    //    the cell's value change event. 
    //    
    //    
    cellValueChanged: function(oldValue, newValue, rowObject, columnIndex)
    {
        // store the new values in our internal data model
        if(columnIndex == 5) {
            if(dojo.isString(newValue)) {
                //rowObject.selection = newValue;
            }
        }
    },
    
    cellActionInvoked: function(rowObject, columnIndex)
    {
		// do nothing
    }
});

dojo.declare("com.ibm.rqm.requirement.web.ui.internal.view.table.RequirementTableViewListRowRenderer",
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.ListRowRenderer,
{    
    // Summary:
    //   Override the base list row renderer's create list content method
    //   to supply more custom contents.
    //
    _createListContents: function(viewer, rowObject, listWidget)
    {
        this.inherited("_createListContents", arguments);   
        
        var moreContents = document.createElement("div");
        var toggle = document.createElement("button");
        toggle.innerHTML = "Added Custom Control";
        moreContents.appendChild(toggle);
        listWidget.contentNode.appendChild(moreContents);
    }
});

dojo.declare("com.ibm.rqm.requirement.web.ui.internal.view.table.RequirementTableViewTableProvider", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentProvider,
{
    // Summary:
    //
    getNumColumns: function(content)
    {
        return 6;
    },
    
    // Summary:
    //
    getColumnHeading: function(content, index)
    {
        var headings = [
        	Constants.getMessage("labelStatusRequirementTable"),
            Constants.getMessage("labelId"), //"WorkItem No.",
            Constants.getMessage("labelTagRequirementTable"),
            Constants.getMessage("labelName"),
            Constants.getMessage("labelDescriptionRequirementTable"),
            Constants.getMessage("labelOwner")
        ];
        return headings[index];
    },

    getIsColumnGroupable: function(content, atColumnIndex)
    {
	 	  return (atColumnIndex == 5 || atColumnIndex == 0 || atColumnIndex == 2);
    },

    getIsColumnSortable: function(content, atColumnIndex)
    {
        return (true);     
    },
    
    getColumnWidth: function(content, atColumnIndex)
    {
        switch(atColumnIndex) {
            case 0: 
                return 5;
            case 1: 
                return 5;
			case 2:
				return 10;
            case 3: 
                return 20;
            case 4: 
                return 40;
            case 5: 
                return 20;
 
        }
        return 0;
    },
    
    // Summary:
    //    The only assumptions the table have on the data that it displays
    //    is that it's an array contents. These are the data content/object that
    //    will be displayed in the table rows.
    //
    getContentObjects: function(content)
    {
        // our content is already an array of objects
        return content;
    },
    
    getRowDataId: function(rowData)
    {
        return "_table_row_for_requirement_" + rowData.id;
    },
    
    // Summary:
    //    Returns the type of the cell to be displayed. By default, the TableViewer
    //    will support a set of cell types. The type of the cell will map to a specific
    //    cell renderer (to be discussed).
    getCellDisplayType: function(rowData, atColumnIndex)
    {
        var type = TableConstants.RENDER_TYPE_TEXT;

        switch(atColumnIndex) {
        	case 0:
				type = TableConstants.RENDER_TYPE_IMAGE;
				break;
            case 1: 
                type = TableConstants.RENDER_TYPE_LINK;  //RENDER_TYPE_REQLINK;
                break;		
			case 3:
				if (rowData.externalUrl != null && rowData.externalUrl.match(/^https?:\//i)) {
					type = RENDER_TYPE_REQLINK;		
				}
				else if (rowData.externalId!=null && ( rowData.externalId.match(/^reqpro\//i) || rowData.externalId.match(/^doors\//i) || rowData.externalId.match(/^https?:\//i) )) {
					type = RENDER_TYPE_REQLINK;		
				}
				break; 			 
        }
        return type;
    },

    getCellAlignment: function(rowData, atColumnIndex)
    {
        if(atColumnIndex == 0)
            return TableConstants.ALIGN_CENTER;
        return TableConstants.ALIGN_LEFT;
    },
    
    // Summary:
    //    Returns the display data of the cell. For cell renderer type of TEXT, this will
    //    be the string. Others cell render type would be Date, or integer value, etc. If the 
    //    cell renderer type is image, the client can also supply cell data that can be sortable/groupable. 
    //    The TableViewer's default sorter, filter operates on this returned data. For "complex" 
    //    cell types such as image where it could have multiple values for different states, the 
    //    client also needs to implement the next method.
    //    
    //    Client must implement this method to provide the cell data.
    //    
    getCellDisplayData: function(rowData, atColumnIndex)
    {
        var val = "data";
        switch(atColumnIndex) {
            case 1: 
                val = rowData.id ? parseInt(rowData.id, 10) : "";
                break;
			case 2: 
                val = rowData.externalTag ? rowData.externalTag : "";
                break;
            case 3: 
                val = this.encodeSpecialChars(rowData.name);
                break;
            case 4: 
                val = this.restoreTags(rowData.description);
                break;
            case 5: 
                val = rowData.owner ? rowData.owner.name : "";
                break;
			case 0: 
				if(!rowData.status || rowData.status=="new")
					val = Constants.getMessage("labelRequirementNormal");
				else if(rowData.status=="unknown")
					val = "";
				else if(rowData.status == "updated")
	                val = Constants.getMessage("labelRequirementUpdated");
				else if(rowData.status == "removed")
	                val = Constants.getMessage("labelRequirementRemoved");
                break;          

        }
        return val;
    },

    
    getCellDisplayExtendedInfo: function(rowData, atColumnIndex)
    {  
        var val = null;
        if(atColumnIndex == 0){
			val = {};
			if(!rowData) {
				val.image = "";
			} else if(rowData.status == "updated"){
				val.image = ImageCache.REQ_UPDATED;
			}else if(rowData.status == "removed"){
				val.image = ImageCache.REQ_REMOVED;
			}else if(rowData.status == "new"){
				val.image = ImageCache.REQ_NORMAL;
			}else {
				val.image = ImageCache.REQ_NORMAL;
			}
		}
        if(atColumnIndex == 1) {
            val = {};
			val.href = Utility.getViewWorkItemURI(rowData.id);  
			val.linkType = Constants.getMessage("RequirementId");
        }
		if(atColumnIndex == 3){
			val = {};
			if (rowData.externalUrl!=null && rowData.externalUrl.match(/^https?:\//i)) {
				val.href = rowData.externalUrl;
			}
			else if (rowData.externalId!=null) {
				var eid=rowData.externalId;
				if(rowData.externalId.match(/^reqpro\//i)){
					// for requirement from reqpro, externaid is like: "reqpro/<reqproserver>:<port>/<project>/<reqKey>", see wi9912
					eid = eid.substring("reqpro/".length, eid.length);
					var idx = eid.indexOf("/");
					var serverAndPort = eid.substring(0, idx);
					eid = eid.substring(idx+1,eid.length);
					idx=eid.indexOf("/");
					var project = eid.substring(0, idx);
					var reqKey = eid.substring(idx+1, eid.length);
					//form reqweb url like: "http://<server>:<port>/ReqWeb/ReqTabbedProp_Page.jsp?txtProject=<project>&ReqKey=<reqKey>&shortCut=true&showMainFrame=true&txtUID=<TypeYourUserID>&txtPWD=<TypeYourPassword>"
					val.href = "http://" + serverAndPort + "/ReqWeb/ReqTabbedProp_Page.jsp?txtProject=" + project + "&ReqKey=" + reqKey +"&shortCut=true&showMainFrame=true&txtUID=<TypeYourUserID>&txtPWD=<TypeYourPassword>";
				}					
				else if(rowData.externalId.match(/^doors\//i)){
					// for requirement from doors, externaid is like: "doors/<server>:<port>/<otherPart>", see wi9912
					eid = eid.substring("doors/".length, eid.length);
					var idx = eid.indexOf("/");
					var serverAndPort = eid.substring(0, idx);
					var otherPart = eid.substring(idx+1, eid.length);
					//form doors url like: "doors://<server>:<port>/?<otherPart>"
					val.href = "doors://" + serverAndPort + "/?" + otherPart.replace(/%26/gi, "&");
				}					
				else
					val.href = eid;
			}
		}		  
        return val;
    },
	
	restoreTags: function(value){
    	var rawText = value;
        rawText = rawText.replace(/\&gt;/gi, ">");
        rawText = rawText.replace(/\&lt;/gi, "<");
        rawText = rawText.replace(/\&amp;/gi, "&");
        rawText = rawText.replace(/\&tilde;/gi, "~");
        rawText = rawText.replace(/\&quot;/gi, "\"");
        rawText = rawText.replace(/\&circ;/gi, "^");
        rawText = rawText.replace(/\&nbsp;/gi, " ");
        rawText = rawText.replace(/<br\/>/gi, "\n");
        rawText = rawText.replace(/\&#09;/g, "\t");
        return rawText;
    },
	
	// encode special characters for html display for requirement names, see wi11946
	encodeSpecialChars: function(str){
		var rawText = str;
		rawText = rawText.replace(/&/gi, "&amp;");
        rawText = rawText.replace(/>/gi, "&gt;");
        rawText = rawText.replace(/</gi, "&lt;");        
        rawText = rawText.replace(/"/gi, "&quot;");
        return rawText;
	} 
});

dojo.declare("com.ibm.rqm.requirement.web.ui.internal.view.table.ExternalRequirementTableViewTableProvider", 
             com.ibm.rqm.requirement.web.ui.internal.view.table.RequirementTableViewTableProvider,
{
    getNumColumns: function(content)
    {
        return 3;
    },
    
    getColumnHeading: function(content, index)
    {
        var headings = [
			Constants.getMessage("labelStatusRequirementTable"),
            Constants.getMessage("labelName"),
            Constants.getMessage("labelDescriptionRequirementTable")
        ];
        return headings[index];
    },
	
	getIsColumnGroupable: function(content, atColumnIndex)
    {
	 	  return (content && content.length > 0 )?(atColumnIndex == 0):false;
    },

    getColumnWidth: function(content, atColumnIndex)
    {
        switch(atColumnIndex) {
            case 0: 
                return 5;
            case 1: 
                return 35;
			case 2: 
			 	return 65;
        }
        return 0;
    },
    
    getCellDisplayType: function(rowData, atColumnIndex)
    {
        var type = TableConstants.RENDER_TYPE_TEXT;
        switch(atColumnIndex) {
        	case 0:
				type = TableConstants.RENDER_TYPE_IMAGE;
				break;
        }
        return type;
    },

    getCellAlignment: function(rowData, atColumnIndex)
    {
        if(atColumnIndex == 0)
            return TableConstants.ALIGN_CENTER;
        return TableConstants.ALIGN_LEFT;
    },
    
    getCellDisplayData: function(rowData, atColumnIndex)
    {
        var val = "data";
        switch(atColumnIndex) {
            case 1: 
                val = rowData ? rowData.name : "";
                break;
            case 2: 
                val = this.restoreTags(rowData ? rowData.description : "");
                break;
			case 0: 
                if(!rowData||!rowData.status || rowData.status=="new")
					val = Constants.getMessage("labelRequirementNormal");
				else if(rowData.status == "updated")
	                val = Constants.getMessage("labelRequirementUpdated");
				else if(rowData.status == "removed")
	                val = Constants.getMessage("labelRequirementRemoved");
	                
        }
        return val;
    },
	
	getCellDisplayExtendedInfo: function(rowData, atColumnIndex)
    {  
        var val = null;
        if(atColumnIndex == 0){
			val = {};
			if(!rowData) {
				val.image = "";
			} else if(rowData.status == "updated"){
				val.image = ImageCache.REQ_UPDATED;
			}else if(rowData.status == "removed"){
				val.image = ImageCache.REQ_REMOVED;
			}else if(rowData.status == "new"){
				val.image = ImageCache.REQ_NORMAL;
			}else {
				val.image = ImageCache.REQ_NORMAL;
			}
		}
        return val;
    }  
});

dojo.declare("com.ibm.rqm.requirement.web.ui.internal.view.table.ExternalRequirementWithPriorityProvider", 
             com.ibm.rqm.requirement.web.ui.internal.view.table.RequirementTableViewTableProvider,
{
    getNumColumns: function(content)
    {
        return 6;
    },
    
    getColumnHeading: function(content, index)
    {
        var headings = [
			Constants.getMessage("labelStatusRequirementTable"),
			Constants.getMessage("labelTagRequirementTable"),
            Constants.getMessage("labelName"),
            Constants.getMessage("labelDescriptionRequirementTable"),
			Constants.getMessage("labelPriorityRequirementTable"),
			Constants.getMessage("labelReviewStatusRequirementTable")
        ];
        return headings[index];
    },

	getIsColumnGroupable: function(content, atColumnIndex)
    {
	 	  return (atColumnIndex == 4 || atColumnIndex == 5 || atColumnIndex == 0);
    },
	
    getColumnWidth: function(content, atColumnIndex)
    {
        switch(atColumnIndex) {
            case 0: 
                return 5;
			case 1:
				return 10;
            case 2: 
                return 30;
			case 3: 
			 	return 50;
			case 4: 
                return 5;
			case 5: 
                return 5;
        }
        return 0;
    },
    
    getCellDisplayType: function(rowData, atColumnIndex)
    {
        var type = TableConstants.RENDER_TYPE_TEXT;
        switch(atColumnIndex) {
        	case 0:
				type = TableConstants.RENDER_TYPE_IMAGE;
				break;
        }
        return type;
    },

    getCellAlignment: function(rowData, atColumnIndex)
    {
        if(atColumnIndex == 0)
            return TableConstants.ALIGN_CENTER;
        return TableConstants.ALIGN_LEFT;
    },
    
    getCellDisplayData: function(rowData, atColumnIndex)
    {
        var val = "data";
        switch(atColumnIndex) {
			case 1:
				val = rowData ? rowData.tag : "";
				break;
            case 2: 
                val = rowData ? rowData.name : "";
                break;
            case 3: 
                val = this.restoreTags(rowData ? rowData.description : "");
                break;
			case 4: 
                val = rowData ? rowData.priority : "";
                break;
			case 5: 
                val = rowData ? rowData.reviewStatus : "";
                break;
			case 0: 
				if(!rowData || !rowData.status || rowData.status=="new")
					val = Constants.getMessage("labelRequirementNormal");
				else if(rowData.status == "updated")
	                val = Constants.getMessage("labelRequirementUpdated");
				else if(rowData.status == "removed")
	                val = Constants.getMessage("labelRequirementRemoved");
                break;
        }
        return val;
    },
	
	getCellDisplayExtendedInfo: function(rowData, atColumnIndex)
    {  
        var val = null;
        if(atColumnIndex == 0){
			val = {};
			if(!rowData) {
				val.image = "";
			} else if(rowData.status == "updated"){
				val.image = ImageCache.REQ_UPDATED;
			}else if(rowData.status == "removed"){
				val.image = ImageCache.REQ_REMOVED;
			}else if(rowData.status == "new"){
				val.image = ImageCache.REQ_NORMAL;
			}else {
				val.image = ImageCache.REQ_NORMAL;
			}
		}
        return val;
    }  
});

dojo.declare("com.ibm.rqm.requirement.web.ui.internal.view.table.RequirementTableView", 
    [dijit._Widget, dijit._Templated],
{    
    templateString: '<div class="com-ibm-rqm-test-artifact-table-view" tabindex="-1">' +
                    '  <div dojoType="com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout" "noline"=true dojoAttachPoint="viewHeaderNode">' +
                    '    <div dojoAttachPoint="_tableViewerNode" class="com-ibm-rqm-test-artifact-table-view" tabindex="-1"></div>' +
                    '  </div>' +
                    '</div>',
	widgetsInTemplate: true, 

    editable: true,
    printable: false,
	isExternal: false,

    constructor: function() {
        this.actions = [];
        this.requirements = [];
        this.showInitLoadProgress = false;
    },

    postCreate: function() 
    {
        this.inherited("postCreate", arguments);                       

        //create the table viewer
        var tableViewer = new com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer({
            //turn off all controls if in print mode 
			showPagingControl: !this.printable,
			showPagingRangeControl: !this.printable,
            showGroupFilterControls: !this.printable,
            showPagingActionsControls: !this.printable,
            allowAdjustSettings: true,
            autoSaveSettings: true          
        });
		
		// the view is in a query page if there is a query name otherwise it is within
        // some container that don't need the header
        this.isQueryPage = this.queryName;
		if (this.isQueryPage) {
            // it is a query page so set header title and add table viewer as the header content
            this.viewHeaderNode.setTitle(this.queryName);
	        this.viewHeaderNode.setCSHelpId("rqm_all_req.html");
			this.viewHeaderNode.setCSHelpButtonLabel(Constants.getMessage("labelRequirementTableViewHelp"));
			this._tableViewerNode.appendChild(tableViewer.domNode);
        } else {
            // it is not a query page i.e. within a section without header
            this.viewHeaderNode.domNode.style.display = "none";
			this.domNode.appendChild(tableViewer.domNode);
        }
		                        
        var content = this.requirements ? this.requirements : [];
        
        tableViewer.tableId = (this.isQueryPage) ? "RQM-REQ-QUERY-TABLEVIWER" : "RQM-REQ-TABLEVIWER";
        tableViewer.setContent(content);
		if(this.isExternal) {
			tableViewer.setContentProvider(new com.ibm.rqm.requirement.web.ui.internal.view.table.ExternalRequirementTableViewTableProvider());
		} else if(this.isExternalByPriority){
			tableViewer.setContentProvider(new com.ibm.rqm.requirement.web.ui.internal.view.table.ExternalRequirementWithPriorityProvider());
		} else {
        	tableViewer.setContentProvider(new com.ibm.rqm.requirement.web.ui.internal.view.table.RequirementTableViewTableProvider());
        }
		tableViewer.registerCellRenderer(RENDER_TYPE_REQLINK, 
            new com.ibm.rqm.requirement.web.ui.internal.view.table.RequirementTableLinkCellRenderer);
		tableViewer.setTableListener(new com.ibm.rqm.requirement.web.ui.internal.view.table.RequirementTableViewTableListener(this));
        tableViewer.setCellModifier(new com.ibm.rqm.requirement.web.ui.internal.view.table.RequirementTableViewCellModifier(this));
        tableViewer.setTableRowsCheckable(this.editable && !this.printable, /* isSingleSelect */ false);
        tableViewer.setTableSummary(Constants.getMessage("labelTableSummary", Constants.getMessage("labelRequirements")));
		
        //add external actions to the table viewer
        for (var i = 0; i < (this.actions ? this.actions.length : 0); i++) {
            var action = this.actions[i];
		    var actionButton = tableViewer.addAction(action.label, action.label, this, action.iconClass, action.actionHandler);
        	if (action.label == Constants.getMessage("labelAssociatedTestPlans")) {
				this.assoicatedTestPlanNode = actionButton;
				this.assoicatedTestPlanNode.setDisabled(true);
			}
			if (action.label == Constants.getMessage("labelAssociatedTestCases")) {
				this.assoicatedTestCaseNode = actionButton;
				this.assoicatedTestCaseNode.setDisabled(true);
			}
			if (action.label == Constants.getMessage("labelDisassociateRequirements")) {
				this.disaccosicateButton = actionButton;
				this.disaccosicateButton.setDisabled(true);
			}
		}
		
		//add trace action

        var type = com.ibm.asq.common.web.client.internal.PermissionsClient.OP_REQ_WORKITEM;
        var perm = com.ibm.asq.common.web.client.internal.PermissionsClient.getStoredPermission(type);
        
		if (this.isQueryPage && (!perm || perm.edit)) {
			this.clearStatusActionNode = tableViewer.addAction("changeStatus", // action id
 				Constants.getMessage("labelResetRequirementStatus"), // label
 				null, // callback data
 				"reset-reqstatus-icon-image", // icon class
 			dojo.hitch(this, "_onChangeStatusActionClick")); // callback
			this.clearStatusActionNode.setDisabled(true);
		}        
        this.tableViewer = tableViewer;
        if(this.showInitLoadProgress) {
            this.tableViewer.showLoadingProgress();
        }
        this.tableViewer.show();
        this.tableViewer.setEditable(this.editable);        
    },
	
	_onChangeStatusActionClick: function() {
		if (this.getSelectedRows() && this.getSelectedRows().length == 1) {
			this.refreshData(this.getSelectedRows()[0]);
		}
	},
    
    setEditable: function(isEditable) {
        this.editable = isEditable;   
        this.tableViewer.setEditable(this.editable);     
    },
    
    refresh: function(requirements) {
      this.requirements = requirements;
	  this.tableViewer.setContent(requirements);
        if(this.showInitLoadProgress) {
            this.tableViewer.endLoadingProgress();
            this.showInitLoadProgress = false;
        }      
	  this.tableViewer.refresh();
      this.tableViewer.setEditable(this.editable);
    },
	
	//change status with latest data
    refreshData: function(requirement){
		if (requirement.status == "updated") {
			this._needUpdatedReq = requirement;
            var args = {
                'message': Constants.getMessage("msgConfirmUpdateRequirement"),
                'yesCallback': function(section){
						section._refreshDataAction();
                	},
                'yesCallbackData': this,
                'noCallback': null,
                'noCallbackData': null
            };
            var confirmDialog = new com.ibm.asq.common.web.ui.internal.widgets.YesNoDialog(args);
            confirmDialog.setSecondaryTitle(Constants.getMessage("labelConfirmation"));
            confirmDialog.open();
        }
    },
    
	_refreshDataAction: function() {
		var responseHandler = new ServiceResponseHandler(this, "_refreshNewestData", "_error");
        RequirementWorkItemClient.getLastestWorkItemDTOs(responseHandler, {
                    	workItemId: this._needUpdatedReq.id
                	});
	},
	
    _refreshNewestData: function(requirements){
        var newRequirements = new Array();
		if (this.requirements && this.requirements.length) {
            for (var i = 0; i < this.requirements.length; i++) {
				if (this.requirements[i].id == requirements[0].id) 
                    newRequirements.push(requirements[0]);
                else 
                    newRequirements.push(this.requirements[i]);
            }
            this.requirements = newRequirements;
            this.refresh(newRequirements);
        }
    },
	
	_error: function(e) {
		if (this.isQueryPage) {
			this.viewHeaderNode.setStatus("Error: " + e.message, ViewHeaderLayout.ERROR);
		}
        console.error(this.declaredClass + ": Error: " + e.message);
    },
    
	// API
	getSelectedRows: function() {
	    var selectrows = this.tableViewer.getCheckedRows();
		return selectrows;
	},
	
	getViewer: function() {
		return this.tableViewer;
	}
});

dojo.declare("com.ibm.rqm.requirement.web.ui.internal.view.table.ExtRequirementTableView", com.ibm.rqm.requirement.web.ui.internal.view.table.RequirementTableView, {
	postCreate: function() {
		this.inherited("postCreate", arguments);
		this.tableViewer.setTableRowsCheckable(!this.printable, /* isSingleSelect */ true);
		this.tableViewer.setTableSummary(Constants.getMessage("labelTableSummary", Constants.getMessage("labelRequirements")));
		this.tableViewer.show();
	},
	
	setInProgress: function(msg) {
		this.viewHeaderNode.setProgressStart(msg);
	},
	
	stopInProgress: function() {
		this.viewHeaderNode.setProgressEnd();
	}
});

})();
