/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.planning.web.ui.internal.view.table.TestPlanTableView");
 
dojo.require("dojox.data.dom");
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.require("com.ibm.rqm.planning.web.client.internal.UserClient");
dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");

dojo.require("com.ibm.asq.common.web.client.internal.PermissionsClient");
dojo.require("com.ibm.asq.common.web.ui.internal.view.common.ImageCache");
dojo.require("com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");
dojo.require("com.ibm.asq.common.web.ui.internal.util.GlobalEvents");

dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.rqm.planning.web.client.internal.PreferenceClient");
dojo.require("com.ibm.rqm.planning.web.ui.internal.util.Utility");
dojo.require("com.ibm.rqm.planning.web.ui.internal.util.EditorUtil");
dojo.require("com.ibm.rqm.planning.web.client.internal.planning.PlanningPageClient");
dojo.require("com.ibm.rqm.planning.web.client.internal.CategoryClient");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.administration.CategoriesEditor");
dojo.require("com.ibm.rqm.planning.web.ui.internal.util.CategoryUtil");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.table.AbstractFilteredTableView");

dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentProvider");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableCellModifier");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.ListRowRenderer");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentFilterProvider");

(function() {

var ServiceResponseHandler = com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
var TableConstants = com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants;
var ImageCache     = com.ibm.asq.common.web.ui.internal.view.common.ImageCache;
var Utility        = com.ibm.rqm.planning.web.ui.internal.util.Utility;
var Constants      = com.ibm.rqm.planning.web.client.internal.Constants;
var PlanningClient = com.ibm.rqm.planning.web.client.internal.planning.PlanningPageClient;
var CategoryClient = com.ibm.rqm.planning.web.client.internal.CategoryClient;
var CategoryUtil   = com.ibm.rqm.planning.web.ui.internal.util.CategoryUtil;
var PermissionsClient = com.ibm.asq.common.web.client.internal.PermissionsClient;
var GlobalEvents   = com.ibm.asq.common.web.ui.internal.util.GlobalEvents;
var EditorUtil = com.ibm.rqm.planning.web.ui.internal.util.EditorUtil;
var ViewHeaderLayout = com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout;
var TableContentFilterProvider = com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentFilterProvider;
var UserClient = com.ibm.rqm.planning.web.client.internal.UserClient;	
var AbstractFilteredTableView = com.ibm.rqm.planning.web.ui.internal.view.table.AbstractFilteredTableView;
var PreferenceClient = com.ibm.rqm.planning.web.client.internal.PreferenceClient;

dojo.declare("TestPlanTableView.TableListener", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableListener,
{
    constructor: function(parentView) {
        this.parentView = parentView;
    },
    
    // Summary:
    //   If the table's rows are checkable, when a row is checked, or unchecked, this method is
    //   called.
    //
    rowCheckStateChanged: function(tableViewer, rowObject, state)
    {
        var selectionCount = tableViewer.getCheckedRows().length;
        if (this.parentView.deleteActionNode)
            this.parentView.deleteActionNode.setDisabled(selectionCount == 0);
			
		if (this.parentView.bulkchangeActionNode)
		    this.parentView.bulkchangeActionNode.setDisabled(selectionCount == 0);
    },
    
    // Summary:
    //    A group check box is shown when the tables rows are checkable and the in multi-select mode.
    //    This method is called when the group's check box is checked/unchecked. The affected rows and 
    //    their states are passed.
    //
    groupRowsCheckStateChanged: function(tableViewer, rowObjects, state) 
    {
        this.rowCheckStateChanged(tableViewer, rowObjects, state);
    },
    
    // Summary:
    //    If the client have registered table actions, this message will be fired when an action (button)
    //    is invoked by the user.
    //
    tableContentActionInvoked: function(tableViewer, actionId, callbackData, callback)
    {                
        if (callback != null && dojo.isFunction(callback)) {
            if (callbackData != null) {
                callback(callbackData);
            } else {
                callback();
            }
        }
    },

    tableHeaderColumnActionInvoked: function(tableViewer, columnIndex, /*optional*/actionId)
    {
        alert("Table Column action invoked, actionId: " + actionId + ", At column: " + columnIndex);           
    },
    
    tableContentFilterActionInvoked: function(tableViewer, actionId, filters, callback, callbackData)
    {
        if(callback) {
            callback(actionId, filters);
        }                     
    },
	
	tableHeaderColumnActionInvoked: function(tableViewer, columnIndex, /*optional*/actionId)
    {
		if (this.parentView.parent && this.parentView.parent._TestPlanHeaderColumnActionInvoked) {
			this.parentView.parent._TestPlanHeaderColumnActionInvoked(tableViewer, columnIndex, actionId);
		}         
    }    
});

dojo.declare("TestPlanTableView.CellModifier", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableCellModifier,
{
    // Summary:
    //    Method to be called when a cell renderer changes the cell value. This notifies
    //    the cell's value change event. 
    //    
    //    
    cellValueChanged: function(oldValue, newValue, rowObject, columnIndex)
    {
        // store the new values in our internal data model
        if(columnIndex == 6) {
            if(dojo.isString(newValue)) {
                rowObject.selection = newValue;
            }
        }
    }
});

dojo.declare("TestPlanTableView.ListRowRenderer",
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.ListRowRenderer,
{    
    // Summary:
    //   Override the base list row renderer's create list content method
    //   to supply more custom contents.
    //
    _createListContents: function(viewer, rowObject, listWidget)
    {
        this.inherited("_createListContents", arguments);   
        
        var moreContents = document.createElement("div");
        var toggle = document.createElement("button");
        toggle.innerHTML = Constants.getMessage("labelAddCustCrtl");
        moreContents.appendChild(toggle);
        listWidget.contentNode.appendChild(moreContents);
    }
});

dojo.declare("TestPlanTableView.TableProvider", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentProvider,
{
    constructor: function(args) {
        dojo.mixin(this, args);
		this.categoryTypeMap = {};
        if (!this.categoryTypes || !dojo.isArray(this.categoryTypes)) {
            throw new Error("Parameter 'categoryTypes' is REQUIRED!");
        }
		
        this.COLUMNS = {
            TYPE: this.toColumn("", 2, false, TableConstants.ALIGN_CENTER, TableConstants.RENDER_TYPE_IMAGE, 'type'),
            ID: this.toColumn(Constants.getMessage("labelId"), 3, false, TableConstants.ALIGN_CENTER, TableConstants.RENDER_TYPE_LINK, 'id'),
            NAME: this.toColumn(Constants.getMessage("labelName"), 30, true, TableConstants.ALIGN_LEFT, TableConstants.RENDER_TYPE_LINK, 'name'),
            STATE: this.toColumn(Constants.getMessage("labelState"), 5, false, TableConstants.ALIGN_LEFT, TableConstants.RENDER_TYPE_TEXT, 'state'),
            MODIFIED: this.toColumn(Constants.getMessage("labelModified"), 20, true, TableConstants.ALIGN_LEFT, TableConstants.RENDER_TYPE_DATE, 'modified')
        }      
        this.COLUMNS.ALL = [this.COLUMNS.TYPE, this.COLUMNS.ID, this.COLUMNS.NAME, this.COLUMNS.STATE];
        
        var numCategories = this.categoryTypes.length;
        for (var i = 0; i < numCategories; i++) {
            var t = this.categoryTypes[i];
			if (!t.archived) {
				this.categoryTypeMap[t.itemId] = t;
				var width = (40 / numCategories);
                var name = Constants.getMessage(t.name); // out of the box category name has translated value.
				this.COLUMNS[t.itemId] = this.toColumn(name, width, true, TableConstants.ALIGN_LEFT, TableConstants.RENDER_TYPE_TEXT);
				this.COLUMNS[t.itemId].typeItemId = t.itemId;
				this.COLUMNS.ALL.push(this.COLUMNS[t.itemId]);
			}
        }
        
        this.COLUMNS.ALL = this.COLUMNS.ALL.concat([this.COLUMNS.MODIFIED]);      
    },
    
    toColumn: function(name, width, groupable, alignment, type, rowName) {
        return {
            name: name,
            width: width,
            groupable: groupable,
            alignment: alignment,
            type: type,
			rowName: rowName
        }
    },  

    getColumnIndex: function(name) {
        for (var i = 0; i < this.COLUMNS.ALL.length; i++) {
            if (this.COLUMNS.ALL[i].name == name) {
                return i;
            }
        }
        return -1;
    },	
	
    setCategoryTypes: function(newTypes) {
        this.categoryTypes = newTypes;
    },	
	
    // Summary:
    //
    getNumColumns: function(content)
    {
        return this.COLUMNS.ALL.length;
    },
    
    // Summary:
    //
    getColumnHeading: function(content, index)
    {
         return this.COLUMNS.ALL[index].name;
    },

    getColumnHeadingImage: function(content, atColumnIndex)
    {
		if (this.enableRowEditable) {
			if (atColumnIndex >= 4 && atColumnIndex <= this.getNumColumns() - 2) {
				return {
					actionId: this.COLUMNS.ALL[atColumnIndex].name,
					tooltip: Constants.getMessage("labelChangeProperties", this.COLUMNS.ALL[atColumnIndex].name),
					src: ImageCache.BULK_CHANGE
				};
			}
		}
		return null;
    },
 
    getColumnHeadingAlignment: function(atColumnIndex)
    {
        return this.COLUMNS.ALL[atColumnIndex].alignment;
    },   
    
    getIsColumnGroupable: function(content, atColumnIndex)
    {
        return this.COLUMNS.ALL[atColumnIndex].groupable;     
    },

    getIsColumnSortable: function(content, atColumnIndex)
    {
        return this.COLUMNS.ALL[atColumnIndex].name != this.COLUMNS.TYPE.name;     
    },
    
    getColumnWidth: function(content, atColumnIndex)
    {
        return this.COLUMNS.ALL[atColumnIndex].width;
    },
    
    // Summary:
    //    The only assumptions the table have on the data that it displays
    //    is that it's an array contents. These are the data content/object that
    //    will be displayed in the table rows.
    //
    getContentObjects: function(content)
    {
        // our content is already an array of objects
        return content;
    },
    
    getRowDataId: function(rowData)
    {
        return "_table_row_for_testPlan_" + rowData.id;
    },
    
    // Summary:
    //    Returns the type of the cell to be displayed. By default, the TableViewer
    //    will support a set of cell types. The type of the cell will map to a specific
    //    cell renderer (to be discussed).
    getCellDisplayType: function(rowData, atColumnIndex)
    {
        return this.COLUMNS.ALL[atColumnIndex].type;
    },

    getCellAlignment: function(rowData, atColumnIndex)
    {
        return this.COLUMNS.ALL[atColumnIndex].alignment;
    },
    
    // Summary:
    //    Returns the display data of the cell. For cell renderer type of TEXT, this will
    //    be the string. Others cell render type would be Date, or integer value, etc. If the 
    //    cell renderer type is image, the client can also supply cell data that can be sortable/groupable. 
    //    The TableViewer's default sorter, filter operates on this returned data. For "complex" 
    //    cell types such as image where it could have multiple values for different states, the 
    //    client also needs to implement the next method.
    //    
    //    Client must implement this method to provide the cell data.
    //    
    getCellDisplayData: function(rowData, atColumnIndex)
    {
        var val = "data";
		var column = this.COLUMNS.ALL[atColumnIndex];
        switch(column.name) {
            case this.COLUMNS.TYPE.name: 
                val = "";
                break;
            case this.COLUMNS.ID.name: 
                val = rowData.id;
                break;
            case this.COLUMNS.NAME.name: 
                val = rowData.name;
                break;
            case this.COLUMNS.STATE.name: 
                //val = rowData.state; 
				val = EditorUtil.getStateNameFromID(rowData.state);            
                break;
            case this.COLUMNS.MODIFIED.name: 
                val = new Date();
                val.setTime(rowData.modified);
                break; 				
            default:
                val = this.getCategoryByType(rowData, column.typeItemId) || "";
                break;			 
        }
        return val;
    },

	getCellRawData: function(rowData, atColumnIndex)
    {
        var val = "";
        var rowName = this.COLUMNS.ALL[atColumnIndex].rowName;
        
        if(rowName) {
            return (rowData[rowName] || val);
        }
        
        var column = this.COLUMNS.ALL[atColumnIndex];
		val = this.getCategoryByType(rowData, column.typeItemId) || "";
        return val;
    },
    
    // Summary:
    //    If applicable, returns the extended display information of the cell. The return extended
    //    info must be an object with the following attributes:
    //    
    //    {
    //      /* attribute common for all cell renderer types */
    //      "tooltip": <string>,
    //
    //      /* attributes for IMAGE and ACTION cell renderer types */
    //      "isHidden": <true, false> the image is hidden if the row is not on the mouse over
    //      "image": base image URL,  
    //      "mouseOverImage": image URL, (optional)
    //      "mouseOutImage": image URL,  (optional) (overrides "image")
    //
    //      /* attributes for SELECT cell renderer type */
    //      "select" : 'value', the selection in the combo
    //      "choices" : [{'text':'display text', 'value':'value'}, ] array of objects with 'text' and 'value' attributes
    //
    //      /* attributes for CHECKBOX cell renderer type */
    //      "state" : <true, false> initial state of the check box
    //
    //      /* attributes for LINK cell renderer type */
    //      "href" : <string> the href string for the link
    //    }
    //
    //    Client can implement this method to provide extended display infor for the cell.
    //    Certain cell renderer type will require the client to implement this method to
    //    provide needed display information, such as an image ACTION.
    //
    getCellDisplayExtendedInfo: function(rowData, atColumnIndex)
    {  
        var val = {};	   
        var colName = this.COLUMNS.ALL[atColumnIndex].name;
        switch (colName) {
            case this.COLUMNS.TYPE.name: 
                val.image = ImageCache.TEST_PLAN;
				val.href = Utility.getTestPlanURI({id: rowData.id});
				val.tooltip = Constants.getMessage("labelClickToOpenTestPlan");	
                break;		
            case this.COLUMNS.ID.name:
				val['linkType'] = Constants.getMessage("TestPlanID");	
            case this.COLUMNS.NAME.name: 
                val['href'] = Utility.getTestPlanURI({id: rowData.id});
				break;
			default:
                break; 			 
		}
        return val;
    },
	
    getCategoryByType: function(plan, typeItemId) {
        if (plan && plan.categories) {
            for (var i = 0; i < plan.categories.length; i++) {
                if (plan.categories[i].categoryType.itemId == typeItemId) {
                    //return plan.categories[i].name;
					return this.getCategoryName(plan.categories[i]);
                }
            }
        }
		return Constants.getMessage("labelUnassigned");
    },
	
	getCategoryName: function(category) {
		var type = this.categoryTypeMap[category.categoryType.itemId];
		for (var i = 0; i < (type.categories ? type.categories.length : 0); i++) {
			if (type.categories[i].itemId == category.itemId) {
				return type.categories[i].name;
			}
		}
		return Constants.getMessage("labelUnassigned");
	}
});

dojo.declare("TestPlanTableView.TableFilterProvider", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentFilterProvider,
{
    constructor: function(tableView, openSection) {
        this.tableView = tableView;
        this.initOpenFilter = openSection;
		
        // define the static filters
        this.filters = [
            {
                name: "myItemsOnly",  // must match key in the arg list of the API
                title: Constants.getMessage("labelOnlyMyTestPlans"),
                promptTitle: Constants.getMessage("labelOnlyMyTestPlans"),
                type: TableContentFilterProvider.FIELD_CHECKBOX,
                defaultValue: true, params: null
            }, {
                name: "name",  // must match key in the arg list of the API
                title: Constants.getMessage("labelname"),
                promptTitle: Constants.getMessage("labelName"),
                type: TableContentFilterProvider.FIELD_TEXT,
                defaultValue: null, params: null
            }
        ];
    },

    getTitle: function() {
        return Constants.getMessage("labelFilterTitle");    
    },
    
    getSummaryText: function() {
        return Constants.getMessage("labelFilterDescription");
    },
    
    getIsSectionOpenInitially: function() {
       return this.initOpenFilter; 
    },
    
    getInitialVisibleFilterCount: function() {
        return 4;    
    },
    
    getFilterCount: function() {
        return this.filters.length;
    },
    
    getFilterName: function(index) {
        return this.filters[index].name;
    },
    
    getFilterTitle: function(index) {
        return this.filters[index].title;
    },
    
    getFilterPromptTitle: function(index) {
        return this.filters[index].promptTitle;        
    },
    
    getFilterType: function(index) {
        return this.filters[index].type;
    },
    
    getFilterDefaultValue: function(index) {
        return this.filters[index].defaultValue;
    },
    
    getFilterParams: function(index) {        
        return this.filters[index].params;
    },
    
    getCustomField: function(index) {
        // custom field widget are dynamically created and stored as the params of the filter
		return this.filters[index].params;
    },
    
    getActionsInfo: function() {
        var actions = [
            {
                id: "cancel",
                title: Constants.getMessage("labelReset"),
                callback: dojo.hitch(this, "filterResetActionInvoked"),
                callbackData: null,
                isDefault: false
            }, {
                id: "run",
                title: Constants.getMessage("labelRun"),
                callback: dojo.hitch(this, "filterRunActionInvoked"),
                callbackData: null,
                isDefault: true
            }
        ];
        return actions;
    },
    
    filterResetActionInvoked: function(actionName, filters) {
        // reset the filters by recreating it.
        this.tableView.tableViewer.setContentFilterAttributeProvider(this.tableView.filterProvider);
    },

    filterRunActionInvoked: function(actionName, filters){
        if (this.tableView) {
            // must have the view context to perform the query and update the table display
            var allCategories = [];
            var args = {};
            
            for (var nameKey in filters) {
                // iterate through the filters and skip those that are not specified
                if (filters[nameKey] != null) {
                    if (nameKey.indexOf("categories") == 0) {
                        // filter name has "categories" prefix, flatten all selected categories into a single array
                        allCategories.push(filters[nameKey].join(","));
                    } else {
                        args[nameKey] = filters[nameKey] || "";
                        if(args[nameKey] == 'Any@@')
                            args[nameKey] = '';
                    }
                }
            }
            // add the flattened categories array to the args if there is any defined
            if (allCategories.length > 0) {
                args["categories"] = allCategories;
            }
            this.tableView.runQuery(args);
        }
    }
});


dojo.declare("com.ibm.rqm.planning.web.ui.internal.view.table.TestPlanTableView", 
    [dijit._Widget, dijit._Templated, AbstractFilteredTableView],
{    
    templateString: '<div class="com-ibm-rqm-test-artifact-table-view" tabindex="-1">' +
                    '  <div dojoType="com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout" "noline"=true dojoAttachPoint="viewHeaderNode">' +
                    '    <div dojoAttachPoint="_tableViewerNode" class="com-ibm-rqm-test-artifact-table-view" tabindex="-1"></div>' +
                    '  </div>' +
                    '</div>',

    widgetsInTemplate: true,

    constructor: function() {
		this.categoryTypes = null;
	 	this.plans = null;
        this.showInitLoadProgress = false;
		this.initOpenFilter = true;
        this.filterArgs = {
            myItemsOnly: true,
            includeArchived: false
        };  // default filter is only "My" test plans only without archived
	 },

    postCreate: function() 
    {
        this.inherited("postCreate", arguments);
        this.viewHeaderNode.setCSHelpId("rqm_view_test_plans.html"); 

        // apply the user preference whether to initially open the 
		// filter area
        if (this.showFilters) {
			var context = {
				self: this,
				prefCallback: function(userPref) {
					this.self.initOpenFilter = (userPref && typeof userPref['value'] != "undefined") ? userPref.value : true;
					this.self._initCategory();
				}
			}
            PreferenceClient.getCurrentUserPreferences(context, context.prefCallback, Constants.USER_UI_CUSTOMISE_QUERYLISTS_FILTER_INITOPEN_CATEGORY.key);			
		}
		else {
			this._initCategory();
		}
		this.setSearchFunction(dojo.hitch(PlanningClient, "searchTestPlans"));
		this.setSearchCallback(dojo.hitch(this, "show"));
		this.setTypeLabel(Constants.getMessage("labelTestPlans"));
	},
	
    _initCategory: function() {
        //get the category types - required to show the table properly and for the filters
        var responseHandler;
        if (this.showFilters) {
            responseHandler = new ServiceResponseHandler(this, "_initializeWithFilters", "_error");
        } else {
            responseHandler = new ServiceResponseHandler(this, "_initialize", "_error");
        }
        // include archived if showing filter
        CategoryClient.getCategoryTypes(responseHandler, Constants.MODEL_TYPE_PLAN, this.showFilters);    
    },
    
    _initializeWithFilters: function(categoryTypes) {
		// create the filter provider for the table
        this.filterProvider = new TestPlanTableView.TableFilterProvider(this, this.initOpenFilter);

        // initialize filters for states
        //

        // save the state filter to add later after the originator
        this.stateFilter = {
            name: "stateIds", // must match key in the arg list of the API
            title: Constants.getMessage("labelStateLabel"),
            promptTitle: Constants.getMessage("labelState"),
            type: TableContentFilterProvider.FIELD_TOGGLELIST,
            defaultValue: [],
            params: {
                options: [{
                    name: Constants.getMessage("com.ibm.rqm.planning.common.new"),
                    value: Constants.STATETRANSITION_STATE_DRAFT,
                    checked: false
                }, {
                    name: Constants.getMessage("com.ibm.rqm.planning.common.underreview"),
                    value: Constants.STATETRANSITION_STATE_UNDERREVIEW,
                    checked: false
                }, {
                    name: Constants.getMessage("com.ibm.rqm.planning.common.approved"),
                    value: Constants.STATETRANSITION_STATE_APPROVED,
                    checked: false
                }, {
                    name: Constants.getMessage("com.ibm.rqm.planning.common.retired"),
                    value: Constants.STATETRANSITION_STATE_RETIRED,
                    checked: false
                }]
            }
        };

        // initialize filters for all the categoryType
        //
		this.allCategoryFilters = CategoryUtil.getCategoryTypesFilters(categoryTypes);
		
        // initlize the orginator filter with the list of contributors
        var self = this;
        var serviceObj = {
            success: function(contributors) {
        		for (var i = 0; i < contributors? contributors.length : 0; i++) {
            		if (contributors[i].name == "Unassigned") {
                		contributors[i].name = Constants.getMessage("labelUnassigned");
            		}
            		contributors[i].value = contributors[i].itemId;
                    contributors[i].checked = false;
        		}
        		var originators = {
                    name: "originatorUUIDs",  // must match key in the arg list of the API
                    title: Constants.getMessage("labeloriginatorLabel"),
                    promptTitle: Constants.getMessage("labelOriginator"),
                    type: TableContentFilterProvider.FIELD_TOGGLELIST,
                    defaultValue: [],
                    params: (contributors == null) ? null : {options: contributors}
            	};
        		self.filterProvider.filters.push(originators);
                // add the state filter
                self.filterProvider.filters.push(self.stateFilter);
                // add the category filters to the end if there is any
                for (var j = 0; j < self.allCategoryFilters.length; j++) {
                    self.filterProvider.filters.push(self.allCategoryFilters[j]);
                }
				self._initialize(categoryTypes);
            },
			
            failure: function(e) {
                self._error(e);
                // add the state and category filters to the end even when
                // it failed to initialize the originator filter
                self.filterProvider.filters.push(self.stateFilter);
                for (var j = 0; j < self.allCategoryFilters.length; j++) {
                    self.filterProvider.filters.push(self.allCategoryFilters[j]);
                }
				self._initialize(categoryTypes);
            }
        };
        var responseHandler = new ServiceResponseHandler(serviceObj, "success", "failure");
        UserClient.getContributors(responseHandler);
    },

    refreshWithFilter: function(userPref) {
		if(typeof userPref == "undefined" || userPref.value)
            this.runQuery(this.filterArgs);
    },
    
	_initialize: function(categoryTypes) {		
        this.categoryTypes = dojo.isArray(categoryTypes) ? categoryTypes : [];

        var tableViewer = new com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer({
            allowAdjustSettings: true,
            autoSaveSettings: true,
            tableId: "RQM-TP-TABLEVIEWER"                                
        });
		if (this.showFilters) {
			tableViewer.setContentFilterAttributeProvider(this.filterProvider);
            
            // we're not showing any content yet, disable the no item message
            tableViewer.noItemMessage = " ";
		}
        dojox.data.dom.removeChildren(this._tableViewerNode);
		this._tableViewerNode.appendChild(tableViewer.domNode);
		          
        var content = this.plans ? this.plans : [];
		this.queryName = this.queryName ? this.queryName : Constants.getMessage("labelTestPlans");
        this.viewHeaderNode.setTitle(this.queryName);
		  
        tableViewer.setContentPageSize(20);
        tableViewer.setContent(content);
        tableViewer.setTableRowsCheckable(true);
		
        this.provider = new TestPlanTableView.TableProvider({
            categoryTypes: this.categoryTypes,  
			enableRowEditable: (this.enableRowEditable? this.enableRowEditable : false)
        });		
        tableViewer.setContentProvider(this.provider);
        tableViewer.setTableListener(new TestPlanTableView.TableListener(this));
        tableViewer.setCellModifier(new TestPlanTableView.CellModifier());
        tableViewer.setTableSummary(Constants.getMessage("labelTableSummary", this.queryName));
		
		//add refresh action if applicable
        if (this.refreshCallback && dojo.isFunction(this.refreshCallback)) {
            tableViewer.addAction("Refresh", Constants.getMessage("labelRefresh"), this, "refresh-icon-image", this.refreshCallback);
        } 
        
        //add any actions provided by the consumer
        for (var i = 0; i < (this.actions ? this.actions.length : 0); i++) {
            var action = this.actions[i];
            if (action.label == Constants.getMessage("labelChangeTestPlanProperties")){
                this.bulkchangeActionNode = tableViewer.addAction(action.label, action.label, null, action.iconClass, action.actionHandler);
                this.bulkchangeActionNode.setDisabled(true);
            }
            else
                tableViewer.addAction(action.label, action.label, null, action.iconClass, action.actionHandler);    
        }   
		
        var permission = PermissionsClient.getStoredPermission(PermissionsClient.OP_TEST_PLAN);
        
        var cat_permission = PermissionsClient.getStoredPermission(PermissionsClient.OP_CATEGORY);
        if (!cat_permission || cat_permission[PermissionsClient.ACTION_EDIT]) {
            //add action for managing categories
            this.configureActionNode = tableViewer.addAction("configure", // action id
                Constants.getMessage("labelManageCategories", Constants.TYPE_PLAN), // label
                null, // callback data
                "categories-icon-image", // icon class
                dojo.hitch(this, "_handleCategoriesClick") // callback
            );
        }
		
		//add delete action
        if (!permission || permission[PermissionsClient.ACTION_ARCHIVE]) {
            this.deleteActionNode = tableViewer.addAction("delete", // action id
                Constants.getMessage("labelDelete"), // label
                null, // callback data
                "delete-icon-image", // icon class
                dojo.hitch(this, "_onDeleteActionClick")); // callback
            this.deleteActionNode.setDisabled(true);   
        }
        if(this.showInitLoadProgress) {
            tableViewer.showLoadingProgress();
        }
        tableViewer.show();
        this.tableViewer = tableViewer;
		
		// apply the user preference whether to run my query immediately.
        if (this.showFilters) {
			PreferenceClient.getCurrentUserPreferences(this, this.refreshWithFilter, Constants.USER_UI_CUSTOMISE_QUERYLISTS_AUTORUN_MYQUERY_CATEGORY.key);
        }
    },
    
	//API
    changeMode: function(event)
    {
        var isList;
        if(event.currentTarget.value == "grid") {
            this.gridToggleNode.checked = true;
            this.listToggleNode.checked = false;
            isList = false;
        }
        else {
            this.gridToggleNode.checked = false;
            this.listToggleNode.checked = true;            
            isList = true;
        }
        var mode = (isList) ? TableConstants.MAJOR_MODE_LIST : TableConstants.MAJOR_MODE_GRID;
        
        this.tableViewer.setTableMajorMode(mode);
        
        // create our own custom row renderer to slip in more contents into
        // default list renderer's collapsible area widget. 
        if(isList) {
            this.tableViewer.setCustomRowRenderer(new TestView.ListRowRenderer());
        }
        this.tableViewer.show();
    },
	
    refresh: function(content, skipClearStatus) {      		
        this.plans = content;
        var cancelProgress = this.showInitLoadProgress;
        
        // we don't create the table until we fetched the categories.
        // The table may not have existed at this point. The real data
        // has arrived. Always reset the init load progress flag. 
        if(this.showInitLoadProgress) {
            this.showInitLoadProgress = false;
        }
        if (this.tableViewer) {
            if(cancelProgress) {
                this.tableViewer.endLoadingProgress();
            }
            this.tableViewer.setContent(content);
            this.tableViewer.refresh();
        }
        if (this.viewHeaderNode && !skipClearStatus) {
            this.viewHeaderNode.clearStatus();
        }			 
     }, 
	 
	 // Summary:
    //    Get categoryTypes first, then displays the table.
    //    The content provider is changed, so invoke _reContructTable to reset the whole table
    //
	show: function(content, skipClearStatus) {
		this.plans = content;
        
        //reset CategoryTypes
		var self = this;
		var handler = {
            success: function(categoryTypes) {
                //reset TableViewer first
                self.categoryTypes = dojo.isArray(categoryTypes) ? categoryTypes : [];
                var cancelProgress = self.showInitLoadProgress;
                // we don't create the table until we fetched the categories.
                // The table may not have existed at this point. The real data
                // has arrived. Always reset the init load progress flag. 
                if (self.showInitLoadProgress) {
                    self.showInitLoadProgress = false;
                }
                if (self.tableViewer) {
                    if (cancelProgress) {
                        self.tableViewer.endLoadingProgress();
                    }
					self._reContructTable(categoryTypes, content);
                }
                if (self.viewHeaderNode && !skipClearStatus) {
                    self.viewHeaderNode.clearStatus();
                }
                
                //reset viewBuilder?
                if (self.showFilters) {
                    var newCategoryFilters = CategoryUtil.getCategoryTypesFilters(self.categoryTypes);
                    if (!CategoryUtil.isCategoryFiltersSame(newCategoryFilters, self.allCategoryFilters)) {
                        //category filters are changed, user have the choice to reset viewbuilder or not
                        self._confirmResetViewBuilder(newCategoryFilters);
                    }
                }
            },
            error: function(e) {
                self._error(e);
            }
        }
        var responseHandler = new ServiceResponseHandler(handler, "success", "error");
		CategoryClient.getCategoryTypes(responseHandler, Constants.MODEL_TYPE_PLAN, this.showFilters);		
	},
		
	//Internal
    _handleCategoriesClick: function() {
        var x = new com.ibm.rqm.planning.web.ui.internal.view.administration.CategoriesEditor({
            artifactType: Constants.MODEL_TYPE_PLAN
        });
    },	
	
	_handleCategoriesChanged: function(categoryTypes) {
		//reset View Builder
		this.categoryTypes = dojo.isArray(categoryTypes) ? categoryTypes : [];
		var newCategoryFilters = CategoryUtil.getCategoryTypesFilters(this.categoryTypes);
		this._resetViewBuilder(newCategoryFilters);
		
		//reset test plans' table
        this._reContructTable(categoryTypes);
	},
		
    _onDeleteActionClick: function() {
        // check if any selected test plans are current displayed in other tabs
        var openedPlans = [];
        this.selectedPlans = [];
        if (this.artifactsDisplayContainer) {
            var userSelectedPlans = this.tableViewer.getCheckedRows();
            
            if (userSelectedPlans.length > 0) {
                for (var i = 0; i < userSelectedPlans.length; i++) {
                    var planURI = Utility.getTestPlanURI({ id: userSelectedPlans[i].id });
                    if (this.artifactsDisplayContainer.hasPage(planURI)) {
                        openedPlans.push(userSelectedPlans[i]);
                    } else {
                        this.selectedPlans.push(userSelectedPlans[i]);
                    }
                }
            }
        } else {
            this.selectedPlans = this.tableViewer.getCheckedRows();
        }
        
        var prompt = Constants.getMessage("msgDelTestPlanConfirm");
        if (openedPlans.length > 0) {
            if (this.selectedPlans.length > 0) {
                // some selected artifacts are not opened in tabs
                prompt = Constants.getMessage("msgDelSomeOpenTestPlanConfirm");
            } else {
                // all selected artifacts are opened in tabs
                prompt = Constants.getMessage("msgDelAllOpenTestPlanConfirm");
            }
        }

        var args = {
            'message': prompt,
            'options': openedPlans,
            'okCallback': 
                function(view) {
                    view._deleteAction();
                },
            'okCallbackData': this,
            'cancelCallback': null,
            'cancelCallbackData': null
        };
        this.confirmDialog = new com.ibm.asq.common.web.ui.internal.widgets.OptionsDialog(args);
        this.confirmDialog.setTitle(Constants.getMessage("labelConfirmation"));
        this.confirmDialog.open();
    },

    _deleteAction: function() {
        this.selectedPlans = this.selectedPlans.concat(this.confirmDialog.getSelection());
        this.selectedPlanCount = this.selectedPlans.length;

        if (this.selectedPlanCount > 0) {
            this.deleteActionNode.setDisabled(true);
            this.errorPlanCount = 0;
            this.deletedPlanCount = 0;

            for (var i = 0; i < this.selectedPlanCount; i++) {
                var responseHandler = new ServiceResponseHandler(this, "_deleteSuccess", "_deleteFailure");
                PlanningClient.postArchiveTestPlan(responseHandler,
                        {
                            uuid_versionable: this.selectedPlans[i].versionableItemId,
                            archive: true
                        });
                this.setInProgress(Constants.getMessage("msgDeletingTestPlan", this.selectedPlans[i].name));
            }
        }
    },
    
    _deleteSuccess: function(response) {
        this.viewHeaderNode.setProgressEnd();
        this.deletedPlanCount++;
        this._setDeleteStatus();

    },
    
    _deleteFailure: function(err) {
        this.viewHeaderNode.setProgressEnd();
        this.errorPlanCount++;
        this._setDeleteStatus();
    },
    
    _setDeleteStatus: function() {
        if ((this.deletedPlanCount + this.errorPlanCount) == this.selectedPlanCount) {
            this.viewHeaderNode.setStatus(
                Constants.getMessage("msgDeletedTestPlans", this.deletedPlanCount, this.selectedPlanCount),
                this.errorPlanCount == 0 ? ViewHeaderLayout.SUCCESS : this.selectedPlanCount == 1 ? ViewHeaderLayout.ERROR : ViewHeaderLayout.INFO
            );
            if (this.deletedPlanCount > 0) {
                // notify all pages (including itself) test plans are deleted
                dojo.publish(GlobalEvents.ArtifactsDeleted, [Constants.TYPE_PLAN, this.selectedPlans]);
            }
        }
    },

    // handler on artifacts changed
    onArtifactChanged: function(changeType, artifactType, artifactArray) {
        // only care about test plans
        if (artifactType == Constants.TYPE_PLAN) {
            if (changeType == GlobalEvents.ArtifactsAdded) {
                // add test plans to the table
                if (!this.plans) {
                    this.plans = artifactArray;
                } else {
                    this.plans = this.plans.concat(artifactArray);
                }
                this.refresh(this.plans, true);
            } else {
                // iterate through the array of artifacts
                for (var i = 0; i < artifactArray.length; i++) {
                    // iterate through the array of test plans in the table
                    for (var j = 0; j < this.plans.length; j++) {
                        // handle the matching test plan
                        if (artifactArray[i].id == this.plans[j].id) {
                            if (changeType == GlobalEvents.ArtifactsUpdated) {
                                // swap test plan on update
                                this.plans.splice(j, 1, artifactArray[i]);
                                this.refresh(this.plans, true);
                            } else if (changeType == GlobalEvents.ArtifactsDeleted) {
                                // remove test plan from table on delete
                                this.plans.splice(j, 1);
                                this.refresh(this.plans, true);
                            }
                            break;
                        }
                    }
                }
            }
        }
        else if(artifactType == Constants.TYPE_TP_CATEGORY) {
            this._handleCategoriesChanged(artifactArray); 
        }        
    },
	
	_mergeCategory: function(categories, CategoryTypeItemId, CategoryValueItemId) {
		var newCategories = [];
 
		for(var i = 0; i < this.categoryTypes.length; i++){
			var type = this.categoryTypes[i];
			var newValueItemId = null;
			
			if (type.itemId == CategoryTypeItemId) {
				newValueItemId = CategoryValueItemId;
			}
			else {
				newValueItemId = this._getCategoryByType(type, categories);
			}
	        if(newValueItemId)
	            newCategories.push(newValueItemId);
		}
  
        return newCategories;
    },
  
    _getCategoryByType: function(type, categories) {
        for(var i = 0; i < (type.categories ? type.categories.length : 0); i++) {
            for(var j = 0; j < (categories?categories.length:0); j++) {
                if(type.categories[i].itemId == categories[j])
                    return categories[j];
            }
        }
        return null;
    },
	
	_reContructTable: function(categoryTypes, plans) {
		if(plans)
			this.tableViewer.setContent(plans);
			
		var currentPageCtr = this.tableViewer.getCurrentPageControl();	
		//reset test plans' table
		this.provider = new TestPlanTableView.TableProvider({
            categoryTypes: categoryTypes,  
			enableRowEditable: (this.enableRowEditable? this.enableRowEditable : false)
        });
		
		this.tableViewer.setContentProvider(this.provider);
		this.tableViewer.reconstruct(currentPageCtr);
	},

	_confirmResetViewBuilder: function(newCategoryFilters) {
        //reset ViewBuilder
		var self = this;
        var args = {
            title: Constants.getMessage("labelConfirmation"),
            message: Constants.getMessage("msgChangeViewBuildConfirm"),
            yesCallback: function() {
				self._resetViewBuilder(newCategoryFilters);
			},
            noCallback: function(){
                return false;
            }
        }
        var dialog = new com.ibm.asq.common.web.ui.internal.widgets.YesNoDialog(args);
        dialog.setSecondaryTitle(args.title);
        dialog.open();
	},
	
	_resetViewBuilder: function(newCategoryFilters) {
		if (this.filterProvider) {
			var newFilters = [];
			var oldFilters = this.filterProvider.filters;
			for(var i = 0; i < oldFilters.length; i++) {
				if(oldFilters[i].name.indexOf("categories") == -1)
					newFilters.push(oldFilters[i]);
			}
			this.allCategoryFilters = newCategoryFilters;
			newFilters = newFilters.concat(this.allCategoryFilters);
			delete this.filterProvider.filters;
			this.filterProvider.filters = newFilters;
			
			this.tableViewer.setContentFilterAttributeProvider(this.filterProvider);
		}
	},
	
    _error: function(e) {
        console.error(this.declaredClass + ": Error: " + e.message);
    }	
	
	
});

})();
