////TSTCTV
/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.execution.web.ui.internal.view.table.TestSuiteTestCasesTableView");
 
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.require("com.ibm.asq.common.web.ui.internal.view.common.ImageCache");
dojo.require("com.ibm.rqm.execution.web.ui.internal.util.Utility");

dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentProvider");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableCellModifier");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.common.ConfigurationCellRenderer");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.views.configurations.ConfigurationsUriUtil");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.rqm.planning.web.ui.internal.util.EditorUtil");

(function() {

var TableConstants 				= com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants;
var ImageCache     				= com.ibm.asq.common.web.ui.internal.view.common.ImageCache;
var Utility        				= com.ibm.rqm.execution.web.ui.internal.util.Utility;
var ConfigurationsUriUtil 		= com.ibm.rational.test.lm.web.ui.internal.views.configurations.ConfigurationsUriUtil;
var Constants					= com.ibm.rqm.planning.web.client.internal.Constants;
var EditorUtil 					= com.ibm.rqm.planning.web.ui.internal.util.EditorUtil;

dojo.declare("TestSuiteTestCasesTableView.TableListener", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableListener,
{        
	constructor: function(parentView) {
        this.parentView = parentView;
    },

    rowCheckStateChanged: function(tableViewer, rowObject, state){
		var selectionCount = tableViewer.getCheckedRows().length;
		if(this.parentView.scriptsEditing){
			if(selectionCount >0){
				this.parentView.scriptsEditing = false;
				this.parentView.toggleSelectScript(true);
				return;
			}
			this.parentView.toggleSelectScript(true);//discard the changes
		}
        if (this.parentView.deleteActionNode)
            this.parentView.deleteActionNode.setDisabled(selectionCount == 0);
		if(this.parentView.executeTestCaseNode)	
			this.parentView.executeTestCaseNode.setDisabled(selectionCount != 1);
		if(this.parentView.editActionNode)	
			this.parentView.editActionNode.setDisabled(selectionCount == 0);
		if(this.parentView.changeScriptActionNode)	
			this.parentView.changeScriptActionNode.setDisabled(selectionCount == 0);	
		if(this.parentView.moveUpActionNode)
			this.parentView.moveUpActionNode.setDisabled(selectionCount == 0 || tableViewer.getGroupByColumn() > -1);
		if(this.parentView.moveDownActionNode)
			this.parentView.moveDownActionNode.setDisabled(selectionCount == 0 || tableViewer.getGroupByColumn() > -1);	
    },
 
    tableContentActionInvoked: function(tableViewer, actionId, callbackData, callback){                
        if (callback == null && callbackData != null && dojo.isFunction(callbackData)) {
            callbackData();
        }
		if (callback != null && dojo.isFunction(callback)) {
            if (callbackData != null) {
                callback(callbackData);
            } else {
                callback();
            }
        } 
    }
});

dojo.declare("TestSuiteTestCasesTableView.CellModifier", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableCellModifier,
{
    
    setChangeListener: function(listener){
		this.changeListener = listener;
	},
    cellValueChanged: function(oldValue, newValue, rowObject, columnIndex){
        // store the new values in our internal data model
		if(columnIndex == 5) {
			var scriptId = newValue;
			rowObject.defaultScript = {};
			rowObject.defaultScript.id = newValue;
			if(rowObject.testCase.scripts){
				for(var i=0;i<rowObject.testCase.scripts.length;i++){
					if(rowObject.testCase.scripts[i].id == newValue){
						rowObject.defaultScript.name = rowObject.testCase.scripts[i].name;
						break;
					}
				}
				if(this.changeListener && this.changeListener.method)
					this.changeListener.method.apply(this.changeListener.context, [rowObject]);
			}
        }    
	},
    
    cellActionInvoked: function(rowObject, columnIndex)
    {}
});

dojo.declare("TestSuiteTestCasesTableView.TableProvider",
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentProvider,
{
    constructor: function(args) {
        dojo.mixin(this, args);
    },

    getNumColumns: function(content){
        return 7;
    },

    getColumnHeading: function(content, index){
        var headings = [];
        headings.push(
			Constants.getMessage("labelTestCase"),    
            Constants.getMessage("labelConfig"),
			Constants.getMessage("labelTestPlan"),
			Constants.getMessage("labelIteration"),
			Constants.getMessage("labelState"),
			Constants.getMessage("labelScript"),
			Constants.getMessage("labelModified")
        );
        return headings[index];
    },
   
    getColumnHeadingImage: function(content, atColumnIndex){
        return null;
    },
	 
    getColumnHeadingAlignment: function(atColumnIndex){
        return this.getCellAlignment(null, atColumnIndex);
    },	 
    
    getIsColumnGroupable: function(content, atColumnIndex){
		return false;     
    },

    getIsColumnSortable: function(content, atColumnIndex){
		return false;
    },
    
    getColumnWidth: function(content, atColumnIndex){
        switch(atColumnIndex) {
            case 0: 
                return 20;
            case 1: 
                return 20;
			case 2:
				return 10;
			case 3:
				return 10;
			case 4:
				return 10;			
            case 5: 
                return 20;
			case 6:
				return 10;
        }
        return 0;
    },
    
    getContentObjects: function(content){
        return content;
    },
    
    getRowDataId: function(rowData){
        return "_table_row_for_suite_testcase_" + rowData.rowId;
    },
    
    getCellDisplayType: function(rowData, atColumnIndex){
        var type = TableConstants.RENDER_TYPE_TEXT;
        switch(atColumnIndex) {
 			case 0:
                type = TableConstants.RENDER_TYPE_LINK;
                break;
			case 1:
				if(rowData.config && rowData.config.name)
					type = TableConstants.RENDER_TYPE_LINK;
				break;
			case 5:
				type = TableConstants.RENDER_TYPE_LINK;
				if(this.scriptEditable){
                    if(this.selectedRows){
						for(var j=0;j<this.selectedRows.length;j++){
							if(this.selectedRows[j].rowId == rowData.rowId){
								type = TableConstants.RENDER_TYPE_ENUM;
                                break;
							}
						}
					}
                }
				break;
			case 6: 
                type = TableConstants.RENDER_TYPE_DATE;
                break;	
        }
        return type;
    },

    getCellAlignment: function(rowData, atColumnIndex){
        return TableConstants.ALIGN_LEFT;
    },
   
    getCellDisplayData: function(rowData, atColumnIndex){
        var val = "";
        switch(atColumnIndex) {
            case 0: 
                val = rowData.testCase ? rowData.testCase.name:"";
                break;
            case 1: 
                val = (rowData.config && rowData.config.name) ? rowData.config.name : Constants.getMessage("labelUnassigned"); 
                break;          
            case 2: 
				val = rowData.testPlan ? rowData.testPlan.name : Constants.getMessage("labelUnassigned");//Test plan
                break;
			case 3:
				val = rowData.testPhase ? rowData.testPhase.name : Constants.getMessage("labelUnassigned");//Test iteration
				break;
			case 4:
				val = rowData.testCase.state ? EditorUtil.getStateNameFromID(rowData.testCase.state) : "";
				break;	
			case 5:
				val = rowData.defaultScript ? rowData.defaultScript.name :
						rowData.testCase.scripts && rowData.testCase.scripts.length > 0 ? rowData.testCase.scripts[0].name : "";
				break;
			case 6:
				if(rowData.testCase.modified){
					val = new Date();
                	val.setTime(rowData.testCase.modified);
				}
				else
					val = "";
                break;			
        }
        return val;
    },

    getCellDisplayExtendedInfo: function(rowData, atColumnIndex){  
        var val = null;
		if(atColumnIndex == 0) {
            val = {};
            val.href = Utility.getTestCaseURI(rowData.testCase.id);
			val.tooltip = Constants.getMessage("labelClickToOpenTestCase");				
        }else if(atColumnIndex == 1){
			val={};
			if(rowData.config && rowData.config.id)
		 		val.href = ConfigurationsUriUtil.getEditConfigurationURI(rowData.config.id);;
		}else if(atColumnIndex == 5){
			val ={};
			if (this.scriptEditable) {
				val.choices = [];
				if (rowData.testCase.scripts && rowData.testCase.scripts.length > 0) {
					for (var i = 0; i < rowData.testCase.scripts.length; i++) {
						val.choices.push({
							text: rowData.testCase.scripts[i].name,
							value: rowData.testCase.scripts[i].id
						});
						val.select = rowData.defaultScript?rowData.defaultScript.id:rowData.testCase.scripts[0].id;
					}
				}
			}else{
				var scriptId = rowData.defaultScript ? rowData.defaultScript.id :
						rowData.testCase.scripts && rowData.testCase.scripts.length > 0 ? rowData.testCase.scripts[0].id : "";
				if(scriptId && scriptId != "")
					val.href = Utility.getTestScriptURI(scriptId);
			}
		}  
        return val;
    },
    setScriptsEditable:function(val,selectedRows){
		this.scriptEditable = val;
		if(val)
			this.selectedRows = selectedRows;
		else
			this.selectedRows = null;
	}
});

dojo.declare("com.ibm.rqm.execution.web.ui.internal.view.table.TestSuiteTestCasesTableView", 
    [dijit._Widget, dijit._Templated],
{    
    templateString: '<div dojoAttachPoint="_tableViewerNode" class="com-ibm-rqm-test-artifact-table-view" tabindex="-1">' +
	                '   <div dojoAttachPoint="_actionSection">' +
					'      <label><input type="checkbox" dojoAttachPoint="_checkValue" dojoAttachEvent="onchange: _checkValueChange"></input></label>' +
					'      <span dojoAttachPoint="_checkTitle" class="query-title">&nbsp;${labelExecuteSuite}</span>' +
					'   </div>' +
					'</div>',

    editable: true,
    widgetsInTemplate: true,
	labelExecuteSuite: Constants.getMessage("labelExecuteSuite"),

    constructor: function(args) {
        this.actions = [];
        this._actionButtons = [];
	 	this.executionWorkItems = [];
		this.queryName = null;
		this.executable = false;
		this.isSerialExecution = true;
		this.setParentSectionDirty = null;
	 },

    postCreate: function(){
        this.inherited("postCreate", arguments);
        var tableViewer = new com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer({
            showFilterControl:false,
            pageSize:2,
            allowAdjustSettings: true,
            autoSaveSettings: true,
            tableId: "RQM-TS-TC-TABLEVIEWER"        
        });        
        this._tableViewerNode.appendChild(tableViewer.domNode);
		var content = this.executionWorkItems ? this.executionWorkItems : [];
		if(this.isSerialExecution != null && this.isSerialExecution != undefined){
			this._checkValue.checked = !this.isSerialExecution;//Checkbox is for parallel wi6856 
		}
        tableViewer.setContent(content);
		this.tableContentProvider = new TestSuiteTestCasesTableView.TableProvider();
        tableViewer.setContentProvider(this.tableContentProvider);
		tableViewer.setTableSummary(Constants.getMessage("labelTableSummary", Constants.getMessage("labelTestCaseInTestSuite")));
		var tableListener = new TestSuiteTestCasesTableView.TableListener(this);
		tableViewer.setTableListener(tableListener);
        
        // only allow the rows to be selectable when there're table actions.
        var canSelect = (this.actions && this.actions.length > 0);
		tableViewer.setTableRowsCheckable(canSelect, /* isSingleSelect */false);
            
        for (var i = 0; i < (this.actions ? this.actions.length : 0); i++) {
            var action = this.actions[i];
            if(action.actionId == "addtestcase"){
				var actionButton = null;
				this.addTestCaseNode = tableViewer.addAction(action.actionId, action.label, action.actionHandler, action.iconClass);
				this.addTestCaseNode.setDisabled(false);
				actionButton = this.addTestCaseNode;
			}else if(action.actionId == "execute"){
				var actionButton = null;
				this.executeTestCaseNode = tableViewer.addAction(action.actionId, action.label, action.actionHandler, action.iconClass);
				this.executeTestCaseNode.setDisabled(true);
				actionButton = this.executeTestCaseNode;
			}else if(action.actionId == "remove"){
				var actionButton  =null;
				this.deleteActionNode = tableViewer.addAction(action.actionId, action.label, action.actionHandler, action.iconClass);
				this.deleteActionNode.setDisabled(true);
				actionButton = this.deleteActionNode;
			}else if(action.actionId == "edit"){
				var actionButton = null;
				this.editActionNode = tableViewer.addAction(action.actionId, action.label, action.actionHandler, action.iconClass);
				this.editActionNode.setDisabled(true);
				actionButton = this.editActionNode;
			}else if(action.actionId == "changescript"){
				var actionButton = null;
				this.changeScriptActionNode = tableViewer.addAction(action.actionId, action.label, action.actionHandler, action.iconClass);
				this.changeScriptActionNode.setDisabled(true);
				actionButton = this.changeScriptActionNode;
			}else if(action.actionId == "save"){
				var actionButton = null;
				this.saveActionNode = tableViewer.addAction(action.actionId, action.label, action.actionHandler, action.iconClass);
				this.saveActionNode.setDisabled(true);
				actionButton = this.saveActionNode;
			}else if(action.actionId == "moveup"){
				var actionButton = null;
				this.moveUpActionNode = tableViewer.addAction(action.actionId, action.label, action.actionHandler, action.iconClass);
				this.moveUpActionNode.setDisabled(true);
				actionButton = this.moveUpActionNode;
			}else if(action.actionId == "movedown"){
				var actionButton = null;
				this.moveDownActionNode = tableViewer.addAction(action.actionId, action.label, action.actionHandler, action.iconClass);
				this.moveDownActionNode.setDisabled(true);
				actionButton = this.moveDownActionNode;
			}else{
				var actionButton = tableViewer.addAction(action.actionId, action.label, action.actionHandler, action.iconClass);
	        }
		    if (action.disabled && action.disabled == true) {
                actionButton.setDisabled(true);
            }
            if (action.hidden && action.hidden == true) {
                dojo.addClass(actionButton.domNode, "dijitDisplayNone");
            }
        	this._actionButtons.push(actionButton);
        }            
		var cellModifier = new TestSuiteTestCasesTableView.CellModifier()
		cellModifier.setChangeListener({
			context: this,
			method:dojo.hitch(this, function(rowObject) {
//                    rowObject.isNew = true;
                }) 
		});
		tableViewer.setCellModifier(cellModifier);
        tableViewer.show();
		tableViewer.setEditable(this.editable);
		this.tableViewer = tableViewer;	
    },
 
	 // API
    getSelectedItems: function() {
        return this.tableViewer.getCheckedRows();
    },
	setRowChecked:function(row,state){
		this.tableViewer.rowCheckedHandler.setRowCheckState(row,state);
	},
	getTableContent: function() {
        return this.tableViewer.getContent();
    },
	 
    appendItem: function(items) {
    	var content = this.tableViewer.getContent();
		for (var i = 0; i < items.length; i++) {
			items[i].rowId = content.length;
			content.push(items[i]);
		}
        this.refresh(content, true);
    },
	
	refresh: function(content,clear){
		if (content) {
			this.tableViewer.setContent(content);
		}
		if(clear){
			this.tableViewer.rowCheckedHandler.clearRowStates();
			this.disableAllActions();
		}
        this.tableViewer.refresh();
	},
	
	updateItem: function(ewi){
		var content = this.tableViewer.getContent();
		for(var i=0;i<content.length;i++){
			if(content[i].testCase.versionableItemId == ewi.testCase.versionableItemId &&
				content[i].isNew){
				if(content[i].configuration && content[i].configuration != ewi.configuration)
					continue;
				var item = ewi;
				if (content[i].config) {
					var config = content[i].config;
					item.config = config;
				}
				else
					item.config = null;
				item.rowId = content[i].rowId;
				//same for default script
				item.defaultScript = content[i].defaultScript;
				if(ewi.phase){
					item.testPhase = {};
					item.testPhase.name = ewi.phase.name;
					item.testPhase.itemId = ewi.phase.itemId;
				} 
				content[i] = item;
			}
		}
		
	},
	
    addConfigurationInfo: function(ewiRowId, config) {
        var content = this.tableViewer.getContent();
        for (var i = 0; i < content.length; i++) {
        	if (content[i].rowId == ewiRowId && !content[i].config) {
        		content[i].config = config;
				content[i].configuration = config.id;
				break;
        	}
        }
        this.tableViewer.setContent(content);
        this.tableViewer.refresh();
    },
	
	getSerialExecutionState: function(){
		return this._checkValue.checked;
	},
	
	_checkValueChange: function(){
		if(this.setParentSectionDirty && dojo.isFunction(this.setParentSectionDirty)){
			this.setParentSectionDirty();
		}
	},
	toggleSelectScript:function(discard){
		if (!this.scriptsEditing) {
			var selectedRows = this.tableViewer.getCheckedRows();
			this.tableContentProvider.setScriptsEditable(true,selectedRows);
			this.scriptsEditing = true;
			this.changedEWI = [];
			this.changeScriptActionNode.setLabel(Constants.getMessage("labelDiscardChanges"));
			dojo.removeClass(this.changeScriptActionNode.iconNode, "edit-icon-image");
			dojo.addClass(this.changeScriptActionNode.iconNode, "discard-edit-icon-image");
			this.saveActionNode.setDisabled(false);
			
			// hide others
			dojo.addClass(this.addTestCaseNode.domNode, "dijitDisplayNone");
			dojo.addClass(this.executeTestCaseNode.domNode, "dijitDisplayNone");
			dojo.addClass(this.deleteActionNode.domNode, "dijitDisplayNone");
			dojo.addClass(this.editActionNode.domNode, "dijitDisplayNone");
			dojo.addClass(this.moveUpActionNode.domNode, "dijitDisplayNone");
			dojo.addClass(this.moveDownActionNode.domNode, "dijitDisplayNone");

  
		}else {
			this.tableContentProvider.setScriptsEditable(false);
			this.scriptsEditing = false;
			this.changeScriptActionNode.setLabel("Change Default Test Script");//Constants.getMessage("labelDiscardChanges"));
			dojo.removeClass(this.changeScriptActionNode.iconNode, "discard-edit-icon-image");
			dojo.addClass(this.changeScriptActionNode.iconNode, "edit-icon-image");
			this.saveActionNode.setDisabled(true);
			dojo.addClass(this.saveActionNode.domNode, "dijitDisplayNone");
			if(this.changedEWI && this.changedEWI.length >0 && !discard)
				this._checkValueChange();
			if(discard)
				this.changedEWI = [];
				
			// show others
			dojo.removeClass(this.addTestCaseNode.domNode, "dijitDisplayNone");
			dojo.removeClass(this.executeTestCaseNode.domNode, "dijitDisplayNone");
			dojo.removeClass(this.deleteActionNode.domNode, "dijitDisplayNone");
			dojo.removeClass(this.editActionNode.domNode, "dijitDisplayNone");
			dojo.removeClass(this.moveUpActionNode.domNode, "dijitDisplayNone");
			dojo.removeClass(this.moveDownActionNode.domNode, "dijitDisplayNone");
			
			
		}
		this.tableViewer.refresh(this.tableViewer.getContent(), true);
	},
	disableAllActions:function(){
		var actions = this.tableViewer.getActionButtons();
		for(var action in actions){
			if(actions[action].actionId != "addtestcase" && !dojo.hasClass(actions[action].domNode, "dijitDisplayNone"))
				actions[action].setDisabled(true);
			if(actions[action].actionId == "save"){
				actions[action].setDisabled(true);
				dojo.addClass(actions[action].domNode, "dijitDisplayNone");
			}
		}
	}
	
});
})();
