/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.process.web.ui.internal.view.viewlets.ReviewViewlet");

dojo.require("dojox.data.dom");

dojo.require("com.ibm.team.dashboard.web.ui.Viewlet");
dojo.require("com.ibm.team.dashboard.web.ui.DashboardConstants");
dojo.require("com.ibm.team.repository.web.client.session.Session");
dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");
dojo.require("com.ibm.asq.common.web.ui.internal.util.GlobalEvents");

dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.common.ImageCache");
dojo.require("com.ibm.rqm.planning.web.ui.internal.util.Utility");
dojo.require("com.ibm.rqm.planning.web.ui.internal.util.TooltipBuilder");
//xojo.require("com.ibm.rqm.planning.web.ui.internal.view.common.SortableFilterableTable");
dojo.require("com.ibm.rqm.planning.web.ui.internal.view.table.WorkItemTableView");

dojo.require("com.ibm.rqm.planning.web.ui.internal.util.EditorUtil");
dojo.require("com.ibm.rqm.process.web.client.internal.approval.ProcessClient");
dojo.require("com.ibm.team.workitem.web.client.internal.QueryClient");
dojo.require("com.ibm.rqm.planning.web.client.internal.QueryClient");

(function()
{
var ImageCache					= com.ibm.rqm.planning.web.ui.internal.view.common.ImageCache;
var Constants 					= com.ibm.rqm.planning.web.client.internal.Constants;
var TooltipBuilder				= com.ibm.rqm.planning.web.ui.internal.util.TooltipBuilder;
var Utility						= com.ibm.rqm.planning.web.ui.internal.util.Utility;
var ProcessClient				= com.ibm.rqm.process.web.client.internal.approval.ProcessClient;
var PlanClient					= com.ibm.rqm.planning.web.client.internal.QueryClient;

var Viewlet 					= com.ibm.team.dashboard.web.ui.Viewlet;
var DashboardConstants          = com.ibm.team.dashboard.web.ui.DashboardConstants;
var QueryClient                 = com.ibm.team.workitem.web.client.internal.QueryClient;
var ServiceResponseHandler 		= com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;	
var getAuthenticatedContributor = com.ibm.team.repository.web.client.session.getAuthenticatedContributor;
var EditorUtil					= com.ibm.rqm.planning.web.ui.internal.util.EditorUtil;
var WorkItemTableView 			= com.ibm.rqm.planning.web.ui.internal.view.table.WorkItemTableView;
var GlobalEvents 				= com.ibm.asq.common.web.ui.internal.util.GlobalEvents;
	
dojo.declare("com.ibm.rqm.process.web.ui.internal.view.viewlets.ReviewViewlet",	Viewlet,
{
	templateString: "<div dojoAttachPoint=\"_resultSection\"></div>",

	_actions: [ 
				Constants.PROCESS_OPEN_ITEM_REVIEWLET,
				Constants.PROCESS_ALREADY_APPROVED_REVIEWLET, 
				Constants.PROCESS_ALREADY_REJECTED_REVIEWLET,
				Constants.PROCESS_PENDING_APPROVALS_REVIEWLET], 
	num: 0,
	needQuery: [],
	
	/*
     * Called by the framework after the viewlet is instantiated, but before the
     * first refresh. Viewlets that need to initialize themselves shoudl override.
     */
    init: function() {
		this.inherited("init", arguments);
		dojo.subscribe(GlobalEvents.RefreshMyTasks, this, "refresh");
    },
	
	refresh: function() {
		this.getSite().setLoading(true);
		dojox.data.dom.removeChildren(this._resultSection);			
		var scope;
		switch (this.getScope()) {
			case DashboardConstants.SCOPE_CONTRIBUTOR:
				scope = QueryClient.SCOPE_PERSONAL;
				break;
			case DashboardConstants.SCOPE_TEAM_AREA:
				scope = QueryClient.SCOPE_TEAM_AREA;
				break;
			case DashboardConstants.SCOPE_PROJECT_AREA:
				scope = QueryClient.SCOPE_PROJECT_AREA;
				break;
			}
			var responseHandler = new ServiceResponseHandler(this, "_success", "_error");
			QueryClient.getScopedQueries(responseHandler, scope, this.getScopeItem().itemId, true, true);
	},
	
	_success: function(scopedQueriesDTO) {
		this.needQuery = new Array();
		var projectArea = EditorUtil.getCurrentProjectArea();
		var scopedQuery = null;
		if(scopedQueriesDTO && scopedQueriesDTO.length > 0) {
			for(var i=0; i<scopedQueriesDTO.length; i++) {
				if(projectArea.name == scopedQueriesDTO[i].scopeName)
					scopedQuery = scopedQueriesDTO[i];
			}
		}
		if (scopedQuery.queries && scopedQuery.queries.length > 0) {
			for (var i = 0; i < scopedQuery.queries.length; i++){
				var query = scopedQuery.queries[i];
				if(this._isInArray(this._actions, query.name))
					this.needQuery.push(query);
			}
		}
		var queries = new Array();
		for(var i=0; i<this.needQuery.length; i++){
			var params = {
				jsonQuery:{
							itemId: this.needQuery[i].itemId
				},
				queryItemId: this.needQuery[i].itemId,
				name: this.needQuery[i].name,
				token: "",
				projectAreaItemId: EditorUtil.getCurrentProjectArea().itemId
			}
			queries.push(params);
		}
		var operationJson = dojo.toJson(queries);
		var param = dojo.toJson({querys: queries});
		var responseHandler = new ServiceResponseHandler(this, "_showResults", "_error");
		ProcessClient.postExecuteQuery(responseHandler, {operationJson: param});
	},
	
	update: function() {
		this.refresh();
//		this._updateVisibility();
	},	
	
	_showResults: function(results) {
		this.getSite().setLoading(false);
		this.getSite().doneRefresh();
		dojox.data.dom.removeChildren(this._resultSection);
	  //change workitem's summary to display what the user should do.  	
	  if (results && results.length > 0) {
	  	for (var i = 0; i < results.length; i++) {
	  		var wiSummary = results[i].workItemSummary;
	  		if (results[i].linkTypeDTOs != null) {
	  			var linkType = results[i].linkTypeDTOs[0];
	  			var taskName = this._getTaskName(linkType);
	  			if (!taskName) {
	  				taskName = wiSummary.summary;
	  			}
				if (taskName != linkType.displayName) {
					//if the name was changed, this is an approval record
					//flag it as such so URI can point to the approvals ta directly
					wiSummary.isApproval = true;
				}
	  			wiSummary.summary = taskName;
	  		}
	  	}
	  }	
	  
	  var itemCount = this.getPreference("items");
      this._tableViewer = new WorkItemTableView({summaries: results, numitems: itemCount, usePageRangeControl: false});
      this._resultSection.appendChild( this._tableViewer.domNode );
      this._resultSection.style.width = "100%";       // CML: hack: the table doesn't fill the viewlet otherwise, looks silly		
	},
	
	_isInArray: function(array, item) {
		if(array != null && array.length > 0) {
			for(var i=0; i<array.length; i++){
				if(array[i]==item)
					return true;
			}
		}
		return false;
	},
		
	_getTaskName: function(linkType) {
		var name = null;
		if(linkType.displayName == this._actions[1]) {
			name = Constants.getMessage("labelApprovedReviewlet", linkType.linkDTOs[0].comment);
		}
		if(linkType.displayName == this._actions[2]) {
			name = Constants.getMessage("labelRejectedReviewlet", linkType.linkDTOs[0].comment);
		}
		if(linkType.displayName == this._actions[3]) {
			name = Constants.getMessage("labelApproveReviewReviewlet", linkType.linkDTOs[0].comment);
		}
		return name;
	},
		
	_error: function(errorObj){
            alert(errorObj.message);
    }
});

})();
