/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.requirement.web.ui.internal.view.viewlets.UpdatedRequirementViewlet");

dojo.require("dojox.data.dom");

dojo.require("com.ibm.team.dashboard.web.ui.Viewlet");
dojo.require("com.ibm.team.dashboard.web.ui.DashboardConstants");
dojo.require("com.ibm.team.repository.web.client.session.Session");
dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");

dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");

dojo.require("com.ibm.rqm.requirement.web.ui.internal.view.table.RequirementTableView");
dojo.require("com.ibm.rqm.requirement.web.client.internal.requirement.RequirementConnectClient");

(function(){
    var Viewlet = com.ibm.team.dashboard.web.ui.Viewlet;
    var DashboardConstants = com.ibm.team.dashboard.web.ui.DashboardConstants;
    var ServiceResponseHandler = com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
    var RequirementTableView = com.ibm.rqm.requirement.web.ui.internal.view.table.RequirementTableView;
    var RequirementConnectClient = com.ibm.rqm.requirement.web.client.internal.requirement.RequirementConnectClient;
    var AlertDialog = com.ibm.asq.common.web.ui.internal.widgets.AlertDialog;
	var Constants = com.ibm.rqm.planning.web.client.internal.Constants;
	
    dojo.declare("com.ibm.rqm.requirement.web.ui.internal.view.viewlets.UpdatedRequirementViewlet", Viewlet, {
        templateString: "<div dojoAttachPoint=\"_resultSection\"></div>",
        
        needQuery: [],
        
        /*
         * Called by the framework after the viewlet is instantiated, but before the
         * first refresh. Viewlets that need to initialize themselves shoudl override.
         */
        init: function(){
        },
        
        refresh: function(){
            this.getSite().setLoading(true);
            dojox.data.dom.removeChildren(this._resultSection);
            var responseHandler = new ServiceResponseHandler(this, "_showResults", "_error");
            RequirementConnectClient.getUpdatedRequirementItems(responseHandler, null);
        },
        
        update: function(){
            this.refresh();
        },
        
        _showResults: function(results){
            this.getSite().setLoading(false);
            this.getSite().doneRefresh();
            dojox.data.dom.removeChildren(this._resultSection);
            var args = {
                requirements: [],
                editable: false,
                isExternal: true
            };
            if (results && results.length > 0 && results[0].priority) {
                args = {
                    requirements: [],
                    editable: false,
                    isExternalByPriority: true
                };
            }
            this._reqTableViewer = new RequirementTableView(args);
            this._resultSection.appendChild(this._reqTableViewer.domNode);
            this._reqTableViewer.refresh(results ? results : []);
        },
        
        _error: function(e){
			var alertDialog = new AlertDialog({'message': e.message});
    	    alertDialog.setSecondaryTitle(Constants.getMessage("labelError"));
        	alertDialog.open();
        }
    });
    
})();
