/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rqm.planning.web.ui.internal.view.viewlets.WorkitemEditorViewlet");

dojo.require("dojox.data.dom");

dojo.require("com.ibm.team.dashboard.web.ui.Viewlet");
dojo.require("com.ibm.team.repository.web.client.session.Session");
dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");

dojo.require("com.ibm.rqm.planning.web.ui.internal.view.common.ImageCache");
//xojo.require("com.ibm.rqm.planning.web.ui.internal.util.Utility");
dojo.require("com.ibm.team.workitem.web.ui.internal.view.editor.WorkItemEditor");
dojo.require("com.ibm.team.workitem.web.ui.internal.page.WorkItemPageView");
dojo.require("com.ibm.team.workitem.web.client.internal.WorkItemClient");
//xojo.require("com.ibm.rqm.planning.web.ui.internal.util.EditorFactory");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");

(function()
{
//var Utility					= com.ibm.rqm.planning.web.ui.internal.util.Utility;
var ImageCache				= com.ibm.rqm.planning.web.ui.internal.view.common.ImageCache;
//var EditorFactory 			= com.ibm.rqm.planning.web.ui.internal.util.EditorFactory;
var Viewlet 				= com.ibm.team.dashboard.web.ui.Viewlet;
var WorkItemClient         	= com.ibm.team.workitem.web.client.internal.WorkItemClient;
var ServiceResponseHandler	= com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
var Constants = com.ibm.rqm.planning.web.client.internal.Constants;

var getAuthenticatedContributor = com.ibm.team.repository.web.client.session.getAuthenticatedContributor;
	
dojo.declare("com.ibm.rqm.planning.web.ui.internal.view.viewlets.WorkitemEditorViewlet",	Viewlet,
{
	templateString: "<div class=\"\" dojoAttachPoint=\"_contentArea\"></div>", //dojo.moduleUrl("com.ibm.team.dashboard.viewlets.web", "ui/internal/templates/MembersViewlet.html"),
	
	refresh: function()
	{
		this._contentArea.innerHTML = "";
		this._hasZoomableContent = true;
		this.getSite().setLoading(true);

		var loading = document.createElement("div");
		loading.innerHTML = Constants.getMessage("labelLoading");
		loading.className = "loadingText";
		this._contentArea.appendChild(loading);

		if (this._workitem != null)
		{
			this.update();
		}
		else
		{
			this.noWorkitem();
		}
		
		//Need to set the isRefreshing on the container so that refreshing of the viewlet can occur,
		//otherwise it can only happen once.
		this.container.isRefreshing = 0;
	},

	noWorkitem: function()
	{
		this._contentArea.innerHTML = "";
		this._hasZoomableContent = false;
		var empty = document.createElement("div");
		empty.innerHTML = Constants.getMessage("labelNoWorkItemSpecified");
		empty.className = "loadingText";
		this._contentArea.appendChild(empty);
		this.getSite().setLoading(false);
	},
	
	getEditorFactory: function() {
		return EditorFactory;
	},

	update: function()
	{
		dojox.data.dom.removeChildren(this._contentArea);

		if (this._wiView == null)
		{
			this._wiView = new com.ibm.team.workitem.web.ui.internal.page.WorkItemPageView({});
		}

		var div = document.createElement("div");
		div.className = "com-ibm-team-workitem";
		
		var wiEditor = new com.ibm.team.workitem.web.ui.internal.view.editor.WorkItemEditor({ parentController: this._wiView.getController() });
		wiEditor.setWorkItem(this._workitem, null);
		
		div.appendChild(wiEditor.domNode);
		this._contentArea.appendChild(div);

		this.getSite().setLoading(false);
	},

	artifactSelected: function(obj)
	{
		dojox.data.dom.removeChildren(this._contentArea);
		this.getSite().setLoading(true);

		var loading = document.createElement("div");
		loading.innerHTML = Constants.getMessage("labelLoading");
		loading.className = "loadingText";
		this._contentArea.appendChild(loading);

		var responseHandler = new ServiceResponseHandler(this, "_viewWorkItemHandler", "_error");
		WorkItemClient.getWorkItemDTO(responseHandler, {id: obj.id});
	},
			
	_viewWorkItemHandler: function(result) 
	{
		if ( dojo.isArray(result) ) 
		{
			result = result[0];	
		}
		this._workitem = result;
		this.update();				
	},
	
	_error: function(errorObj)
	{
		alert("Error getting data (message: '" + errorObj.message + "') in TestCaseViewlet#_error");
	},
	
	hasZoomableContent: function() {
//		if (this._count && this._count > 10)
			return true;
//		return false;
	},
	
	settingsChanged: function(oldSettings, newSettings) {
		alert("in settingsChanged function");
/*		if (newSettings.scope != oldSettings.scope || newSettings.scopeItemId != oldSettings.scopeItemId ||
			(newSettings.scope == DashboardConstants.SCOPE_TEAM_AREA && newSettings.scopeSubteams != oldSettings.scopeSubteams))
			this.refresh();
		else
			this.update();
*/
	}
});

})();
