/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2009. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.rational.test.lm.web.ui.internal.views.configurations.QueryConfigurationsView");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dojox.data.dom");
dojo.require("dojo.parser");
dojo.require("dijit.layout.ContentPane");
dojo.require("dijit.form.Button");
dojo.require("dijit.form.CheckBox");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.RtlmUiUtil");

dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");
dojo.require("com.ibm.team.repository.web.client.internal.ServerStatusClient");

dojo.require("com.ibm.asq.common.web.client.internal.PermissionsClient");
dojo.require("com.ibm.rational.test.lm.web.client.internal.config");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.widgets.CSHelp");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.views.configurations.ConfigurationsUriUtil");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.pages.AssetUriUtil");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.views.machines.MachineSearchView");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.pages.PageUtil");

dojo.require("com.ibm.asq.common.web.ui.internal.util.GlobalEvents");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.CommonDialog");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.views.providers.ConfigurationsTableProvider"); 
dojo.require("com.ibm.rational.test.lm.web.ui.internal.views.requests.RequestUriUtil");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.views.configurations.AssetDescriptionSelectorDialog");
dojo.require("com.ibm.asq.common.web.ui.internal.view.common.ImageCache");
dojo.require("com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout");


(function() 
{
	var ServiceResponseHandler	= com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
	var ServerStatusClient = com.ibm.team.repository.web.client.internal.ServerStatusClient;
	var ConfigurationUriUtil = com.ibm.rational.test.lm.web.ui.internal.views.configurations.ConfigurationsUriUtil;
	var TableConstants = com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants;
	var AssetUriUtil = com.ibm.rational.test.lm.web.ui.internal.pages.AssetUriUtil;
	var PageUtil = com.ibm.rational.test.lm.web.ui.internal.pages.PageUtil;
    var GlobalEvents = com.ibm.asq.common.web.ui.internal.util.GlobalEvents;
    var PermissionsClient = com.ibm.asq.common.web.client.internal.PermissionsClient;
	var RtlmUiUtil = com.ibm.rational.test.lm.web.ui.internal.RtlmUiUtil;
	var ImageCache = com.ibm.asq.common.web.ui.internal.view.common.ImageCache;
	var ViewHeaderLayout = com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout;

dojo.declare("QueryConfigurationsView.TocTableProvider",
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentProvider, 
{
    // Summary:
    //
    getNumColumns: function(content)
    {
        return 8;
    },
    
    // Summary:
    //
    getColumnHeading: function(content, index)
    {
        var headings = [
            RtlmUiUtil.getMessage("pl_name"),
            RtlmUiUtil.getMessage("Database"),
            RtlmUiUtil.getMessage("pl_operatingsystem"),
            RtlmUiUtil.getMessage("ApplicationServer"),
            RtlmUiUtil.getMessage("Browser"),
            RtlmUiUtil.getMessage("TestTool"),
            RtlmUiUtil.getMessage("CPU"),
            RtlmUiUtil.getMessage("ManagementAgent")
        ];
        return headings[index];
    },

     
    getIsColumnGroupable: function(content, atColumnIndex)
    {
        return false;     
    },

    getIsColumnSortable: function(content, atColumnIndex)
    {
        return true;   
    },
    
    getColumnWidth: function(content, atColumnIndex)
    {
        switch(atColumnIndex) {
            case 0: 
                return 13;
            case 1: 
                return 13;
            case 2: 
                return 13;
            case 3: 
                return 13;
            case 4: 
                return 13;
            case 5: 
                return 9;
            case 6: 
                return 13;
            case 7: 
                return 13;
        }
        return 0;
    },
    
    // Summary:
    //    The only assumptions the table have on the data that it displays
    //    is that it's an array contents. These are the data content/object that
    //    will be displayed in the table rows.
    //
    getContentObjects: function(content)
    {
        // our content is already an array of objects
        return content;
    },
    
    getRowDataId: function(rowData)
    {
        return rowData.id;
    },
    
    // Summary:
    //    Returns the type of the cell to be displayed. By default, the TableViewer
    //    will support a set of cell types. The type of the cell will map to a specific
    //    cell renderer (to be discussed).
    getCellDisplayType: function(rowData, atColumnIndex)
    {
        var type = TableConstants.RENDER_TYPE_TEXT;

        switch(atColumnIndex) {
            case 0:
                type = TableConstants.RENDER_TYPE_ACTION;
                break;
        }
        return type;
    },

    getCellAlignment: function(rowData, atColumnIndex)
    {
      //  if(atColumnIndex == 0 || atColumnIndex == 1)
       //     return TableConstants.ALIGN_CENTER;
        return TableConstants.ALIGN_LEFT;
    },
    
    // Summary:
    //    Returns the display data of the cell. For cell renderer type of TEXT, this will
    //    be the string. Others cell render type would be Date, or integer value, etc. If the 
    //    cell renderer type is image, the client can also supply cell data that can be sortable/groupable. 
    //    The TableViewer's default sorter, filter operates on this returned data. For "complex" 
    //    cell types such as image where it could have multiple values for different states, the 
    //    client also needs to implement the next method.
    //    
    //    Client must implement this method to provide the cell data.
    //    
    getCellDisplayData: function(rowData, atColumnIndex)
    {
        var val = "";
        switch(atColumnIndex) {
            case 0: 
                val = rowData.name;
                break;
            case 1: 
                val = rowData.database;
                break;          
            case 2: 
                val = rowData.os;
                break;          
            case 3: 
                val = rowData.appServer;
                break;          
            case 4: 
                val = rowData.browsers;
                break;          
            case 5: 
                val = rowData.testTools;
                break;          
            case 6: 
                val = rowData.cpu;
                break;          
            case 7: 
                val = rowData.managementAgent;
                break;          
        }
        return val;
    },

    
    // Summary:
    //    If applicable, returns the extended display information of the cell. The return extended
    //    info must be an object with the following attributes:
    //    
    //    {
    //      /* attribute common for all cell renderer types */
    //      "tooltip": <string>,
    //
    //      /* attributes for IMAGE and ACTION cell renderer types */
    //      "isHidden": <true, false> the image is hidden if the row is not on the mouse over
    //      "image": base image URL,  
    //      "mouseOverImage": image URL, (optional)
    //      "mouseOutImage": image URL,  (optional) (overrides "image")
    //
    //      /* attributes for SELECT cell renderer type */
    //      "select" : 'value', the selection in the combo
    //      "choices" : [{'text':'display text', 'value':'value'}, ] array of objects with 'text' and 'value' attributes
    //
    //      /* attributes for CHECKBOX cell renderer type */
    //      "state" : <true, false> initial state of the check box
    //
    //      /* attributes for LINK cell renderer type */
    //      "href" : <string> the href string for the link
    //    }
    //
    //    Client can implement this method to provide extended display infor for the cell.
    //    Certain cell renderer type will require the client to implement this method to
    //    provide needed display information, such as an image ACTION.
    //
     getCellDisplayExtendedInfo: function(rowData, atColumnIndex)
    {  
        var val = null;
        if(atColumnIndex == 0) {
            val = {};
            val['index'] = rowData.id;
        }

        return val;
    }  
});

dojo.declare("QueryConfigurationsView.TableProvider",
			 com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentProvider, 
{
    // Summary:
    //
    getNumColumns: function(content)
    {
        return 3;
    },
    
    // Summary:
    //
    getColumnHeading: function(content, index)
    {
        var headings = [
			"",
            RtlmUiUtil.getMessage("cfgName"),
            RtlmUiUtil.getMessage("cfgSummary")
        ];
        return headings[index];
    },

	 
    getIsColumnGroupable: function(content, atColumnIndex)
    {
        return false;     
    },

    getIsColumnSortable: function(content, atColumnIndex)
    {
        return atColumnIndex > 0;   
    },
    
    getColumnWidth: function(content, atColumnIndex)
    {
        switch(atColumnIndex) {
			case 0:
				return 1;
            case 1: 
                return 34;
            case 2: 
                return 65;
        }
        return 0;
    },
    
    // Summary:
    //    The only assumptions the table have on the data that it displays
    //    is that it's an array contents. These are the data content/object that
    //    will be displayed in the table rows.
    //
    getContentObjects: function(content)
    {
        // our content is already an array of objects
        return content;
    },
    
    getRowDataId: function(rowData)
    {
        return rowData.id;
    },
    
    // Summary:
    //    Returns the type of the cell to be displayed. By default, the TableViewer
    //    will support a set of cell types. The type of the cell will map to a specific
    //    cell renderer (to be discussed).
    getCellDisplayType: function(rowData, atColumnIndex)
    {
        var type = TableConstants.RENDER_TYPE_TEXT;

        switch(atColumnIndex) {
 			case 0:
                type = TableConstants.RENDER_TYPE_IMAGE;
                break;
        
 			case 1:
                type = TableConstants.RENDER_TYPE_LINK;
                break;
        }
        return type;
    },

    getCellAlignment: function(rowData, atColumnIndex)
    {
      //  if(atColumnIndex == 0 || atColumnIndex == 1)
       //     return TableConstants.ALIGN_CENTER;
        return TableConstants.ALIGN_LEFT;
    },
    
    // Summary:
    //    Returns the display data of the cell. For cell renderer type of TEXT, this will
    //    be the string. Others cell render type would be Date, or integer value, etc. If the 
    //    cell renderer type is image, the client can also supply cell data that can be sortable/groupable. 
    //    The TableViewer's default sorter, filter operates on this returned data. For "complex" 
    //    cell types such as image where it could have multiple values for different states, the 
    //    client also needs to implement the next method.
    //    
    //    Client must implement this method to provide the cell data.
    //    
    getCellDisplayData: function(rowData, atColumnIndex)
    {
        var val = "";
        switch(atColumnIndex) {
            case 1: 
                val = rowData.name;
                break;
            case 2: 
                val = rowData.summary;
                break;          
        }
        return val;
    },

    
    // Summary:
    //    If applicable, returns the extended display information of the cell. The return extended
    //    info must be an object with the following attributes:
    //    
    //    {
    //      /* attribute common for all cell renderer types */
    //      "tooltip": <string>,
    //
    //      /* attributes for IMAGE and ACTION cell renderer types */
    //      "isHidden": <true, false> the image is hidden if the row is not on the mouse over
    //      "image": base image URL,  
    //      "mouseOverImage": image URL, (optional)
    //      "mouseOutImage": image URL,  (optional) (overrides "image")
    //
    //      /* attributes for SELECT cell renderer type */
    //      "select" : 'value', the selection in the combo
    //      "choices" : [{'text':'display text', 'value':'value'}, ] array of objects with 'text' and 'value' attributes
    //
    //      /* attributes for CHECKBOX cell renderer type */
    //      "state" : <true, false> initial state of the check box
    //
    //      /* attributes for LINK cell renderer type */
    //      "href" : <string> the href string for the link
    //    }
    //
    //    Client can implement this method to provide extended display infor for the cell.
    //    Certain cell renderer type will require the client to implement this method to
    //    provide needed display information, such as an image ACTION.
    //
     getCellDisplayExtendedInfo: function(rowData, atColumnIndex)
    {  
        var val = null;
        if(atColumnIndex == 0) {
            val = {};
            val['href'] = ConfigurationUriUtil.getEditConfigurationURI( rowData.id );
			val['image'] = ImageCache.CONFIGURATION_ICON;
        }
        if(atColumnIndex == 1) {
            val = {};
            val['href'] = ConfigurationUriUtil.getEditConfigurationURI( rowData.id );
        }

        return val;
    }  
    
    
});


//Handler for the TOC table cell click
dojo.declare("QueryConfigurationsView.TOCCellModifier",
			 com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableCellModifier, 
{
	constructor: function(view) {
		this._view = view;
	},
	
	cellActionInvoked: function(rowObject, columnIndex)
    {
		//Get the config ID out of the row data and open 
		var URI = ConfigurationUriUtil.getEditConfigurationURI( rowObject.configID );
		window.location.href = URI;
    }
});









dojo.declare("com.ibm.rational.test.lm.web.ui.internal.views.configurations.QueryConfigurationsView", [dijit._Widget, dijit._Templated], 
{
	//This line is NECESSARY fot the attachPoints in the PageLayout to get instantiated
	widgetsInTemplate: true,
	
	//The layout of the page.
	templateString: 
		'<div id="${id}" dojoAttachPoint="domNode">' +
		'<div dojoType="com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout"' +
		'     dojoAttachPoint="myPageLayout" noline="true">' + 		
		' <!-- The table of configurations -->  '+
		' <div dojoAttachPoint="configurations_panel"> '+
		'   <table width="100%" cellpadding="12" cellspacing="12"> '+
		'       <tr> '+
		'          <td> '+
		'               <!-- table resultarea --> '+
		'               <div dojoAttachPoint="resultDiv" > '+
		'               </div> '+
		'          </td> '+
		'       </tr> '+
		'       <tr>' +
		'          <td>' +
        '              <span dojoAttachPoint="TOCTitle" class="view-subtitle"></span>' +
		'          </td>' +
		'       </tr>' +
		'       <tr> '+
		'          <td> '+
		'               <!-- detail grid are --> '+
		'               <div dojoAttachPoint="detailDiv" > '+
		'               </div> '+
		'          </td> '+
		'       </tr> '+		
		'   </table> '+
		' </div>' +
		'</div>'+
		'<div dojoType="com.ibm.rational.test.lm.web.ui.internal.widgets.CSHelp"  dojoAttachPoint="CSHelp"/div>' +
		'</div>',

    
    postCreate: function()
    {
        com.ibm.rational.test.lm.web.ui.internal.views.configurations.QueryConfigurationsView.superclass.postCreate.apply(this);
		
		//Set the title and cs help id on the page
		this.myPageLayout.setTitle(RtlmUiUtil.getMessage("cfgConfigurationsPageTitle"));
		this.myPageLayout.setCSHelpId("rtlm_view_all_configurations.html", com.ibm.rational.test.lm.web.CSHelpID);
		this.myPageLayout.setCSHelpButtonLabel(RtlmUiUtil.getMessage("labelHelp", "", RtlmUiUtil.getMessage("cfgConfigurationsPageTitle")));
				
		//Create the table that will hold the reservations
		this.createTable();
		
		//Create the grid that will show the content of a selelcted config
		this.createTOC();
		
		this.loadTable();
	},
	
	_onRefreshActionClick: function()
	{
		this.loadTable();
	},

	_onCopyActionClick: function()
	{
		var rows = this.tableViewer.getCheckedRows();  
		//Should only be enabled if 1 row is selected so just get the first one
		var configID = rows[0].id;
		
		//Open up the editor with a copy of the selected config.
		var URI = ConfigurationUriUtil.getCopyConfigurationURI( configID );
		window.location.href = URI;
	},
	
	_onPreviewClick : function()
	{
		var rows = this.tableViewer.getCheckedRows();
		
		var configID = rows[0].id;

		if (configID) 
		{
			var configService =  new com.ibm.rational.test.lm.web.client.internal.config();
			var rh = new com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper(this, "loadTOC", "_getConfigDetailsError");
			configService.retrieveConfigurationWithDetails(rh, configID);
		}
    },
	
	loadTOC : function(response)
	{
		this._view.loadTOC(response);
		dijit.scrollIntoView(this._view.detailDiv);	
	},
	
	createTable: function()
	{
		this.tableViewer = new com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer({
            allowAdjustSettings: true,
            autoSaveSettings: true,
			sortByColumn: 1,
			sortDir: TableConstants.SORT_DIR_ASCEND,
            tableId: "RQM-LM-TE-TABLEVIEWER"                                
        });
		this.resultDiv.appendChild( this.tableViewer.domNode );
		
		this.tableViewer.setTableMajorMode(TableConstants.MAJOR_MODE_GRID);
//		this.tableViewer.setCustomRowRenderer( new com.ibm.rational.test.lm.web.ui.internal.views.providers.ConfigurationsListRowRenderer() );
//		this.tableViewer.setContentProvider( new com.ibm.rational.test.lm.web.ui.internal.views.providers.ConfigurationsTableProvider() );
		this.tableViewer.setContentProvider( new QueryConfigurationsView.TableProvider() );
		this.tableViewer.setContentPageSize(10);
		this.tableViewer.setTableRowsCheckable(true, false);
		this.tableViewer.setTableListener(this);
		this.tableViewer.setTableSummary(RtlmUiUtil.getMessage("labelTableSummary", RtlmUiUtil.getMessage("cfgConfigurationsPageTitle")));

        var tePerm = PermissionsClient.getStoredPermission(PermissionsClient.OP_LM_TEST_ENVIRONMENT);  
        var reqPerm = PermissionsClient.getStoredPermission(PermissionsClient.OP_LM_REQUEST);  

		//Refresh Action
        this.refreshAction = this.tableViewer.addAction("Refresh", RtlmUiUtil.getMessage("Refresh"), null, "refresh-icon-image", dojo.hitch( this, this._onRefreshActionClick ) );

		//Copy Action
        if(!tePerm || tePerm[PermissionsClient.ACTION_CREATE]) {       
            this.copyAction = this.tableViewer.addAction("Copy", RtlmUiUtil.getMessage("labelCopyButton"), null, "copy-icon-image", dojo.hitch( this, this._onCopyActionClick ) );
		    this.copyAction.setDisabled(true);
	    }
        			
		//Preview Button
        this.previewAction = this.tableViewer.addAction("Preview", RtlmUiUtil.getMessage("labelPreview"), null, "preview-icon-image", dojo.hitch(this, this._onPreviewClick));
        this.previewAction.setDisabled(true);
        
		//Create Request Action
        if (!reqPerm || reqPerm[PermissionsClient.ACTION_CREATE]) {
		    this.createRequestAction = this.tableViewer.addAction("CreateRequest", RtlmUiUtil.getMessage("createRequestAction"), null, "create-request-icon-image",dojo.hitch(this, "_createRequest"));
		    this.createRequestAction.setDisabled(true);	
		}
        
        // Search Asset action
		this.searchAction = this.tableViewer.addAction("Search", RtlmUiUtil.getMessage("searchAssetAction"), null, "search-icon-image", dojo.hitch(this, "_searchAssets"));
		this.searchAction.setDisabled(true);

		// Delete action
        if (!tePerm || tePerm[PermissionsClient.ACTION_ARCHIVE]) {
            this.deleteAction = this.tableViewer.addAction("Delete", RtlmUiUtil.getMessage("cfgDelete"), null, "delete-icon-image", dojo.hitch(this, "_deleteConfig"));
            this.deleteAction.setDisabled(true);
        }
	},
	
	createTOC: function()
	{
		this.TOCTable = new com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableViewer();
		this.detailDiv.appendChild( this.TOCTable.domNode );
		
		this.TOCTable.setTableMajorMode(TableConstants.MAJOR_MODE_GRID);
		this.TOCTable.setContentProvider( new QueryConfigurationsView.TocTableProvider() );
		this.TOCTable.setContentPageSize(10);
		this.TOCTable.setCellModifier(new QueryConfigurationsView.TOCCellModifier(this));
		this.TOCTable.setShowingFilterControl(false);
        this.TOCTable.setShowingPagingControl(false);		
	},
	
	loadTable: function()
	{
		//Disable the actions before we refresh
        if(this.createRequestAction)
		    this.createRequestAction.setDisabled(true);	
		this.searchAction.setDisabled(true);

		var configs = new com.ibm.rational.test.lm.web.client.internal.config();
		var responseHandler = new com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper(this, "_loadTable", "_errorFunc");
		configs.getAll(responseHandler);
    },	
	
	_loadTable: function(response)
	{
		this.tableViewer.setContent( ( response ) ? response : [] );  
		this.tableViewer.show();       
	},
	
	loadTOC : function(response)
	{
		if (response.configuration) 
		{
			this.TOCTitle.innerHTML = response.name;

			var catalog = new com.ibm.asq.common.web.client.internal.Catalog();
			var config = catalog.createConfigurationFromJson(response.configuration);
			
			//Build the content to be passed to the TOC
			var content = [];
			var partCount = config.getRootParts().length;
			for (var i = 0; i < partCount; i++) 
			{
				var rowData = {};
				var thisPart = config.getRootPart(i);
				var thisLabel = config.getLabel(i);
				rowData.configID = response.id;
				rowData.id = i;
				rowData.name = thisLabel;
				rowData.database = config.getValueByIndex(i, "DataBase");
				rowData.os = config.getValueByIndex(i, "OperatingSystem");
				rowData.appServer = config.getValueByIndex(i, "Application Server");
				rowData.browsers = config.getValueByIndex(i, "Browsers");
				rowData.testTools = config.getValueByIndex(i, "TestTools");
				rowData.cpu = config.getValueByIndex(i, "CPU");
				rowData.managementAgent = config.getValueByIndex(i, "ManagementAgent");
				content.push(rowData);
			}
			
			this.TOCTable.setShowingPagingControl(partCount > 10);
			this.TOCTable.setContent(content);
			this.TOCTable.show();
		}
		
	},
	
	_errorFunc: function(errorType, errorMessage) 
	{
		// bring down the working dialog
		RtlmUiUtil.hideWorkingDialog();
//		setWidgetContent('current_reservation_results', getMessage("userHmFailGetMyReservations"));
	},
	
    
	/**
	 * Show the context sensitive help content in a predefined help panel.
	 */
	showHelpContent: function(helpButton, contextId)
	{
		this.CSHelp.showHelpContent(helpButton.domNode, contextId);
	}, 

	tableContentActionInvoked: function(tableViewer, actionId, callbackData, callback) 
	{
		callback(callbackData);
	},
	
	_createRequest:function()
	{
		var rows = this.tableViewer.getCheckedRows();
		
		var configID = rows[0].id;
		var args;
		if(configID)
            args = {'configId': configID};
		
        var newRequestUri = com.ibm.rational.test.lm.web.ui.internal.views.requests.RequestUriUtil.getNewRequestURI(args);
        window.location.href = newRequestUri;
	},
	
	_deleteConfig : function()
	{
		var args = {
            'message': RtlmUiUtil.getMessage("configConfirmDelete"),
            'yesCallback': 
                function(view) {
                    view._deleteAction();
                },
            'yesCallbackData': this,
            'noCallback': null,
            'noCallbackData': null
        };
        var confirmDialog = new com.ibm.asq.common.web.ui.internal.widgets.YesNoDialog(args);
        confirmDialog.setSecondaryTitle(RtlmUiUtil.getMessage("msgConfirmTitle"));
        confirmDialog.open();
	},
	
	_deleteAction: function() {
		var rows = this.tableViewer.getCheckedRows();
		if (rows.length == 0)
			return;
		
		var idArray = [];
		for (var i = 0; i < rows.length; i++)
		{
			idArray.push(rows[i].id);
		}
		var configService =  new com.ibm.rational.test.lm.web.client.internal.config();
		var rh = new com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper(this, "_deleteSuccess", "_deleteError");
		configService.deleteConfigurations(rh, idArray);
	},
	
	_deleteSuccess : function(response)
	{
        // broadcast the delete event including to itself to clean up the table
        dojo.publish(GlobalEvents.ArtifactsDeleted, [RtlmUiUtil.TYPE_CONFIG, this.tableViewer.getCheckedRows()]);
	},
	
	_deleteError : function(response)
	{
        var details = (response && response.message) ? response.message : null;
        this.myPageLayout.setStatus(RtlmUiUtil.getMessage("cfgMsgActionError"), ViewHeaderLayout.ERROR, details);
	},
	
	
	//Methods for performing the search action
	_searchAssets: function()
	{
		var rows = this.tableViewer.getCheckedRows();
		var configID = rows[0].id;

		if (configID) 
		{
			var configService =  new com.ibm.rational.test.lm.web.client.internal.config();
			var rh = new com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper(this, "_getConfigDetailsForSearchSuccess", "_getConfigDetailsError");
			configService.retrieveConfigurationWithDetails(rh, configID);
		}
	},
	
	
	_getConfigDetailsForSearchSuccess: function(response) 
	{
		if (response.configuration) 
		{
		 	var catalog = new com.ibm.asq.common.web.client.internal.Catalog();
			var config = catalog.createConfigurationFromJson(response.configuration);
			var parts = config.getRootParts();
		
			if (parts.length > 1) 
			{
				// Prompt user which part to search
				this.selectDlg = new com.ibm.rational.test.lm.web.ui.internal.views.configurations.AssetDescriptionSelectorDialog({title: RtlmUiUtil.getMessage("cfgSelectAssetForSearch")});
				this.selectDlg.setOKAction( dojo.hitch( this, this._handleConfigPartSelectOK ) );
				this.selectDlg.addListItem(response.id, response.name);
				//Set the initial selection to the 0th item (actually there is only 1 item so select it)
				this.selectDlg.selectItem(0); 
				this.selectDlg.show();
			}
			else 
				if (parts.length == 1) 
				{
					var args = {'type' : "Machine",
								'initialConfigID' : response.id,
								'initialPartIndex' : 0};
			
					window.location.href = AssetUriUtil.getSearchAssetURIWithArgs(args);
				}
		}
	},
	
	_handleConfigPartSelectOK: function(){
		var selectedPart = this.selectDlg.getSelectedAssetDescriptor();
		if(selectedPart) 
		{
			var args = {'type' : "Machine",
						'initialConfigID' : this.selectDlg.getSelectedConfigID(),
						'initialPartIndex' : this.selectDlg.getSelectedIndex()};
			
			window.location.href = AssetUriUtil.getSearchAssetURIWithArgs(args);
		}
	},

	_getConfigDetailsError: function(response) 
	{
		console.debug(response);
	},
		
	rowCheckStateChanged: function(tableViewer, rowObject, state)
	{
        this._updateTableActions();
        this.myPageLayout.clearStatus();
	},
	
    _updateTableActions: function()
    {
        //determine how many rows are checked
        var numCheckedRows = this.tableViewer.getCheckedRows().length;
        
        if(this.createRequestAction)
            this.createRequestAction.setDisabled(numCheckedRows != 1);
            
        this.searchAction.setDisabled(numCheckedRows != 1);
        this.previewAction.setDisabled(numCheckedRows != 1);
        
        if(this.copyAction)
            this.copyAction.setDisabled(numCheckedRows != 1);
        
        if(this.deleteAction)    
            this.deleteAction.setDisabled(numCheckedRows == 0);        
    },
    
    // handler on artifacts changed
    onArtifactChanged: function(changeType, artifactType, artifactArray) {
        // only care about config
        if (artifactType == RtlmUiUtil.TYPE_CONFIG) {
            if (changeType == GlobalEvents.ArtifactsAdded) {
                // refresh table on add to sync up with server
                this.loadTable();
            } else {
                var content = this.tableViewer.getContent();
                // iterate through the array of artifacts
                for (var i = 0; i < artifactArray.length; i++) {
                    // iterate through the array of config in the table
                    for (var j = 0; j < content.length; j++) {
                        // handle the matching content
                        if (artifactArray[i].id == content[j].id) {
                            if (changeType == GlobalEvents.ArtifactsUpdated) {
                                // swap config on update
                                content.splice(j, 1, artifactArray[i]);
                                this.tableViewer.setContent(content);
                                this.tableViewer.refresh();
                            } else if (changeType == GlobalEvents.ArtifactsDeleted) {
                                // remove config from table on delete
                                content.splice(j, 1);
                                this.tableViewer.setContent(content);
                                this.tableViewer.refresh();
                                this._updateTableActions();
                            }
                            break;
                        }
                    }
                }
            }
        }
    }
});

})();
