/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/

dojo.provide("com.ibm.rational.test.lm.web.ui.internal.views.machines.ParameterDialog");

dojo.require("dijit.Dialog");
dojo.require( "com.ibm.asq.common.web.ui.internal.widgets.OptionChooser" );
dojo.require("com.ibm.rational.test.lm.web.ui.internal.RtlmUiUtil");

( function() {
var RtlmUiUtil = com.ibm.rational.test.lm.web.ui.internal.RtlmUiUtil;

dojo.declare("com.ibm.rational.test.lm.web.ui.internal.views.machines.ParameterDialog",
			 dijit.Dialog,
{
	optionList: null,
	sectionKey: null,
	okMethod: null,
	
	postCreate: function()
	{
		this.inherited( "postCreate", arguments );
		this.chooser = new com.ibm.asq.common.web.ui.internal.widgets.OptionChooser( {leftTitle:RtlmUiUtil.getMessage("attributesNotShowing"), 
																				 rightTitle:RtlmUiUtil.getMessage("attributeShowing")});
		this.chooser.enableOkCancel();
		this.chooser.addOkListener( dojo.hitch( this, this.okAction ) );
		this.chooser.addCancelListener( dojo.hitch( this, this.cancelAction ) );
		this.containerNode.appendChild( this.chooser.domNode );
	},
	
	setOptions: function( optionList )
	{
		this.optionList = optionList;
	},
	
	show: function()
	{
		if( this.optionList )
		{
			for( var name in this.optionList )
			{
				var attrName = RtlmUiUtil.getMessage( "pl_" + name );
				if( !attrName )
				{
					attrName = name;	
				}
				
				this.chooser.addOption( attrName, this.optionList[ name ], this.optionList[ name ].selected );	
			}
		}
		
		this.inherited( "show", arguments );
	},
	
	okAction: function( event )
	{
		this.hide();
		if( this.okMethod )
		{
			var selected = this.chooser.getOptions();
			this.okMethod( this.sectionKey, selected );
		}
	},
	
	cancelAction: function( event )
	{
		this.hide();
	},
	
	setOKaction: function( method )
	{
		this.okMethod = method;
	}
	
});		 
})();
