/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/

dojo.provide("com.ibm.rational.test.lm.web.ui.internal.views.providers.RequestReservedMachinesTableProvider"); 

dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentProvider");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.views.providers.DefaultTableProvider");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.pages.AssetUriUtil");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.RtlmUiUtil");

(function() {

	var RtlmUiUtil = com.ibm.rational.test.lm.web.ui.internal.RtlmUiUtil;
	var TableConstants = com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants;
	var column_types = [
						TableConstants.RENDER_TYPE_LINK,
						TableConstants.RENDER_TYPE_TIMESTAMPDATE,
						TableConstants.RENDER_TYPE_TIMESTAMPDATE ];
						
dojo.declare("com.ibm.rational.test.lm.web.ui.internal.views.providers.RequestReservedMachinesTableProvider", 
             com.ibm.rational.test.lm.web.ui.internal.views.providers.DefaultTableProvider,
{
	constructor: function()
	{
		this.setParameters( { "column_headings" : this.getColumnHeadings(),
					  "id_fields" : this.getIdFields(),
					  "column_types" : column_types } );
	},
	
	getColumnHeadings : function()
	{
		return( [{title: RtlmUiUtil.getMessage("reshostname"), native_column: dojo.hitch( this, this.getMachineName ), isSortable: true, includeInFilter: true, width: 34},              
                 {title: RtlmUiUtil.getMessage("reserveFrom"), native_column: "reserveFrom", isSortable: true, includeInFilter: true, width: 33},              
                 {title: RtlmUiUtil.getMessage("reserveTo"), native_column: "reserveTo", isSortable: true, includeInFilter: true, width: 33}]);
	},
	
	getIdFields: function()
	{
		return( dojo.hitch( this, this.getId ) );
	},
	
	getMachineName: function( rowData, atColumnIndex )
	{
		return( rowData[ "configuration" ].getRootAttribute().getValue().getAttributeValue( 'name' ) );
	},
	
	getId: function( rowData )
	{
		return( rowData[ "configuration" ].getId() );
	},
    
    getCellDisplayExtendedInfo: function(rowData, atColumnIndex)
    {  
        var val = null;
		if(atColumnIndex == 0) {
            val = {};
			var AssetUriUtil = com.ibm.rational.test.lm.web.ui.internal.pages.AssetUriUtil;
            val['href'] = AssetUriUtil.getViewAssetDetailURI("Machine", this.getRowDataId( rowData ) );
        }

        return val;
    }       
});

})();
