/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/

dojo.provide("com.ibm.rational.test.lm.web.ui.internal.views.providers.ReservationTableProvider"); 

dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableContentProvider");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.pages.AssetUriUtil");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.views.requests.RequestUriUtil");
dojo.require("com.ibm.asq.common.web.ui.internal.view.common.ImageCache");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.views.providers.DefaultTableProvider");
dojo.require("com.ibm.rational.test.lm.web.ui.internal.RtlmUiUtil");

(function() {

	var RtlmUiUtil = com.ibm.rational.test.lm.web.ui.internal.RtlmUiUtil;
	var TableConstants = com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants;
	var ImageCache = com.ibm.asq.common.web.ui.internal.view.common.ImageCache;
	var column_types = [
						TableConstants.RENDER_TYPE_IMAGE,
						TableConstants.RENDER_TYPE_TEXT,
						TableConstants.RENDER_TYPE_LINK,
						TableConstants.RENDER_TYPE_TIMESTAMPDATE,
						TableConstants.RENDER_TYPE_TIMESTAMPDATE,
						TableConstants.RENDER_TYPE_LINK,
						TableConstants.RENDER_TYPE_TEXT,
						TableConstants.RENDER_TYPE_TEXT ];
						
dojo.declare("com.ibm.rational.test.lm.web.ui.internal.views.providers.ReservationTableProvider", 
             com.ibm.rational.test.lm.web.ui.internal.views.providers.DefaultTableProvider,
{
	constructor: function()
	{
		this.setParameters( { "column_headings" : this.getColumnHeadings(),
					  "id_fields" : this.getIdFields(),
					  "column_types" : column_types } );
	},
	
	getColumnHeadings : function()
	{
		return( [{title: "", native_column: "visibleId", isSortable: false, includeInFilter: false, width: 1},
				 {title: RtlmUiUtil.getMessage("resId"), native_column: "visibleId", isSortable: true, includeInFilter: true, width: 5},              
                 {title: RtlmUiUtil.getMessage("resMachineName"), native_column: "assetName", isSortable: true, includeInFilter: true, width: 29},              
                 {title: RtlmUiUtil.getMessage("resStartDate"), native_column: "reserveFrom", isSortable: true, includeInFilter: true, width: 15},              
                 {title: RtlmUiUtil.getMessage("resEndDate"), native_column: "reserveTo", isSortable: true, includeInFilter: true, width: 15},
                 {title: RtlmUiUtil.getMessage("resRequestId"), native_column: "requestVisibleId", isSortable: true, includeInFilter: true, width: 5},             
                 {title: RtlmUiUtil.getMessage("resRequestStatus"), native_column: "requestStatus", isSortable: true, includeInFilter: true, width: 15},
                 {title: RtlmUiUtil.getMessage("resReservedBy"), native_column: "reservedBy", isSortable: true, includeInFilter: true, width: 15}]            
 				);
	},
	
	getIdFields: function()
	{
		return( "id" );
	},
	
    getCellDisplayExtendedInfo: function(rowData, atColumnIndex)
    {  
        var val = null;
		if (atColumnIndex == 0) 
		{
			val = {};
			val.image = ImageCache.RESERVATION;
		}

		if(atColumnIndex == 5) {
            val = {};
			var UriUtil = com.ibm.rational.test.lm.web.ui.internal.views.requests.RequestUriUtil;
			if( rowData.requestItemId )
            	val['href'] = UriUtil.getEditRequestURI(rowData.requestItemId)
        }
        if(atColumnIndex == 2){
            val = {};
			
            var AssetUriUtil = com.ibm.rational.test.lm.web.ui.internal.pages.AssetUriUtil;
			var assetType = rowData.assetType;
			var id = rowData.assetItemId;
            val['href'] = AssetUriUtil.getViewAssetDetailURI( assetType, id );
        }

        return val;
    }       
});

})();
