/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
console.debug("Loading: com.ibm.asq.common.web.ui.internal.widgets.SortableOptionChooser");
dojo.provide("com.ibm.asq.common.web.ui.internal.widgets.SortableOptionChooser");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dijit.Dialog");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.OptionChooser");
dojo.require("com.ibm.asq.common.web.ui.internal.view.common.ImageCache");

dojo.require("com.ibm.asq.common.web.client.internal.Constants");

(function(){ // module container

var Constants = com.ibm.asq.common.web.client.internal.Constants;

    var ImageCache = com.ibm.asq.common.web.ui.internal.view.common.ImageCache;
	
    dojo.declare("com.ibm.asq.common.web.ui.internal.widgets.SortableOptionChooser", [dijit._Widget, dijit._Templated, com.ibm.asq.common.web.ui.internal.widgets.OptionChooser], {
        
        templateString: '<div id="${id}" dojoAttachPoint="domNode" tabindex="-1">' +
                        ' <table border="0">' +
                        '  <tr>' +
                        '   <td dojoAttachPoint="leftSelectTitleNode"/>'+
                        '   <td/>' +
                        '   <td>' +
                        '       <span dojoAttachPoint="rightSelectTitleNode"></span>' +
                        '       <img src="${newIcon}" dojoAttachPoint="newButton" class="chooserActionImg" title="${newLabel}" dojoAttachEvent="onclick: _onNew">' +
                        '       <img src="${upIcon}" dojoAttachPoint="upButton" class="chooserActionImg" title="${upLabel}"  dojoAttachEvent="onclick: _onMoveUp">' +
                        '       <img src="${downIcon}" dojoAttachPoint="downButton" class="chooserActionImg" title="${downLabel}" dojoAttachEvent="onclick: _onMoveDown">' +  
                        '   </td>' +
                        '  </tr>' +
                        '  <tr>' +
                        '   <td>' +
                        '    <label><select dojoAttachPoint="choosableOptionsNode" name="choosableOptions" class="optionSelect" multiple="true" size="20" dojoAttachEvent="onchange: _onChooseSelect">' +
                        '    </select></label>' +
                        '   </td>' +
                        '   <td>' +
                        '    <table border="0">' +
                        '     <tr>' +
                        '      <td><button class="optionButton" dojoAttachPoint="addItemNode" dojoAttachEvent="onclick:_onAddItems">&gt;</button></td>' +
                        '     </tr>' +
                        '     <tr>' +
                        '      <td><button class="optionButton" dojoAttachPoint="addAllItemsNode" dojoAttachEvent="onclick:_onAddAllItems">&gt;&gt;</button></td>' +
                        '     </tr>' +
                        '     <tr>' +
                        '      <td><button class="optionButton" dojoAttachPoint="removeItemNode" dojoAttachEvent="onclick:_onRemoveItems">&lt;</button></td>' +
                        '     </tr>' +
                        '     <tr>' +
                        '      <td><button class="optionButton" dojoAttachPoint="removeAllItemsNode" dojoAttachEvent="onclick:_onRemoveAllItems">&lt;&lt;</button></td>' +
                        '     </tr>' +
                        '    </table>' +
                        '   </td>' +
                        '   <td>' +
                        '    <label><select dojoAttachPoint="chosenOptionsNode" class="optionSelect" multiple="true" size="20" dojoAttachEvent="onchange:_onChosenSelect">' +
                        '    </select></label>' +
                        '   </td>' +
                        '  </tr>' +
                        ' </table>' +
                        ' <div align="center">' +
                        ' <table class="chooser-button-area" dojoAttachPoint="buttonTableNode" border="0">' +
                        '  <tr>' +
                        '   <td class="action-button-cell">' +
                        '    <button dojoAttachPoint="okNode" class="option-action-button" dojoAttachEvent="onclick: _okAction"></button>' +
                        '   </td>' +
                        '   <td class="action-button-cell">' +
                        '    <button dojoAttachPoint="cancelNode" class="option-action-button" dojoAttachEvent="onclick: _cancelAction"></button>' +
                        '   </td>' +
                        '  </tr>' +
                        ' </table>' +
                        ' </div>' +
                        '</div>',
						
		newLabel: Constants.getMessage("labelNew"),
		newIcon: ImageCache.ADD_ICON_ENABLED,		
		upLabel: Constants.getMessage("labelUp"),
		upIcon: ImageCache.MOVE_UP_ICON_ENABLED,
		downLabel: Constants.getMessage("labelDown"),
		downIcon: ImageCache.MOVE_DOWN_ICON_ENABLED,
			
		addNewListener: function(newListener) {
			if (dojo.isFunction(newListener)) {
				this._newListener = newListener;
			}
		},
		
		setDisabled: function(/*boolean*/ disabled) {
			this.inherited("setDisabled",arguments); 
			if (disabled) {
				this._disableButtons();
				this.newButton.style.display = "none";
				this.upButton.style.display = "none";
				this.downButton.style.display = "none";
			}
		},
		
        _onNew: function() {
            if (dojo.isFunction(this._newListener)) {
                this._newListener();
            }
        },
				
		_onMoveUp: function(){
			if(this.chosenOptionsNode.options[0].selected == true){
				return;
			}
			for( var i = 0; i < this.chosenOptionsNode.options.length; i++){
				if(this.chosenOptionsNode.options[i].selected == true && i > 0){
					var option = dojo.clone(this.chosenOptionsNode.options[i - 1]);
					this.chosenOptionsNode.options[i - 1].value = this.chosenOptionsNode.options[i].value;
					this.chosenOptionsNode.options[i - 1].innerHTML = this.chosenOptionsNode.options[i].innerHTML;
					this.chosenOptionsNode.options[i - 1].selected = true;
					this.chosenOptionsNode.options[i - 1].required = this.chosenOptionsNode.options[i].required;
					this.chosenOptionsNode.options[i - 1].className = this.chosenOptionsNode.options[i].className;
					 this.chosenOptionsNode.options[i - 1].title = this.chosenOptionsNode.options[i].title;
					this.chosenOptionsNode.options[i].value = option.value;
					this.chosenOptionsNode.options[i].innerHTML = option.innerHTML;
					this.chosenOptionsNode.options[i].selected = option.selected;
					this.chosenOptionsNode.options[i].required = option.required;
					this.chosenOptionsNode.options[i].className = option.className;
					this.chosenOptionsNode.options[i].title = option.title;
				}
			}
		},
		
		_onMoveDown: function(){
			if(this.chosenOptionsNode.options[this.chosenOptionsNode.options.length - 1].selected == true){
				return;
			}
			for( var i = this.chosenOptionsNode.options.length - 1; i >= 0; i--){
				if(this.chosenOptionsNode.options[i].selected == true && i < this.chosenOptionsNode.options.length - 1){
					var option = dojo.clone(this.chosenOptionsNode.options[i + 1]);
					this.chosenOptionsNode.options[i + 1].value = this.chosenOptionsNode.options[i].value;
					this.chosenOptionsNode.options[i + 1].innerHTML = this.chosenOptionsNode.options[i].innerHTML;
					this.chosenOptionsNode.options[i + 1].selected = true;
					this.chosenOptionsNode.options[i + 1].required = this.chosenOptionsNode.options[i].required;
					this.chosenOptionsNode.options[i + 1].className = this.chosenOptionsNode.options[i].className;
					this.chosenOptionsNode.options[i + 1].title = this.chosenOptionsNode.options[i].title;
					this.chosenOptionsNode.options[i].value = option.value;
					this.chosenOptionsNode.options[i].innerHTML = option.innerHTML;
					this.chosenOptionsNode.options[i].selected = option.selected;
					this.chosenOptionsNode.options[i].required = option.required;
					this.chosenOptionsNode.options[i].className = option.className;
					this.chosenOptionsNode.options[i].title = option.title;
				}
			}
		},
		
		_okAction: function( event )
		{
			this.okNode.disabled = true;
			if( this.oklistener )
				this.oklistener( event );
		},

        _enableButtons: function() {
            this.inherited('_enableButtons', arguments);
            this.newButton.disabled = false;
            this.upButton.disabled = false;
            this.downButton.disabled = false;
        },
		        
        _disableButtons: function() {
			this.inherited('_disableButtons', arguments);
			this.newButton.disabled = true;
			this.upButton.disabled = true;
			this.downButton.disabled = true;
        }
        
    });
    
})();
