/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
// author: Paul Beaulieu
//
// Summary: This is a widget that brings both the DateBox and TimePicker together
//

dojo.provide("com.ibm.asq.common.web.ui.internal.widgets.datetimepicker.DateTimePicker");

dojo.require( "dijit._Widget" );
dojo.require( "dijit._Templated" );
dojo.require( "dijit.form.Button" );
dojo.require("dojo.date.locale");
dojo.require("dojox.data.dom");

dojo.require("com.ibm.asq.common.web.ui.internal.util.MessageUtil");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.datetextbox.DateTextBox");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.TimePicker");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.DatePicker");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.SimpleTimeSelector");

(function() {


dojo.declare(
    "com.ibm.asq.common.web.ui.internal.widgets.datetimepicker.DateTimePicker",
    [dijit._Widget, dijit._Templated],
{
    templateString: '<div class="datetimepicker-widget" dojoAttachPoint="domNode" tabindex="-1">' +
					' <table>' +
					'  <tr>' +
					'   <td dojoAttachPoint="labelNode"  class="label-class"></td>' +
					'   <td dojoAttachPoint="rowPickersNode" class="date-picker-class">' +
//					'     <div class="${dateClass}" name="${dateName}" minDate="${minimumDate}" dojoType="com.ibm.asq.common.web.ui.internal.widgets.DatePicker" dojoAttachPoint="dateNode" dojoAttachEvent="onchange: onDateChange" size="20"/>' +
//					'     <div dojoType="com.ibm.asq.common.web.ui.internal.widgets.datetextbox.DateTextBox" dojoAttachPoint="dateNode" dojoAttachEvent="onchange: onDateChange" size="20"/>' +
//					'     <div name="${dateName}" dojoType="com.ibm.rational.test.lm.web.ui.internal.widgets.RlmDateTextBox" dojoAttachPoint="dateNode" dojoAttachEvent="onchange: onDateChange" size="20"/>' +
					'   </td>' +
//					'   <td class="calendar-button-image">' +
//					'     <div dojoType="dijit.form.Button" class="datetimepicker-calendar-button-class" label="${calendarButtonLabel}" showLabel="false" iconClass="timepicker-calendar-button-image" dojoAttachPoint="calendarButtonNode" dojoAttachEvent="onclick: _onCalendarClick"/>' +
//					'   </td>' +
					'   <td dojoAttachPoint="timePickersNode" class="time-picker-class">' +
//					'     <div dojoType="com.ibm.asq.common.web.ui.internal.widgets.SimpleTimeSelector" dojoAttachPoint="timeNode" dojoAttachEvent="onchange: onTimeChange"/>' +
//					'     <div dojoType="com.ibm.asq.common.web.ui.internal.widgets.TimePicker" dojoAttachPoint="timeNode" dojoAttachEvent="onchange: onTimeChange"/>' +
					'   </td>' +
					'  </tr>' +
					' </table>' +
                    '</div>',

	dateName: "",
	dateClass: "",
	minimumDate: "",
	widgetsInTemplate: true,
	calendarButtonLabel: MessageUtil.getMessage(MessageBundle.COMMON, "scheduler_buttoncalendar"),

	postCreate: function()
	{
		if( this.label )
		{
			this.labelNode.innerHTML = this.label;
		}
		
		//this.dateNode.className = "date-field";
		//debugger;
		//dojo.addClass(this.dateNode.domNode, this.dateClass);
		//this.dateNode.className = this.dateClass;
		//this.calendarButtonNode.onClick = dojo.hitch( this, this._onCalendarClick );
        this.dateNode = new com.ibm.asq.common.web.ui.internal.widgets.DatePicker({
                    name: this.dateName,
                    value: "",
                    minDate:this.minDate,
                    invalidMessage: MessageUtil.getMessage(MessageBundle.COMMON, "dtpInvalidDate"),
                    onChange: dojo.hitch(this, "onDateChange"),
                    onkeyup: ( this.onKeyUp ) ? this.onKeyUp : dojo.hitch(this, "_onkeyup"),
                    "class": this.dateClass
                });

		this.rowPickersNode.appendChild( this.dateNode.domNode );
		this.dateNode.init();
		if( this.date )
			this.dateNode.setValue( this.date );
			
        this.timeField = new com.ibm.asq.common.web.ui.internal.widgets.SimpleTimeSelector({time:this.time});
        this.timeField.onChange = dojo.hitch( this, this.onTimeChange );
        dojo.style(this.timeField.domNode, "display", "inline");
        this.timePickersNode.appendChild(this.timeField.domNode);
		//this.dateNode.onChange = dojo.hitch( this, this.onDateChange );
		//this.timeNode.onChange = dojo.hitch( this, this.onTimeChange );
		//this.dateNode.onkeyup = dojo.hitch( this, this._onkeyup );
//		var defaultTime = new Date();
//		defaultTime.setHours(0);
//		defaultTime.setMinutes(0);
//		this.timeNode.setTime( defaultTime );
	},
	
	_onCalendarClick: function()
	{
//		this.dateNode._open();
		
		if (!this._picker) 
		{
			var popupProto = dojo.getObject("dijit._Calendar", true /*false*/);
			this._picker = new popupProto({
				_currentDateBox: this.dateNode,
				_dateBoxId: null,
				_container: this,
				_parent: this.calendarButtonNode,
				closable:true,
				onValueSelected: function(date)
				{
					dijit.popup.close(this._container._picker);
					this._currentDateBox.setValue( date );
				}
			});
                
			// constraint the size of the calendar. Otherwise, it'll take
			// up the rest of the space of the page.
			dojo.style(this._picker.domNode, "width", "180px");
			dojo.style(this._picker.domNode, "height", "200px");
		}
				
		this._picker.setValue(new Date());
            
		// put the focus to the date box. This will allow
		// the popup to pop down when the user click elsewhere
		// in the form.
		this.calendarButtonNode.picker = this._picker;
		var body = document.getElementsByTagName( "body" );
		var self = this;
		
		if( body.length == 1 )
		{			
			var onclick = body[ 0 ].onclick;				  
			body[ 0 ].onclick = function( e )
								{ 
									var parent = e.target;
									var id = self.calendarButtonNode.picker.domNode.id;
									var lost_focus = true;
									
									while( parent != null )
									{
										if( parent.id && ( parent.id == id ) )
										{
											lost_focus = false;
											break;
										}
										
										parent = parent.parentNode;
									}
									
									if( lost_focus )
									{
										dijit.popup.close( self.calendarButtonNode.picker );
										if( onclick == undefined )
										{
											delete this[ "onclick" ];
										}
										else
										{
											this.onclick = onclick;
										}
									}
									
									if( onclick )
									{
										onclick( e );
									}
								}
		}											  
        
		dijit.popup.open({
			parent: this.calendarButtonNode,
			popup: this._picker,
			around: this.calendarButtonNode.domNode,
			onClose: function()
			{//do nothing
			}
		});				
	},
	
	onDateChange: function()
	{
	},
	
	onTimeChange: function()
	{
	},
	
	getValue: function()
	{
		var theDate = this.dateNode.getValue();
		if(theDate){
			var theTime = this.timeField.getTime();
			
			theDate.setHours( theTime.getHours(), theTime.getMinutes(), 0, 0 );
		}
		
		return( theDate );
	},
	
	getDateValue: function()
	{
		return( this.dateNode.getValue() );
	},
	
	getTimeValue: function()
	{
		return( this.timeField.getTime() );
	},
	
	clear: function()
	{
		this.dateNode.setDisplayedValue( "" );
		//this.timeNode.setDisplayedValue( "" );
		this.dateNode.setValue( null );

        if(this.dateNode.constraints['min'])
            delete this.dateNode.constraints['min'];
        
        if(this.dateNode.constraints['max'])
            delete this.dateNode.constraints['max'];

        if (this.dateNode._picker) {
            var picker = this.dateNode._picker;
            delete picker;
            this.dateNode._picker = null;
        }
        
//		this.timeNode.setValue( null );
		var defaultTime = new Date();
		defaultTime.setHours(0);
		defaultTime.setMinutes(0);
		this.timeField.setTime( defaultTime );
	},
	
	_onkeyup: function( evt )
	{
		//Override so that date is not validated as the user types it.  Wait till later
	},
	
    isValid: function(/* Boolean*/isFocused){
		return( this.dateNode.isValid( isFocused ) );
	}
}	
);

})();