/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/

dojo.provide("com.ibm.asq.common.web.ui.internal.widgets.propertyeditor.PropertyDialog");

dojo.require("dijit.Dialog");
dojo.require( "dijit._Widget" );
dojo.require( "dijit._Templated" );

dojo.require("com.ibm.asq.common.web.client.internal.Constants");

( function() {

	var Constants = com.ibm.asq.common.web.client.internal.Constants;

dojo.declare("com.ibm.asq.common.web.ui.internal.widgets.propertyeditor.PropertyDialog",
			 dijit.Dialog,
{	
//	constructor: function( okcallback, propertyValue )
//	{
//		this.callback = okcallback;
//		this.propertyValue = propertyValue;	
//	},
	
	postCreate: function()
	{
		this.inherited( "postCreate", arguments );
		var args = {"value": this.propertyValue,
					"name": this.propertyName,
					"okcallback": dojo.hitch( this, this.okAction ),
					"cancelcallback": dojo.hitch( this, this.cancelAction )};
		var node = new PropertyDialog.Content( args );
		this.containerNode.appendChild( node.domNode );
	},
			
	okAction: function( value )
	{
		this.hide();
		if( this.callback )
			this.callback( this.callbackdata, value );
		
	},
	
	cancelAction: function( event )
	{
		this.hide();
	}
});

dojo.declare("PropertyDialog.Content",
			 [dijit._Widget, dijit._Templated],
{
	templateString :	'<div id="${id}" dojoAttachPoint="domNode" tabIndex="-1">' +
						' <table>' +
						'  <tbody>' +
						'   <tr>' +
						'    <td class="property-dialog-content-name">' +
						'     <div dojoAttachPoint="propertyNameNode"></div>' +
						'    </td>' +
						'    <td class="property-dialog-content-value">' +
						'     <label for="property"><input type="text" dojoAttachPoint="inputNode" size="100" id="property"/></label>' +
						'    </td>' +
						'   </tr>' +
						'  </tbody>' +
						' </table>' +
						' <div class="property-dialog-button-area" align="center">' +
						' <table class="property-dialog-button-area1" dojoAttachPoint="buttonTableNode" border="0">' +
						'  <tr>' +
						'   <td class="action-button-cell">' +
						'    <button dojoAttachPoint="okNode" class="option-action-button" dojoAttachEvent="onclick: _okAction"></button>' +
						'   </td>' +
						'   <td class="action-button-cell">' +
						'    <button dojoAttachPoint="cancelNode" class="option-action-button" dojoAttachEvent="onclick: _cancelAction"></button>' +
						'   </td>' +
						'  </tr>' +
						' </table>' +
						' </div>' +						
						'</div>',
					
//	constuctor: function( callback, propertyValue )
//	{
//		this.callback = callback;
//		this.propertyValue = propertyValue;
//	},
	
	postCreate: function()
	{
		this.inherited( "postCreate", arguments );
		this.propertyNameNode.innerHTML = this.name;
		this.inputNode.value = this.value;
		this.okNode.innerHTML = Constants.getMessage("actionLabel_ok");
		this.cancelNode.innerHTML = Constants.getMessage("actionLabel_cancel");
	},					
						
	_okAction: function( event )
	{
		if( this.okcallback )
			this.okcallback( this.inputNode.value );
	},
	
	_cancelAction: function( event )
	{
		if( this.cancelcallback )
			this.cancelcallback( event );
	}				
});		 
})();
