/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.ImageCellRenderer");

dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableCellRenderer");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants");

(function() {

dojo.declare("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.ImageCellRenderer", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableCellRenderer,
{    
    // Summary:
    //    Renders the image cell content. The following cellData can be expected. 
    //    
    renderCell: function(viewer, cellData, extendedDisplayInfo, /*table.CellModifier*/cellModifier, rowObject, columnIndex)
    {
        var img = document.createElement("img");
        var tooltip = cellData;
        
        if(extendedDisplayInfo && dojo.isObject(extendedDisplayInfo)) {
            var imgSrc = (typeof extendedDisplayInfo['mouseOutImage'] != "undefined") ? extendedDisplayInfo['mouseOutImage'] : extendedDisplayInfo['image'];
            img.alt = cellData;
            img.src = imgSrc;
            img.extendData = extendedDisplayInfo;
            
            if(extendedDisplayInfo['tooltip'])
                tooltip = extendedDisplayInfo['tooltip'];
        }
        else {
            img.src = cellData;
        }
        dojo.connect(img, "onmouseover", this, "overImage");
        dojo.connect(img, "onmouseout", this, "outOfImage");
		
        var dojoTooltip = this._attachTooltipToCell(img, tooltip);
            
        if (extendedDisplayInfo &&  typeof extendedDisplayInfo['href'] != "undefined") {
            var anchor = document.createElement("a");
            anchor.href = extendedDisplayInfo.href;
            anchor.appendChild(img);
			anchor.tooltip = dojoTooltip;
            return anchor;
        }
		img.tooltip = dojoTooltip;
		
        return img;
    },
    
    overImage: function(e)
    {
        if(e.target.extendData && e.target.extendData['mouseOverImage']) {
            e.target.src = e.target.extendData['mouseOverImage'];
        }
    },
    
    outOfImage: function(e)
    {
        if(e.target.extendData && e.target.extendData['mouseOverImage']) {
            var data = e.target.extendData;
            e.target.src = (typeof data['mouseOutImage'] != "undefined") ? data['mouseOutImage'] : data['image'];
        }
    }
});

})();
