/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TimeStampDateCellRenderer");

dojo.require("dojo.date.locale"); 
dojo.require("com.ibm.asq.common.web.client.internal.CommonPreferenceClient");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableCellRenderer");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableConstants");
dojo.require("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.Util");

(function() {

dojo.declare("com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TimeStampDateCellRenderer", 
             com.ibm.asq.common.web.ui.internal.widgets.tableViewer.TableCellRenderer,
{    
    // Summary:
    //    Renders the cell content. For renderer that can modify the cell value,
    //    
    renderCell: function(viewer, cellData, extendedDisplayInfo, /*table.CellModifier*/cellModifier, rowObject, columnIndex, cellWidthHint)
    {
         var str = cellData;
         var date = com.ibm.asq.common.web.ui.internal.widgets.tableViewer.Util.convertTimeStampToDate(cellData);
         
        if(date) {
            var dateFormatLength = com.ibm.asq.common.web.client.internal.CommonPreferenceClient.getDateFormatLength();            
            str = dojo.date.locale.format(date, {formatLength: dateFormatLength});
        }
        var node = document.createElement("span");
        this._renderCellText(viewer, str, extendedDisplayInfo, node, cellWidthHint);
        return node;
    }
});

})();
