/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
// author: Paul Beaulieu
//
// Summary: This is a widget to choose options.
//

dojo.provide("com.ibm.asq.common.web.ui.internal.widgets.toolbar.Toolbar");

dojo.require( "dijit._Widget" );
dojo.require( "dijit._Templated" );

(function() {
dojo.declare(
    "com.ibm.asq.common.web.ui.internal.widgets.toolbar.Toolbar",
    [dijit._Widget, dijit._Templated],
{
    templateString:
					'<div id="${id}" class="toolbar-container" dojoAttachPoint="domNode" tabindex="-1">' +
                    '</div>',

	postCreate: function()
	{
		if( this.buttons )
		{
			for( var button = 0; button < this.buttons.length; button++ )
			{
				var buttonargs = { "iconClass": this.buttons[ button ][ "imgclass" ], 
								   "showLabel": false,
								   "onClick": function( e ) { this.clientCallback( this.callbackData, e ); } };
				var dButton = new dijit.form.Button( buttonargs );
				
				dButton.clientCallback = this.buttons[ button ][ "handler" ];
				dButton.callbackData = this.buttons[ button ][ "data" ];
				dojo.addClass( dButton.domNode, "com-ibm-asq-common-web-ui-internal-widgets-toolbar" );
				this.domNode.appendChild( dButton.domNode );
			}
		}
	}
});
})();
